library(methods)
{{rimport}}('__init__.r', 'plot.r')

indir  = {{i.indir | R}}
outdir = {{o.outdir | R}}

plink    = {{args.plink | R}}
samplecr = {{args.samplecr | R}}
snpcr    = {{args.snpcr | R}}
devpars  = {{args.devpars | R}}

bedfile = Sys.glob(file.path(indir, '*.bed'))
input   = tools::file_path_sans_ext(bedfile)
output  = file.path(outdir, basename(input))

params = list(
	bfile   = input,
	missing = T,
	out     = output
)
cmd = sprintf("%s %s 1>&2", plink, cmdargs(params, equal = ' '))
runcmd(cmd)

imiss = read.table(paste0(output, '.imiss'), header = T, row.names = NULL, check.names = F)
callrate.sample = data.frame(Callrate = 1-imiss$F_MISS)
rownames(callrate.sample) = paste(imiss$FID, imiss$IID, sep = "\t")
callrate.sample.fail = rownames(callrate.sample[callrate.sample$Callrate < samplecr, , drop = F])
writeLines(callrate.sample.fail, con = file(paste0(output, '.samplecr.fail')))

{% if args.plot %}
callrate.sample$Status = "Pass"
callrate.sample[callrate.sample.fail, "Status"] = "Fail"
plot.histo(
	data     = callrate.sample,
	plotfile = paste0(output, '.samplecr.png'),
	params   = list(aes(fill=Status), bins = 50),
	ggs      = list(
		xlab       = list("Sample Call Rate"),
		ylab       = list("Count"),
		geom_vline = list(xintercept = samplecr, color = "red", linetype="dashed"),
		theme      = list(legend.position = "none"),
		geom_text  = list(
			aes(x = samplecr, y = Inf, label = samplecr),
			colour="red", angle=90, vjust = 1.2, hjust = 1.2
		)
	)
)
{% endif %}

lmiss = read.table(paste0(output, '.lmiss'), header = T, row.names = NULL, check.names = F)
lmiss$Callrate = 1-lmiss$F_MISS
callrate.snp.fail = lmiss[which(lmiss$Callrate < snpcr), 'SNP', drop = F]
write.table(callrate.snp.fail, paste0(output, '.snpcr.fail'), row.names = F, col.names = F, sep = "\t", quote = F)

{% if args.plot %}
lmiss$Status = "Pass"
lmiss[which(lmiss$Callrate < snpcr), "Status"] = "Fail"
plot.histo(
	data     = lmiss,
	plotfile = paste0(output, '.snpcr.png'),
	x        = 'Callrate',
	params   = list(aes(fill=Status), bins = 50),
	ggs      = list(
		xlab       = list("SNP Call Rate"),
		ylab       = list("Count"),
		geom_vline = list(xintercept = snpcr, color = "red", linetype="dashed"),
		theme      = list(legend.position = "none"),
		geom_text  = list(
			aes(x = snpcr, y = Inf, label = snpcr),
			colour="red", angle=90, vjust = 1.2, hjust = 1.2
		)
	),
	devpars = devpars
)
{% endif %}

library(philentropy)
{{rimport}}('__init__.r')

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
inopts  = {{args.inopts | R}}
method  = {{args.method | R}}
transfm = {{args.transfm | R}}
na      = {{args.na | R}}

indata = read.table.inopts(infile, inopts)
indata[is.na(indata)] = na

d = distance(indata, method = method, test.na = F)
if (transfm != FALSE) {
	ma = max(d)
	mi = min(d)
	scaled = 1 - (d-mi) / (ma-mi)
	if (transfm == 'scale') {
		d = scaled
	} else if (transfm == 'similarity' || transfm == 'sim') {
		d = 1 - scaled
	}
}
rownames(d) = rownames(indata)
colnames(d) = rownames(indata)
write.table(round(d, 3), outfile, col.names = TRUE, row.names = TRUE, sep = "\t", quote = F)

{{rimport}}('plot.r', '__init__.r')

infile   = {{i.infile | quote}}
outfile  = {{o.outfile | quote}}
fccut    = {{args.fccut | R}}
pcut     = {{args.pvalcut | R}}
usep     = {{args.usepval | R}}
hilights = {{args.hilights | R}}
devpars  = {{args.devpars | R}}
ggs      = {{args.ggs | R}}

indata = read.table.inopts(infile, list(rnames = TRUE, cnames = TRUE))
cnames = c()
for (cname in colnames(indata)) {
	cname_to_check = tolower(gsub("[^[:alnum:] ]", "", cname))
	if (cname_to_check %in% c("logfc", "log2fc", "logfoldchange", "log2foldchange")) {
		cnames = c(cnames, "logFC")
	} else if (usep && (cname_to_check %in% c("p", "pvalue", "pval"))) {
		cnames = c(cnames, "FDR")
	} else if (!usep && (cname_to_check %in% c("q", "qvalue", "qval", "fdr", "adjpval", "adjpvalue"))) {
		cnames = c(cnames, "FDR")
	} else {
		cnames = c(cnames, cname)
	}
}
colnames(indata) = cnames

plot.volplot(indata, outfile, fccut, pcut, ggs = ggs, devpars = devpars)

{{rimport}}('__init__.r')
library(QuantumClone)
library(vcfR)
options(stringsAsFactors = FALSE)

vfvcfs   = {{i.vfvcfs | R}}
outdir   = {{o.outdir | quote}}
params   = {{args.params | R}}
vfsamcol = {{args.vfsamcol | R}}
varcount = {{args.varcount | :a if a else 'NULL'}}
nthread  = {{args.nthread | R}}
if (!is.function(varcount)){
	varcount = function(fmt) as.integer(unlist(strsplit(fmt$AD, ","))[2])
}
varWithInfo = length(formals(varcount)) > 1

makeSample = function(fmt, sam) {
	# fmt = DP:FDP:SDP:SUBDP:AU:CU:GU:TU
	# sam = 2:0:0:0:0,0:2,3:0,0:0,0	2:0:0:0:2,2:0,0:0,0:0,0
	ns = unlist(strsplit(fmt, ":", fixed = TRUE))
	sm = unlist(strsplit(sam, ":", fixed = TRUE))
	as.list(setNames(sm, ns))
}

makeInfo = function(vari) {
	# SOMATIC;QSS=2;TQSS=1;NT=ref;QSS_NT=2;TQSS_NT=1;SGT=CC->CC;DP=5;MQ=38.23;MQ0=0;ReadPosRankSum=0.00;SNVSB=0.00;SomaticEVS=1.50
	do.call(c, lapply(unlist(strsplit(as.character(vari), ';', fixed = TRUE)), function(x) {
		ret = list()
		if (!grepl('=', x)) {
			ret[[x]] = TRUE
		} else {
			parts = unlist(regmatches(x, regexpr("=", x), invert = TRUE))
			ret[[ parts[1] ]] = parts[2]
		}
		ret
	}))
}

vcf2vaf = function(vcffile) {
	vcf = read.vcfR(vcffile)
	# vcf@gt
	# FORMAT	NORMAL	TUMOR
	# DP:FDP:SDP:SUBDP:AU:CU:GU:TU	2:0:0:0:0,0:2,3:0,0:0,0	2:0:0:0:2,2:0,0:0,0:0,0
	# DP:FDP:SDP:SUBDP:AU:CU:GU:TU	2:0:0:0:0,0:0,0:2,2:0,0	2:0:0:0:2,2:0,0:0,0:0,0
	vaf = data.frame(
		SampleName = character(),
		Chr        = character(),
		Start      = integer(),
		Depth      = integer(),
		Alt        = integer(),
		Genotype   = character()
	)
	samname = colnames(vcf@gt)[vfsamcol + 1]
	for (i in 1:nrow(vcf@gt)) {
		sample = makeSample(vcf@gt[i, "FORMAT"], vcf@gt[i, vfsamcol + 1])
		tryCatch({
			if (varWithInfo) {
				vari = makeInfo(vcf@fix[i, "INFO"])
				varc = varcount(sample, vari)
			} else {
				varc = varcount(sample)
			}
		}, error = function(e) {
			logger('Unable to get AD of variant ', vcf@fix[i, "CHROM"], ':', vcf@fix[i, "POS"], level = 'WARNING')
			varc = NULL
		})
		if (!is.list(varc)) {
			varc = list(count = varc)
		}
		if (is.null(varc$count)) 
			next
		varc$count = as.numeric(varc$count)
		varc$depth = as.numeric(list.get(varc, 'depth', as.numeric(sample$DP)))
		if (sample$GT == '.') {
			logger('Unknown genotype, use AB instead for', vcf@fix[i, "CHROM"], ':', vcf@fix[i, "POS"], level = 'WARNING')
			varGt = 'AB'
		} else {
			gt1 = as.integer(substr(sample$GT, 1, 1))
			gt2 = as.integer(substr(sample$GT, nchar(sample$GT), nchar(sample$GT)))
			if (gt1 + gt2 == 0) {
				varGt = 'AA'
			} else if (gt1 + gt2 == 2) {
				varGt = 'BB'
			} else {varGt = 'AB'}
		}
		vaf        = rbind(vaf, list(
			SampleName = samname,
			Chr        = vcf@fix[i, "CHROM"],
			Start      = as.numeric(vcf@fix[i, "POS"]),
			Depth      = as.numeric(varc$depth),
			Alt        = as.numeric(varc$count),
			Genotype   = varGt
		))
	}
	rownames(vaf) = NULL
	vaf[complete.cases(vaf),,drop = FALSE]
}

# prepare input data
indata = list()
for (vfvcf in vfvcfs) {
	indata = c(indata, list(vcf2vaf(vfvcf)))
}

output = One_step_clustering(
	indata, 
	contamination    = rep(0, length(vfvcfs)),
	output_directory = outdir
)

{{rimport}}('__init__.r')

infile  = {{i.infile | quote}}
outfile = {{o.outfile | quote}}
outdir  = {{o.outdir | quote}}
inopts  = {{args.inopts | R}}
plotman = {{args.plot | R}}
ggs     = {{args.ggs | R}}
params  = {{args.params | R}}
devpars = {{args.devpars | R}}
hifile  = {{args.hifile | R}}
hilabel = {{args.hilabel | R}}

library(coloc)
options(stringsAsFactors = FALSE)

indata = read.table.inopts(infile, inopts)
snps   = indata[,4]
nsnps  = nrow(indata)
ret = coloc.abf(
	dataset1 = list(pvalues = indata[, 8], snp = snps, N = nsnps, type = "quant"),
	dataset2 = list(pvalues = indata[, 9], snp = snps, N = nsnps, type = "quant"),
	MAF      = indata[, 7]
)
write.table(as.data.frame(ret$summary), outfile, col.names = FALSE, sep = "\t", quote = FALSE)
detailfile = file.path(outdir, 'coloc.details.txt')
write.table(ret$results, detailfile, sep = "\t", quote = FALSE, row.names = FALSE)

if (!plotman) 
	q(save = FALSE)

{{rimport}}('plot.r')

library(ggrepel)
# assign regions
nbins   = 10
minpos  = min(indata[,3])
maxpos  = max(indata[,3])
binsize = (maxpos - minpos) / nbins
bits    = round(log10(binsize))
nbits   = binsize/10 ** bits
binsize = round(nbits * 4) / 4 * 10 ** bits
nbins   = ceiling((maxpos - minpos)/binsize)
start   = as.integer(minpos / binsize + 1) * binsize 
glabels = seq(start, maxpos, binsize)
gbreaks = glabels - minpos
glabels = sapply(glabels, function(x) {
	if (x < 1000) {
		return(x)
	} else if (x < 1000000) {
		return(paste0(x/1000, 'K'))
	} else {
		return(paste0(x/1000000, 'M'))
	}
})

if (is.true(colnames(indata))) {
	phenotypes = colnames(indata)[8:9]
} else {
	phenotypes = c('Phenotype1', 'Phenotype2')
}
data1 = data.frame(X = indata[,3] - min(indata[,3]) + 1, Y = -log10(indata[, 8]), Group = phenotypes[1])
data2 = data.frame(X = data1$X, Y = -log10(indata[, 9]), Group = phenotypes[2])
data  = rbind(data1, data2)
rm(data1)
rm(data2)

hidata = list()
if (hifile != '') {
	# possible # columns:
	# 1: snp
	# 2: snp, color
	# 3: chr, start, end
	# 4: chr, start, end, color
	hidata = read.table(hifile, header = FALSE, row.names = NULL, sep = "\t", quote = '"', check.names = FALSE)
	hincol = ncol(hidata)
	if (hincol == 1) {
		colnames(hidata) = 'snps'
	} else if (hincol == 2) {
		colnames(hidata) = c('snps', 'color')
	} else if (hincol == 3) {
		colnames(hidata) = c('chr', 'start', 'end')
	} else {
		colnames(hidata)[1:4] = c('chr', 'start', 'end', 'color')
	}
	hidata = apply(hidata, 1, as.list)
}

ggs_hilight = list()
hinames = names(hidata)
if (!is.null(hinames)) {
	hidata = list(hidata)
}
hdata = NULL
for (hilight in hidata) {
	if ('snps' %in% names(hilight)) {
		hdata_tmp = data[Snp %in% hilight$snps]
		hdata = ifelse(is.null(hdata), hdata_tmp, rbind(hdata, hdata_tmp))
		rm(hdata_tmp)
	} else if ('chr' %in% names(hilight)) {
		hdata_tmp = data[Chr == hilight$chr & Pos >= as.numeric(hilight$start) & Pos <= as.numeric(hilight$end)]
		hdata = ifelse(is.null(hdata), hdata_tmp, rbind(hdata, hdata_tmp))
		rm(hdata_tmp)
	} else {
		stop('Either "snps" or "chr" needed to locate the snps to be highlighted.')
	}
}
if (!is.null(hdata)) {
	hicolor = ifelse(is.null(hilight$color), "red", hilight$color)
	ggs_hilabel = list()
	if (hilabel) {
		ggs_hilabel = list(geom_label_repel = list(aes_string(x = 'X', y = 'Y', label = 'Snp'), color = "white", fill = hicolor, data = hdata, inherit.aes = FALSE, alpha = .8))
	}
	ggs_hilight = c(
		ggs_hilight, 
		ggs_hilabel,
		list(geom_point = list(aes_string(x = 'X', y = 'Y'), color = hicolor, data = hdata, inherit.aes = FALSE))
	)
}
ggs = c(list(
	geom_vline         = list(xintercept = gbreaks, color = '#DEDEDE', size = .3),
	expand_limits      = list(y = c(0, max(data[, 'Y']) * 1.05)),
	geom_point         = list(aes_string(color = 'Group'), alpha = .8),
	scale_y_continuous = list(expand = c(0, 0)),
	scale_x_continuous = list(expand = expand_scale(mult = c(0.01, 0.01)), label = glabels, breaks= gbreaks),
	theme_bw           = list(),
	theme              = list(
		panel.grid.minor   = element_blank(),
		panel.grid.major.x = element_blank(),
		axis.text.x        = element_text(angle = 90, hjust = 1, vjust = 0.5)
	),
	labs               = list(x = "", y = "-log10(p-value)")
	), ggs_hilight, ggs)
plotfile = file.path(outdir, 'coloc.man.png')
plot.scatter (data, plotfile, x = 'X', y = 'Y', params = list(aes_string(color = "Group")), ggs = ggs, devpars = devpars)

{{rimport}}('__init__.r')
options(stringsAsFactors = FALSE)
library(sciClone)
library(vcfR)

mutfile = {{i.vfvcfs | R}}
cnvfile = {{i.cnvcfs | R}}
outdir  = {{o.outdir | quote}}
params  = {{args.params | R}}
exfile  = {{args.exfile | quote}}
mutctrl = {{args.mutctrl | R}}
cnctrl  = {{args.mutctrl | R}}





vfsamcol = {{args.vfsamcol | R}}
cnsamcol = {{args.cnsamcol | R}}
varcount = {{args.varcount | :a if a else 'NULL'}}
cncount  = {{args.cncount | :a if a else 'NULL'}}
if (!is.function(varcount)){
	varcount = function(fmt) as.integer(unlist(strsplit(fmt$AD, ","))[2])
}
if (!is.function(cncount)) {
	cncount = function(fmt) fmt$CN
}
varWithInfo = length(formals(varcount)) > 1
cnWithInfo  = length(formals(cncount)) > 1

if (length(vfvcfs) > 2) {
	stop('No more than 2 samples supported at this moment.')
}

if (length(cnvcfs) > 0 && length(cnvcfs) != length(vfvcfs)) {
	stop('Unequal # copy number data and the input vcf files.')
}

makeSample = function(fmt, sam) {
	# fmt = DP:FDP:SDP:SUBDP:AU:CU:GU:TU
	# sam = 2:0:0:0:0,0:2,3:0,0:0,0	2:0:0:0:2,2:0,0:0,0:0,0
	ns = unlist(strsplit(fmt, ":", fixed = TRUE))
	sm = unlist(strsplit(sam, ":", fixed = TRUE))
	as.list(setNames(sm, ns))
}

makeInfo = function(vari) {
	# SOMATIC;QSS=2;TQSS=1;NT=ref;QSS_NT=2;TQSS_NT=1;SGT=CC->CC;DP=5;MQ=38.23;MQ0=0;ReadPosRankSum=0.00;SNVSB=0.00;SomaticEVS=1.50
	do.call(c, lapply(unlist(strsplit(as.character(vari), ';', fixed = TRUE)), function(x) {
		ret = list()
		if (!grepl('=', x)) {
			ret[[x]] = TRUE
		} else {
			parts = unlist(regmatches(x, regexpr("=", x), invert = TRUE))
			ret[[ parts[1] ]] = parts[2]
		}
		ret
	}))
}

vcf2vaf = function(vcffile) {
	vcf = read.vcfR(vcffile)
	# vcf@gt
	# FORMAT	NORMAL	TUMOR
	# DP:FDP:SDP:SUBDP:AU:CU:GU:TU	2:0:0:0:0,0:2,3:0,0:0,0	2:0:0:0:2,2:0,0:0,0:0,0
	# DP:FDP:SDP:SUBDP:AU:CU:GU:TU	2:0:0:0:0,0:0,0:2,2:0,0	2:0:0:0:2,2:0,0:0,0:0,0
	vaf = data.frame(
		chr      = character(),
		start    = integer(),
		refCount = integer(),
		varCount = integer(),
		VAF      = double()
	)
	samname = colnames(vcf@gt)[vfsamcol + 1]
	for (i in 1:nrow(vcf@gt)) {
		sample = makeSample(vcf@gt[i, "FORMAT"], vcf@gt[i, vfsamcol + 1])
		if (varWithInfo) {
			vari = makeInfo(vcf@fix[i, "INFO"])
			varc = varcount(sample, vari)
		} else {
			varc = varcount(sample)
		}
		if (!is.list(varc)) {
			varc = list(count = varc)
		}
		if (is.null(varc$count)) 
			next
		varc$count = as.numeric(varc$count)
		varc$depth = as.numeric(list.get(varc, 'depth', as.numeric(sample$DP)))
		vaf        = rbind(vaf, list(
			chr      = vcf@fix[i, "CHROM"],
			start    = as.numeric(vcf@fix[i, "POS"]),
			refCount = as.numeric(varc$depth),
			varCount = as.numeric(varc$count),
			VAF      = 100.0*varc$count/varc$depth
		))
	}
	list(vaf = vaf, sample = samname)
}

vcf2cn = function(vcffile) {
	vcf = read.vcfR(vcffile)
	cn  = data.frame(
		chr    = character(),
		start  = integer(),
		stop   = integer(),
		probes = integer(),
		cn     = double()
	)
	#cnfile = file.path(outdir, paste0(vcf@gt[cnsamcol + 1], '.cn'))
	for (i in 1:nrow(vcf@gt)) {
		sample = makeSample(vcf@gt[i, "FORMAT"], vcf@gt[i, cnsamcol + 1])
		cninfo = makeInfo(vcf@fix[i, "INFO"])
		if (cnWithInfo) {
			cno    = cncount(sample, cninfo)
		} else {
			cno = cncount(sample)
		}
		if (!is.list(cno))
			cno = list(cn = cno)
		if (is.null(cno$cn))
			next
		cno$cn     = as.numeric(cno$cn)
		cno$end    = list.get(cno, 'end', cninfo$END)
		cno$probes = list.get(cno, 'probes', cninfo$PROBES)
		cn         = rbind(cn, list(
			chr    = vcf@fix[i, "CHROM"],
			start  = as.numeric(vcf@fix[i, "POS"]),
			stop   = as.numeric(cno$end),
			probes = as.numeric(cno$probes),
			cn     = cno$cn
		))
	}
	cn
}

if (nchar(exfile) > 0 && file.exists(exfile)) {
	exreg = read.table(exfile, header = FALSE, row.names = FALSE, sep = "\t", check.names = FALSE)
} else {
	exreg = NULL
}

vafsams = lapply(vfvcfs, vcf2vaf)
vafs = lapply(vafsams, function(x) x$vaf)
sams = unlist(lapply(vafsams, function(x) x$sample))
rm(vafsams)
if (length(cnvcfs) > 0) {
	cns = lapply(cnvcfs, vcf2cn)
} else {
	cns = NULL
}

params$vafs             = vafs
params$copyNumberCalls  = cns
params$sampleNames      = sams
params$regionsToExclude = exreg

sc = do.call(sciClone, params)
clustfile = file.path(outdir, paste0(paste(sams, collapse = '-'), '.cluster.txt'))
plotfile1 = file.path(outdir, paste0(paste(sams, collapse = '-'), '.plot1d.pdf'))
plotfile2 = file.path(outdir, paste0(paste(sams, collapse = '-'), '.plot2d.pdf'))
writeClusterTable(sc, clustfile)
sc.plot1d(sc, plotfile1)
if (length(sams) > 1) {
	sc.plot2d(sc, plotfile2)
}

{{rimport}}('__init__.r')

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
inunit  = {{args.inunit | R}}
outunit = {{args.outunit | R}}
meanfl  = {{args.meanfl | R}}
nreads  = {{args.nreads | R}}
refexon = {{args.refexon | R}}
inform  = {{args.inform | lambda x: 'NULL' if not x else x}}
outform = {{args.outform | lambda x: 'NULL' if not x else x}}

data    = read.table.inopts (infile, list(cnames = TRUE), dup = 'drop')
samples = colnames(data)
if (!is.null(inform)) {
	data = inform(data)
}

glenFromExon = function(exonfile, data) {
	gff  = read.table(exonfile, header = F, row.names = NULL)
	# V4: start, V5: end, V10: gene name
	glen = aggregate(V5-V4+1 ~ V10, gff, sum)
	genes = glen[,1]
	glen = glen[,-1,drop=F]
	rownames(glen) = genes

	mygenes  = rownames(data)
	outgenes = intersect(refgenes, mygenes)
	if (length(outgenes) < length(mygenes))
		logger('Genes not found in refexon: ', paste(setdiff(mygenes, outgenes), collapse = ','), level = 'WARNING')

	glen[outgenes, , drop = FALSE]
}

meanflFromFile = function(samples, mflfile) {
	if (is.numeric(mflfile)) {
		ret = matrix(mflfile, nrow = length(samples), ncol = 1)
		rownames(ret) = samples
	} else {
		ret = read.table(mflfile, header = F, row.names = 1, check.names = F, sep = "\t")
		ret = ret[samples,,drop = F]
	}
	ret
}

nreadsFromFile = function(samples, nreads) {
	if (is.numeric(nreads)) {
		ret = matrix(nreads, nrow = length(samples), ncol = 1)
		rownames(ret) = samples
	} else {
		ret = read.table(nreads, header = F, row.names = 1, check.names = F, sep = "\t")
		ret = ret[samples,,drop = F]
	}
	ret
}

count2cpm = function(data) {
	edgeR::cpm(data)
}

count2fpkm = function(data) {
	# may lose some genes
	glen = glenFromExon(refexon)
	data = data[rownames(glen), , drop = F]
	dge  = edgeR::DGEList(counts=data)

	dge$genes$Length = glen
	edgeR::rpkm(dge)
}

count2fpkmuq = function(data) {
	# may lose some genes
	glen = glenFromExon(refexon)
	data = data[rownames(glen), , drop = FALSE]

	fld  = meanflFromFile(samples, meanfl)
	expr = sapply(samples, function(s){
		RC75 = quantile(data[, s], .75)
		exp( log(data[, s]) + log(1e9) - log(glen - fld[s, ] + 1) - log(RC75) )
	})
	rownames(expr) = rownames(data)
	expr
}

count2tpm = function(data) {
	glen = glenFromExon(refexon)
	data = data[rownames(glen), , drop = F]
	fld  = meanflFromFile(samples, meanfl)

	# see: https://gist.github.com/slowkow/c6ab0348747f86e2748b
	expr     = sapply(samples, function(s){
		rate  = log(data[, s]) - log(glen - fld[s, ] + 1)
		denom = log(sum(exp(rate)))
		exp(rate - denom + log(1e6))
	})
	rownames(expr) = rownames(data)
	expr
}

count2tmm = function(data) {
	dge = edgeR::DGEList(counts=data)
	dge = edgeR::calcNormFactors(dge, method = "TMM")
	edgeR::cpm(dge)
}

fpkm2count = function(data) {
	glen    = glenFromExon(refexon)
	data    = data[rownames(glen), , drop = F]
	fld     = meanflFromFile(samples, meanfl)
	totalnr = nreadsFromFile(samples, nreads)

	expr    = sapply(samples, function(s){
		N = totalnr[s, ]
		exp( log(data[, s]) + log(N) + log(glen - fld[s, ] + 1) - log(1e9) )
	})
	rownames(expr) = rownames(data)
	expr
}

fpkm2tpm = function(data) {
	expr = sapply(samples, function(s) {
		exp( log(data[, s]) - log(sum(data[, s])) + log(1e6) )
	})
	rownames(expr) = rownames(data)
	expr
}

fpkm2cpm = function(data) {
	glen = glenFromExon(refexon)
	data = data[rownames(glen), , drop = F]
	expr = sapply(samples, function(s) {
		exp( log(data[, s]) - log(1e3) - log(glen - fld[s, ] + 1) )
	})
	rownames(expr) = rownames(data)
	expr
}

tpm2count = function(data) {
	totalnr = nreadsFromFile(samples, nreads)
	ngenes  = nrow(data)

	expr     = sapply(samples, function(s){
		# counts to tpm:
		# rate <- log(counts) - log(effLen)
		# denom <- log(sum(exp(rate)))
		# tpm = exp(rate - denom + log(1e6))
		# so:
		# log(tpm) = rate - denom + log(1e6)
		# rate = log(tpm) + denom - log(1e6)
		# log(counts) - log(effLen) = log(tpm) + log(sum(exp(rate))) - log(1e6)
		# log(counts) - log(effLen) = log(tpm) + log(sum(exp(log(counts) - log(effLen)))) - log(1e6)
		# log(counts) - log(effLen) = log(tpm) + log(sum(exp(log(counts))/exp(log(effLen)))) - log(1e6)
		# log(counts) - log(effLen) = log(tpm) + log(sum(counts/effLen)) - log(1e6)
		#                                                ?????????????
		# ??? estimated by sum(counts)/sum(effLen) * length(effLen)
		# log(counts) = log(effLen) + log(tpm) + log(sum(counts)) - log(effLen) + log(length(effLen))) - log(1e6)
		# counts = expr( log(tpm) + log(nreads) + log(length(effLen)) - log(1e6) )
		exp( log(data[, s]) + log(totalnr[s, ]) + log(ngenes) - log(1e6) )
	})
	rownames(expr) = rownames(data)
	expr
}

tpm2fpkm = function(data) {
	totalnr = nreadsFromFile(samples, nreads)
	expr = sapply(samples, function(s) {
		exp( log(data[, s]) - log(1e6) + log(totalnr[s, ]) )
	})
	rownames(expr) = rownames(data)
	expr
}

tpm2cpm = function(data) {
	glen   = glenFromExon(refexon)
	data   = data[rownames(glen), , drop = F]
	fld    = meanflFromFile(samples, meanfl)
	ngenes = length(outgenes)

	expr = sapply(samples, function(s) {
		exp( log(data[, s]) + log(glen - fld[s, ] + 1) - log(sum(glen - fld[s, ] + 1)) + log(ngenes) )
	})
	rownames(expr) = rownames(data)
	expr
}

cpm2count = function(data) {
	totalnr = nreadsFromFile(samples, nreads)

	expr = sapply(samples, function(s) {
		exp( log(data[, s]) + log(totalnr[s, ]) - log(1e6) )
	})
	rownames(expr) = rownames(data)
	expr
}

cpm2fpkm = function(data) {
	glen = glenFromExon(refexon)
	data = data[rownames(glen), , drop = F]
	expr = sapply(samples, function(s) {
		exp( log(data[, s]) + log(1e3) - log(glen - fld[s, ] + 1) )
	})
	rownames(expr) = rownames(data)
	expr
}

cpm2tpm = function(data) {
	glen   = glenFromExon(refexon)
	data   = data[rownames(glen), , drop = F]
	ngenes = nrow(glen)
	expr   = sapply(samples, function(s) {
		exp( log(data[, s]) - log(glen - fld[s, ] + 1) - log(sum(glen - fld[s, ] + 1)) + log(ngenes) )
	})
	rownames(expr) = rownames(data)
	expr
}

is.count  = function(unit) {unit %in% c('count', 'counts', 'rawcount', 'rawcounts')}
is.cpm    = function(unit) {unit == 'cpm'}
is.fpkm   = function(unit) {unit %in% c('fpkm', 'rpkm')}
is.fpkmuq = function(unit) {unit %in% c('fpkmuq', 'rpkmuq', 'fpkm-uq', 'rpkm-uq')}
is.tpm    = function(unit) {unit == 'tpm'}
is.tmm    = function(unit) {unit == 'tmm'}


convert = function(data, inunit, outunit) {
	if (is.count(inunit) && is.cpm(outunit))
		return (count2cpm(data))
	if (is.count(inunit) && is.fpkm(outunit))
		return (count2fpkm(data))
	if (is.count(inunit) && is.fpkmuq(outunit))
		return (count2fpkmuq(data))
	if (is.count(inunit) && is.tpm(outunit))
		return (count2tpm(data))
	if (is.count(inunit) && is.tmm(outunit))
		return (count2tmm(data))
	if (is.fpkm(inunit) && is.count(outunit))
		return (fpkm2count(data))
	if (is.fpkm(inunit) && is.tpm(outunit))
		return (fpkm2tpm(data))
	if (is.fpkm(inunit) && is.cpm(outunit))
		return (fpkm2cpm(data))
	if (is.tpm(inunit) && is.count(outunit))
		return (tpm2count(data))
	if (is.tpm(inunit) && is.fpkm(outunit))
		return (tpm2fpkm(data))
	if (is.tpm(inunit) && is.cpm(outunit))
		return (tpm2cpm(data))
	if (is.cpm(inunit) && is.count(outunit))
		return (cpm2count(data))
	if (is.cpm(inunit) && is.fpkm(outunit))
		return (cpm2fpkm(data))
	if (is.cpm(inunit) && is.tpm(outunit))
		return (cpm2tpm(data))
	stop(paste('Unsupported conversion from', inunit, 'to', outunit, '.'))
}

expr = convert(data, inunit, outunit)
if (!is.null(outform)) {
	expr = outform(expr)
}

write.table(round(expr, 3), outfile, quote=FALSE, row.names=TRUE, col.names=TRUE, sep="\t")

library(reshape2)
{{rimport}}('__init__.r', 'plot.r')

infile       = {{i.infile | quote}}
outdir       = {{o.outdir | quote}}
outfile      = {{o.outfile | quote}}
byrow        = {{args.byrow | R}}
inopts       = {{args.inopts | R}}
doplot       = {{args.plot | R}}
pval         = {{args.pval | R}}
method       = {{args.method | quote}}
outfmt       = {{args.outfmt | quote}}
params       = {{args.params | R}}
devpars      = {{args.devpars | R}}
plotfile     = {{o.outfile | prefix | @append: ".png" | quote}}
pvalfile     = {{o.outfile | prefix | @append: ".pval.txt" | quote}}
outpairfile  = {{o.outfile | prefix | @append: ".pairs.txt" | quote}}
outmatfile   = {{o.outfile | prefix | @append: ".mat.txt" | quote}}
pvalpairfile = {{o.outfile | prefix | @append: ".pval.pairs.txt" | quote}}
pvalmatfile  = {{o.outfile | prefix | @append: ".pval.mat.txt" | quote}}
groupfile    = {{i.groupfile | R}}
if (is.false(groupfile)) {
	groupfile = {{args.groupfile | R}}
}

data = read.table.inopts(infile, inopts)
if (byrow) data = t(data)

if (is.true(groupfile)) {
	if (file.exists(groupfile)) {
		groupdata = read.table(groupfile, row.names = NULL, col.names = FALSE)
		groups = levels(as.factor(groupdata[, 2]))
		if (length(groups) != 2) {
			stop("Only 2 groups allowed!")
		}
		group1 = groupdata[groupdata[,2] == groups[1], 1, drop = TRUE]
		group2 = groupdata[groupdata[,2] == groups[2], 1, drop = TRUE]
	} else { # group variable assigned directly
		groups = unlist(strsplit(groupfile, ";", fixed = TRUE))
		if (length(groups) != 2) {
			stop("Only 2 groups allowed!")
		}
		group1 = unlist(strsplit(groups[1], ",", fixed = TRUE))
		group2 = unlist(strsplit(groups[2], ",", fixed = TRUE))
	}
} else {
	group1 = colnames(data)
	group2 = group1
}
corrmat = matrix(NA, ncol = length(group2), nrow = length(group1))
pvalmat = matrix(NA, ncol = length(group2), nrow = length(group1))
rownames(corrmat) = group1
colnames(corrmat) = group2
rownames(pvalmat) = group1
colnames(pvalmat) = group2

if (pval) {
	for (v1 in group1) {
		for (v2 in group2) {
			corr = cor.test(data[, v1], data[, v2], method = method)
			corrmat[v1, v2] = corr$estimate
			corrmat[v2, v1] = corr$estimate
			pvalmat[v1, v2] = corr$p.value
			pvalmat[v2, v1] = corr$p.value
		}
	}
	write.table(pvalmat, pvalmatfile, row.names = T, col.names = T, quote = F, sep = "\t")
	ppairs = melt(pvalmat, na.rm = T)
	write.table(ppairs, pvalpairfile, row.names = F, col.names = F, quote = F, sep = "\t")
} else {
	corrmat = cor(data[, group1, drop = FALSE], data[, group2, drop = FALSE], method = method, use = "na.or.complete")
}
write.table(corrmat, outmatfile, row.names = T, col.names = T, quote = F, sep = "\t")
cpairs = melt(corrmat, na.rm = T)
write.table(cpairs, outpairfile, row.names = F, col.names = F, quote = F, sep = "\t")

if (outfmt == 'matrix') {
	file.symlink(outmatfile, outfile)
	if(pval) file.symlink(pvalmatfile, pvalfile)
} else {
	file.symlink(outpairfile, outfile)
	if(pval) file.symlink(pvalpairfile, pvalfile)
}

if (doplot) {
	col_fun = circlize::colorRamp2(c(-1, 0, 1), c("blue", "white", "red"))
	plot.heatmap2(corrmat, plotfile = plotfile, params = c(list(
		col                  = col_fun,
		cluster_rows         = FALSE,
		cluster_columns      = FALSE,
		row_names_side       = "left",
		column_names_side    = "top",
		column_names_rot     = 60,
		heatmap_legend_param = list(title = "Correlation")), params
	), devpars = devpars)
}

{{rimport}}('__init__.r', 'plot.r')
options(stringsAsFactors = FALSE)

infile  = {{ i.infile | quote}}
outfile = {{ o.outfile | quote}}
inopts  = {{ args.inopts | R}}
devpars = {{ args.devpars | R}}
ggs     = {{ args.ggs | R}}
params  = {{ args.params | R}}

indata = read.table.inopts(infile, inopts)

plot.qq(
	indata, 
	plotfile = outfile,
	x        = ifelse(ncol(indata) == 1, NULL, 1),
	y        = ifelse(ncol(indata) == 1, 1, 2),
	stacked  = TRUE,
	params   = params,
	ggs      = ggs,
	devpars  = devpars
)

{{rimport}}('__init__.r', 'plot.r')
library(ComplexHeatmap)

infile    = {{i.infile | R}}
outfile   = {{o.outfile | R}}
outdir    = {{o.outdir | R}}
hmfile    = {{o.outfile | prefix | @append: ".rds" | quote}}
rcfile    = {{o.outfile | prefix | @append: ".rowclusters.xls" | quote}}
ccfile    = {{o.outfile | prefix | @append: ".colclusters.xls" | quote}}
inopts    = {{args.inopts | R}}
devpars   = {{args.devpars | R}}
anopts    = {{args.anopts | R}}
saveinfo  = {{args.saveinfo | R}}
annofiles = {{i.annofiles | R}}
seed      = {{args.seed | R}}
set.seed(seed)

data = read.table.inopts(infile, inopts)
annos = list()
for (annofile in annofiles) {
	annos = c(annos, list(read.table.inopts(annofile, anopts)))
}
if (length(annos) == 1) {
	annos = annos[[1]]
}
eval(parse(text = {{args.helper | repr}}))
params    = {{args.params | R}}
drawps    = {{args.draw | R}}

hm = plot.heatmap2(data, 'return', params = params, draw = drawps, devpars = devpars)
do.call(png, c(list(filename=outfile), devpars))
do.call(ComplexHeatmap::draw, c(list(hm), drawps))
dev.off()

if (saveinfo) {
	saveRDS(hm, hmfile)

	# export clusters
	ro = row_order(hm)
	# if no split, treat the whole as one cluster
	if (!is.list(ro)) ro = list(ro)
	if (is.null(names(ro))) {
		names(ro) = paste0('C', 1:length(ro))
	}
	rn_orig = rownames(data)
	if (is.null(rn_orig)) {
		rn_orig = 1:nrow(data)
	}
	rclines = c()
	for (clname in names(ro)) {
		rclines = c(
			rclines,
			paste("# Cluster:", clname, ', Size:', length(ro[[clname]])),
			paste(rn_orig[ ro[[clname]] ], collapse = ", ")
		)
	}
	rc_conn = file(rcfile)
	writeLines(rclines, rc_conn)
	close(rc_conn)

	co = column_order(hm)
	# if no split, treat the whole as one cluster
	if (!is.list(co)) co = list(co)
	if (is.null(names(co))) {
		names(co) = paste0('C', 1:length(co))
	}
	cn_orig = colnames(data)
	if (is.null(cn_orig)) {
		cn_orig = 1:nrow(data)
	}
	cclines = c()
	for (clname in names(co)) {
		cclines = c(
			cclines,
			paste("# Cluster:", clname, ', Size:', length(co[[clname]])),
			paste(cn_orig[ co[[clname]] ], collapse = ", ")
		)
	}
	cc_conn = file(ccfile)
	writeLines(cclines, cc_conn)
	close(cc_conn)
}

{{rimport}}('plot.r', 'sampleinfo.r')

library(methods)
library(simpleaffy)

indir     = {{i.indir | R}}
saminfo   = {{i.sifile | R}}
pattern   = {{args.pattern | R}}
norm      = {{args.norm | R}}
cdffile   = {{args.cdffile | R}}
outfile   = {{o.outfile | R}}
celdir    = file.path({{job.outdir | quote}}, 'CELs')
prefix    = {{i.indir, args.pattern | *dirpat2name | R}}
transfm   = {{args.transfm | lambda x: x or 'NULL'}}
fn2sample = Vectorize({{args.fn2sample}})

dir.create(celdir, showWarnings = TRUE, recursive = TRUE)
setwd(celdir)
files = Sys.glob(file.path(indir, pattern))
for (celfile in files) {
	tryCatch({
		file.link(celfile, file.path(celdir, basename(celfile)))
	}, error = function(e){
		file.copy(celfile, file.path(celdir, basename(celfile)), overwrite = TRUE)
	}, warning = function(w){
		file.copy(celfile, file.path(celdir, basename(celfile)), overwrite = TRUE)
	})
}

files = basename(files)
samples = fn2sample(files)

gfile = "covdesc.txt"
if (saminfo == '') {
	# generate a covdesc file
	group = matrix(1, ncol = 1, nrow = length(files))
	colnames(group) = c("treatment")
	rownames(group) = files
	write.table(group, gfile, quote = F, sep = "\t")
} else {
	sampleinfo = SampleInfo(saminfo)$dataframe()
	group = matrix(NA, ncol = 1, nrow = length(files))
	colnames(group) = c("treatment")
	rownames(group) = files
	for (i in 1:length(files)) {
		group[files[i], "treatment"] = sampleinfo$Group[which(rownames(sampleinfo) == samples[i])]
	}
	write.table(group, gfile, quote = F, sep = "\t")
}

affydata = read.affy(covdesc = gfile)
if (cdffile != '') {
  library(makecdfenv)
  cdfname = cleancdfname(whatcdf(files[1]))
  assign(cdfname, make.cdf.env(basename(cdffile), cdf.path = dirname(cdffile)))
  affydata@cdfName = cdfname
}
exprs    = call.exprs(affydata, algorithm = norm, do.log = TRUE)
exprsout = exprs@assayData$exprs
colnames(exprsout) = fn2sample(colnames(exprsout))

if (!is.null(transfm)) exprsout = transfm(exprsout)
write.table(round(exprsout, 3), outfile, quote=F, sep="\t")

library(methods)
library(filelock)
library(reticulate)
bioprocs = import('bioprocs')
source(file.path(bioprocs$UTILS, '__init__.r'))

getkw = function (kwargs, key, default) {
	kwnames = names(kwargs)
	if (!key %in% kwnames) {
		value = default
	} else {
		value = kwargs[[key]]
		kwargs[[key]] = NULL
	}
	ret = list(kwargs = kwargs)
	ret[[key]] = value
	return (ret)
}

wait = function (func, ...) {
	ret = getkw(as.list(match.call()), 'interval', .1)
	ret$kwargs$func = NULL
	ret$kwargs[[1]] = NULL
	env = parent.frame()
	ret$kwargs = lapply(ret$kwargs, function(row) eval(row, envir = env))
	while (do.call(func, ret$kwargs)) {
		Sys.sleep(ret$interval)
	}
}

Poll = function (workdir, joblen, jobindex) {
	poll = list()
	poll$workdir  = workdir
	poll$joblen   = joblen
	poll$jobindex = jobindex

	poll$first    = function(todo, ...) {
		ret = getkw(as.list(match.call()), 'lockfile', 'poll.first.lock')
		ret$kwargs$todo = NULL
		ret$kwargs[[1]] = NULL
		lockfilename = file.path(workdir, '1', 'output', ret$lockfile)
		if (jobindex == 0) {
			lockfile = lock(lockfilename)
			if (is.function(todo)) {
				do.call(todo, ret$kwargs)
			} else {
				cmd = do.call(sprintf, c(list(todo), ret$kwargs))
				runcmd(cmd)
			}
		}
	}

	poll$non1st    = function(todo, ...) {
		ret = getkw(as.list(match.call()), 'lockfile', 'poll.non1st.lock')
		ret$kwargs$todo = NULL
		ret$kwargs[[1]] = NULL
		lockfilenames = sapply(1:joblen, function (x) file.path(workdir, x, 'output', ret$lockfile))
		if (jobindex == 0) {
			for (i in 1:joblen) {
				if (i == 1) next
				wait(function(x) !file.exists(x), lockfilenames[i])
				unlock(lock(lockfilenames[i]))
			}
		} else {
			lockfile = lock(lockfilenames[jobindex + 1])
			if (is.function(todo)) {
				do.call(todo, ret$kwargs)
			} else {
				cmd = do.call(sprintf, c(list(todo), ret$kwargs))
				runcmd(cmd)
			}
			unlock(lockfile)
		}
	}

	poll$all = function(todo, ...) {
		ret = getkw(as.list(match.call()), 'lockfile', 'poll.all.lock')
		ret$kwargs$todo = NULL
		ret$kwargs[[1]] = NULL
		lockfilenames = sapply(1:joblen, function (x) file.path(workdir, x, 'output', ret$lockfile))
		lockfile = lock(lockfilenames[jobindex + 1])
		if (is.function(todo)) {
			do.call(todo, ret$kwargs)
		} else {
			cmd = do.call(sprintf, c(list(todo), ret$kwargs))
			runcmd(cmd)
		}
		unlock(lockfile)
		for (i in 1:joblen) {
			if (i == jobindex + 1) next
			wait(function(x) !file.exists(x), lockfilenames[i])
			unlock(lock(lockfilenames[i]))
		}
	}

	return(poll)

}

library(methods)
library(preprocessCore)
{{rimport}}('__init__.r')

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
inopts  = {{args.inopts | R}}

indata = read.table.inopts(infile, inopts)
rnames = ifelse(inopts$rnames, rownames(indata), NULL)
cnames = ifelse(inopts$cnames, colnames(indata), NULL)

indata = normalize.quantiles(as.matrix(indata))
if (!is.null(rnames)) rownames(indata) = rnames
if (!is.null(cnames)) colnames(indata) = cnames

write.table(indata, outfile, col.names = inopts$cnames, row.names = inopts$rnames, sep = "\t", quote = F)

normW   = {{args.normW | R}}
normE   = {{args.normE | R}}

W = read.table ({{i.Wfile | quote}}, sep="\t", header=T, row.names=1, check.names=F, strip.white=T)
W = as.matrix(W)

if (normW) {
	library(NetPreProc)
	W = abs(W)
	W = Laplacian.norm(W)
}

E = read.table ({{i.Efile | quote}}, header=F, row.names=1, check.names=F, strip.white=T)
E = as.matrix(E)
E = E[colnames(W), ]

RWR = function (W, e, c = {{args.c}}, eps = {{args.eps}}, tmax={{args.niter}}) {
	r0 = e
	for (i in 1:tmax) {
		r1 = ((1-c) * W) %*% r0 + c * e
		diff = norm (r1 - r0, 'f')
		if (diff < eps) break
		r0 = r1
	}

	return (list(r=r1, eps=diff, tmax=i))
}

r = RWR (W, E)
print (paste("eps: ", r$eps))
print (paste("tmax:", r$tmax))

write.table (round(r$r, 3), {{o.outfile | quote}}, quote=F, col.names=F, row.names = T, sep="\t")

{{rimport}}('__init__.r')

infiles  = {{i.infiles | R}}
outfile  = {{o.outfile | R}}
params   = {{args.params | R}}
na       = {{args.na | R}}
fn2cname = {{args.fn2cname}}
fill     = as.logical({{args.fill | R}})
{% assign inopts = {} %}
{% for key, val in args.inopts.items() %}
	{% if isinstance(val, list) %}
		{% if len(val) == 1 %}
			{% python inopts[key] = val * len(i.infiles) %}
		{% else %}
			{% python inopts[key] = val %}
		{% endif %}
	{% else %}
		{% python inopts[key] = [val] * len(i.infiles) %}
	{% endif %}
{% endfor %}
inopts = {{inopts | R}}

mats = list()
for (i in 1:length(infiles)) {
	inparams = c(list(
		file      = infiles[i],
		header    = ifelse(is.null(inopts$cnames[i]), T, as.logical(inopts$cnames[i])),
		row.names = ifelse(is.null(inopts$rnames[i]) || inopts$rnames[i], 1, NULL),
		sep       = ifelse(is.null(inopts$delimit[i]), "\t", inopts$delimit[i]),
		skip      = ifelse(is.null(inopts$skip[i]), 0, inopts$skip[i])
	), params)
	mats[[i]]  = do.call(read.table, inparams)

	if (!inparams$header && !is.null(fn2cname)) {
		cname = fn2cname(tools::file_path_sans_ext(basename(infiles[i])))
		#if (ncol(mats[[i]]) == 1)
		#	colnames(mats[[i]]) = cname
		#else
		#	colnames(mats[[i]]) = paste(cname, 1:ncol(mats[[i]]), sep='_c')
		colnames(mats[[i]]) = cname
	}
}
mat = ifelse(fill, do.call(cbind.fill, mats), do.call(cbind, mats))
mat[is.na(mat)] = na

outparams = list(
	x         = mat,
	file      = outfile,
	sep       = '\t',
	quote     = F,
	col.names = T,
	row.names = ifelse(is.null(inopts$rnames[1]), T, as.logical(inopts$rnames[1]))
)
do.call(write.table, outparams)

{{rimport}}('__init__.r', 'plot.r')
options(stringsAsFactors = TRUE)

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
inopts  = {{args.inopts | R }}
devpars = {{args.devpars | R}}
params  = {{args.params | R}}
ggs     = {{args.ggs | R}}

indata = read.table.inopts(infile, inopts)
plot.pairs(indata, outfile, params = params, ggs = ggs, devpars = devpars)

{{rimport}}('__init__.r', 'plot.r')
options(stringsAsFactors = FALSE)

infile  = {{ i.infile | quote}}
hifile  = {{ i.hifile | quote}}
outfile = {{ o.outfile | quote}}
inopts  = {{ args.inopts | R}}
devpars = {{ args.devpars | R}}
hilabel = {{ args.hilabel | R}}
ggs     = {{ args.ggs | R}}
# chr1	249250621
# chr2	243199373
# chr3	198022430
# chr4	191154276
gsfile  = {{ args.gsize | R }}

# A bed file with last column the p-value and region (8 columns)
# Use region to color the snps if the snps are from the same chromosome
# chr, start, end, name, score, strand, pvalue, region
indata = read.table.inopts(infile, inopts)
pdata = data.frame(Snp = indata[,4], Chr = indata[,1], Pos = indata[,3], P = indata[,7])
if (ncol(indata) > 7)
	pdata$Region = indata[,8]

hidata = list()
if (hifile != '') {
	# possible # columns:
	# 1: snp
	# 2: snp, color
	# 3: chr, start, end
	# 4: chr, start, end, color
	hidata = read.table(hifile, header = FALSE, row.names = NULL, sep = "\t", quote = '"', check.names = FALSE)
	hincol = ncol(hidata)
	if (hincol == 1) {
		colnames(hidata) = 'snps'
	} else if (hincol == 2) {
		colnames(hidata) = c('snps', 'color')
	} else if (hincol == 3) {
		colnames(hidata) = c('chr', 'start', 'end')
	} else {
		colnames(hidata)[1:4] = c('chr', 'start', 'end', 'color')
	}
	hidata = apply(hidata, 1, as.list)
}
if (!is.null(gsfile) && gsfile != "" && file.exists(gsfile)) {
	gsize = read.table.inopts(gsfile, list(rnames = TRUE, cnames = FALSE))
} else {
	gsize = NULL
}
plot.man(pdata, plotfile = outfile, hilights = hidata, hilabel = hilabel, gsize = gsize, ggs = ggs, devpars = devpars)

library(methods)
{{rimport}}('__init__.r', 'plot.r')

indir  = {{i.indir | R}}
outdir = {{o.outdir | R}}

plink   = {{args.plink | R}}
cutoff  = {{args.cutoff | R}}
devpars = {{args.devpars | R}}

bedfile = Sys.glob(file.path(indir, '*.bed'))
input   = tools::file_path_sans_ext(bedfile)
output  = file.path(outdir, basename(input))

params = list(
	bfile = input,
	hardy = T,
	out   = output
)
cmd = sprintf("%s %s 1>&2", plink, cmdargs(params, equal = ' '))
runcmd(cmd)

hardy = read.table(paste0(output, '.hwe'), header = T, row.names = NULL, check.names = F)
hardy.fail = hardy[which(hardy$P < cutoff), 'SNP', drop = F]
write.table(hardy.fail, paste0(output, '.hardy.fail'), col.names = F, row.names = F, sep = "\t", quote = F)

{% if args.plot %}
hardy$Pval   = -log10(hardy$P)
hardy$Status = "Pass"
hardy[which(hardy$SNP %in% hardy.fail$SNP), "Status"] = "Fail"

plot.histo(
	data     = hardy,
	x        = 'Pval',
	plotfile = paste0(output, '.hardy.png'),
	params   = list(aes(fill=Status), bins = 50),
	ggs      = list(
		xlab       = list("-log10(HWE p-value)"),
		ylab       = list("Count"),
		geom_vline = list(xintercept = -log10(cutoff), color = "red", linetype="dashed"),
		theme      = list(legend.position = "none"),
		geom_text  = list(
			aes(x = -log10(cutoff), y = Inf, label = cutoff),
			colour="red", angle=90, vjust = 1.2, hjust = 1.2
		)
	),
	devpars = devpars
)
{% endif %}

data = read.table ({{i.infile | quote}}, sep="\t", header={{args.cnames | R}}, row.names={{args.rnames | lambda x: 'NULL' if not x else int(x)}}, check.names=F)
if ({{args.transpose | R}}) {
	data = t(data)
}
data = data[, apply(data, 2, sd)!=0, drop=F]

dmat = dist(data)
if ({{args.fast | R}}) {
	library('fastcluster')
}
orderfile = file.path ({{o.outdir | quote}}, "order.txt")
mergefile = file.path ({{o.outdir | quote}}, "merge.txt")
clustfig  = file.path ({{o.outdir | quote}}, "hclust.png")
hobj = hclust (dmat, method={{args.method | quote}})

do.call(png, c(list(file = clustfig), {{args.devpars | Rlist}}))
library('ggplot2')
library('ggdendro')
ggdendrogram (hobj, rotate={{args.rotate | R}})
dev.off()
orderobj = data.frame (Order=hobj$order, Labels=hobj$labels)
mergeobj = data.frame (Merge1=hobj$merge[,1], Merge2=hobj$merge[,2], Height=hobj$height)
write.table (orderobj, orderfile, quote=F, row.names=F, col.names = T, sep="\t")
write.table (mergeobj, mergefile, quote=F, row.names=F, col.names = T, sep="\t")

{{rimport}}('__init__.r')

infile       = {{i.infile | quote}}
outmodel     = {{o.outmodel | quote}}
outdir       = {{o.outdir | quote}}
args.plot    = {{args.plot | R}}
args.formula = {{args.formula | R}}
inopts       = {{args.inopts | R}}
params       = {{args.params | R}}
ggs          = {{args.ggs | R}}
devpars      = {{args.devpars | R}}
prefix       = {{i.infile | stem | quote}}
yval         = {{args.yval | quote}}

indata = read.table.inopts(infile, inopts)

cnames = colnames(indata)
if (is.null(cnames)) {
	colnames(indata) = c(paste('X', 1:(ncol(indata)-1)), 'Y')
	cnames = colnames(indata)
}

if (is.null(args.formula)) {
	ycol = cnames[ncol(indata)]
	args.formula = as.formula(paste(
		cnames[ncol(indata)], '~',
		paste(bQuote(cnames[1:(ncol(indata)-1)]),
		collapse = '+')))
} else {
	args.formula = as.formula(args.formula)
	ycol = all.vars(args.formula)[1]
}

if (yval == 'categ') {
	ylabs   = levels(as.factor(indata[, ycol]))
	ylevels = order(ylabs)
	ymin    = min(ylevels)
	ymax    = max(ylevels)
	indata[, ycol] = (match(indata[, ycol], ylabs) - ymin)/(ymax - ymin)
	model.fit = do.call(glm, c(list(args.formula, data = indata), params))
	model.fit$ylabs   = ylabs
} else if (yval == 'numeric') {
	ymin = min(indata[, ycol])
	ymax = max(indata[, ycol])
	indata[, ycol] = (indata[, ycol] - ymin) / (ymax - ymin)
	model.fit = do.call(glm, c(list(args.formula, data = indata), params))
}
model.fit$ymin = ymin
model.fit$ymax = ymax
model.fit$yval = yval
model.fit$ycol = ycol

saveRDS(model.fit, outmodel)

model.fit.sum = summary(model.fit)
ret = model.fit.sum$coefficients

OR = as.matrix(coef(model.fit))
colnames(OR) = 'OR'
ret = cbind(ret, exp(OR))
ret[, 1:3] = round(ret[, 1:3], 3)
ret[, 4] = formatC(ret[, 4], format = "E", digits = 2)

tryCatch({
	# confident interval
	conf.int = confint(model.fit)
	colnames(conf.int) = c('ci_95_1', 'ci_95_2')
	ret = cbind(ret, exp(cont.int))
}, error = function(e) {})

rownames(ret) = nobQuote(rownames(ret))
write.table(ret,
	file.path(outdir, paste0(prefix, '.features.txt')),
	row.names = TRUE,
	col.names = TRUE,
	sep = "\t",
	quote = FALSE)

{% if args.plot %}
{{rimport}}('plot.r')
plotfile = file.path(outdir, paste0(prefix, '.glm.png'))
featdata = model.fit$model[, -1, drop = F]
# what about categorical features
numcols = unlist(lapply(featdata, is.numeric))

plotdata = cbind(
	model.fit$model[, 1, drop=F],
	apply(featdata[, numcols, drop = FALSE], 1, sum))
colnames(plotdata) = c(
	ycol,
	ifelse(ncol(model.fit$model) > 2,
		'Features',
		colnames(model.fit$model)[ncol(model.fit$model)]))

plot.scatter(plotdata, plotfile, x = 2, y = 1, ggs = ggs, devpars = devpars)
{% endif %}

library(methods)
library(mediation)
library(parallel)
{{rimport}}('__init__.r')
options(stringsAsFactors = FALSE)
set.seed(8525)

# inputs/outputs/arguments
infile   = {{i.infile | R}}
case0    = {{i.infile | fn2 | R}}
outfile  = {{o.outfile | R}}
outdir   = {{o.outdir | R}}
casefile = {{i.casefile | R}}
argscase = {{args.case | R}}
covfile  = {{args.cov | R}}
medopts  = {{args.medopts | R}}
inopts   = {{args.inopts | R}}
plotmed  = {{args.plot | R}}
pval     = {{args.pval | R}}
dofdr    = {{args.fdr | R}}
devpars  = {{args.devpars | R}}
nthread  = {{args.nthread | R}}

if (!is.list(plotmed) && plotmed == T) plotmed = list()
if (dofdr == T) dofdr = 'BH'

indata = read.table.inopts(infile, inopts)
if (casefile != "") {
	csdata = read.table(casefile, header = T, row.names = NULL, sep = "\t", check.names = F)
	colnames(csdata) = c('Case', 'Model', 'Fmula')
} else {
	if ('model' %in% names(argscase)) {
		argscase = list(argscase)
		names(argscase) = case0
	}
	csdata = as.data.frame(t(sapply(names(argscase), function(r) list(Case = r, Model = argscase[[r]]$model, Fmula = argscase[[r]]$fmula))))
}

covs = c()
if (covfile != '') {
	covdata = read.table(covfile, header = T, row.names = 1, sep = "\t", check.names = F)
	covs    = paste(bQuote(colnames(covdata)), collapse = '+')
	indata  = cbind(indata, covdata[rownames(indata)])
}

medanalysis = function(i) {
	tryCatch({
		# Case, Model, Fmula
		row = csdata[i,,drop = FALSE]
		logger('Dealing with case:', row$Case, '...')
		if (grepl(',', row$Model, fixed = TRUE)) {
			models = trimws(unlist(strsplit(row$Model, ',', fixed = T)))
			modelm = match.fun(models[2])
			modely = match.fun(models[1])
		} else {
			modelm = match.fun(row$Model)
			modely = match.fun(row$Model)
		}
		vars     = all.vars(as.formula(row$Fmula))
		outcome  = vars[1]
		treat    = vars[2]
		mediator = vars[3]
		fmulam   = as.formula(sprintf('%s ~ %s', bQuote(mediator), bQuote(treat)))
		fmulay   = as.formula(sprintf('%s ~ %s + %s', bQuote(outcome), bQuote(mediator), bQuote(treat)))
		if (length(covs) > 0) {
			fmulam = update.formula(fmulam, paste('. ~ +', covs))
			fmulay = update.formula(fmulay, paste('. ~ +', covs))
		}
		mm  = modelm(fmulam, data = indata)
		my  = modely(fmulay, data = indata)
		med = mediate(mm, my, treat = treat, mediator = mediator, outcome = outcome, boot = medopts$boot, sims = medopts$sims)
		if (is.na(med$d1.p) || is.na(med$n1)) {
			NULL
		} else {
			if (is.list(plotmed) && med$d1.p < pval && med$n1 > 0) {
				do.call(png, c(list(file.path(outdir, paste0(case, '.png'))), devpars))
				do.call(plot.mediate, c(list(med), plotmed))
				dev.off()
			}
			data.frame(
				Case      = row$Case,
				ACME      = med$d1,
				ACME95CI1 = med$d1.ci[1],
				ACME95CI2 = med$d1.ci[2],
				TotalE    = med$tau.coef,
				ADE       = med$z1,
				PropMed   = med$n1,
				Pval      = med$d1.p
			)
		}
	}, error = function(e) {
		logger(row$Case, ':', e, level = 'ERROR')
		NULL
	})
}

ret = do.call(rbind, mclapply(1:nrow(csdata), medanalysis, mc.cores = nthread))

if (is.null(ret)) {
	ret = data.frame(
		Case             = character(),
		ACME             = double(),
		ACME95CI1        = double(),
		ACME95CI2        = double(),
		TotalE           = double(),
		ADE              = double(),
		PropMed          = double(),
		Pval             = double()
	)
}

if (dofdr != F && nrow(ret) > 0) {
	ret$Qval = p.adjust(ret$Pval, method = dofdr)
}
if (nrow(ret)>0) {
	ret = ret[ret$Pval < pval & ret$PropMed > 0,,drop=F]
}

write.table(pretty.numbers(ret, list(ACME..ACME95CI1..ACME95CI2..PropMed..TotalE..ADE = '%.3f', Pval..Qval = '%.2E')), outfile, col.names = T, row.names = F, sep = "\t", quote = F)

# /**
# * Calculate p-value of hypergeometric test
# * $k : overlop number
# * $m : set 1 size
# * $n : set 2 size
# * $N : background size
# *               C(m,k) * C(N-m, n-k)
# * log(P) = log[----------------------]
# *                   C(N, n)
# *               m!/(k!(m-k)!) * (N-m)!/(n-k)!(N-m-n+k)!)
# *        = log[------------------------------------------]
# *                          N!/(n!(N-n)!)
# *        =   logfact(m) + logfact(N-m) + logfact(n) + logfact(N-n)
# *          - logfact(k) - logfact(m-k) - logfact(n-k) - logfact(N-m-n+k) - logfact(N)
# */
{{rimport}}('__init__.r')
library(methods)

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
intype  = {{args.intype | R}}
N       = {{args.N | R}}
inopts  = update.list(list(rnames=T, cnames=T), {{args.inopts | R}})


ret    = matrix(nrow = 0, ncol = 5)
colnames(ret) = c('k', 'm', 'n', 'N', 'pval')

if (intype == 'raw') {
	rn     = if (inopts$rnames) 1 else NULL
	data   = read.table(infile, row.names = rn, header = inopts$cnames, sep = "\t", check.names = F)
	cnames = colnames(data)
	ncols  = ncol(data)
	if (is.null(N))
		N = nrow(data)
	if (ncols < 2)
		stop ('Need at least 2 columns.') 
	if (!inopts$cnames) {
		cnames = paste0("COL", 1:ncols)
		colnames(data) = cnames
	}
	for (i in 1:(ncols-1)) {
		for (j in (i+1):ncols) {
			row       = list(k = NA, m = NA, n = NA, N = N, pval = NA)
			row$m     = sum(data[, i], na.rm = T)
			row$n     = sum(data[, j], na.rm = T)
			row$k     = nrow(data[which(data[, i] + data[, j] == 2), ])
			row$pval  = phyper(row$k, row$m, row$N-row$m, row$n, lower.tail = F)
			row.names = paste(cnames[i], 'vs', cnames[j], sep = '.')
			row       = as.data.frame(row)

			rownames(row) = row.names

			ret = rbind(ret, row)
		}
	}
} else {
	rn     = if (inopts$rnames) 1 else NULL
	data   = read.table(infile, row.names = rn, header = inopts$cnames, sep = "\t", check.names = F)
	cnames = colnames(data)
	ncols  = ncol(data)
	if (!inopts$cnames) {
		cnames = c('k', 'm', 'n', 'N')[1:ncols]
		colnames(data) = cnames
	}
	if (!'N' %in% cnames && is.null(N)) {
		stop('N is not specified neither in infile nor args.N.')
	}
	if (!'k' %in% cnames || !'m' %in% cnames || !'n' %in% cnames) {
		stop('Column k, m or n is missing.')
	}
	rnames = rownames(data)
	if (!inopts$rnames) {
		rnames = paste0('ROW', 1:nrow(data))
		rownames(data) = rnames
	}
	for (rname in rnames) {
		if ('N' %in% cnames) N = data[rname, 'N']
		row      = list(k = NA, m = NA, n = NA, N = N, pval = NA)
		row$m    = data[rname, 'm']
		row$n    = data[rname, 'n']
		row$k    = data[rname, 'k']
		row$pval = phyper(row$k, row$m, row$N-row$m, row$n, lower.tail = F)
		row      = as.data.frame(row)

		rownames(row) = rname
		ret = rbind(ret, row)
	}
}

write.table(
	pretty.numbers(ret, formats = list(pval = '%.2E')), 
	outfile, quote = F, row.names = T, col.names = T, sep = "\t"
)

{{rimport}}('__init__.r', 'plot.r')
library(maftools)

indir    = {{i.indir | quote}}
msdir    = {{i.msdir | quote}}
outdir   = {{o.outdir | quote}}
isTCGA   = {{args.isTCGA | R}}
extypes  = {{args.extypes | R}}
devpars  = {{args.devpars | R}}
plots    = {{args.plot | R}}
mtparams = {{args.params | R}}
ngenes   = {{args.ngenes | R}}
nthread  = {{args.nthread | R}}
genome   = {{args.genome | quote}}

setwd(outdir)
if (file.exists(indir) && dir.exists(indir)) {
	# you probably have multiple maf files
	maffiles = c(Sys.glob(file.path(indir, "*.maf")), Sys.glob(file.path(indir, "*.maf.gz")))

	if (length(maffiles) == 0) {
		stop('No maf files found in input directory!')
	}
	maffile  = maffiles[1]
	if (length(maffiles) > 1) {
		log2pyppl('You multiple MAF files in input directory, using the first one:', maffile, level = 'warning')
	}
} else if (file.exists(indir)) {
	maffile = indir
	indir = {{job.indir | quote}}
}

# get annotation file
annofiles = c(Sys.glob(file.path(indir, "*annot.tsv")), Sys.glob(file.path(indir, "*annotion.txt")))
if (length(annofiles) == 0) {
	annofile = NULL
} else {
	annofile  = annofiles[1]
	if (length(annofiles) > 1) {
		log2pyppl('You multiple annotation files in input directory, using the first one:', annofile, level = 'warning')
	}
}

# custom cnv data, see https://support.bioconductor.org/p/94113/
cntables = c(Sys.glob(file.path(indir, "*cnv.tsv")), Sys.glob(file.path(indir, "*cnv.txt")))
if (length(cntables) == 0) {
	cntable = NULL
} else {
	cntable  = cntables[1]
	if (length(cntables) > 1) {
		log2pyppl('You multiple cnTable files in input directory, using the first one:', cntable, level = 'warning')
	}
}

# Gistic cnv data
alllesions = Sys.glob(file.path(indir, 'all_lesions.conf_*.txt'))
if (length(alllesions) == 0) {
	alllesion = NULL
} else {
	alllesion  = alllesions[1]
	if (length(alllesions) > 1) {
		log2pyppl('You multiple all-lesion files in input directory, using the first one:', alllesion, level = 'warning')
	}
}

ampgenes = Sys.glob(file.path(indir, 'amp_genes.conf_*.txt'))
if (length(ampgenes) == 0) {
	ampgene = NULL
} else {
	ampgene  = ampgenes[1]
	if (length(ampgenes) > 1) {
		log2pyppl('You multiple amp-gene files in input directory, using the first one:', ampgene, level = 'warning')
	}
}

delgenes = Sys.glob(file.path(indir, 'del_genes.conf_*.txt'))
if (length(delgenes) == 0) {
	delgene = NULL
} else {
	delgene  = delgenes[1]
	if (length(delgenes) > 1) {
		log2pyppl('You multiple del-gene files in input directory, using the first one:', delgene, level = 'warning')
	}
}

gisscores = Sys.glob(file.path(indir, 'scores.gistic'))
if (length(gisscores) == 0) {
	gisscore = NULL
} else {
	gisscore  = gisscores[1]
}

# is gistic data complete?
hasGistic = FALSE
if (!is.null(alllesion) && !is.null(ampgene) && !is.null(delgene) && !is.null(gisscore)) {
	hasGistic = TRUE
	lamlGistic = readGistic(gisticAllLesionsFile = alllesion, gisticAmpGenesFile = ampgene, gisticDelGenesFile = delgene, gisticScoresFile = gisscore, isTCGA = isTCGA)
}

mafdata = read.table.inopts(maffile, list(cnames = TRUE, rnames = FALSE, fill = TRUE))
alltypes = levels(as.factor(mafdata$Variant_Classification))

laml = read.maf(
	maf                  = maffile,
	clinicalData         = annofile,
	gisticAllLesionsFile = alllesion,
	gisticAmpGenesFile   = ampgene,
	gisticDelGenesFile   = delgene,
	gisticScoresFile     = gisscore,
	cnTable              = cntable,
	isTCGA               = isTCGA,
	vc_nonSyn            = setdiff(alltypes, extypes)
)

genesum = getGeneSummary(laml)
samsum  = getSampleSummary(laml)
genes   = genesum$Hugo_Symbol[1:ngenes]
nsample = nrow(samsum)

if (is.true(msdir) && dir.exists(msdir)) {
	siggene = c(
		Sys.glob(file.path(msdir, '*sig_genes.txt.gz')), 
		Sys.glob(file.path(msdir, '*sig_genes.txt')))[1]
} else if (is.true(msdir) && file.exists(msdir)) {
	siggene = msdir
} else {
	siggene = NULL
}
if (!is.null(siggene)) {
	msdata = read.table.inopts(siggene, list(rnames = TRUE, cnames = TRUE))
	genes = rownames(msdata)[1:ngenes]
}

samples = samsum$Tumor_Sample_Barcode

devpars2       = devpars
devpars2$width = devpars2$width * 2
#### summary
if (plots$summary) {
	logger('## Plotting summary ...')
	summaryplot = file.path(outdir, 'summary.png')
	do.call(png, c(list(filename = summaryplot), devpars2))
	tryCatch({
		do.call(plotmafSummary, c(list(maf = laml), mtparams$summary))
	}, error = function(e) {
		log2pyppl('Failed to plot summary:', e, level = 'warning')
	})
	dev.off()
}

#### oncoplot
if (plots$oncoplot) {
	cat('## Plotting oncoplot ...\n')
	oncoplotfile = file.path(outdir, 'oncoplot.png')
	do.call(png, c(list(filename = oncoplotfile), devpars2))
	params = c(list(maf = laml), mtparams$oncoplot)
	if (!'top' %in% names(params) && !'genes' %in% names(params)){
		#params$top = ngenes
		params$genes = genes
	} else if ('top' %in% names(params)) {
		params$genes = genes[1:params$top]
	}

	if (!is.null(annofile)) {
		params$sortByAnnotation = TRUE
	}
	tryCatch({
		do.call(oncoplot, params)
	}, error = function(e) {
		log2pyppl('Failed to plot oncoplot:', e, level = 'warning')
	})
	dev.off()
}

#### oncostrip
if (plots$oncostrip) {
	logger('## Plotting oncostrip ...')
	oncostripfile = file.path(outdir, 'oncostrip.png')
	params        = mtparams$oncostrip
	params$maf    = laml
	if (!'genes' %in% names(params)) {
		params$genes = genes
	}
	do.call(png, c(list(filename = oncostripfile), devpars2))
	tryCatch({
		do.call(oncostrip, params)
	}, error = function(e) {
		log2pyppl('Failed to plot oncostrip:', e, level = 'warning')
	})
	dev.off()
}

#### titv
if (plots$titv) {
	logger('## Plotting titv ...')
	titvplot = file.path(outdir, 'titv.png')
	titvobj  = titv(maf = laml, plot = FALSE, useSyn = TRUE)
	params   = mtparams$titv
	params$res = titvobj
	do.call(png, c(list(filename = titvplot), devpars))
	tryCatch({
		do.call(plotTiTv, params)
	}, error = function(e) {
		log2pyppl('Failed to plot titv:', e, level = 'warning')
	})
	dev.off()
}

#### lollipop
if (plots$lollipop) {
	logger('## Plotting lollipops ...')

	params     = mtparams$lollipop
	params$maf = laml
	if ('genes' %in% names(params)) {
		if ('top' %in% names(params)) params$top = NULL
		lpgenes = params$genes
		params$genes = NULL
	} else if ('top' %in% names(params)) {
		lpgenes = genes[1:params$top]
		params$top = NULL
	} else {
		lpgenes = genes
	}

	lollipopPlotSingle = function(gene) {
		ps = params
		ps$gene = gene
		lpdir  = file.path(outdir, 'lollipops')
		dir.create(lpdir, showWarnings = F)
		lpplot = file.path(lpdir, paste0(ps$gene, '.lollipop.png'))
		do.call(png, c(list(filename = lpplot), devpars2))
		tryCatch({
			print(do.call(lollipopPlot, ps))
		}, error = function(e) {
			log2pyppl('Failed to plot lollipop for', gene, ':', e, level = 'warning')
		})
		dev.off()
	}

	if (nthread == 1) {
		for (gene in lpgenes) {
			lollipopPlotSingle(gene)
		}
	} else {
		library(doParallel)
		cl = makeCluster(nthread)
		registerDoParallel(cl)
		foreach(i=1:length(lpgenes), .verbose = T, .packages=c('maftools')) %dopar% {
			lollipopPlotSingle(lpgenes[i])
		}
		stopCluster(cl)
	}
}

#### cbsseg
if (plots$cbsseg) {
	logger('## Plotting cbsseg ...')
	params  = c(list(maf = laml), mtparams$cbsseg)
	sams    = ifelse (!'tsb' %in% names(params), samples, params$tsb)

	cbssegSingle = function(sam) {
		segfiles = c(
			Sys.glob(file.path(indir, paste0(sam, '*.seg.txt'))),
			Sys.glob(file.path(indir, paste0(gsub('-', '.', sam), '*.seg.txt'))),
			Sys.glob(file.path(indir, paste0(gsub('_', '.', sam), '*.seg.txt')))
		)
		if (length(segfiles) == 0) {
			logger('   No seg file found for sample:', sam ,', skip.')
		} else {
			segdir  = file.path(outdir, 'cbssegs')
			dir.create(segdir, showWarnings = F)
			segplot = file.path(segdir, paste0(sam, '.cbsseg.png'))
			do.call(png, c(list(filename = segplot), devpars2))
			tryCatch({
				do.call(plotCBSsegments, c(list(cbsFile = segfiles[1]), params))
			}, error = function(e) {
				log2pyppl('Failed to plot cbsseg:', e, level = 'warning')
			})
			dev.off()
		}
	}

	if (nthread == 1) {
		for (sam in sams) {
			cbssegSingle(sam)
		}
	} else {
		library(doParallel)
		cl = makeCluster(nthread)
		registerDoParallel(cl)
		foreach(i=1:length(sams), .verbose = T, .packages=c('maftools')) %dopar% {
			cbssegSingle(sams[i])
		}
		stopCluster(cl)
	}
}

#### rainfall
if (plots$rainfall) {
	logger('## Plotting rainfall ...')
	params = c(list(maf = laml), mtparams$rainfall)
	if ('tsb' %in% names(params)) {
		sams = params$tsb
		prams$tsb = NULL
	} else {
		sams = samples
	}

	rainfallSingle = function(sam) {
		rfdir  = file.path(outdir, 'rainfalls')
		dir.create(rfdir, showWarnings = F)
		rfplot = file.path(rfdir, paste0(sam, '.rainfall.png'))
		do.call(png, c(list(filename = rfplot), devpars2))
		tryCatch({
			print(do.call(rainfallPlot, c(list(tsb = sam), params)))
		}, error = function(e){
			if (!params$detectChangePoints) {
				log2pyppl('Failed to plot rainfall without detecting change points for sample:', sam, level = 'warning')
			} else {
				tryCatch({
					do.call(rainfallPlot, c(list(tsb = sam, detectChangePoints = F), params))
				}, error = function(e){
					log2pyppl('Failed to plot rainfall without detecting change points for sample', sam, e, level = 'warning')
				})
			}
		})
		dev.off()
	}
	if (nthread == 1) {
		for (sam in sams) {
			rainfallSingle(sam)
		}
	} else {
		library(doParallel)
		cl = makeCluster(nthread)
		registerDoParallel(cl)
		foreach(i=1:length(sams), .verbose = T, .packages=c('maftools')) %dopar% {
			rainfallSingle(sams[i])
		}
		stopCluster(cl)
	}
}

#### tcgacomp
if (plots$tcgacomp) {
	logger('## Plotting tcgacompare ...')
	tcgacompplot = file.path(outdir, 'tcgacomp.png')
	do.call(png, c(list(filename = tcgacompplot), devpars2))
	params = c(list(maf = laml), mtparams$tcgacomp)
	if (!'cohortName' %in% names(params)) {
		params$cohortName = unlist(strsplit(basename(maffile), '.', fixed = T))[1]
	}
	tryCatch({
		do.call(tcgaCompare, params)
	}, error = function(e){
		log2pyppl('Failed to plot tcgacomp:', e, level = 'warning')
	})
	dev.off()
}

#### vaf
if (plots$vaf) {
	logger('## Plotting vaf ...')
	params = c(list(maf = laml), mtparams$vaf)
	if (!'vafCol' %in% names(params)) {
		log2pyppl('No vafCol(args.params.vaf.vafCol) provided, skip plotting VAF.', level = 'warning')
	} else {
		vafplot = file.path(outdir, 'vaf.png')
		do.call(png, c(list(filename = vafplot), devpars))
		tryCatch({
			do.call(plotVaf, params)
		}, error = function(e){
			log2pyppl('Failed to plot vaf:', e, level = 'warning')
		})
		dev.off()
	}
}

#### genecloud
if (plots$genecloud) {
	logger('## Plotting genecloud ...')
	gcplot = file.path(outdir, 'genecloud.png')
	do.call(png, c(list(filename = gcplot), devpars))
	params = c(list(input = laml), mtparams$genecloud)
	tryCatch({
		do.call(geneCloud, params)
	}, error = function(e){
		log2pyppl('Failed to plot genecloud:', e, level = 'warning')
	})
	dev.off()
}


#### gisticGenome
if (plots$gisticGenome) {
	logger('## Plotting gisticGenome ... ')
	if (!hasGistic) {
		logger('   No gistic files found, skip')
	} else {
		gisgplot = file.path(outdir, 'gisticGenome.png')
		do.call(png, c(list(filename = gisgplot), devpars2))
		params = c(list(gistic = lamlGistic), mtparams$gisticGenome)
		tryCatch({
			do.call(gisticChromPlot, params)
		}, error = function(e){
			log2pyppl('Failed to plot gisticGenome:', e, level = 'warning')
		})
		dev.off()
	}
}

#### gisticBubble
if (plots$gisticBubble) {
	logger('## Plotting gisticBubble ...')
	if (!hasGistic) {
		logger('   No gistic files found, skip\n')
	} else {
		gisbplot = file.path(outdir, 'gisticBubble.png')
		do.call(png, c(list(filename = gisbplot), devpars))
		params = c(list(gistic = lamlGistic), mtparams$gisticBubble)
		tryCatch({
			do.call(gisticBubblePlot, params)
		}, error = function(e){
			log2pyppl('Failed to plot gisticBubble:', e, level = 'warning')
		})
		dev.off()
	}
}

#### gisticOncoplot
if (plots$gisticOncoplot) {
	logger('## Plotting gisticOncoplot ...')
	if (!hasGistic) {
		logger('   No gistic files found, skip')
	} else {
		gisoncoplotfile = file.path(outdir, 'gisticOncoplot.png')
		params = c(list(gistic = lamlGistic), mtparams$gisticOncoplot)
		if (!is.null(annofile)) {
			params$clinicalData     = getClinicalData(x = laml)
			params$sortByAnnotation = TRUE
			if (!'top' %in% names(params))
				params$top = ngenes
		}
		do.call(png, c(list(filename = gisoncoplotfile), devpars2))
		tryCatch({
			do.call(gisticOncoPlot, params)
		}, error = function(e) {
			if (is.null(annofile)) {
				log2pyppl('Cannot generate gisticOncoplot without clinic features, skip.', level = 'warning')
			} else {
				tryCatch({
					params$clinicalFeatures = NULL
					do.call(gisticOncoPlot, params)
				}, error = function(e) {
					log2pyppl('Failed to plot gisticOncoplot:', e, level = 'warning')
				})
			}
		})
		dev.off()
	}
}

#### somInteraction
if (plots$somInteraction) {
	logger('## Plotting somInteraction ...')
	somInteractionfile = file.path(outdir, 'somInteraction.png')
	params = c(list(maf = laml), mtparams$somInteraction)
	if (!'top' %in% names(params) && !'genes' %in% names(params)){
		#params$top = ngenes
		params$genes = genes
	} else if ('top' %in% names(params)) {
		params$genes = genes[1:params$top]
	}
	do.call(png, c(list(filename = somInteractionfile), devpars))
	tryCatch(
		{
			do.call(somaticInteractions, params)
		}, error = function(e) {
			log2pyppl('Failed to plot somaticInteractions:', e, level = 'warning')
		}
	)
	dev.off()
}

#### oncodrive
if (plots$oncodrive) {
	logger('## Plotting oncodrive ...')
	oncodrivefile = file.path(outdir, 'oncodrive.png')
	OcParams = list(maf = laml, AACol = NULL, minMut = 5, pvalMethod = "zscore",
					nBgGenes = 100, bgEstimate = TRUE, ignoreGenes = NULL)
	params = mtparams$oncodrive
	for (name in names(params)) {
		if (name %in% names(OcParams))
			OcParams[[name]] = params[[name]]
	}
	tryCatch(
		{
			sig = do.call(oncodrive, OcParams)

			PocParams = list(res = sig, fdrCutOff = 0.05, useFraction = FALSE,
							colCode = NULL) #, labelSize = 2) # plotOncodrive hangs with labelSize argument
			for (name in names(params)) {
				if (name %in% names(PocParams))
					PocParams[[name]] = params[[name]]
			}
			do.call(png, c(list(filename = oncodrivefile), devpars))
			do.call(plotOncodrive, PocParams)
			dev.off()
		}, error = function(e) {
			log2pyppl('Failed to plot oncodrive:', e, level = 'warning')
		}
	)
}

#### pfam
if (plots$pfam) {
	logger('## Plotting pfam ...')
	pfamfile = file.path(outdir, 'pfam.png')
	params = c(list(maf = laml), mtparams$pfam)
	if (!'top' %in% names(params))
		params$top = ngenes
	do.call(png, c(list(filename = pfamfile), devpars))
	tryCatch(
		{
			pfam = do.call(pfamDomains, params)
			pfsum = pfam$proteinSummary
			# add link to domains 
			pfsum$DomainLabel = sapply(
				pfsum$DomainLabel, 
				function(x) {sprintf("[%s](https://www.ncbi.nlm.nih.gov/cdd/?term=%s)", x, x)})
			write.table(
				pfsum[!is.na(pfsum$DomainLabel), 1:7, with=FALSE], 
				file.path(outdir, 'pfam.csv'),
				row.names = FALSE, col.names = TRUE, sep = ",", quote = FALSE)

		}, error = function(e) {
			log2pyppl('Failed to plot pfam:', e, level = 'warning')
		}
	)
	dev.off()
}

#### pancan
if (plots$pancan) {
	if (!is.null(siggene)) {
		params  = mtparams$pancan
		params$mutsigResults = siggene
		if (!'cohortName' %in% names(params)) {
			params$cohortName = unlist(strsplit(basename(maffile), '.', fixed = T))[1]
		}
		if (!'inputSampleSize ' %in% names(params)) {
			params$inputSampleSize  = nsample
		}
		pancanfile = file.path(outdir, 'pancan.png')
		do.call(png, c(list(filename = pancanfile), devpars))
		tryCatch({
			do.call(pancanComparison, params)
		}, error = function(e){
			log2pyppl('Failed to plot pancan:', e, level = 'warning')
		})
		dev.off()
	}
}

#### survival
if (plots$survival) {
cat('## Plotting survivals ...\n')

	params        = mtparams$survival
	params$maf    = laml
	params$isTCGA = isTCGA
	if (!'time' %in% names(params) || !'Status' %in% names(params)) {
		cat('-  No time/Status column specified for survival analysis!')
	} else {
		survivalSingle = function(gene) {
			ps = params
			ps$genes = gene
			svdir  = file.path(outdir, 'survivals')
			dir.create(svdir, showWarnings = F)
			svplot = file.path(svdir, paste0(ps$genes, '.survival.png'))
			do.call(png, c(list(filename = svplot), devpars))
			tryCatch({
				do.call(mafSurvival, ps)
			}, error = function(e){
				log2pyppl('Failed to plot survival for gene', gene, ':', e, level = 'warning')
			})
			dev.off()
		}
		if ('genes' %in% names(params)) {
			svgenes = params$genes
			params$genes = NULL
		} else {
			svgenes = genes
		}

		if (nthread == 1) {
			for (gene in svgenes) {
				survivalSingle(gene)
			}
		} else {
			library(doParallel)
			cl = makeCluster(nthread)
			registerDoParallel(cl)
			foreach(i=1:length(svgenes), .verbose = T, .packages=c('maftools')) %dopar% {
				survivalSingle(svgenes[i])
			}
			stopCluster(cl)
		}
	}
}

#### heterogeneity
if (plots$heterogeneity) {
	logger('## Plotting heterogeneity ...')
	if ('tsb' %in% names(params)) {
		sams = params$tsb
		params$tsb = NULL
	} else {
		sams = samples
	}

	ihParams = list(maf = laml, top = 5, vafCol = NULL,
	ignChr = NULL, minVaf = 0, maxVaf = 1,
	dirichlet = FALSE)

	params = mtparams$heterogeneity
	for (name in names(params)) {
		if (name %in% names(ihParams))
			ihParams[[name]] = params[[name]]
	}

	PocParams = list(genes = NULL, showCNvars = FALSE,
	savePlot = FALSE, width = 6, height = 5, colors = NULL)
	for (name in names(params)) {
		if (name %in% names(PocParams))
			PocParams[[name]] = params[[name]]
	}

	if (is.null(ihParams$vafCol)) {
		log2pyppl('No vafCol(args.params.heterogeneity.vafCol) provided, skip plotting heterogeneity.', level = 'warning')
	} else {
		heteroSingle = function(sam) {
			segfiles = c(
				Sys.glob(file.path(indir, paste0(sam, '*.seg.txt'))),
				Sys.glob(file.path(indir, paste0(gsub('-', '.', sam), '*.seg.txt'))),
				Sys.glob(file.path(indir, paste0(gsub('_', '.', sam), '*.seg.txt')))
			)
			tryCatch({
				if (length(segfiles) == 0) {
					hetero = do.call(inferHeterogeneity, c(list(tsb = sam), ihParams))
				} else {
					hetero = do.call(inferHeterogeneity, c(list(tsb = sam, segFile = segfiles[1]), ihParams))
				}
				hgdir  = file.path(outdir, 'heterogeneities')
				dir.create(hgdir, showWarnings = F)
				heterogeneityfile = file.path(hgdir, paste0(sam, '.heterogeneity.png'))
				do.call(png, c(list(filename = heterogeneityfile), devpars))
				do.call(plotClusters, c(list(clusters = hetero, tsb = sam), PocParams))
				dev.off()
			}, error = function(e) {
				log2pyppl('Failed to plot heterogeneity for sample', sam, ':', e, level = 'warning')
			})
		}

		if (nthread == 1) {
			for (sam in sams) {
				heteroSingle(sam)
			}
		} else {
			library(doParallel)
			cl = makeCluster(nthread)
			registerDoParallel(cl)
			foreach(i=1:length(sams), .verbose = T, .packages=c('maftools')) %dopar% {
				heteroSingle(sams[i])
			}
			stopCluster(cl)
		}
	}
}

#### signature
if (plots$signature) {
	logger('## Plotting signature ...')
	require('NMF')
	params = mtparams$signature
	tmParams = list(prefix = '', add = TRUE, ignoreChr = NULL, useSyn = TRUE, fn = NULL)
	for (name in names(params)) {
		if (name %in% names(tmParams)) {
			tmParams[[name]] = params[[name]]
			params  [[name]] = NULL
		}
	}
	tmParams$ref_genome = paste0('BSgenome.Hsapiens.UCSC.', genome)
	tmParams$maf = laml
	tryCatch({
		tm = do.call(trinucleotideMatrix, tmParams)
	}, error = function(e){
		tmParams$add <<- FALSE
		tryCatch({
			tm <<- do.call(trinucleotideMatrix, tmParams)
		}, error = function(e){
			tmParams$prefix = NULL
			tm <<- do.call(trinucleotideMatrix, tmParams)
		})
	})
	# apobec
	apobecfile = file.path(outdir, 'apobec.png')
	do.call(png, c(list(filename = apobecfile), devpars))
	tryCatch(
		{
			plotApobecDiff(tnm = tm, maf = laml)
		}, error = function(e) {
			log2pyppl('Failed to plot apobec signature:', e, level = 'warning')
		}
	)
	dev.off()

	# sigs
	sgParams = list(n = NULL, nTry = 6, pConstant = 1, plotBestFitRes = FALSE, parallel = NULL)
	for (name in names(params)) {
		if (name %in% names(sgParams)) {
			sgParams[[name]] = params[[name]]
			params  [[name]] = NULL
		}
	}
	sgParams$mat = tm
	tryCatch({
		cophenfile = file.path(outdir, 'signature-cophen.png')
		do.call(png, c(list(filename = cophenfile), devpars))
		dev.off()
		sigs  = do.call(extractSignatures, sgParams)
		sigfile = file.path(outdir, 'signature.png')
		do.call(png, c(list(filename = sigfile), devpars))
		plotSignatures(sigs)
		dev.off()
		# cosine similarity against validated signatures
		plot.heatmap(sigs$coSineSimMat, file.path(outdir, 'signature-sim.png'), devpars = devpars, params = list(dendro = 'col'))
		# signature contrib
		sigcfile = file.path(outdir, 'signature-contrib.png')
		do.call(png, c(list(filename = sigcfile), devpars))
		plotSignatures(nmfRes = sigs, contributions = TRUE)
		dev.off()
	}, error = function(e) {
		log2pyppl('Failed to plot extract signatures:', e, level = 'warning')
	})


}

#library (Gviz)
region = unlist(strsplit({{i.region | quote}}, ':', fixed = T))
chrom  = region[1]
region = unlist(strsplit(region[2], '-', fixed = T))
start  = as.numeric(region[1])
end    = as.numeric(region[2])
params = list(
	genome     = {{args.genome | quote}},
	chromosome = chrom,
	from       = start,
	to         = end,
	name       = {{i.name | quote}},
	trackType  = {{i.trackType | quote}},
	track      = {{i.track | quote}}
)
params = c(params, {{args.params | Rlist}})

ret = list()
ret$trackType = 'UcscTrack'
ret$trackParams = params

saveRDS (ret, {{o.outfile | quote}})

library(methods)
{{rimport}}('__init__.r')

indir  = {{i.indir | R}}
pdir   = {{i.pdir | R}}
outdir = {{o.outdir | R}}
plink  = {{args.plink | R}}

bedfile = Sys.glob(file.path(indir, '*.bed'))
input   = tools::file_path_sans_ext(bedfile)
output  = file.path(outdir, basename(input))

if (dir.exists(pdir)) {
	fails = Sys.glob(file.path(pdir, '*.fail'))
} else {
	fails = pdir
}

isSampleFail = function(fail) {
	endsWith(fail, '.samplecr.fail') ||
	endsWith(fail, '.het.fail') ||
	endsWith(fail, '.ibd.fail') ||
	endsWith(fail, '.sex.fail')
}

isSNPFail = function(fail) {
	endsWith(fail, '.snpcr.fail') ||
	endsWith(fail, '.hwe.fail') ||
	endsWith(fail, '.mingt.fail') ||
	endsWith(fail, '.freq.fail') ||
	endsWith(fail, '.hardy.fail')
}

for (i in c('.bed', '.bim', '.fam'))
	file.symlink(paste0(input, i), paste0(output, i))

for (fail in fails) {
	if (isSampleFail(fail)) {
		params = list(
			bfile      = output,
			remove     = fail,
			out        = output,
			`make-bed` = T
		)
		cmd = sprintf("%s %s 1>&2", plink, cmdargs(params, equal = ' '))
		runcmd(cmd)
	} else if (isSNPFail(fail)) {
		params = list(
			bfile      = output,
			exclude    = fail,
			out        = output,
			`make-bed` = T
		)
		cmd = sprintf("%s %s 1>&2", plink, cmdargs(params, equal = ' '))
		runcmd(cmd)
	}
}

for (f in Sys.glob(paste0(output, '.*~')))
	file.remove(f)

{{rimport}}('__init__.r')
options(stringsAsFactors = FALSE)

infile    = {{i.infile | quote}}
fmfile    = {{i.fmfile | quote}}
casefile  = {{i.casefile | quote}}
outfile   = {{o.outfile | quote}}
outdir    = {{o.outdir | quote}}
inopts    = {{args.inopts | R}}
args.plot = {{args.plot | R}}
covfile   = {{args.cov | R}}
devpars   = {{args.devpars | R}}
yval      = {{args.yval | R}}
glmfam    = {{args.glmfam}}
savemodel = {{args.save | R}}

regressone = function(idata, model, fmula, covs, case) {
	logger('Handing case:', case, '...')
	model = as.character(model)
	mdl   = eval(parse(text = model))
	ycol  = trimws(unlist(strsplit(fmula, "~", fixed = T))[1])
	ycol  = gsub('^`|`$', '', ycol)
	if (yval == 'categ') {
		ylabs   = levels(as.factor(idata[, ycol]))
		if (length(ylabs) < 2) 
			stop('Require more than 1 levels for categorical Y values in case ', case)
		ylevels = order(ylabs)
		ymin    = min(ylevels)
		ymax    = max(ylevels)
		idata[, ycol] = (match(idata[, ycol], ylabs) - ymin)/(ymax - ymin)
	} else {
		ymin = min(idata[, ycol], na.rm = T)
		ymax = max(idata[, ycol], na.rm = T)
		idata[, ycol] = (idata[, ycol] - ymin) / (ymax - ymin)
	}
	fml  = ifelse(
		is.null(covs), 
		as.character(fmula), 
		paste(c(as.character(fmula), sapply(covs, bQuote)), collapse = ' + ')
	)
	m = ifelse(
		model == 'glm', 
		mdl(as.formula(fml), data = idata, family = glmfam), 
		mdl(as.formula(fml), data = idata)
	)
	if (args.plot) {
		do.call(png, c(list(file.path(outdir, paste0(case, '.png'))), devpars))
		layout(matrix(1:4, ncol = 2))
		plot(m, pch = 20)
		dev.off()
	}
	m$ycol = ycol
	m$ymin = ymin
	m$ymax = ymax
	if (yval == 'categ') m$ylabs = ylabs
	if (savemodel)
		saveRDS(m, file.path(outdir, paste(case, model, 'rds', sep = '.')))
	ret = summary(m)$coefficients
	terms = rownames(ret)
	nterm = length(terms)
	cbind(Case = rep(case, nterm), Model = rep(model, nterm), Term = terms, ret)
}

indata = read.table.inopts(infile, inopts)
insts  = rownames(indata)
covs   = NULL
if (covfile!='') {
	covdata = read.table(covfile, header = T, row.names = 1, sep = "\t", check.names = F)
	covs    = colnames(covdata)
	indata  = cbind(indata, covdata[insts,,drop=F])
}

fmdata = read.table(fmfile, header = F, row.names = NULL, sep = "\t", check.names = F)
if (ncol(fmdata) < 3) 
	fmdata = cbind(Case = paste0('Case', 1:nrow(fmdata)), fmdata, stringsAsFactors = F)

casedata = NULL
if (casefile != '')
	casedata = read.table(casefile, header = F, row.names = NULL, sep = "\t", check.names = F)

cases = fmdata[,1]
out = data.frame(
	Case     = character(),
	Model    = character(),
	Term     = character(),
	Estimate = double(),
	StdError = double(),
	Stat     = double(),
	Pval     = double()
)
for (case in cases) {
	cdata = ifelse(
		is.null(casedata), 
		indata, 
		indata[casedata[which(casedata[,2]==case), 1],,drop=F])
	fdata = fmdata[which(fmdata[,1] == case),,drop=T]
	ret = regressone(cdata, fdata[[2]], fdata[[3]], covs, case)
	colnames(ret) = colnames(out)
	out = rbind(out, ret)
}
colnames(out) = c('Case', 'Model', 'Term', 'Estimate', 'StdError', 'Stat', 'Pval')

write.table(pretty.numbers(
	out, list(Estimate..StdError..Stat = '%.3f', Pval = '%.2E')
), outfile, row.names = F, col.names = T, sep = "\t", quote = F)

{{rimport}}('__init__.r', 'plot.r')

library(ggplot2) # make aes available

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
inopts  = {{args.inopts | R}}
devpars = {{args.devpars | R}}
params  = {{args.params | R}}
ggs     = {{args.ggs | R}}
x       = {{args.x | R}}
y       = {{args.y | R}}
stacked = {{args.stacked | R}}

inopts$file        = infile
inopts$header      = inopts$cnames
inopts$cnames      = NULL
inopts$sep         = inopts$delimit
inopts$delimit     = NULL
inopts$check.names = F

rnames = inopts$rnames
inopts$rnames = NULL

inopts = c(inopts, list(row.names = if(rnames) 1 else NULL))
data   = read.table.inopts(infile, inopts)

eval(parse(text = {{args.helper | repr}}))

plot.bar(data, outfile, x, y, stacked, params, ggs, devpars = devpars)

{{rimport}}('__init__.r')

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
params  = {{args.params | R}}
inopts  = {{args.inopts | R}}

mat = read.table.inopts(infile, inopts)

{% if isinstance(args.code, list) %}
	{% for c in args.code %}
	{{c}}
	{% endfor %}
{% else %}
	{{args.code}}
{% endif %}

outparams = list(
	x         = mat,
	file      = outfile,
	sep       = inopts$delimit,
	quote     = F,
	col.names = as.logical(inopts$cnames),
	row.names = as.logical(inopts$rnames)
)

do.call(write.table, outparams)

{{rimport}}('__init__.r')

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
inopts  = {{args.inopts | R}}

indata = t(read.table.inopts(infile, inopts))
write.table(indata, outfile, quote = F, sep = "\t", row.names = inopts$cnames, col.names = inopts$rnames)

{{rimport}}('__init__.r')
options(stringsAsFactors = FALSE)

infiles   = {{ i.infiles | R}}
outfile   = {{ o.outfile | quote}}
inopts    = {{ args.inopts | R}}
fn2sample = {{args.fn2sample}}

ret = NULL
for (infile in infiles) {
	sample = fn2sample(tools::file_path_sans_ext(basename(infile)))
	indata = read.table.inopts(infile, inopts)[, 1, drop = FALSE]
	colnames(indata) = sample
	if (is.null(ret)) {
		ret = indata
	} else {
		ret = cbind(ret, indata[rownames(ret),,drop = FALSE])
	}
}
write.table(ret, outfile, sep = "\t", quote = F, row.names = TRUE, col.names = TRUE)

{{rimport}}('__init__.r', 'plot.r')

infile  = {{i.infile | quote}}
inmodel = {{i.model | quote}}
outdir  = {{o.outdir | quote}}
outprob = {{args.outprob | R}}
inopts  = {{args.inopts | R}}
outauc  = {{args.outauc | R}}
params  = {{args.params | R}}
devpars = {{args.devpars | R}}
ggs     = {{args.ggs | R}}
prefix  = file.path(outdir, {{i.infile | stem | quote}})

indata = read.table.inopts(infile, inopts)

cnames = colnames(indata)
if (is.null(cnames)) {
	colnames(indata) = c(paste('X', 1:(ncol(indata)-1)), 'Y')
	cnames = colnames(indata)
}

model = readRDS(inmodel)
prob  = do.call(predict.glm, c(list(model, indata, type="response"), params))

if (model$yval == 'prob') {
	if (outprob) {
		out = cbind(indata, Predict.Result = round(prob, 3), Predict.Prob = prob)
	} else {
		out = cbind(indata, Predict.Result = round(prob, 3))
	}
} else if (model$yval == 'categ') {
	ymin  = model$ymin
	ymax  = model$ymax
	index = round(prob * (ymax - ymin) + ymin)
	if (outprob) {
		out = cbind(indata, Predict.Result = model$ylabs[index], Predict.Prob = round(prob, 3))
	} else {
		out = cbind(indata, Predict.Result = model$ylabs[index])
	}
} else if (model$yval == 'numeric') {
	ymin  = model$ymin
	ymax  = model$ymax
	value = prob * (ymax - ymin) + ymin
	if (outprob) {
		out = cbind(indata, Predict.Result = value, Predict.Prob = round(prob, 3))
	} else {
		out = cbind(indata, Predict.Result = value)
	}
}
if (outprob) {
	preds = predict.glm(model, newdata = indata, type = "link", se.fit = TRUE)
	ci95_1 = model$family$linkinv(preds$fit - 1.96*preds$se.fit)
	ci95_2 = model$family$linkinv(preds$fit + 1.96*preds$se.fit)
	out = cbind(out, Predict.ProbCI95_1 = round(ci95_1, 3), Predict.ProbCI95_2 = round(ci95_2, 3))
}

ycol = model$ycol
if (outauc) {
	if (!ycol %in% cnames) {
		stop('No Y values found in input data, unable to plot ROC or output AUC.')
	}
	if (model$yval == 'prob' || model$yval == 'numeric') {
		stop('ROC/AUC is only available for categorical Y values, unable to plot ROC or output AUC.')
	}
	aucdata = data.frame(D = indata[, ycol] == out$Predict.Result, M = prob)
	roc = plot.roc(aucdata,
		paste0(prefix, '.roc.png'),
		params = list(returnTable = TRUE),
		ggs = ggs, devpars = devpars)
	out = cbind(out, AUC = roc$table[1, 'auc'])
}

write.table(out,
	paste0(prefix, '.result.txt'),
	row.names = list.get(inopts, 'rnames', TRUE),
	col.names = TRUE, sep = "\t", quote = F)

library(methods)
library(data.table)
{{rimport}}('__init__.r', 'plot.r')
options(stringsAsFactors = FALSE)

infile   = {{i.infile     | quote}}
samfile  = {{i.samfile    | quote}}
casefile = {{i.casefile   | quote}}
gfile    = {{i.groupfile  | quote}}
outdir   = {{o.outdir     | quote}}
outfile  = {{o.outfile    | quote}}
inopts   = {{args.inopts  | R}}
pcut     = {{args.pval    | R}}
dofdr    = {{args.fdr     | R}}
fdrfor   = {{args.fdrfor  | R}}
doplot   = {{args.plot    | R}}
method   = {{args.method  | quote}}
ggs      = {{args.ggs     | R}}
devpars  = {{args.devpars | R}}
if (dofdr == T) dofdr = 'BH'

getCorr = function(gname1, mat1, gname2, mat2) {
	# returns:
	# $corr
	# 	Group1	Group2	Corr
	# 	A		B		.9
	# 	A		C		.1
	# $n
	# 	10
	rnames1 = rownames(mat1)
	rnames2 = rownames(mat2)
	mat     = merge(mat1, mat2, by = c())
	halfcol = ncol(mat) / 2
	rm(mat1, mat2)
	corr = data.frame(corr = apply(mat, 1, function(row) cor(
		row[1:halfcol],
		row[(halfcol+1):(2*halfcol)],
		method = method,
		use = "pairwise.complete.obs"
	)))
	corr = cbind(merge(rnames1, rnames2, by = c()), corr)
	colnames(corr) = c(gname1, gname2, 'Corr')
	
	lvl1 = levels(corr[,1])
	lvl2 = levels(corr[,2])
	levels(corr[,1]) = union(lvl1, lvl2)
	levels(corr[,2]) = union(lvl1, lvl2)
	list(corr = corr[which(corr[,1] != corr[,2]),, drop = F], n = halfcol)
}

diffCorr = function(corr1, corr2) {
	# returns:
	#   Group1 Group2 Corr1 Corr2 N1 N2 Z     Pval  Qval
	#   A      B     .9    .3     10 20 1.435 .001  .01
	n1    = corr1$n
	n2    = corr2$n
	colnames(corr1$corr)[3] = 'Corr1'
	colnames(corr2$corr)[3] = 'Corr2'
	corr  = cbind(corr1$corr$Corr1, corr2$corr$Corr2)
	dzcor = apply(corr, 1, function(row) {
		z1 = log( (1+row[1])/(1-row[1]) ) / 2
		z2 = log( (1+row[2])/(1-row[2]) ) / 2
		dz = z1 - z2
		sedz = sqrt( 1/(n1 - 3) + 1/(n2 - 3) )
		dz/sedz
		# two-sized
		#list(Z = z, Pval = 2 * pnorm(abs(z), lower.tail=F))
	})
	pval = 2*pnorm(abs(dzcor), lower.tail = F)
	ret = cbind(corr1$corr, Corr2 = corr2$corr$Corr2, N1 = n1, N2 = n2, Z = dzcor, Pval = pval)
}

indata  = read.table.inopts(infile, inopts)
#    S1   S2   S3 ...
# A  1    2    1
# B  3    9    8
# ...
samdata = read.table(samfile, header = F, row.names = NULL, check.names = F)
# S1     G1
# S2     G1
# S3     G2
# ...
# Sm     G3
# Sn     G3
samgrps = factor(samdata[,2])
samgrps = relevel(samgrps, as.character(samdata[1,2]))
samgrps = levels(samgrps)
# G1, G2, G3

if (gfile != '') {
	rgdata  = read.table(gfile, header = F, row.names = 1, check.names = F)
	# A     TF
	# B     TF
	# C     TF
	# ...
	# X     Gene
	# Y     Gene
	# Z     Gene
	rgroups = factor(rgdata[,1])
	rgroups = levels(rgroups)
	if (length(rgroups)!=2) {
		stop('Group file should only contain 2 groups!')
	}
	rgname1 = rgroups[1] # TF
	rgname2 = rgroups[2] # Gene
	rgroup1 = rownames(rgdata[which(rgdata[,1] == rgname1),, drop = F])
	# A, B, C
	rgroup2 = rownames(rgdata[which(rgdata[,1] == rgname2),, drop = F])
	# X, Y, Z
} else {
	rgname1 = 'R1'
	rgname2 = 'R2'
	rgroup1 = rownames(indata)
	# A, B, C, ..., X, Y, Z
	rgroup2 = rgroup1
	# A, B, C, ..., X, Y, Z
}

corrs = list()
for (samgrp in samgrps) {
	sams = samdata[which(samdata[,2] == samgrp), 1]
	if (length(sams) < 3) next # not able to do correlation
	corrs[[samgrp]] = getCorr(rgname1, indata[rgroup1, sams, drop=F], rgname2, indata[rgroup2, sams,drop=F])
	# $corr
	# 	G1	G2	Corr
	# 	A	Z	.9
	# 	A	Z	.1
	# 	...
	# $n
	# 	10
}

if (casefile != '') {
	cases = read.table(casefile, header = F, row.names = NULL, sep = "\t", check.names = F)
	colnames(cases) = c('x', 'y')
	# x     y
	# G1    G3
	# G2    G3
} else {
	cases = merge(samgrps, samgrps, by = c())
	lvlx  = levels(cases$x)
	lvly  = levels(cases$y)
	levels(cases$x) = union(lvlx, lvly)
	levels(cases$y) = union(lvlx, lvly)
	cases = cases[which(cases$x != cases$y),, drop = F]
	# x     y
	# G1    G3
	# G2    G3
}

results = NULL
# returns:
# 	Case1   Case2  TF Gene Corr1 Corr2 N1 N2 Z     Pval  Qval
# 	G1      G3     A  B    .9    .3    10 20 1.435 .001  .01
for (i in 1:nrow(cases)) {
	x = as.vector(cases[i, 1])
	y = as.vector(cases[i, 2])
	if (is.null(corrs[[x]]) || is.null(corrs[[y]])) 
		next
	dc = diffCorr(corrs[[x]], corrs[[y]])
	if (nrow(dc) == 0)
		dc = cbind(Case1 = NULL, Case2 = NULL, dc)
	else
		dc = cbind(Case1 = x, Case2 = y, dc)
	results = if(is.null(results)) dc else rbind(results, dc)
}
if (dofdr != F && !is.null(results)) {
	results$Qval = NA
	if (fdrfor == 'all') {
		results$Qval = p.adjust(results$Pval, method = dofdr)
	} else {
		for (i in 1:nrow(cases)) {
			x = as.vector(cases[i, 1])
			y = as.vector(cases[i, 2])
			rows = which(results$Case1 == x & results$Case2 == y)
			if (length(rows)>0)
				results[rows, 'Qval'] = p.adjust(results[rows, 'Pval'], method = dofdr)
		}
	}
}
if (is.null(results)) {
	if (dofdr == F) {
		results = data.frame(Case1 = character(), Case2 = character(), rgname1 = character(), rgname2 = character(), Corr1 = double(), Corr2 = double(), N1 = integer(), N2 = integer(), Z = double(), Pval = double())
	} else {
		results = data.frame(Case1 = character(), Case2 = character(), rgname1 = character(), rgname2 = character(), Corr1 = double(), Corr2 = double(), N1 = integer(), N2 = integer(), Z = double(), Pval =double(), Qval = double())
	}
	colnames(results)[3:4] = c(rgname1, rgname2)
} else { 
	results = results[results$Pval < pcut,,drop = F]
}
write.table(pretty.numbers(results, list(Corr1..Corr2..Z = '%.3f', Pval..Qval = '%.2E')), 
	outfile, col.names = T, row.names = F, sep = "\t", quote = F)

# indata:
#    S1   S2   S3 ...
# A  1    2    1
# B  3    9    8
# ...
if (doplot && nrow(results)>0) {
	for (i in 1:nrow(results)) {
		row = results[i,]
		case1 = as.vector(unlist(row[1]))
		case2 = as.vector(unlist(row[2]))
		sam1  = as.vector(unlist(samdata[which(samdata[,2] == case1),1]))
		sam2  = as.vector(unlist(samdata[which(samdata[,2] == case2),1]))
		plotdata = as.data.frame(t(indata[unlist(row[3:4]), c(sam1,sam2),drop=F]))
		plotdata$Case = ""
		plotdata[sam1, 'Case'] = case1
		plotdata[sam2, 'Case'] = case2
		plotfile = file.path(outdir, paste(c(as.vector(unlist(row[1:4])), 'png'), collapse = '.'))
		plot.scatter(
			plotdata,
			plotfile,
			x = 1,
			y = 2,
			ggs = c(ggs, list(
				geom_smooth = list(
					aes(color = Case),
					method  = 'lm',
					se      = F
				),
				scale_color_manual = list(
					values = scales::hue_pal()(2), 
					limit  = c(case1, case2),
					labels = c(
						paste0(case1, ' (r=', round(row[5], 3),')'), 
						paste0(case2, ' (r=', round(row[6], 3),')'))
				),
				guides = list(shape = F)
			)),
			params = list(aes(shape = Case, color = Case))
		)
	}
}

library(methods)
library(atSNP)
library(chunked)
options(stringsAsFactors = FALSE)

snpfile  = {{i.snpfile | R}}
tffile   = {{i.tffile | R}}
outfile  = {{o.outfile | R}}
outdir   = {{o.outdir | R}}
tfmotifs = {{args.tfmotifs | R}}
fdr      = {{args.fdr | :'BH' if a is True else a | R}}
pval     = {{args.pval | R}}
nthread  = {{args.nthread | R}}
genome   = {{args.genome | R}}
doplot   = {{args.plot | R}}
devpars  = {{args.devpars | R}}
prefix   = file.path(outdir, {{o.outfile | fn2 | R}})

logger = function(..., level = 'LOG') {
	msg = paste(...)
	if (!endsWith(msg, "\n")) msg = paste0(msg, "\n")
	cat(paste0('pyppl.log.', level, ': ', msg), file = stderr())
}

### load desired pwms
# load the list (or motifs)
# col1: motif
# col2: tf
tflist = read.table(tffile, header = FALSE, row.names = NULL, sep = "\t", check.names = FALSE)
# load all of 'em first
pwms = LoadMotifLibrary(tfmotifs)
pwms = pwms[unique(tflist[,1])]

### load snp information
if (endsWith(snpfile, '.bed')) {
	logger('Reformatting bed file to atSNP format ...')
	# suppose no head
	# must be a bed file with 8 columns
	# bed6 + ref + alt alleles (C,G)
	# first 2 will be used (ref and minor alleles in this case)
	snps    = read.table(snpfile, header = FALSE, row.names = NULL, sep = "\t", check.names = FALSE)
	snpfile = file.path(outdir, 'snps.txt')
	# write it to snpfile for loading
	snps2 = data.frame(snpid = snps[,4], chr = snps[,1], snp = snps[,3], a1 = snps[,7])
	snps2 = cbind(snps2, a2 = sapply(snps[,8], function(x) unlist(strsplit(as.character(x), ',', fixed = TRUE))[1]))
	rm(snps)
	write.table(snps2, file = snpfile, row.names = FALSE, quote = FALSE, sep = "\t")
}

chunksize = 50
logger('Handling the snp file in chunks (chunksize:', chunksize, ')')
chunks  = read_chunkwise(snpfile, chunk_size = chunksize, format = "table", header = TRUE)
i       = 0
results = NULL
while (!chunks$is_complete()) {
	i = i + 1
	logger('- Handling chunk #', i, '...')
	sfile = file.path(outdir, paste0('snp-chunk', i, '.txt'))
	nextChunk = chunks$next_chunk()
	if (is.null(nextChunk)) {
		break
	}
	write.table(nextChunk, sfile, col.names = TRUE, row.names = FALSE, sep = "\t", quote = FALSE)
	snp_info = LoadSNPData(
		sfile, 
		genome.lib       = sprintf("BSgenome.Hsapiens.UCSC.%s", genome),
		half.window.size = max(sapply(pwms, length))/4,
		default.par      = TRUE,
		mutation         = TRUE
	)
	file.remove(sfile)

	atsnp.scores = ComputeMotifScore(pwms, snp_info, ncores = nthread)
	atsnp.result = ComputePValues(motif.lib = pwms, snp.info = snp_info, motif.scores = atsnp.scores$motif.scores, ncores = nthread)
	if (fdr == FALSE) {
		atsnp.result = atsnp.result[order(pval_rank) & pval_rank < pval, list(snpid, motif, pval_ref, pval_snp, pval_rank)]
	}
	colnames(atsnp.result) = c('Snp', 'Motif', 'Pval_Ref', 'Pval_Mut', 'Pval_Diff')
	atsnp.result[, TF := paste(tflist[which(tflist[,1] == Motif), 2], collapse = ','), by = Motif]
	atsnp.result = atsnp.result[, list(Snp, TF, Motif, Pval_Ref, Pval_Mut, Pval_Diff)]
	if (is.null(results)) {
		results = atsnp.result
	} else {
		results = rbind(results, atsnp.result)
	}

	if (doplot) {
		for (i in 1:nrow(atsnp.result)) {
			if (atsnp.result[i, Pval_Diff] >= pval) next
			plotfile = paste(prefix, atsnp.result[i, Snp], atsnp.result[i, TF], atsnp.result[i, Motif], 'png', sep = '.')
			devpars$file = plotfile
			do.call(png, devpars)
			plotMotifMatch(
				snp.tbl      = atsnp.scores$snp.tbl,
				motif.scores = atsnp.scores$motif.scores,
				snpid        = atsnp.result[i, Snp],
				motif.lib    = pwms,
				motif        = atsnp.result[i, Motif])
			dev.off()
		}
	}
}
if (fdr != FALSE) {
	results[, Qval_Diff := p.adjust(Pval_Diff, method = ifelse(fdr == TRUE, 'BH', fdr))]
	results = results[order(Pval_Diff) & Pval_Diff < pval]
}

write.table(results, outfile, col.names = TRUE, row.names = FALSE, sep = "\t", quote = FALSE)

{{rimport}}('__init__.r')

infiles  = {{i.infiles | R}}
outfile  = {{o.outfile | R}}
inopts   = {{args.inopts, i.infiles | lambda x, files: (x, len(files)) | lambda x: {k:(v if isinstance(v, list) and len(v) > 1 else v*x[1] if isinstance(x, list) and len(v) == 1 else [v]*x[1]) for k, v in x[0].items()} | R}}
params   = {{args.params | R}}
na       = {{args.na | R}}
fn2rname = {{args.fn2rname}}
fill     = as.logical({{args.fill | R}})

mats = list()
for (i in 1:length(infiles)) {
	inparams = c(list(
		file      = infiles[i],
		header    = ifelse(is.null(inopts$cnames[i]), T, as.logical(inopts$cnames[i])),
		row.names = ifelse(is.null(inopts$rnames[i]) || inopts$rnames[i], 1, NULL),
		sep       = ifelse(is.null(inopts$delimit[i]), "\t", inopts$delimit[i]),
		skip      = ifelse(is.null(inopts$skip[i]), 0, inopts$skip[i])
	), params)
	mats[[i]]  = do.call(read.table, inparams)

	if (is.null(inparams$row.names) && !is.null(fn2rname)) {
		rname = fn2rname(tools::file_path_sans_ext(basename(infiles[i])))
		if (nrow(mats[[i]]) == 1)
			rownames(mats[[i]]) = rname
		else
			rownames(mats[[i]]) = paste(rname, 1:nrow(mats[[i]]), sep='_r')
	}
}
mat = ifelse(fill, do.call(rbind.fill, mats), do.call(rbind, mats))
mat[is.na(mat)] = na

outparams = list(
	x         = mat,
	file      = outfile,
	sep       = '\t',
	quote     = F,
	col.names = ifelse(is.null(inopts$cnames[1]), T, as.logical(inopts$cnames[1])),
	row.names = T
)
do.call(write.table, outparams)

require('ggplot2')
require('ggrepel')
pdf(NULL) # preventing Rplots.pdf

.script.file = function() {
	for (i in 1:length(sys.frames())) {
		ofile = sys.frame(i)$ofile
		if (!is.null(ofile)) {
			return (ofile)
		}
	}
}
source(file.path(dirname(.script.file()), '__init__.r'))

DEVPARS = list(height = 2000, width = 2000, res = 300)

.stack.data = function(data, colnames = c('values', 'ind')) {
	data = stack(as.data.frame(data))
	colnames(data) = colnames
	return(data)
}

.get.aes.string = function(data, ...) {
	# colnames(data) = c('A', 'B', 'C')
	# .get.aes.string(data, x=2, y=1)
	# => list(x='B', y='A')
	cols   = list(...)
	cnames = colnames(data)
	ret    = list()
	anames = names(cols)
	for (i in 1:length(anames)) {
		aname = anames[i]
		colidx = cols[[aname]]
		ret[[aname]] = ifelse(is.numeric(colidx), cnames[colidx], cols[[aname]])
	}
	return (ret)
}

# Update an aes in alist (named "mapping") for ggplot2 functions
# namesbefore = c('data')
update.aes = function(alist, newaes, namesbefore = c()) {
	alnames = names(alist)
	if ('mapping' %in% alnames) {
		alist$mapping = update.list(alist$mapping, newaes)
	} else {
		delidx = NULL
		if (length(namesbefore) > 0) {
			for (i in 1:length(namesbefore)) {
				if (namesbefore[i] %in% alnames)
					delidx = c(delidx, i)
			}
		}
		if (!is.null(delidx)) namesbefore = namesbefore[-delidx]
		pos = length(namesbefore) + 1
		if (is.null(alnames)) {
			if (length(alist) < pos) alist$mapping = newaes
			else alist[[pos]] = update.list(alist[[pos]], newaes)
		} else {
			x = 0
			if (length(alnames) > 0) {
				for (i in 1:length(alnames)) {
					if (alnames[i] != "") next
					x = x + 1
					if (x == pos) {
						alist[[i]] = update.list(alist[[i]], newaes)
						break
					}
				}
			}
			if (x == 0) {
				alist$mapping = newaes
			}
		}
	}
	return (alist)
}

apply.ggs = function(p, ggs) {
	if (is.null(ggs) || length(ggs) == 0)
		return(p)
	funcs = names(ggs)
	for (i in 1:length(funcs)) {
		if (!is.null(ggs[[i]])) {
			p = p + do.call(funcs[i], ggs[[i]])
		}
	}
	return (p)
}

save.plot = function(p, plotfile, devpars = DEVPARS) {
	if (is.null(plotfile)) {
		print(p)
	} else if (plotfile == 'return') {
		return(p)
	} else if (endsWith(plotfile, '.png')) {
		do.call(png, c(list(filename = plotfile), devpars))
		print(p)
		dev.off()
	} else {
		stop('Only .png file supported to save plots for now.')
	}
}

plot.no = function(data, plotfile = NULL, params = list(), ggs = list(), devpars = DEVPARS) {
	params$data = as.data.frame(data)
	p = do.call(ggplot, params)
	p = apply.ggs(p, ggs)
	save.plot(p, plotfile, devpars)
}

plot.xy = function(data, plotfile = NULL, x = 1, y = 2, ggs = list(), devpars = DEVPARS) {
	cnames = colnames(data)
	cnames = make.names(cnames)
	colnames(data) = cnames
	if (is.numeric(x)) x = sprintf("`%s`", cnames[x])
	if (is.numeric(y)) y = sprintf("`%s`", cnames[y])
	params = list(mapping = aes_string(x = x, y = y))
	plot.no(data, plotfile, params, ggs, devpars)
}

plot.x = function(data, plotfile, x = 1, ggs = list(), devpars = DEVPARS) {
	cnames = colnames(data)
	cnames = make.names(cnames)
	colnames(data) = cnames
	if (is.numeric(x)) x = cnames[x]
	params = list(mapping = aes_string(x = x))
	plot.no(data, plotfile, params, ggs, devpars)
}

plot.stack = function(data, plotfile, x = 'ind', y = 'values', ggs = list(), devpars = DEVPARS) {
	data = stack(as.data.frame(data))
	plot.xy(data, plotfile, x = x, y = y, ggs = ggs, devpars = devpars)
}

plot.roc = function(
	data,
	plotfile = NULL,
	stacked = FALSE,
	params = list(returnTable = FALSE, showAUC = TRUE, bestCut = FALSE),
	ggs = list(), devpars = DEVPARS) {
	# plot the ROC curve
	# see: https://cran.r-project.org/web/packages/plotROC/vignettes/examples.html
	# @params:
	#	`data`: The data for plotting.
	#		- If stacked, then there should be only 3 columns: D, M, name
	#		- Else the 1st column should be D, and rest are `<M1>, <M2>, ...`
	#		- D must be binary.
	#	`plotfile`: The file to save the plot.
	#	`stacked` : Whether the data is stacked(melt). See `data`
	#	`params`  : The parameters for plotting.
	#		- `showAUC`  : Show AUC on the plot
	#		- `returnTable`: Whether return a table of details. If TRUE, to get plot, use ret$plot and table use ret$table
	require('pROC')

	if (stacked) {
		if (ncol(data) != 3)
			stop('Expect 3 columns (D, M, Group) in stacked data to plot ROC.')
		colnames(data) = c('D', 'M', 'Group')
	} else {
		ncols = ncol(data)
		if (ncols < 2) {
			stop('Expect at least 2 columns (D, M1, ..., Mn)')
		}
		data = cbind(rep(data[,1], ncols-1), stack(data[, 2:ncols, drop = FALSE]))
		colnames(data) = c('D', 'M', 'Group')
	}
	groups = levels(factor(data$Group))
	returnTable = params$returnTable
	if (is.null(returnTable)) returnTable = FALSE

	showAUC = params$showAUC
	if (is.null(showAUC)) showAUC = TRUE

	bestCut = params$bestCut
	if (is.null(bestCut)) bestCut = FALSE

	params$returnTable = NULL
	params$showAUC     = NULL
	params$bestCut     = NULL

	# get roc objects
	rocs = list()
	for (grup in groups) {
		rocs[[grup]] = roc(D ~ M, data = data, subset=(Group == grup))
	}

	# get table of a roc object
	roc.table = function(rocobj) {
		aucci = ci(rocobj)
		ret = data.frame(
			threshold   = rocobj$thresholds,
			sensitivity = rocobj$sensitivities,
			specificity = rocobj$specificities,
			auc         = as.vector(rocobj$auc),
			auc_95ci1   = aucci[1],
			auc_95ci2   = aucci[3])
		# checkout the best cut points
		bests = as.matrix(coords(rocobj, 'best'))
		cbind(ret, is.best = ret$threshold %in% bests[1,])
	}
	roc.tables = function(rocs) {
		ret = NULL
		for (name in names(rocs)) {
			rtable = roc.table(rocs[[name]])
			tmp = cbind(Group = name, rtable)
			ret = ifelse(is.null(ret), tmp, rbind(ret, tmp))
		}
		ret
	}

	ret       = list()
	ret$plot  = do.call(ggroc, c(list(rocs), params))
	ret$table = roc.tables(rocs)
	# add best cut
	if (bestCut) {
		bestdata = ret$table[ret$table$is.best,,drop=FALSE]
		ret$plot = ret$plot + geom_point(
			aes(x = specificity, y = sensitivity, color = Group),
			data = bestdata,
			inherit.aes = FALSE
		) + geom_segment(
			aes(x = specificity, xend = specificity, y = sensitivity, yend = -Inf, color = Group),
			data = bestdata,
			linetype = 'dashed',
			inherit.aes = FALSE
		) + geom_segment(
			aes(x = Inf, xend = specificity, y = sensitivity, yend = sensitivity, color = Group),
			data = bestdata,
			linetype = 'dashed',
			inherit.aes = FALSE
		) + geom_text_repel(
			aes(x = specificity, y = sensitivity,
				label = paste0('best (', round(specificity, 3), ', ', round(sensitivity, 3) ,')'),
				color = Group),
			data = bestdata
		)
	}
	# add AUC
	if (showAUC) {
		aucs = unique(ret$table[, c('Group', 'auc')])
		if (nrow(aucs) == 1) {
			ret$plot = ret$plot + annotate("text", x = .1, y = .05,
				label = paste('AUC', round(aucs[1,2], 3), sep = ' = '))
			ret$plot = ret$plot + scale_color_discrete(guide = F)
		} else {
			auclabels = apply(aucs, 1, function(row) {
				sprintf('AUC(%s) = %.3f', row[1], as.numeric(row[2]))
			})
			ret$plot = ret$plot + scale_color_discrete(name = "",
				breaks = groups,
				labels = as.vector(auclabels))
		}
	}

	ret$plot = apply.ggs(ret$plot, ggs)
	if (returnTable) {
		save.plot(ret$plot, plotfile, devpars)
		return(ret)
	}
	save.plot(ret$plot, plotfile, devpars)
}

plot.scatter = function(data, plotfile = NULL, x = 1, y = 2, params = list(), ggs = list(), devpars = DEVPARS) {
	ggs = c(list(geom_point = params), ggs)
	plot.xy(data, plotfile, x, y, ggs, devpars)
}
# alias
plot.points = plot.scatter

plot.col = function(
	data,
	plotfile = NULL,
	x = 2,
	y = 0,
	params = list(),
	ggs = list(), devpars = DEVPARS) {
	# y = 1 # y as counts
	# x = 2
	# ----------------------
	# Counts	Group	Fill
	# 10	Ga	Yes
	# 10	Gb	No
	#
	#    |
	# 10 | |-|  |-|     Fill
	#    | |x|  |.|     x: Yes
	#    |_|x|__|.|___  .: No
	#      Ga    Gb
	#
	# y.is.counts = FALSE
	# x = 1
	# y = 0 # counting Sub-groups
	# ---------------------------
	# Group	Fill
	# Ga	Yes
	# Ga	Yes
	# Ga	Yes
	# Gb	No
	# Gb	No
	# Gb	No
	#
	#    |
	# 3  | |-|  |-|     Fill
	#    | |x|  |.|     x: Yes
	#    |_|x|__|.|___  .: No
	#      Ga    Gb
	#
	if (y == 0) {
		data = cbind(data, Count = 1)
		y = ncol(data)
	}

	aes.string = .get.aes.string(data, x = x, y = y)
	ggs = c(
		list(geom_col = params),
		list(theme = list(axis.text.x = element_text(angle = 60, hjust = 1))),
		list(xlab = list(aes.string$x)),
		ggs
	)
	data[, x] = as.character(data[, x])
	plot.xy(data, plotfile, aes.string$x, aes.string$y, ggs, devpars)
}
# alias
plot.bar = plot.col

plot.boxplot = function(data, plotfile = NULL, x = 2, y = 1, stacked = TRUE, params = list(), ggs = list(), devpars = DEVPARS) {
	if (stacked) {
		cnames = colnames(data)
		cnames = make.names(cnames)
		colnames(data) = cnames
		if (is.numeric(x)) {
			x = cnames[x]
		}
		if (is.numeric(y)) {
			y = cnames[y]
		}
		#params = update.aes(params, aes_string(group = x))

		ggs = c(
			list(geom_boxplot = params),
			list(theme = list(axis.title.x = element_blank(), axis.text.x = element_text(angle = 60, hjust = 1))),
			ggs
		)
		plot.xy(data, plotfile, x, y, ggs, devpars)
	} else {
		ggs = c(
			list(geom_boxplot = params),
			list(theme = list(axis.title.x = element_blank(), axis.text.x = element_text(angle = 60, hjust = 1))),
			ggs
		)
		plot.stack(data, plotfile, ggs = ggs, devpars = devpars)
	}
}

plot.violin = function(data, plotfile = NULL, x = 2, y = 1, stacked = TRUE, params = list(), ggs = list(), devpars = DEVPARS) {
	if (!stacked) {
		data = .stack.data(data)
		x = 2
		y = 1
	}
	aes.string = .get.aes.string(data, x = x, y = y)
	ggs = c(
		list(geom_violin = params),
		list(theme = list(axis.title.x = element_blank(), axis.text.x = element_text(angle = 60, hjust = 1))),
		ggs
	)
	plot.xy(data, plotfile, aes.string$x, aes.string$y, ggs, devpars)
}

plot.heatmap2 = function(
	data, plotfile = NULL, params = list(), draw = list(),
	devpars = DEVPARS) {
	library(ComplexHeatmap)

	params$matrix = data
	hm = do.call(Heatmap, params)

	if (is.null(plotfile)) {
		do.call(ComplexHeatmap::draw, c(list(hm), draw))
	} else if (plotfile == 'return') {
		return(hm)
	}  else {
		do.call(png, c(list(filename=plotfile), devpars))
		do.call(ComplexHeatmap::draw, c(list(hm), draw))
		dev.off()
	}
}

plot.heatmap = function(data, plotfile, params = list(dendro = T), ggs = list(), devpars = DEVPARS) {
	require('ggdendro')
	require('gtable')
	require('grid')

	do.call(png, c(list(filename=plotfile), devpars))

	theme_none = theme(
		panel.grid.major = element_blank(),
		panel.grid.minor = element_blank(),
		panel.background = element_blank(),
		axis.title.x = element_text(colour=NA),
		axis.title.y = element_blank(),
		axis.text.x = element_blank(),
		axis.text.y = element_blank(),
		axis.line = element_blank(),
		axis.ticks = element_blank()
	)

	ggplus = list(
		scale_fill_gradient2 = list(),
		theme = list(
			axis.ticks  = element_blank(),
			axis.title.x = element_blank(),
			axis.title.y = element_blank(),
			axis.text.x  = element_text(angle = 60, hjust = 1),
			legend.title = element_blank()
		)
	)

	dendro = params$dendro
	if (is.null(dendro)) dendro = T

	rnames = rownames(data)
	cnames = colnames(data)
	if (is.null(rnames)) {
		rnames = paste('ROW', 1:nrow(m), sep='')
		rownames(data) = rnames
	}
	if (is.null(cnames)) {
		cnames = paste('COL', 1:ncol(m), sep='')
		colnames(data) = cnames
	}
	# Dendrogram 1
	if (dendro == TRUE || dendro == 'both' || dendro == 'row') {
		ddrleft   = hclust(dist(data))
		plotdleft = ggplot(segment(dendro_data(as.dendrogram(ddrleft)))) +
		geom_segment(aes(x=x, y=y, xend=xend, yend=yend)) +
		theme_none + theme(plot.margin = margin(r=-5, l = 10)) +
		coord_flip() +
		scale_y_reverse(expand = c(0, 0)) +
		scale_x_discrete(expand = c(0, 0.5))
		rowidx  = ddrleft$order
	} else {
		plotdleft = NULL
		rowidx    = 1:length(rnames)
		rowidx    = rev(rowidx)
	}

	# Dendrogram 2
	if (dendro == TRUE || dendro == 'both' || dendro == 'col') {
		ddrtop   = hclust(dist(t(data)))
		plotdtop = ggplot(segment(dendro_data(as.dendrogram(ddrtop)))) +
		geom_segment(aes(x=x, y=y, xend=xend, yend=yend)) +
		theme_none + theme(plot.margin = margin(b=-15, t = 10)) +
		scale_x_discrete(expand = c(0, 0.5)) +
		scale_y_continuous(expand = c(0, 0))
		colidx  = ddrtop$order
	} else {
		plotdtop = NULL
		colidx   = 1:length(cnames)
	}

	mm        = stack(as.data.frame(data[rowidx, colidx]))
	mm$rnames = rnames[rowidx]
	plothm    = ggplot(mm, aes(ind, rnames)) + geom_tile(aes(fill=values)) +
	xlim(unique(as.vector(mm$ind))) + scale_y_discrete(position="right", limits=rnames)

	ggs = c(ggplus, ggs)
	plothm = apply.ggs(plothm, ggs)

	if (dendro == TRUE || dendro == 'both') {
		ghm = ggplotGrob(plothm)
		gd1 = ggplotGrob(plotdtop)
		gd2 = ggplotGrob(plotdleft)
		maxheights  = as.list(unit.pmax(ghm$heights, gd2$heights))
		ghm$heights = maxheights
		gd2$heights = maxheights
		maxwidths   = as.list(unit.pmax(ghm$widths, gd1$widths))
		ghm$widths  = maxwidths
		gd1$widths  = maxwidths

		g   = gtable(unit(c(.15,.85), "npc"), unit(c(.15,.85), "npc"))
		g   = gtable_add_grob(g, ghm, 2, 2)
		g   = gtable_add_grob(g, gd1, 1, 2)
		g   = gtable_add_grob(g, gd2, 2, 1)

		grid.newpage()
		grid.draw(g)
	} else if (dendro == 'col') {
		ghm = ggplotGrob(plothm)
		gd1 = ggplotGrob(plotdtop)

		maxwidths   = as.list(unit.pmax(ghm$widths, gd1$widths))
		ghm$widths  = maxwidths
		gd1$widths  = maxwidths

		g   = gtable(unit(1, "npc"), unit(c(.15,.85), "npc"))
		g   = gtable_add_grob(g, ghm, 2, 1)
		g   = gtable_add_grob(g, gd1, 1, 1)

		grid.newpage()
		grid.draw(g)
	} else if (dendro == 'row') {
		ghm = ggplotGrob(plothm)
		gd2 = ggplotGrob(plotdleft)
		maxheights  = as.list(unit.pmax(ghm$heights, gd2$heights))
		ghm$heights = maxheights
		gd2$heights = maxheights

		g   = gtable(unit(c(.15,.85), "npc"), unit(1, "npc"))
		g   = gtable_add_grob(g, ghm, 1, 2)
		g   = gtable_add_grob(g, gd2, 1, 1)

		grid.newpage()
		grid.draw(g)
	} else {
		print(plothm)
	}
	dev.off()
}

plot.histo = function(data, plotfile = NULL, x = 1, params = list(), ggs = list(), devpars = DEVPARS) {
	ggs = c(list(geom_histogram = params), ggs)
	plot.x(data, plotfile, x, ggs, devpars)
}

plot.density = function(
	data,            # the data, either stacked or not
	# NULL: print the plot,
	# 'return': return the ggplot object,
	# 'filepath': save the plot to file
	plotfile = NULL,
	x = 1, # The data column for values, only for stacked data
	y = 2, # The data column for groups, only for stacked data
	stacked = TRUE,  # whether the data is stacked, if not will stack it
	params = list(), # The params for geom_density
	ggs = list(), devpars = DEVPARS) {

	if (!stacked) {
		data = .stack.data(data)
		x = 1
		y = 2
	}
	aes.string = .get.aes.string(data, x = x, y = y)
	params = c(params, list(mapping = aes_string(fill = aes.string$y), alpha = .3))
	ggs = c(list(geom_density = params), ggs)
	plot.x(data, plotfile, aes.string$x, ggs, devpars)
}


plot.freqpoly = function(data, plotfile, x = 1, params = list(), ggs = list(), devpars = DEVPARS) {
	ggs = c(list(geom_freqpoly = params), ggs)
	plot.x(data, plotfile, x, ggs, devpars)
}

plot.maplot = function(data, plotfile, threshold, ggs = list(), devpars = DEVPARS) {
	data = as.data.frame(data)
	cnames = colnames(data)
	A      = if ("A" %in% cnames) data$A else data[, 1]
	M      = if ("M" %in% cnames) data$M else data[, 2]
	thres  = threshold
	data = data.frame(A, M, thres)

	ggs = c(list(
		theme       = list(legend.position = 'none'),
		geom_hline  = list(color = 'blue3', yintercept = 0, linetype = 'dashed'),
		stat_smooth = list(se = F, method = 'loess', color = 'red3')
	), ggs)

	params = list(size = 1.5, alpha = 1/5)
	if (!is.null(thres)) {
		params$mapping = aes(color = factor(thres))
	}
	plot.scatter(data, plotfile, x = 'A', y = 'M', params = params, ggs = ggs, devpars = devpars)
}

plot.qq = function(data, plotfile = NULL, x = NULL, y = 1, params = list(), ggs = list(), devpars = DEVPARS) {
	data = as.data.frame(data)
	n    = nrow(data)
	q    = (1:n)/n
	if (is.null(x)) {
		data = cbind(data, Theoretical = qnorm(q))
		x = "Theoretical"
	}
	data[, x] = quantile(data[, x], q)
	data[, y] = quantile(data[, y], q)
	if (is.numeric(x)) x = sprintf("`%s`", colnames(data)[x])
	if (is.numeric(y)) y = sprintf("`%s`", colnames(data)[y])

	plot.scatter(data, plotfile, x = x, y = y, params = params, ggs = ggs, devpars = devpars)
}

# data:
# 		cat1	cat2	cat3
# item1	1		0		1
# item2	1		1		0
# item3	0		1		1
# item4	1		0		0
# item5	1		0		1
plot.venn = function(data, plotfile = NULL, params = list(), devpars = DEVPARS) {

	library(VennDiagram)
	rnames = rownames(data)
	if (is.null(rnames)) {
		rnames = paste0('ROW', 1:nrow(data))
		rownames(data) = rnames
	}
	x = list()
	for (cname in colnames(data)) {
		x[[cname]] = rownames(data[which(data[, cname] == 1), cname, drop=F])
	}
	default.params = list(x = x, filename = plotfile, height = devpars$height, width = devpars$width, resolution = devpars$res, imagetype = "png", alpha = .5, fill = rainbow(ncol(data)))
	params = update.list(default.params, params)
	do.call(venn.diagram, params)
}

plot.upset = function(data, plotfile = NULL, params = list(), devpars = DEVPARS) {
	library(UpSetR)
	default.params = list(data = data, nsets = ncol(data))
	params = update.list(default.params, params)
	p = do.call(upset, params)
	save.plot(p, plotfile, devpars)
}

plot.pie = function(data, plotfile, ggs = list(), devpars = DEVPARS) {
	percent    = function(x) paste0(format(round(x*100, 1), nsmall = 1), "%")
	N          = nrow(data)
	Group      = colnames(data)
	oValue     = if (N == 1) data[1,] else colSums(data)
	oValue     = as.vector(as.matrix(oValue))
	GroupName  = paste0(Group, " (", oValue, ")")
	Value      = 100*oValue/sum(oValue)
	Labels     = percent(Value / 100)
	data       = data.frame (Group = Group, Value = Value)
	data$Group = factor(data$Group, levels = data$Group)
	ytext      = cumsum(rev(Value)) - rev(Value) / 2

	default.ggs = list(
		geom_bar            = list(aes(fill = Group), width = 1, stat = 'identity'),
		geom_text           = list(y = ytext, label = rev(Labels)),
		coord_polar         = list('y'),
		scale_fill_discrete = list(labels = GroupName, breaks = Group)
	)
	ggs = c(default.ggs, ggs)
	plot.xy(data, plotfile, x = '""', y = 'Value', ggs, devpars)
}

# Volcano plot
# data must be a data frame of log fold change and p/q value
# params is a list of:
#	- logfccut: The absolute log fold change cutoff
#	- pcut: The p/q value cutoff
#	- hilight: genes to highlight
#		- either the names (rownames) of the genes, or
#		- A number or a vector of two numbers, of genes to highlight for both up-/down genes, or
#		- a list of cutoffs for logfc and p/q value
#			- list(logfc = 2, p = .05), or if you want have different logfc cutoff for up-/down genes:
#			- list(logfc = c(-2, +2), p = .05), or
#
plot.volplot = function(data,
	plotfile,
	params  = list(logfccut = 2, pcut = 0.05, hilight = 5),
	ggs     = list(),
	devpars = DEVPARS) {

	data = as.data.frame(data)
	# let's see if it is p or q value
	is.pval = grepl('p', colnames(data)[2], fixed = TRUE)
	colnames(data) = ifelse(is.pval, c('logFC', 'log10.P.'), c('logFC', 'log10.FDR.'))
	data[, 2] = -log10(data[, 2])

	pcutlabel = round(params$pcut, 3)
	params$pcut = -log10(params$pcut)
	data$Group = apply(data, 1, function(row) {
		if (row[1]>=params$logfccut && row[2]>params$pcut) {
			'UP_SIG'
		} else if (row[1]<=-params$logfccut && row[2]>params$pcut) {
			'DOWN_SIG'
		} else {
			'INSIG'
		}
	})
	data$Group = factor(data$Group, levels = c('DOWN_SIG', 'UP_SIG', 'INSIG'))
	# parse Labels
	rnames = rownames(data)
	labeldata = NULL
	if (is.null(params$hilight)) {
		# pass
	} else if (!is.list(params$hilight) && !is.numeric(params$hilight)) {
		# gene names
		labeldata = data[params$hilight, 1:2]
		labeldata = cbind(labeldata, Label = params$hilight)
	} else if (!is.list(params$hilight) && is.numeric(params$hilight)) {
		# tops
		if (length(params$hilight) == 1) {
			params$hilight = c(params$hilight, params$hilight)
		}
		downtop   = params$hilight[1]
		uptop     = params$hilight[2]
		labeldata = data[order(data$logFC),,drop = FALSE]
		labeldata = labeldata[labeldata$Group != 'INSIG',,drop = FALSE]
		ngenes    = nrow(labeldata)
		labeldata = labeldata[c(1:downtop, (ngenes-uptop+1):ngenes),,drop = FALSE]
		labeldata$Label = rownames(labeldata)
	} else if (is.list(params$hilight)) {
		logfc = params$hilight$logfc
		if (is.null(logfc)) {
			logfc = c(-4, 4)
		} else if (length(logfc) == 1) {
			logfc = c(-logfc, logfc)
		}
		p         = params$hilight$p
		p         = -log10(ifelse(is.null(p), 0.01, p))
		labeldata = data[(data$logFC <= logfc[1] | data$logFC >= logfc[2]) & data[,2] > p,,drop = FALSE]
		labeldata$Label = rownames(labeldata)
	}

	vline = list(xintercept = c(-params$logfccut, params$logfccut),
		linetype = 'dashed', color = c('red3', 'blue3'))
	vtext1 = list(x = -params$logfccut, y = 0,
		label = paste(-params$logfccut, 'fold'), vjust = 1, hjust = 1.1, color='red3')
	vtext2 = list(x = +params$logfccut, y = 0,
		label = paste0('+', params$logfccut, ' ', 'fold'), vjust = 1, hjust = -0.1, color="blue3")
	hline = list(yintercept = params$pcut, linetype = 'dashed', color = 'black')
	htext = list(x = max(data$logFC), y = params$pcut,
		label = paste(ifelse(is.pval, 'P', 'FDR'), '=', pcutlabel),
		vjust = -1, hjust = 1, color = 'black')
	labels = NULL
	if (!is.null(labeldata)) {
		labels = list(aes_string(
			x = 'logFC', y = ifelse(is.pval, 'log10.P.', 'log10.FDR.'), label = 'Label', color = 'Group'
		), alpha = 1, data = labeldata, min.segment.length = unit(0, 'lines'), inherit.aes = FALSE)
	}
	xlim = max(max(data$logFC), abs(min(data$logFC)))
	ggs = c(list(
		geom_point         = list(alpha = .4, size = 1.75, aes(color = Group)),
		scale_color_manual = list(values=c("#F8766D", "#619CFF", "#999999")),
		geom_hline         = hline,
		geom_text          = htext,
		geom_vline         = vline,
		geom_text          = vtext1,
		geom_text          = vtext2,
		xlim               = list(c(-xlim, xlim)),
		theme_bw           = list(),
		theme              = list(legend.position ="none",
								panel.grid.major = element_blank(),
								panel.grid.minor = element_blank()),
		geom_label_repel = labels,
		xlab             = list('log2 Fold Change'),
		ylab             = list(ifelse(is.pval, '-log10(P)', '-log10(FDR)'))
	), ggs)

	plot.xy(data, plotfile,
		x = 'logFC', y = ifelse(is.pval, 'log10.P.', 'log10.FDR.'),
		ggs = ggs, devpars = devpars)
}

plot.man = function(data, plotfile = NULL, hilights = list(), hilabel = TRUE,
	gsize = NULL, ggs = list(), devpars = DEVPARS) {
	# manhattan plot
	# data is a data frame of
	# Chr, Pos, P[, Region]
	# Rownames should be snp name
	# The region is used to divide the plot, in case
	# all snps are on the same chromosome

	library(data.table)
	data = as.data.table(data)
	if (ncol(data) == 4) {
		colnames(data) = c('Snp', 'Chr', 'Pos', 'P')
		data$Region = data$Chr
	} else if (ncol(data) == 5) {
		colnames(data) = c('Snp', 'Chr', 'Pos', 'P', 'Region')
	} else {
		stop('Expect a data frame of 4 or 5 columns to do manhattan plot.')
	}
	# calculate the x axis for each snp, position on each chromsome should be accumulated.
	# min and max pos for each chr

	if (is.null(gsize)) {
		# Chr	minPos	maxPos	cumPos
		# chr1	910473	249162263	0
		# chr2	449487	242926381	249162263
		# chr3	281636	197837967
		chrlen = data[, .(minPos = min(Pos), maxPos = max(Pos)), by = Chr][, .(Chr, minPos, maxPos, cumPos = shift(cumsum(as.numeric(maxPos)), 1, fill = 0))]
		# add it back to data
	} else {
		chrs   = unique(unlist(data[, "Chr"]))
		gsize  = gsize[chrs,,drop = FALSE]
		gsize  = as.data.table(cbind(Chr = rownames(gsize), minPos = 0, maxPos = gsize[,1]))
		gsize  = gsize[Chr %in% chrs]
		chrlen = gsize[, .(Chr, minPos, maxPos, cumPos = shift(cumsum(as.numeric(maxPos)), 1, fill = 0))]
	}
	data = merge(data, chrlen, by = "Chr", sort = FALSE)

	data[, X:= Pos + cumPos][, Y:=-log10(P)]
	# get region centers
	rdata = data[, .(Region, centerPos = (min(X) + max(X))/2), by = Region]
	# fix the order
	data$Region = factor(data$Region, levels = unique(data$Region))
	# hilight
	# 1. rows, color, ... or
	# 2. chr, start, end, color
	ggs_hilight = list()
	hinames = names(hilights)
	if (!is.null(hinames)) {
		hilights = list(hilights)
	}
	hdata = NULL
	for (hilight in hilights) {
		if ('snps' %in% names(hilight)) {
			hdata_tmp = data[Snp %in% hilight$snps]
			hdata = ifelse(is.null(hdata), hdata_tmp, rbind(hdata, hdata_tmp))
			rm(hdata_tmp)
		} else if ('chr' %in% names(hilight)) {
			hdata_tmp = data[Chr == hilight$chr & Pos >= as.numeric(hilight$start) & Pos <= as.numeric(hilight$end)]
			hdata = ifelse(is.null(hdata), hdata_tmp, rbind(hdata, hdata_tmp))
			rm(hdata_tmp)
		} else {
			stop('Either "snps" or "chr" needed to locate the snps to be highlighted.')
		}
	}
	if (!is.null(hdata)) {
		hicolor = ifelse(is.null(hilight$color), "red", hilight$color)
		ggs_hilabel = list()
		if (hilabel) {
			ggs_hilabel = list(geom_label_repel = list(aes_string(x = 'X', y = 'Y', label = 'Snp'), color = "white", fill = hicolor, data = hdata, inherit.aes = FALSE, alpha = .8))
		}
		ggs_hilight = c(
			ggs_hilight,
			ggs_hilabel,
			list(geom_point = list(aes_string(x = 'X', y = 'Y'), color = hicolor, data = hdata, inherit.aes = FALSE))
		)
	}
	ggs = c(list(
		expand_limits      = list(y = c(0, max(data[, 'Y']) * 1.05)),
		geom_point         = list(aes_string(color = 'Region'), alpha = .8),
		guides             = list(color = FALSE),
		scale_color_manual = list(values = rep(c("grey", "skyblue"), nrow(rdata))),
		scale_y_continuous = list(expand = c(0, 0)),
		scale_x_continuous = list(expand = expand_scale(mult = c(0.01, 0.01)), label = rdata$Region, breaks= rdata$centerPos),
		theme_bw           = list(),
		theme              = list(
			panel.grid.minor   = element_blank(),
			panel.grid.major.x = element_blank(),
			axis.text.x        = element_text(angle = 90, hjust = 1, vjust = 0.5)
		),
		labs               = list(x = "", y = "-log10(p-value)")
		), ggs_hilight, ggs)
	plot.xy (data, plotfile, x = 'X', y = 'Y', ggs = ggs, devpars = devpars)
}

plot.pairs = function(data, plotfile = NULL, params = list(), ggs = list(),
	devpars = list(res = 300, width = 400, height = 400)) {

	library(GGally)
	p = do.call(ggpairs, c(list(data), params))
	for (n in names(ggs)) {
		p = p + do.call(n, ggs[[n]])
	}
	ncols          = ifelse(is.null(params$columns), ncol(data), length(params$columns))
	devpars$width  = devpars$width*ncols
	devpars$height = devpars$height*ncols
	save.plot(p, plotfile, devpars)
}

.surv.cut = function(data, vars = NULL, by = 'maxstat', labels = c("low", "high"), keep.raw = FALSE) {
	# by = mean, median, q25, q75, asis, maxstat
	# or a value as cutoff
	cnames = colnames(data)
	if (is.null(vars)) {
		vars = c(cnames[3:ncol(data)])
	}
	p = list()
	for (v in vars) {
		vdata = as.vector(unlist(data[,v]))
		if (keep.raw) {
			rawv  = paste0('raw.', v)
			data[, rawv] = data[, v]
		}
		if (by == 'asis' || !is.numeric(vdata) || length(levels(factor(vdata))) <= 5) {
			data[, v] = as.factor(as.character(vdata))
		} else if (by == 'maxstat') {
			data.cut = surv_cutpoint(data, time = cnames[1], event = cnames[2], variables = v)
			data.cat = surv_categorize(data.cut)
			data[, v] = data.cat[, v]
			p[[v]] = plot(data.cut)[[v]]
		} else {
			if (by == 'mean') {
				vcut = mean(vdata)
			} else if (by == 'median') {
				vcut = median(vdata)
			} else if (by == 'q25') {
				vcut = quantile(vdata, .25)
			} else if (by == 'q75') {
				vcut = quantile(vdata, .75)
			} else {
				vcut = by
			}
			icut = as.integer(median(which(vdata %in% vcut)))
			tmp = sapply(1:length(vdata), function(i) {
				if (vdata[i] < vcut) {
					labels[1]
				} else if (vdata[i] > vcut) {
					labels[2]
				} else if (i < icut) {
					labels[1]
				} else {
					labels[2]
				}
			})
			data[,v] = tmp
		}
	}
	# plot is a list of plots named with the variables
	return(list(data = data, plot = p))
}

plot.survival.km = function(data, plotfile = NULL, params = list(
	risk.table  = TRUE,
	pval        = TRUE,
	cut         = 'maxstat',
	cutlabels   = c('low', 'high')
), ggs = list(table = NULL), devpars = DEVPARS) {
	# @description:
	#   Use Kaplan Merier to do survival analysis
	#   See: http://www.sthda.com/english/wiki/survival-analysis-basics#kaplan-meier-survival-estimate
	# @params:
	#   dat: The data frame, where:
	#     - 1st col is time
	#     - 2nd col is status
	#     - 3rd col is the variable (have to be categorical)
	#   varname: The variable name to display instead of var (3rd colname)
	#   params:  The params used for ggsurvplot. If provided, global plot$params will not be override
	# @returns:
	#   list(plot, table, cutplot)
	library(survival)  # 2.44-1.1
	library(survminer) # 0.4.4.999

	ret = list()
	cnames  = colnames(data)
	variable = cnames[3]

	cutmethod = list.get(params, 'cut', 'maxstat')
	cutlabels = list.get(params, 'cutlabels', c('low', 'high'))

	params$cut       = NULL
	params$cutlabels = NULL

	survcut = .surv.cut(data, by = cutmethod, labels = cutlabels, keep.raw = TRUE)
	data    = survcut$data

	ret$cutplot = ifelse(length(survcut$plot) > 0, survcut$plot[[variable]], NULL)
	ret$data    = data

	# compose formula
	fmula  = sprintf('Surv(%s, %s) ~ %s',
		bQuote(cnames[1]),
		bQuote(cnames[2]),
		bQuote(variable))
	modfit = surv_fit(as.formula(fmula), data = data)

	returnTable = list.get(params, 'returnTable', FALSE)
	params$returnTable = NULL
	params$risk.table = list.get(params, 'risk.table', TRUE)
	params$pval = list.get(params, 'pval', TRUE)

	ret$plot = do.call(ggsurvplot, c(list(modfit, data = data), params))
	if (length(levels(as.factor(data[, 3]))) < 2) {
		ret$table = data.frame(
			var    = variable,
			method = 'Kaplan Merier',
			test   = 'LogRank',
			groups = 1,
			df     = 1,
			pvalue = '1.00E+00'
		)
	} else {
		counts = as.data.frame(table(data[, variable]))
		ret$table = data.frame(
			var    = variable,
			method = 'Kaplan Merier',
			test   = 'LogRank',
			groups = paste(apply(counts, 1, function(row) paste(row, collapse = ':')),
				collapse = ', '),
			df     = 1,
			pvalue = sprintf('%.2E', surv_pvalue(modfit, data = data)$pval)
		)
	}

	tableggs       = list.get(ggs, 'table', list())
	ggs$table      = NULL
	ret$plot$table = apply.ggs(ret$plot$table, tableggs)
	ret$plot$plot  = apply.ggs(ret$plot$plot, ggs)
	save.plot(ret$plot, plotfile, devpars)
	if (!is.null(plotfile) && !is.null(ret$cutplot)) {
		save.plot(
			ret$cutplot,
			sprintf("%s.cut.png", tools::file_path_sans_ext(plotfile)),
			devpars)
	}
	return(ret)
}


plot.survival.cox = function(data, plotfile = NULL, params = list(
	risk.table  = TRUE,
	pval        = TRUE,
	# mean, median, q25, q75, asis, or a value as cutoff
	# asis uses the levels in 3rd column, requring categorical values
	# or if 3rd column has <= 5 levels, regard it as categorical,
	# ignore this argument
	cut = 'maxstat',
	cutlabels = c('low', 'high')
), ggs = list(table = NULL), devpars = DEVPARS) {
	# @description:
	#   Use Kaplan Merier to do survival analysis
	#   See: http://www.sthda.com/english/wiki/cox-proportional-hazards-model
	# @params:
	#   dat: The data frame, where:
	#     - 1st col is time
	#     - 2nd col is status (censoring)
	#     - 3rd col is the target variable
	#     - ... covariates ...
	#   varname: The variable name to display instead of var (3rd colname)
	#   params:  The params used for ggsurvplot. If provided, global plot$params will not be override
	# @returns:
	#   list(data, plot, cutplot, forest, table)
	library(survival)
	library(survminer)

	ret      = list()
	cnames   = colnames(data)
	variable = cnames[3]
	if (length(cnames) > 3) {
		for (i in 4:length(cnames)) {
			data[, i] = as.numeric(as.factor(data[, i]))
		}
	}

	# compose formula
	fmula    = sprintf('Surv(%s, %s) ~ .', bQuote(cnames[1]), bQuote(cnames[2]))
	# do cox regression
	fit0     = coxph(as.formula(fmula), data = data)
	sumfit    = summary(fit0)
	ret$table = data.frame(
		var    = rownames(sumfit$conf.int),
		method = 'Cox Regression',
		test   = 'Log Rank')

	ret$table         = cbind(
		ret$table, sumfit$conf.int[, -2, drop = FALSE], sumfit$coefficients[, 4:5, drop = FALSE])
	ret$table$df      = sumfit$logtest[2]
	ret$table$modpval = sumfit$logtest[3]
	ret$forest        = ggforest(fit0, data = data)
	colnames(ret$table)[4:8] = c('HR', 'CI95_1', 'CI95_2', 'z', 'pvalue')

	# now we cut the variable to plot it
	cutmethod = list.get(params, 'cut', 'maxstat')
	cutlabels = list.get(params, 'cutlabels', c('low', 'high'))
	params$cut = NULL
	params$cutlabels = NULL
	survcuts  = .surv.cut(data, by = cutmethod, labels = cutlabels, vars = variable, keep.raw = TRUE)
	ret$cutplot = ifelse(length(survcuts$plot) > 0, survcuts$plot[[variable]], NULL)
	ret$data    = survcuts$data
	survcuts$data[[paste0('raw.', variable)]] = NULL
	fit     = coxph(as.formula(fmula), data = survcuts$data)
	groups  = levels(as.factor(survcuts$data[,variable]))
	newdata = data.frame(groups = groups)
	colnames(newdata) = variable
	if (length(cnames) > 3) {
		for (i in 4:length(cnames)) {
			var = cnames[i]
			newdata[[var]] = mean(as.numeric(survcuts$data[,var]), na.rm = TRUE)
		}
	}
	fit2 = survfit(fit, newdata = newdata)
	risktable = list.get(params, 'risk.table', TRUE)
	params$risk.table = FALSE
	pval = list.get(params, 'pval', TRUE)
	if (pval) {
		params$pval = sprintf(
			'P = %.3E\nHR = %.3f (95%% CI %.3f ~ %.3f)',
			sumfit$logtest[3], ret$table[1,4], ret$table[1,5], ret$table[1,6])
	}

	ret$plot = do.call(ggsurvplot,
		c(list(fit2, data = newdata, legend.labs=paste(variable, '=', groups)), params))

	# need to hack a risk table.
	# See https://github.com/kassambara/survminer/issues/231#issuecomment-309453646
	if (risktable) {
		fmula = sprintf('Surv(%s, %s) ~ %s',
				bQuote(cnames[1]), bQuote(cnames[2]), bQuote(variable))
		kmfit = surv_fit(as.formula(fmula), data = survcuts$data)
		rtparams = list(kmfit, risk.table = TRUE, data = survcuts$data)
		if (!is.null(params$break.time.by)) {
			rtparams = c(rtparams, list(break.time.by = params$break.time.by))
		}
		if (!is.null(params$xlim)) {
			rtparams = c(rtparams, list(xlim = params$xlim))
		}
		kmplot = do.call(ggsurvplot, rtparams)
		kmplot$plot = ret$plot$plot
		ret$plot = kmplot
		tableggs = list.get(ggs, 'table', list())
		ggs$table = NULL
		ret$plot$table = apply.ggs(ret$plot$table, tableggs)
	}
	ret$plot$plot = apply.ggs(ret$plot$plot, ggs)
	save.plot(ret$plot, plotfile, devpars)
	if (!is.null(plotfile) && !is.null(ret$cutplot)) {
		save.plot(
			ret$cutplot[[variable]],
			sprintf("%s.cut.png", tools::file_path_sans_ext(plotfile)),
			devpars)
	}
	if (!is.null(plotfile)) {
		save.plot(
			ret$forest,
			sprintf("%s.forest.png", tools::file_path_sans_ext(plotfile)),
			devpars)
	}
	return(ret)
}

# The data should be a data.frame with rows as samples and columns as genes
#         Group   Gene1  Gene2 ... GeneN
# sample1 Control 1      2     ... x
# ...
# params$has.group indicates if the data has first column as group or not
plot.mds = function(data, plotfile, params = list(has.group = TRUE, ndim = 2),
	ggs = list(), devpars = DEVPARS) {

	data = as.data.frame(data)
	groupdata = NULL
	if (list.get(params, 'has.group', TRUE)) {
		groupdata = data[, 1, drop = FALSE]
		data = data[, -1, drop = FALSE]
	}
	plotdata = as.data.frame(cmdscale(dist(scale(data)), k = list.get(params, 'ndim', 2)))
	if(!is.null(groupdata)) {
		plotdata = cbind(plotdata,Group = groupdata[rownames(plotdata),])
		hulldata = NULL
		for (grup in levels(as.factor(plotdata$Group))) {
			if (is.null(hulldata)) {
				hulldata = plotdata[plotdata$Group == grup,,drop = FALSE][
					chull(plotdata[plotdata$Group == grup, 1:2]), ]
			} else {
				hulldata = rbind(hulldata, plotdata[plotdata$Group == grup,,drop = FALSE][
					chull(plotdata[plotdata$Group == grup, 1:2]), ])
			}
		}
		print(hulldata)
		ggs = c(list(
			geom_point = list(aes_string(color = 'Group'), shape = 21),
			geom_polygon = list(aes_string(fill = 'Group', group = 'Group'), alpha = .3, data = hulldata),
			geom_text_repel = list(label = rownames(plotdata), min.segment.length = unit(0, 'lines')),
			theme_bw = list(),
			labs = list(x = 'Dimension 1', y = 'Dimension 2'),
			theme = list(axis.text.x = element_blank(),  # remove x-axis text
				axis.text.y = element_blank(), # remove y-axis text
				axis.ticks = element_blank(),  # remove axis ticks
				panel.background = element_blank(),
				panel.grid.major = element_blank(),  #remove major-grid labels
				panel.grid.minor = element_blank(),  #remove minor-grid labels
				plot.background = element_blank())
		), ggs)
	} else {
		ggs = c(list(
			geom_point = list(shape = 21),
			geom_text_repel = list(label = rownames(plotdata), min.segment.length = unit(0, 'lines')),
			theme_bw = list(),
			labs = list(x = 'Dimension 1', y = 'Dimension 2'),
			theme = list(axis.text.x = element_blank(),  # remove x-axis text
				axis.text.y = element_blank(), # remove y-axis text
				axis.ticks = element_blank(),  # remove axis ticks
				panel.background = element_blank(),
				panel.grid.major = element_blank(),  #remove major-grid labels
				panel.grid.minor = element_blank(),  #remove minor-grid labels
				plot.background = element_blank())
		), ggs)
	}
	plot.xy(plotdata, plotfile, x = 'V1', y = 'V2', ggs = ggs, devpars = devpars)

}

{{rimport}}('__init__.r', 'plot.r')
options(stringsAsFactors = FALSE)

infile  = {{i.infile | R}}
inmodel = {{i.model | R}}
outfile = {{o.outfile | R}}
outdir  = {{o.outdir | R}}
inopts  = {{args.inopts | R}}
outopts = {{args.out | R}}
plotroc = {{args.plot | R}}
devpars = {{args.devpars | R}}
ggs     = {{args.ggs | R}}

predictOne = function(idata, model, case) {
	prob  = predict(model, idata, type="response")
	ncols = ncol(idata)
	if (!is.null(model$ylabs)) { # categorical
		ymin   = model$ymin
		ymax   = model$ymax
		index  = round(prob * (ymax - ymin) + ymin)
		result = model$ylabs[index]
	} else {
		ymin   = model$ymin
		ymax   = model$ymax
		result = prob * (ymax - ymin) + ymin
	}
	out   = cbind(idata, Case = case, Predict.Result = result)
	colnames(out)[ncols+2] = paste0(model$ycol, '.Result')
	if (outopts$prob) {
		out = cbind(out, Predict.Prob = round(prob, 3))
		colnames(out)[ncols+3] = paste0(model$ycol, '.Prob')
	}
	out
}

indata = read.table.inopts(infile, inopts)
if (dir.exists(inmodel)) {
	mfiles = Sys.glob(file.path(inmodel, '*.*.rds'))
} else {
	mfiles = inmodel
}

out   = NULL
ycol  = NULL
ylabs = NULL
for (mfile in mfiles) {
	case  = tools::file_path_sans_ext(basename(mfile))
	model = readRDS(mfile)
	if (!is.null(ycol) && model$ycol != ycol)
		stop('Models are not on the same column')
	if (is.null(ycol)) ycol = model$ycol
	if (is.null(ylabs)) ylabs = model$ylabs
	ret   = predictOne(indata, model, case)
	out   = ifelse(is.null(out), ret, rbind(out, ret))
}

vars = colnames(indata)
if (!ycol %in% vars) {
	logger('Y column not included, no ROC plotted and no AUCs output anyway.')
	quit()
}

if (outopts$auc || is.list(plotroc)) {
	cases    = levels(factor(out$Case))
	if (length(ylabs) == 0) {
		rocdata  = data.frame(D = as.integer(out[, ycol] > mean(out[, ycol])))
	} else if (length(ylabs) == 1) {
		stop('Unable to do AUC on 1 level only for Y column.')
	} else if (length(ylabs) == 2) {
		rocdata = data.frame(D = as.integer(out[, ycol] == ylabs[2]))
	} else {
		rocdata = data.frame(D = as.integer(out[, ycol] == ylabs[length(ylabs)]))
	}
	for (case in cases) {
		rocdata  = cbind(rocdata, x = out[which(out$Case == case), paste0(ycol, '.Result')])
		colnames(rocdata)[ncol(rocdata)] = case
	}
	nrows = nrow(rocdata)
	aucs = plot.roc(
		rocdata, 
		plotfile = file.path(outdir, {{i.infile | fn2 | @append: '.roc.png' | quote}}),
		stacked  = FALSE,
		params   = c(list(returnAUC = TRUE), plotroc),
		ggs      = ggs,
		devpars  = devpars
	)
	if (outopts$auc) {
		out$AUC = NA
		for (case in cases)
			out[which(out$Case == case), 'AUC'] = aucs[[case]]
	}
}

write.table(out, outfile, row.names = inopts$rnames, col.names = T, sep = "\t", quote = F)

library(methods)
library(data.table)
{{rimport}}('__init__.r', 'plot.r')

infile1 = {{i.infile1    | quote}}
infile2 = {{i.infile2    | quote}}
outdir  = {{o.outdir     | quote}}
outfile = {{o.outfile    | quote}}
dopval  = {{args.pval    | R}}
dofdr   = {{args.fdr     | R}}
inopts1 = {{args.inopts1 | R}}
inopts2 = {{args.inopts2 | R}}
doplot  = {{args.plot    | R}}
method  = {{args.method  | quote}}
outfmt  = {{args.outfmt  | quote}}
params  = {{args.params  | R}}
ggs     = {{args.ggs     | R}}
devpars = {{args.devpars | R}}

indata1 = read.table.inopts(infile1, inopts1)
indata2 = read.table.inopts(infile2, inopts2)
len1    = ncol(indata1)
len2    = ncol(indata2)
indata = merge(indata1, indata2)

rnames1 = rownames(indata1)
rnames2 = rownames(indata2)
if (is.null(rnames1))
	rnames1 = paste0('R1_', 1:nrow(indata1))
if (is.null(rnames2))
	rnames2 = paste0('R2_', 1:nrow(indata2))
rm(indata1, indata2)
saveResults = function (corr, rnames1, rnames2, outfmt, outfile) {
	if (outfmt == 'pairs') {
		rownames(corr) = apply(merge(rnames1, rnames2), 1, function(row) paste(row, collapse = "\t"))
		write.table(corr, outfile, col.names = F, row.names = T, quote = F, sep = "\t")
	} else {
		corr = cbind(merge(rnames1, rnames2), corr = corr)
		corr = dcast(corr, x ~ y, value.var = 'corr')
		rownames(corr) = corr[, 1]
		corr = corr[, -1, drop = F]
		write.table(corr, outfile, col.names = T, row.names = T, quote = F, sep = "\t")
	}
}

if (!dopval && dofdr == F) {
	corr = apply(indata, 1, function(row) cor(
		row[1:len1],
		row[len1+1:len2],
		method = method
	))
	corr = data.frame(corr = corr)
	saveResults(corr, rnames1, rnames2, outfmt, outfile)
} else {
	corr0 = apply(indata, 1, function(row) cor.test(
		row[1:len1],
		row[len1+1:len2],
		method = method
	))
	corr = data.frame(corr = sapply(corr0, function(x) x$estimate))
	saveResults(corr, rnames1, rnames2, outfmt, outfile)
	pvals = sapply(corr0, function(x) x$p.value)
	corrp = data.frame(pval = sapply(corr0, function(x) x$p.value))
	saveResults(corrp, rnames1, rnames2, outfmt, paste0(tools::file_path_sans_ext(outfile), '_pval.txt'))

	if (dofdr != F) {
		if (dofdr == T) dofdr = 'BH'
		qvals = p.adjust(pvals, method = dofdr)
		corrq = data.frame(qval = qvals)
		saveResults(corrp, rnames1, rnames2, outfmt, paste0(tools::file_path_sans_ext(outfile), '_qval.txt'))
	}
}

if (doplot) {
	outplot = paste0(tools::file_path_sans_ext(outfile), '.png')
	if (is.null(params$dendro))
		params$dendro = F
	corr = cbind(merge(rnames1, rnames2), corr = corr)
	corr = dcast(corr, x ~ y, value.var = 'corr')
	rownames(corr) = corr[, 1]
	corr = corr[, -1, drop = F]
	#corr[lower.tri(corr)] = 0
	ggs = c(list(
		theme = list(
			legend.position      = c(0.03, 0.97),
			legend.justification = c("left", "top"),
			legend.title         = element_text(margin = margin(b = 5)),
			legend.box.just      = "right"
		),
		guides = list(
			fill = guide_legend(title = paste0(toupper(substring(method, 1, 1)), substring(method, 2)), reverse = T)
		)
	), ggs)
	plot.heatmap(corr, outplot, params, ggs, devpars)
}

library(randomForest)
{{rimport}}('__init__.r')

infile       = {{i.infile | quote}}
outmodel     = {{o.outmodel | quote}}
outdir       = {{o.outdir | quote}}
args.plot    = {{args.plot | R}}
args.formula = {{args.formula | R}}
inopts       = {{args.inopts | R}}
devpars      = {{args.devpars | R}}
na           = {{args.na | R}}
prefix       = {{i.infile | stem | quote}}

indata = read.table.inopts(infile, inopts)
indata[is.na(indata)] = na

cnames = colnames(indata)
if (is.null(cnames)) {
	colnames(indata) = c(paste('X', 1:(ncol(indata)-1)), 'Y')
	cnames = colnames(indata)
}

if (is.null(args.formula)) {
	backtick = function(x) sprintf('`%s`', x)
	ycol = cnames[ncol(indata)]
	args.formula = as.formula(paste(cnames[ncol(indata)], '~', paste(backtick(cnames[1:(ncol(indata)-1)]), collapse = '+')))
} else {
	ycol = unlist(strsplit(args.formula, '\\s*~\\s*'))[1]
	args.formula = as.formula(args.formula)
}

model.rf = randomForest(args.formula, data = indata)
saveRDS(model.rf, outmodel)

# save importance
write.table(
	round(model.rf$importance[order(model.rf$importance[, 1], decreasing = T), , drop = F], 3), 
	file.path(outdir, paste0(prefix, '.importance.txt')), 
	col.names = T, row.names = T, quote = F, sep = "\t")

# plot importance
{% if args.plot %}
do.call(png, c(list(file.path(outdir, paste0(prefix, '.importance.png'))), devpars))
randomForest::varImpPlot(model.rf, main = 'Feature importance')
dev.off()
{% endif %}

library ('factoextra')
library ('apcluster')
data = read.table ({{i.infile | quote}}, sep="\t", header={{args.cnames | R}}, row.names={{args.rnames | lambda x: 'NULL' if not x else int(x)}}, check.names=F)
if ({{args.transpose | R}}) {
	data = t(data)
}
data = data[, apply(data, 2, sd)!=0, drop=F]
ap        = apcluster(negDistMat(r=2), data)
clusters  = ap@clusters
nclust    = length (clusters)
clusts    = matrix (NA, ncol=1, nrow=ap@l)
rownames (clusts) = rownames(data)
for (i in 1:nclust) {
	cids  = unlist (clusters[i])
	for (cid in cids) clusts[cid, 1] = i
}
fvizobj   = {}
fvizobj$data = data
fvizobj$cluster = clusts

clustfile = file.path ({{o.outdir | quote}}, "clusters.txt")
write.table (clusts, clustfile, quote=F, col.names = F, sep="\t")
clustfig  = file.path ({{o.outdir | quote}}, "clusters.png")

do.call(png, c(list(file = clustfig), {{args.devpars | Rlist}}))
labels    = colnames(data)
print (fviz_cluster (fvizobj, main = ""))
dev.off()

{{rimport}}('__init__.r', 'plot.r')

infile       = {{i.infile | quote}}
outmodel     = {{o.outmodel | quote}}
outdir       = {{o.outdir | quote}}
args.plot    = {{args.plot | R}}
args.formula = {{args.formula | R}}
ggs          = {{args.ggs | R}}
devpars      = {{args.devpars | R}}
prefix       = {{i.infile | stem | quote}}
yval         = {{args.yval | quote}}

indata = read.table.nodup(
	infile, 
	header      = {{args.inopts.get('cnames', True) | R}},
	row.names   = {{args.inopts.get('rnames', True) | :1 if a else None | R}},
	sep         = {{args.inopts.get('delimit', '\t') | R}},
	check.names = {{args.inopts.get('check.names', False) | R}}
)

cnames = colnames(indata)
if (is.null(cnames)) {
	colnames(indata) = c(paste('X', 1:(ncol(indata)-1)), 'Y')
	cnames = colnames(indata)
}

if (is.null(args.formula)) {
	ycol = cnames[ncol(indata)]
	args.formula = as.formula(paste(cnames[ncol(indata)], '~', paste(cnames[1:(ncol(indata)-1)], collapse = '+')))
} else {
	ycol = unlist(strsplit(args.formula, '\\s*~\\s*'))[1]
	args.formula = as.formula(args.formula)
}

if (yval == 'categ') {
	ylabs   = levels(as.factor(indata[, ycol]))
	ylevels = order(ylabs)
	ymin    = min(ylevels)
	ymax    = max(ylevels)
	indata[, ycol] = (match(indata[, ycol], ylabs) - ymin)/(ymax - ymin)
	model.fit = lm(args.formula, data = indata)
	model.fit$ymin    = ymin
	model.fit$ymax    = ymax
	model.fit$ylabs   = ylabs
} else if (yval == 'numeric') {
	ymin = min(indata[, ycol])
	ymax = max(indata[, ycol])
	indata[, ycol] = (indata[, ycol] - ymin) / (ymax - ymin)
	model.fit = lm(args.formula, data = indata)
	model.fit$ymin = ymin
	model.fit$ymax = ymax
}
model.fit$yval = yval
model.fit$ycol = ycol

saveRDS(model.fit, outmodel)

model.fit.sum = summary(model.fit)
ret = model.fit.sum$coefficients

# confident interval
conf.int = confint(model.fit)
colnames(conf.int) = c('confInt25', 'confInt975')

OR = as.matrix(coef(model.fit))
colnames(OR) = 'OR'
ret = cbind(ret, exp(OR), exp(conf.int))
ret[, c(1:3, 5:7)] = round(ret[, c(1:3, 5:7)], 3)
ret[, 4] = formatC(ret[, 4], format = "E", digits = 2)
write.table(ret, file.path(outdir, paste0(prefix, '.features.txt')), row.names = T, col.names = T, sep = "\t", quote = F)

{% if args.plot %}
library(ggplot2)
plotfile = file.path(outdir, paste0(prefix, '.lm.png'))
plotdata = cbind(model.fit$model[, 1, drop=F], apply(model.fit$model[, -1, drop = F], 1, sum))
colnames(plotdata) = c(ycol, if (ncol(model.fit$model) > 2) 'Features' else colnames(model.fit$model)[ncol(model.fit$model)])

plot.scatter(plotdata, plotfile, x = 2, y = 1, ggs = ggs, devpars = devpars)
{% endif %}

library(methods)
{{rimport}}('__init__.r')
options(stringsAsFactors = FALSE)

indir     = {{i.indir | R}}
outfile   = {{o.outfile | R}}
outdir    = {{o.outdir | R}}
params    = {{args.params | R}}
select    = {{args.select | R}}
plots     = {{args.plots | R}}
devpars   = {{args.devpars | R}}
plink     = {{args.plink | quote}}
nthread   = {{args.nthread | R}}
samid     = {{args.samid | R}}
indep     = {{args.indep | R}}
highld    = {{args.highld | R}}
jobstdout = {{job.outfile | R}}

if (is.true(plots, 'any')) {
	{{rimport}}('plot.r')
}

bedfile = Sys.glob(file.path(indir, '*.bed'))
input   = tools::file_path_sans_ext(bedfile)
output  = file.path(outdir, basename(input))

# if (is.true(covfile) && is.true(covname)) {
# 	newcovfile = paste0(output, '.cov.txt')
# 	covdata = read.table.inopts(covfile, list(rnames = FALSE))
# 	if (covname == 'fid' || covname == 'iid') {
# 		covdata = cbind(covdata[,1,drop=FALSE], covdata)
# 	} else {
# 		ids = do.call(rbind, strsplit(as.character(covdata[,1]), '_', fixed = TRUE))
# 		nids = ncol(ids)
# 		if (nids %% 2 > 0) {
# 			stop('You have imbalanced _ in FID and IID')
# 		}
# 		midunscore = as.integer(nids/2)
# 		ids = data.frame(
# 			FID = apply(ids[, 1:midunscore], 1, function(x) paste(x, collapse = '_')),
# 			IID = apply(ids[, (midunscore + 1):nids], 1, function(x) paste(x, collapse = '_'))
# 		)
# 		covdata = cbind(ids, covdata[, -1, drop = FALSE])
# 	}
# 	colnames(covdata)[1:2] = c('FID', 'IID')
# 	write.table(covdata, newcovfile, col.names = TRUE, row.names = FALSE, quote = FALSE, sep = "\t")
# 	covfile = newcovfile
# }

# prune high LD SNPs
pruneparams = list(
	bfile            = input,
	exclude          = highld,
	range            = T,
	`indep-pairwise` = indep,
	out              = output
)
cmd = sprintf("%s %s 1>&2", plink, cmdargs(pruneparams, equal = ' '))
runcmd(cmd)

prunein = paste0(output, '.prune.in')

default.params = list(
	pca     = TRUE,
	bfile   = input,
	out     = output,
	threads = nthread,
	extract = prunein
	#covar   = ifelse(is.true(covfile), covfile, FALSE)
)

params = update.list(default.params, params)
# stdout slows down the program
cmd = sprintf("%s %s 1>&2", plink, cmdargs(params, equal = ' '), jobstdout)
runcmd(cmd)

valfile = paste0(output, '.eigenval')
vecfile = paste0(output, '.eigenvec')

sdevdf = read.table(valfile, header = FALSE, row.names = NULL)
rownames(sdevdf) = paste0('PC', 1:nrow(sdevdf))
colnames(sdevdf) = 'Sdev'

sdevdf$Percent    = 100 * sdevdf$Sdev / sum(sdevdf$Sdev)
sdevdf$CumPercent = cumsum(sdevdf$Percent)

write.table(sdevdf, paste0(output, '.sdev.txt'), sep = "\t", quote = FALSE)

npcs = nrow(sdevdf)
if (is.null(select)) {
	select = 1:npcs
} else if (select >= 1) {
	select = 1:min(npcs, select)
} else {
	select = 1:max(2, min(npcs, sum(sdevdf$Percent >= select * 100)))
}

pcs = read.table(vecfile, header = FALSE, row.names = NULL, sep = " ", check.names = FALSE)
if (samid == 'fid') {
	rownames(pcs) = pcs[,1]
} else if (samid == 'iid') {
	rownames(pcs) = pcs[,2]
} else {
	rownames(pcs) = paste(pcs[,1], pcs[,2], sep = '_')
}
pcs = pcs[, -(1:2), drop = FALSE]
colnames(pcs) = paste0('PC', 1:ncol(pcs))
write.table(pcs, paste0(output, '.allpcs.txt'), sep = "\t", quote = FALSE)
write.table(pcs[, select, drop = FALSE], outfile, sep = "\t", quote = FALSE)

if (is.true(plots$scree)) {
	screefile = paste0(output, '.screeplot.png')
	if (!is.list(plots$scree)) {
		plots$scree = list(ncp = 20)
	}
	plot.bar(
		cbind(sdevdf[1:plots$scree$ncp,,drop = FALSE], PCS = paste0('PC', 1:plots$scree$ncp)), 
		screefile,
		x = 'PCS', y = 'Percent'
	)
}

if (is.true(plots$pairs$anno)) {
	options(stringsAsFactors = TRUE)
	annos = read.table.inopts(plots$pairs$anno, list(cnames = TRUE, rnames = TRUE))
	annos = annos[rownames(pcs),,drop = FALSE]
	pdata = cbind(pcs[, 1:plots$pairs$ncp,drop = FALSE], annos)
	pairsfile = paste0(output, '.pairs.png')
	if (is.null(plots$pairs$params))
		plots$pairs$params = list()
	if (is.null(plots$pairs$ggs))
		plots$pairs$ggs = list()
	plot.pairs(pdata, pairsfile, params = plots$pairs$params, ggs = plots$pairs$ggs)
}

{{rimport}}('__init__.r', 'plot.r')

infile   = {{i.infile | quote}}
outfile  = {{o.outfile | quote}}
prefix   = {{o.outfile | prefix2 | quote}}
outdir   = {{o.outdir | quote}}
inopts   = {{args.inopts | R}}
annofile = {{args.anfile | quote}}
anopts   = {{args.anopts | R}}
devpars  = {{args.devpars | R}}
na       = {{args.na | R}}
seed     = {{args.seed | R}}
select   = {{args.select | R}}
set.seed(seed)

indata = read.table.inopts(infile, inopts)
if (!is.logical(na)) {
	indata[is.na(indata)] = na
}

indata = indata[complete.cases(indata), colSums(indata)!=0, drop = FALSE]

anno = NULL
if (annofile != "") {
	anno = read.table.inopts(annofile, anopts)[rownames(indata),,drop=FALSE]
}
plots = {{args.plots | R}}
pca   = prcomp(indata, scale = TRUE)

allpcfile    = paste0(prefix, '.allpcs.txt')
sdevfile     = paste0(prefix, '.sdev.txt')
centerfile   = paste0(prefix, '.center.txt')
rotationfile = paste0(prefix, '.rotation.txt')
write.table(round(pca$x, 3), allpcfile, sep = "\t", quote = FALSE)
sdev = data.frame(Sdev = pca$sdev, Percent = 100.0*pca$sdev/sum(pca$sdev))
sdev$CumPercent = cumsum(sdev$Percent)
rownames(sdev) = paste0('PC', 1:length(pca$sdev))
write.table(sdev, sdevfile, sep = "\t", quote = FALSE)
center = as.data.frame(pca$center)
colnames(center) = 'Center'
write.table(center, centerfile, sep = "\t", quote = FALSE)
rm(center)
write.table(pca$rotation, rotationfile, sep = "\t", quote = FALSE)

if (is.null(select)) {
	pcs = pca$x
} else if (select > 1) {
	pcs = pca$x[, 1:select, drop = FALSE]
} else {
	npcs = which(sdev$Percent >= select * 100)
	npcs = 1:max(c(2, npcs))
	pcs  = pca$x[, npcs, drop = FALSE]
}
write.table(round(pcs, 3), outfile, sep = "\t", quote = FALSE)

if (is.true(plots$scree)) {
	library(factoextra)
	screefile = paste0(prefix, '.screeplot.png')
	if (!is.list(plots$scree)) {
		plots$scree = list(ncp = 20)
	}
	do.call(png, c(list(screefile), devpars))
	print(do.call(fviz_screeplot, c(list(pca), plots$scree)))
	dev.off()
}

if (is.true(plots$var)) {
	library(factoextra)
	varfile = paste0(prefix, '.varplot.png')
	if (!is.list(plots$var)) {
		plots$var = list(repel = TRUE)
	}
	do.call(png, c(list(varfile), devpars))
	print(do.call(fviz_pca_var, c(list(pca), plots$var)))
	dev.off()
}

if (is.true(plots$bi)) {
	library(factoextra)
	bifile = paste0(prefix, '.biplot.png')
	if (!is.list(plots$bi)) {
		plots$bi = list(repel = TRUE)
	}
	do.call(png, c(list(bifile), devpars))
	print(do.call(fviz_pca_biplot, c(list(pca), plots$bi)))
	dev.off()
}

if (is.true(plots$clplot, 'any')) {
	library(factoextra)
	library(cluster)
	clusterfile = paste0(prefix, '.clusterplot.png')

	clmethod = plots$cluster$method
	plots$cluster$method = NULL
	plots$cluster$x = scale(pcs)
	cldata          = do.call(clmethod, plots$cluster)
	
	if (!is.list(plots$clplot)) {
		plots$clplot = list(repel = TRUE)
	}
	plots$clplot$object = cldata
	plots$clplot$data   = pcs
	plots$clplot$ggs    = NULL

	do.call(png, c(list(clusterfile), devpars))
	p = do.call(fviz_cluster, plots$clplot)
	if (!is.null(anno)) anno = cbind(p$data, anno)
	# reload anno
	ggs = {{args.plots.get('clplot', {}).get('ggs', {}) | R}}
	print(apply.ggs(p, ggs))
	dev.off()
}

if (is.true(plots$pairs)) {
	pcs = pca$x[, 1:plots$pairs$pcs, drop = FALSE]
	cname = NULL
	if (plots$pairs$anno == 'kmeans') {
		anno = as.data.frame(kmeans(pcs, plots$pairs$k, nstart = ifelse(is.null(plots$pairs$nstart), 25, plots$pairs$nstart), iter.max = ifelse(is.null(plots$pairs$niter), 1000, plots$pairs$niter))$clust)
		colnames(anno) = 'Cluster'
		pcs = cbind(pcs, anno)
		pcs$Cluster = as.factor(pcs$Cluster)
		cname = 'Cluster'
	} else if (file.exists(plots$pairs$anno)) {
		anno = read.table(plots$pairs$anno, row.names = 1, header = TRUE, sep = "\t", check.names = FALSE)
		anno = anno[rownames(pcs),,drop = FALSE]
		anno[,1] = as.factor(anno[,1])
		cname = colnames(anno)[1]
		pcs = cbind(pcs, anno)
	}
	pairsfile = paste0(prefix, '.pairs.png')
	if (!is.null(cname)) {
		plot.pairs(pcs, pairsfile, params = list(mapping = ggplot2::aes_string(color = cname), upper = list(continuous = "density")), ggs = list(theme = list(axis.text.x = element_text(angle = 90, hjust = 1))))
	} else {
		plot.pairs(pcs, pairsfile, params = list(upper = list(continuous = "density")), ggs = list(theme = list(axis.text.x = element_text(angle = 90, hjust = 1))))
	}
}

{{rimport}}('__init__.r')

infile   = {{i.infile    | quote}}
outfile  = {{o.outfile  | quote}}

{% if args.intype == 'pair' or args.intype == 'pairs' %}

#
# A+	B+	4
# A-	B-	175 
# A+	B-	12
# A-	B+	1
#
lines       = readLines(infile)
cont.tables = list()
for (line in lines) {
	parts = unlist(strsplit(line, "\t", fixed = T))
	if (length(parts) < 3) {
		stop(paste('Cannot parse line in pair-file:', line))
	}
	name1 = parts[1]
	name2 = parts[2]
	if (!endsWith(name1, '+') && !endsWith(name1, '-')) {
		stop(paste('Name has to end with + or -:', name1))
	}
	if (!endsWith(name2, '+') && !endsWith(name2, '-')) {
		stop(paste('Name has to end with + or -:', name2))
	}
	cname1 = substr(name1, 1, nchar(name1)-1)
	cname2 = substr(name2, 1, nchar(name2)-1)
	name = paste(cname1, cname2, sep = ".vs.")
	if (!name %in% names(cont.tables)) {
		cont.tables[[name]] = matrix(NA, ncol = 2, nrow = 2)
		colnames(cont.tables[[name]]) = c(paste0(cname1, '+'), paste0(cname1, '-'))
		rownames(cont.tables[[name]]) = c(paste0(cname2, '+'), paste0(cname2, '-'))
	}
	cont.tables[[name]][name2, name1] = as.integer(parts[3])
}
# check if we miss any pair values
for (name in names(cont.tables)) {
	if (is.na(cont.tables[[name]]) || F) {
		stop(paste('Missing values in contingency table:', name))
	}
}

{% else %}

#
# 
#    | A | B | ... | X |
# ---+---+---+-----+---+
# S1 | 1 | 0 | ... | 1 |
# S2 | 0 | 1 | ... | 0 |
# .. | 0 | 0 | ... | 1 |
# Sn | 0 | 1 | ... | 1 |
#
inopts.rnames = {{args.rnames | R}}
indata = read.table(infile, sep = "\t", header = T, row.names = if (inopts.rnames) 1 else NULL, check.names = F)
indata = indata[complete.cases(indata), , drop = F]
if (!inopts.rnames) {
	rownames(indata) = paste0('ROW', 1:nrow(indata))
}
it.names = colnames(indata)
cont.tables = list()
for (name1 in it.names) {
	for (name2 in it.names) {
		if (name1 >= name2) next
		
		name1plus  = paste0(name1, '+')
		name1minus = paste0(name1, '-')
		name2plus  = paste0(name2, '+')
		name2minus = paste0(name2, '-')
		name1plus.cols  = rownames(indata[indata[,name1]==1, , drop = F])
		name1minus.cols = rownames(indata[indata[,name1]==0, , drop = F])
		name2plus.cols  = rownames(indata[indata[,name2]==1, , drop = F])
		name2minus.cols = rownames(indata[indata[,name2]==0, , drop = F])
		cont.table = matrix(0, ncol = 2, nrow = 2)
		rownames(cont.table) = c(name1plus, name1minus)
		colnames(cont.table) = c(name2plus, name2minus)
		
		cont.table[name1plus, name2plus]   = length(intersect(name1plus.cols, name2plus.cols))
		cont.table[name1plus, name2minus]  = length(intersect(name1plus.cols, name2minus.cols))
		cont.table[name1minus, name2plus]  = length(intersect(name1minus.cols, name2plus.cols))
		cont.table[name1minus, name2minus] = length(intersect(name1minus.cols, name2minus.cols))
		
		name = paste(name1, name2, sep = '.vs.')
		cont.tables[[name]] = cont.table
	}
}

{% endif %}

out = matrix(NA, ncol = 11, nrow = 0)
colnames(out) = c('ApBp', 'ApBa', 'AaBp', 'AaBa', 'confInt1', 'confInt2', 'oddsRatio', 'pval', 'qval', 'alternative', 'method')

rets  = list()
pvals = c()
ct.names = names(cont.tables)
for (name in ct.names) {
	rets[[name]] = fisher.test(cont.tables[[name]])
	pvals = c(pvals, rets[[name]]$p.value)	
}
qvals = p.adjust(pvals, method = {{args.padj | quote}})
rm (pvals)
for (i in 1:length(ct.names)) {
	name       = ct.names[i]
	qval       = qvals[i]
	ret        = rets[[name]]
	cont.table = cont.tables[[name]]
	items      = unlist(strsplit(name, '.vs.', fixed = T))
	tmp   = data.frame(
		Name1       = items[1],
		Name2       = items[2],
		ApBp        = cont.table[1,1],
		ApBa        = cont.table[1,2],
		AaBp        = cont.table[2,1],
		AaBa        = cont.table[2,2],
		confInt1    = ret$conf.int[1], 
		confInt2    = ret$conf.int[2], 
		oddsRatio   = ret$estimate, 
		pval        = ret$p.value,
		qval        = qval,
		alternative = ret$alternative,
		method      = ret$method
	)
	#rownames(tmp) = name
	out = rbind(out, tmp)
}

write.table(pretty.numbers(out, formats = list(pval..qval = '%.2E', ApBp..ApBa..AaBp..AaBa = '%d', confInt1..confInt2..oddsRatio = '%.3f')), outfile, col.names = T, row.names = F, sep = "\t", quote = F)

{{rimport}}('__init__.r', 'plot.r')
library(caret)
options(stringsAsFactors = FALSE)

{% python from pyppl.utils import alwaysList %}
{% python from os import path %}
infile   = {{ i.infile | quote}}
prefix   = {{ o.outdir, fn2(i.infile) | *path.join | quote }}
outmodel = {{ o.outmodel | quote}}
outdir   = {{ o.outdir | quote}}
inopts   = {{ args.inopts | R}}
seed     = {{ args.seed | R}}
plots    = {{ args.plots | alwaysList | R}}
ctrl     = {{ args.ctrl | R}}
nthread  = {{ args.nthread | R}}
trainps  = {{ args.train | R}}
devpars  = {{ args.devpars | R}}

set.seed(seed)

if (is.null(ctrl$method) || ctrl$method == '') {
	stop('Method has not been specified for trainControl (args.ctrl.method).')
}

if (is.null(trainps$method) || trainps$method == '') {
	stop('Method has not been specified for training (args.train.method).')
}

if (is.null(trainps$form) || trainps$form == '') {
	stop('Formula has not been specified for training (args.train.form).')
}
trainps$form = as.formula(trainps$form)

# method specific packages
# make it a complete list in the future
if (trainps$method %in% c('glm')) {
	library(e1071)
}

if (nthread > 1) {
	library(doParallel)
	cl = makePSOCKcluster(nthread)
	registerDoParallel(cl)
}

indata            = read.table.inopts(infile, inopts)
# I tried na.action for train function, but I got an error:
# Error in as.character(call_obj$na.action) :
#	cannot coerce type 'closure' to vector of type 'character'
# haven't figured out a way to fixed, just remove all NA records
indata = indata[complete.cases(indata),,drop = FALSE]
ycol = all.vars(trainps$form)[1]
# for glm or binary output
if (!is.numeric(indata[, ycol])) {
	indata[, ycol] = as.factor(indata[, ycol])
}
ctrl$verboseIter  = TRUE
train.control     = do.call(trainControl, ctrl)
trainps$data      = indata
trainps$trControl = train.control
m                 = do.call(train, trainps)

if (nthread > 1) {
	stopCluster(cl)
}
saveRDS(m, outmodel)

if ('model' %in% plots) {
	modelplot = paste0(prefix, '.model.png')
	tryCatch({
		save.plot(ggplot(m), modelplot, devpars = devpars)
	}, error = function(e) {
		logger(e, level = 'WARNNING')
	})
}

klass = m$pred$obs
if (is.null(m$pred$Resample)) {
	m$pred$Resample = 'M'
}
if (length(levels(factor(klass))) > 2) {
	rocdata = data.frame(D = klass >= .5, M = m$pred[,4], name = m$pred$Resample)
} else {
	rocdata = data.frame(D = klass, M = m$pred[,4], name = m$pred$Resample)
}
aucs = plot.roc(rocdata, 'return',
	params = list(returnTable = TRUE),
	ggs    = list(scale_color_discrete = list(guide = FALSE)),
	stacked = TRUE, devpars = devpars)
aucs$table$mean_auc = mean(aucs$table$auc)
aucfile = sprintf('%s.aucs.txt', prefix)
write.table(
	pretty.numbers2(aucs$table[aucs$table$is.best,, drop=FALSE], threshold..sensitivity..specificity..auc..auc_95ci1..auc_95ci2..mean_auc = '%.3f'),
	aucfile, row.names = FALSE, quote = FALSE, sep = "\t")

if ('roc' %in% plots) {
	rocplot = sprintf('%s.roc.png', prefix)
	save.plot(aucs$plot, rocplot, devpars)
}

vi = varImp(m)
vifile = sprintf('%s.varimp.txt', prefix)
write.table(vi$importance, vifile, quote = FALSE, sep = "\t")
if ('varimp' %in% plots) {
	viplot = sprintf('%s.varimp.png', prefix)
	save.plot(ggplot(vi), viplot, devpars = devpars)
}

{{runcmd}}
{{cbindfill}}
{{plotHist}}

outsample = file.path("{{o.outdir}}", "{{i.indir | fn}}.sampleCallRate.txt")
figsample = file.path("{{o.outdir}}", "{{i.indir | fn}}.sampleCallRate.png")
outsnp    = file.path("{{o.outdir}}", "{{i.indir | fn}}.snpCallRate.txt")
figsnp    = file.path("{{o.outdir}}", "{{i.indir | fn}}.snpCallRate.png")

setwd("{{i.indir}}")
files = list.files(pattern = "*.vcf")

data  = NULL

for (file in files) {
	sample  = tools::file_path_sans_ext(tools::file_path_sans_ext(file))
	tmp     = runcmd (paste('awk', '\'BEGIN{OFS="\\t"} $0 !~ /^#/ {print $1":"$2,1}\'', file), intern=T)
	con     =  textConnection(tmp)
	tmp     = read.table (con, header=F, row.names=1, check.names=F)
	close(con)
	colnames(tmp) = c(sample)
	data    = cbindfill(data, tmp)
}

samplecr = colSums(data) / nrow(data)
snpcr    = rowSums(data) / ncol(data)

# sample/snp call rate
write.table (samplecr, outsample, quote=F, sep="\t", col.names=F)
plotHist (samplecr, figsample, devpars={{args.devpars | Rlist}}, ggs={{args.histplotggs | lambda x: x + ['r:ggtitle("Sample call rate")', 'r:ylab("# samples")', 'r:xlab("Call rate")'] | Rlist}})
write.table (snpcr, outsnp, quote=F, sep="\t", col.names=F)
plotHist (snpcr, figsnp, devpars={{args.devpars | Rlist}}, ggs={{args.histplotggs | lambda x: x + ['r:ggtitle("SNP call rate")', 'r:ylab("# SNPs")', 'r:xlab("Call rate")'] | Rlist}})

{{rimport}}('plot.r', '__init__.r', 'sampleinfo.r')

library(methods)
options(stringsAsFactors = FALSE)
set.seed(8525)

exprfile  = {{i.efile | R}}
groupfile = {{i.gfile | R}}
cutoff    = {{args.cutoff | :{"by": "p", "value": a, "sign": "<"} if not isinstance(a, dict) else a | R }}
outdir    = {{o.outdir | R}}
allfile   = {{o.outfile | prefix | prefix | @append: ".all.txt" | quote}}
upfile    = {{o.outfile | prefix | prefix | @append: ".up.txt" | quote}}
downfile  = {{o.outfile | prefix | prefix | @append: ".down.txt" | quote}}
outfile   = {{o.outfile | R}}
tool      = {{args.tool | R}}
plots     = {{args.plot | R}}
ggs       = {{args.ggs | R}}
params    = {{args.params | R}}
devpars   = {{args.devpars | R}}
mapfile   = {{args.mapfile | quote}}

# get the exp data
ematrix   = read.table.nodup (exprfile,  header=T, row.names = 1, check.names=F, sep="\t")

# get groups
saminfo = SampleInfo2$new(groupfile, checkPaired = TRUE)

groups = saminfo$all.groups()
if (length(groups) != 2) {
	stop("I don't know how to do comparison between non-paired groups (# group must equal 2)")
}
group1   = groups[1]
group2   = groups[2]
samples1 = saminfo$get.samples(by = 'Group', value = group1)
samples2 = saminfo$get.samples(by = 'Group', value = group2)
# the real matrix
samples = c(samples1, samples2)
saminfo$select(samples)
ematrix = ematrix[, samples, drop = FALSE]

maps = NULL
if (mapfile != "") {
	maps = read.table(mapfile, header = FALSE, row.names = 1, sep = "\t", check.names = FALSE)
}

if (tool == 'edger') {
	# detect DEGs using edgeR
	# get model
	design = saminfo$as.edger.design()

	library(edgeR)
	dge = DGEList(counts = ematrix, group = saminfo$mat$Group)
	dge$samples$lib.size = colSums(dge$counts)
	dge = calcNormFactors(dge)

	disp = estimateDisp (dge, design)
	#fit  = glmQLFit (disp, design)
	#fit  = glmQLFTest (fit, coef = 2)
	fit = glmFit(disp, design)
	fit = glmLRT(fit, coef = 2)

	allgene = topTags (fit, n=nrow(fit$table), p.value = 1)
	allgene = allgene$table
	if (!is.null(maps)) {
		probes = rownames(allgene)
		allgene = cbind(Gene = maps[probes, 1], allgene)
		rownames(allgene) = probes
		rm(probes)
		colnames(allgene)[1] = 'Gene'
	}

	write.table (
		pretty.numbers2(
			allgene, PValue..FDR='%.2E', .='%.3f'
		), allfile, quote=FALSE, sep="\t")

	allgene = allgene[!is.na(allgene$PValue) & !is.na(allgene$FDR),, drop=F]
	if (cutoff$by == 'q') {
		degene = allgene[as.numeric(allgene$FDR) < cutoff$value,, drop = FALSE]
	} else {
		degene = allgene[as.numeric(allgene$PValue) < cutoff$value,, drop=FALSE]
	}
	write.table (
		pretty.numbers2(
			degene, PValue..FDR='%.2E', .='%.3f'
		), outfile, quote=FALSE, sep="\t")
	write.table (
		pretty.numbers2(
			degene[degene$logFC > 0,], PValue..FDR='%.2E', .='%.3f'
		), upfile, quote=FALSE, sep="\t")
	write.table (
		pretty.numbers2(
			degene[degene$logFC < 0,], PValue..FDR='%.2E', .='%.3f'
		), downfile, quote=FALSE, sep="\t")

	# for plots
	normedCounts = log2(dge$counts[rownames(allgene),, drop=FALSE] + 1)
	alllogFC     = allgene$logFC
	allPval      = ifelse(cutoff$by == 'q', allgene$FDR, allgene$PValue)

} else if (tool == 'deseq2') {
	# detect DEGs using DESeq2
	library(DESeq2)
	# model
	design = saminfo$as.deseq2.design()
	dge = DESeqDataSetFromMatrix(round(ematrix), design$coldata, design = design$design)

	dge     = DESeq(dge)
	allgene = results(dge)
	allgene = allgene[order(allgene$pvalue),,drop=F]
	if (!is.null(maps)) {
		probes = rownames(allgene)
		allgene = cbind(Gene = maps[probes, 1], allgene)
		rownames(allgene) = probes
		rm(probes)
		colnames(allgene)[1] = 'Gene'
	}

	write.table (
		pretty.numbers2(
			allgene, pvalue..padj='%.2E', .='%.3f'
		), allfile, quote=FALSE, sep="\t")

	allgene  = allgene[!is.na(allgene$pvalue) & !is.na(allgene$padj),,drop=F]
	if (cutoff$by == 'q') {
		degene = allgene[as.numeric(allgene$padj) < cutoff$value,, drop = FALSE]
	} else {
		degene = allgene[as.numeric(allgene$pvalue) < cutoff$value,, drop = FALSE]
	}
	write.table (
		pretty.numbers2(
			degene, pvalue..padj='%.2E', .='%.3f'
		), outfile, quote=FALSE, sep="\t")
	write.table (
		pretty.numbers2(
			degene[degene$log2FoldChange > 0, ], pvalue..padj='%.2E', .='%.3f'
		), upfile, quote=FALSE, sep="\t")
	write.table (
		pretty.numbers2(
			degene[degene$log2FoldChange < 0, ], pvalue..padj='%.2E', .='%.3f'
		), downfile, quote=FALSE, sep="\t")

	degene$logFC  = degene$log2FoldChange
	degene$PValue = degene$pvalue

	# for plots
	normedCounts  = log2(assay(dge)[rownames(allgene),, drop=FALSE] + 1)
	alllogFC      = allgene$log2FoldChange
	allPval       = ifelse(cutoff$by == 'q', allgene$padj, allgene$pvalue)
} else {
	stop(paste('Unsupported tool:', tool))
}

# MDS plot
if (plots$mdsplot) {
	library(limma)
	mdsplot = file.path (outdir, "mdsplot.png")
	do.call(png, c(list(filename=mdsplot), devpars))
	plotMDS(normedCounts, col=c(rep("red3", length(samples1)), rep("blue3", length(samples2))))
	dev.off()
}

# Volcano
if (plots$volplot) {
	volplot = file.path (outdir, "volcano.png")
	log2fc  = alllogFC
	fdr     = allPval
	plot.volplot(
		data.frame(logFC = log2fc, FDR = fdr),
		fccut    = params$volplot$fccut,
		pcut     = cutoff$value,
		plotfile = volplot,
		ggs      = ggs$volplot,
		devpars  = devpars
	)
}

# heatmap
if (plots$heatmap) {
	if (nrow(degene) < 2) {
		logger('Cannot generate heatmap as < 2 DEGs detected.')
	} else {
		hmap   = file.path (outdir, "heatmap.png")

		mat   = normedCounts[rownames(degene), ]
		plot.heatmap(mat, hmap, ggs = ggs$heatmap, devpars = devpars)
	}
}

# maplots
if (plots$maplot) {
	maplot = file.path(outdir, "maplot.png")
	A = rowSums(normedCounts) / ncol(normedCounts)
	M = alllogFC
	threshold = allPval < cutoff$value
	plot.maplot(
		data.frame(A, M),
		maplot,
		threshold,
		ggs = ggs$maplot,
		devpars = devpars
	)
}

# qqplot
if (plots$qqplot) {
	qqplot = file.path(outdir, 'qqplot.png')
	plot.qq(data.frame(`-log10(Pval)` = -log10(degene$PValue)), qqplot, stacked = TRUE, ggs = ggs$qqplot, devpars = devpars)
}

{{rimport}}('__init__.r', 'plot.r')

set.seed(8525)
library(PCAtools)

infile   = {{i.infile | quote}}
metafile = {{i.metafile | quote}}
outfile  = {{o.outfile | quote}}
prefix   = {{o.outfile | prefix2 | quote}}
outdir   = {{o.outdir | quote}}
inopts   = {{args.inopts | R}}
devpars  = {{args.devpars | R}}
params   = {{args.params | R}}
na       = {{args.na | R}}
plots    = {{args.plots | R}}
npc      = {{args.npc | R}}

indata = read.table.inopts(infile, inopts)
if (!is.logical(na)) {
	indata[is.na(indata)] = na
}

indata = indata[complete.cases(indata),, drop = FALSE][rowSums(indata)!=0,,drop = FALSE]

metadata = NULL
if (metafile != "") {
	metadata = read.table.inopts(metafile, list(cnames = TRUE, rnames = TRUE))
}

metadata = metadata[colnames(indata),,drop = FALSE]

params$mat = indata
params$metadata = metadata
p = do.call(pca, params)

allpcfile   = paste0(prefix, '.allpcs.txt')
sdevfile    = paste0(prefix, '.sdev.txt')
rotatedfile = paste0(prefix, '.rotated.txt')

write.table(p$rotated, allpcfile, quote = FALSE, sep = "\t")
write.table(p$loadings, rotatedfile, quote = FALSE, sep = "\t")
write.table(p$sdev, sdevfile, quote = FALSE, sep = "\t")
sdev = data.frame(sdev = p$sdev, variance = p$variance)
rownames(sdev) = p$components
write.table(sdev, sdevfile, quote = FALSE, sep = "\t")

# try select optimal number of PCs and save them into output file
npcmethod = NULL
if (npc == 'horn') {
	npcmethod = npc
	horn <- parallelPCA(indata)
	npc = horn$n
} else if (npc == 'elbow') {
	npcmethod = npc
	npc = findElbowPoint(p$variance)
} else if (!is.numeric(npc)) {
	stop('Expected a number, "horn" or "elbow" for optimal number of PCs.')
}
write.table(p$rotated[, 1:npc], outfile, quote = FALSE, sep = "\t")

# start plotting
if (is.list(plots$scree) || plots$scree != FALSE) {
	screepng = paste0(prefix, '.scree.png')
	if (!is.list(plots$scree)) {
		plots$scree = list()
	}
	do.call(png, c(list(filename = screepng), devpars))
	screeggs = plots$scree$ggs
	plots$scree$ggs = NULL
	plots$scree$pcaobj = p
	plots$scree$components = getComponents(p, 1:20)
	plots$scree$vline = npc
	if (!is.null(npcmethod)) {
		screeggs = c(screeggs, list(
			geom_text = list(aes(npc+1, 50, label = npcmethod, vjust = -1))
		))
	}
	print(apply.ggs(do.call(screeplot, plots$scree), screeggs))
	dev.off()
}

if (is.list(plots$bi) || plots$bi != FALSE) {
	bipng = paste0(prefix, '.bi.png')
	if (!is.list(plots$bi)) {
		plots$bi = list()
	}
	do.call(png, c(list(filename = bipng), devpars))
	plots$bi$pcaobj = p
	print(do.call(biplot, plots$bi))
	dev.off()
}

if (is.list(plots$pairs) || plots$pairs != FALSE) {
	pairspng = paste0(prefix, '.pairs.png')
	if (!is.list(plots$pairs)) {
		plots$pairs = list()
	}
	do.call(png, c(list(filename = pairspng), devpars))
	plots$pairs$pcaobj = p
	plots$pairs$components = getComponents(p, 1:5)
	print(do.call(pairsplot, plots$pairs))
	dev.off()
}

if (is.list(plots$loadings) || plots$loadings != FALSE) {
	loadingspng = paste0(prefix, '.loadings.png')
	if (!is.list(plots$loadings)) {
		plots$loadings = list()
	}
	do.call(png, c(list(filename = loadingspng), devpars))
	plots$loadings$pcaobj = p
	print(do.call(plotloadings, plots$loadings))
	dev.off()
}

if (is.list(plots$eigencor) || plots$eigencor != FALSE) {
	eigencorpng = paste0(prefix, '.eigencor.png')
	if (!is.list(plots$eigencor)) {
		plots$eigencor = list()
	}
	do.call(png, c(list(filename = eigencor), devpars))
	plots$eigencor$pcaobj = p
	print(do.call(eigencorplot, plots$eigencor))
	dev.off()
}

{{rimport}}('plot.r')

library(ggplot2) # make aes available

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
cnames  = {{args.cnames | R }}
rnames  = {{args.rnames | R }}
devpars = {{args.devpars | R}}
x       = {{args.x | repr}}
y       = {{args.y | repr}}

data = read.table(infile, header = cnames, row.names = if (rnames) 1 else NULL, sep = '\t', check.names = F)
if (!is.na(as.numeric(x))) x = as.integer(x)
if (!is.na(as.numeric(y))) y = as.integer(y)

eval(parse(text = {{args.helper | repr}}))
params  = {{args.params | R}}
ggs     = {{args.ggs | R}}

plot.scatter(data, outfile, x, y, params, ggs, devpars = devpars)

{{rimport}}('plot.r', '__init__.r', 'sampleinfo.r')

library(methods)
options(stringsAsFactors = FALSE)
set.seed(8525)

exprfile  = {{i.efile | R}}
groupfile = {{i.gfile | R}}
cutoff    = {{args.cutoff | ?isinstance: dict
						  | :{"by": _.get("by", "p"), "value": _.get("value", .05)}
						  | :{"by": "p", "value": _, "sign": "<"} | R }}
outdir    = {{o.outdir | R}}
allfile   = {{o.outfile | prefix | prefix | @append: ".all.xls" | quote}}
upfile    = {{o.outfile | prefix | prefix | @append: ".up.xls" | quote}}
downfile  = {{o.outfile | prefix | prefix | @append: ".down.xls" | quote}}
outfile   = {{o.outfile | R}}
tool      = {{args.tool | R}}
inopts    = {{args.inopts | R}}
ggs       = {{args.ggs | R}}
params    = {{args.params | R}}
devpars   = {{args.devpars | R}}
mapping   = {{args.mapping | quote}}

# get the exp data
indata = read.table.inopts(exprfile, inopts)

# get groups
saminfo = SampleInfo2$new(groupfile, checkPaired = TRUE)

groups = saminfo$all.groups()
if (length(groups) != 2) {
	stop("I don't know how to do comparison between non-paired groups (# group must equal 2)")
}
group1   = groups[1]
group2   = groups[2]
samples1 = saminfo$get.samples(by = 'Group', value = group1)
samples2 = saminfo$get.samples(by = 'Group', value = group2)
# the real matrix
samples = c(samples1, samples2)
saminfo$select(samples)
ematrix = indata[, samples, drop = FALSE]

maps = NULL
replacecol = NULL
if (is.true(mapping)) {
	splits = unlist(strsplit(mapping, ':'))
	if (length(splits) == 1) {
		if (file.exists(splits)) {
			maps = read.table.inopts(mapping, list(rnames = TRUE, colnames = TRUE))
		} else {
			replacecol = ifelse(is.na(as.numeric(splits)), splits, as.numeric(splits))
		}
	} else {
		replacecol = ifelse(is.na(as.numeric(splits[2])), splits[2], as.numeric(splits[2]))
		maps = read.table.inopts(mapping, list(rnames = TRUE, colnames = is.na(as.numeric(replacecol))))
	}
} else if (is.null(maps) && ncol(indata) > length(samples)) {
	maps = indata[, setdiff(colnames(indata), samples), drop = FALSE]
}

do_edger = function() {
	require('edgeR')
	# detect DEGs using edgeR
	# get model
	design = saminfo$as.edger.design()
	dge = DGEList(counts = ematrix, group = saminfo$mat$Group)
	dge$samples$lib.size = colSums(dge$counts)
	dge = calcNormFactors(dge)
	disp = estimateDisp (dge, design)
	#fit  = glmQLFit (disp, design)
	#fit  = glmQLFTest (fit, coef = 2)
	fit = glmFit(disp, design)
	fit = glmLRT(fit, coef = 2)

	allgene  = topTags(fit, n=nrow(fit$table), p.value = 1)
	allgenes = rownames(allgene)
	allgene  = data.frame(
		logFC  = allgene$table$logFC,
		PValue = allgene$table$PValue,
		FDR    = allgene$table$FDR,
		logCPM = allgene$table$logCPM,
		LR = allgene$table$LR
	)
	rownames(allgene) = allgenes
	allgene = allgene[!is.na(allgene$PValue) & !is.na(allgene$FDR),,drop=FALSE]
	list(allgene = allgene, normcounts = log2(dge$counts[rownames(allgene),, drop=FALSE] + 1))
}

do_deseq2 = function() {
	# detect DEGs using DESeq2
	library(DESeq2)
	# model
	design = saminfo$as.deseq2.design()
	dge = DESeqDataSetFromMatrix(round(ematrix), design$coldata, design = design$design)

	dge      = DESeq(dge)
	allgene  = results(dge)
	allgene  = as.data.frame(allgene[order(allgene$pvalue),,drop=FALSE])
	allgenes = rownames(allgene)
	allgene  = data.frame(
		logFC    = allgene$log2FoldChange,
		PValue   = allgene$pvalue,
		FDR      = allgene$padj,
		baseMean = allgene$baseMean,
		lfcSE    = allgene$lfcSE,
		stat     = allgene$stat
	)
	rownames(allgene) = allgenes
	allgene = allgene[!is.na(allgene$PValue) & !is.na(allgene$FDR),,drop=FALSE]
	list(allgene = allgene, normcounts = log2(assay(dge)[rownames(allgene),, drop=FALSE] + 1))
}

if (tool == 'edger') {
	ret = do_edger()
} else if (tool == 'deseq2') {
	ret = do_deseq2()
} else {
	stop(paste('Unsupported tool:', tool))
}

# save allgenes
# add maps to allgenes
if (!is.null(maps)) {
	probes = rownames(ret$allgene)
	if (is.true(replacecol)) {
		rownames(ret$allgene) = maps[, replacecol]
		restmaps = ifelse(is.numeric(replacecol),
			colnames(maps)[-replacecol],
			setdiff(colnames(maps), replacecol))
		allgene = cbind(ret$allgene, probes, maps[, restmaps, drop = FALSE])
		colnames(allgene)[ncol(allgene) + 1] = 'Original_Probe'
	} else {
		allgene = cbind(ret$allgene, maps[probes, , drop=FALSE])
	}
}
write.xls(allgene, allfile)

# get and save degs
if (cutoff$by == 'q') {
	degene = allgene[allgene$FDR < cutoff$value,,drop = FALSE]
} else {
	degene = allgene[allgene$PValue < cutoff$value,,drop = FALSE]
}
write.xls(degene, outfile)

# save up genes
write.xls(degene[degene$logFC>0,,drop=FALSE], upfile)
# save down genes
write.xls(degene[degene$logFC<0,,drop=FALSE], downfile)

# MDS plot
if (!is.logical(ggs$mdsplot) || ggs$mdsplot!=FALSE) {
	mdsplot = file.path (outdir, "mdsplot.png")
	mdsdata = data.frame(Group = c(rep(group1, length(samples1)), rep(group2, length(samples2))))
	rownames(mdsdata) = c(samples1, samples2)
	mdsdata = cbind(mdsdata, t(ret$normcounts[rownames(degene), c(samples1, samples2),drop=FALSE]))
	plot.mds(mdsdata, mdsplot, ggs = ggs$mdsplot, devpars = devpars)
}

# Volcano
if (!is.logical(ggs$volplot) || ggs$volplot!=FALSE) {
	volplot = file.path (outdir, "volcano.png")
	plot.volplot(
		allgene[, c('logFC', 'FDR')],
		volplot,
		params = list(logfccut = list.get(params$volplot, 'logfccut', 2),
					  pcut = list.get(params$volplot, 'pcut', 0.05),
					  hilight = list.get(params$volplot, 'hilight', NULL)),
		ggs      = ggs$volplot,
		devpars  = devpars
	)
}

# heatmap
if (!is.logical(ggs$heatmap) || ggs$heatmap!=FALSE) {
	if (nrow(degene) < 2) {
		logger('Cannot generate heatmap as < 2 DEGs detected.')
	} else {
		hmap   = file.path (outdir, "heatmap.png")
		ngenes = list.get(params$heatmap, 'ngenes', 500, check.names = TRUE)
		hmgenes = rownames(degene)
		if (!is.null(ngenes) && nrow(degene) > ngenes*2) {
			logger('Too many degs for heatmap, will cut it to', ngenes * 2)
			hmgenes = c(rownames(degene[degene$logFC > 0,,drop=FALSE])[1:ngenes],
						rownames(degene[degene$logFC < 0,,drop=FALSE])[1:ngenes])
		}
		mat   = ret$normcounts[hmgenes, ]
		params$heatmap$ngenes = NULL
		plot.heatmap2(mat, hmap, params = params$heatmap, draw = ggs$heatmap, devpars = devpars)
	}
}

# maplots
if (!is.logical(ggs$maplot) || ggs$maplot!=FALSE) {
	maplot = file.path(outdir, "maplot.png")
	A = rowSums(ret$normcounts) / ncol(ret$normcounts)
	M = allgene$logFC
	threshold = allgene$PValue < cutoff$value
	plot.maplot(
		data.frame(A, M),
		maplot,
		threshold,
		ggs = ggs$maplot,
		devpars = devpars
	)
}

# qqplot
if (!is.logical(ggs$qqplot) || ggs$qqplot!=FALSE) {
	qqplot = file.path(outdir, 'qqplot.png')
	plot.qq(data.frame(`-log10(Pval)` = -log10(degene$PValue)), qqplot, ggs = ggs$qqplot, devpars = devpars)
}

{{rimport}}('plot.r', '__init__.r', 'sampleinfo.r')

library(methods)

set.seed(8525)

exprfile  = {{i.efile | R}}
groupfile = {{i.gfile | R}}
annofile  = {{args.annofile | R}}
cutoffway = {{args.pval | lambda x: str(x).split(':')[0] == 'q' and 'q' or 'p' | quote}}
cutoffval = {{args.pval | lambda x: str(x).split(':')[-1] | R}}
filters   = {{args.filter | lambda x: x if isinstance(x, (list, tuple)) else [int(y.strip()) for y in x.split(',')] | R}}
outdir    = {{o.outdir | R}}
allfile   = file.path(outdir, '{{i.efile | fn2}}-{{i.gfile | fn2}}.all.txt')
outfile   = {{o.outfile | R}}
tool      = {{args.tool | R}}
plot      = {{args.plot | R}}
ggs       = {{args.ggs | R}}
hmrows    = {{args.hmrows | R}}
devpars   = {{args.devpars | R}}

# get the exp data
ematrix   = read.table.nodup (exprfile,  header=T, row.names = 1, check.names=F, sep="\t")

# get groups
sampleinfo = SampleInfo2$new(groupfile)

gfactor   = factor(sampleinfo$all.groups())
group1    = levels(gfactor)[1]
group2    = levels(gfactor)[2]
samples1  = sampleinfo$get.samples(by = 'Group', value = group1)
samples2  = sampleinfo$get.samples(by = 'Group', value = group2)
samples   = c(samples1, samples2)
ematrix   = ematrix[, samples, drop=F]

n1 = length(samples1)
n2 = length(samples2)

ematrix = ematrix[rowSums(ematrix > filters[1]) >= filters[2], , drop=F]

# detect DEGs using limma
if (tool == 'limma') {
	# get model
	design = sampleinfo$as.edger.design()
	#print(design)
	library(limma)
	fit     = lmFit(ematrix, design)
	fit     = eBayes(fit)

	allgene = topTable(fit, n=nrow(ematrix), adjust="BH", coef = 2)
	write.table (pretty.numbers(allgene, list(P.Value..adj.P.Val = '%.2E', . = '%.3f')), allfile, quote=F, sep="\t")

	if (cutoffway == 'p') {
		degene  = allgene[allgene$P.Value < cutoffval,,drop=F]
	} else {
		degene  = allgene[allgene$adj.P.Val < cutoffval,,drop=F]
	}

	alllogFC = allgene$logFC
	allPval  = allgene$P.Value
	allQval  = allgene$adj.P.Val

	annodegs = NULL
	# add annotation
	if (annofile != '') {
		annos = read.table(annofile, header=F, sep="\t", row.names = 1, check.names = F )
		genes = data.frame(Gene = annos[rownames(degene), ])
		annodegs = cbind(genes, degene)
		write.table (pretty.numbers(annodegs, list(P.Value..adj.P.Val = '%.2E', logFC..AveExpr..t..B = '%.3f')), outfile, quote=F, sep="\t")
	} else {
		write.table (pretty.numbers(degene, list(P.Value..adj.P.Val = '%.2E', . = '%.3f')), outfile, quote=F, sep="\t")
	}

} else {
	stop(paste('Unsupported tool:', tool))
}

# MDS plot
if (plot$mdsplot) {
	library(limma)
	mdsplot = file.path (outdir, "mdsplot.png")
	do.call(png, c(list(filename=mdsplot), devpars))
	plotMDS(ematrix, col=c(rep("red2", n1), rep("blue2", n2)))
	dev.off()
}

# Volcano
if (plot$volplot != F) {
	volplot = file.path (outdir, "volcano.png")
	log2fc  = alllogFC
	fdr     = ifelse(cutoffway == 'p', allPval, allQval)
	plot.volplot(
		data.frame(logFC = log2fc, FDR = fdr),
		plotfile = volplot,
		fccut    = plot$volplot$fccut,
		pcut     = plot$volplot$pcut,
		ggs      = ggs$volplot,
		devpars  = devpars
	)
}

# heatmap
if (plot$heatmap) {
	if (nrow(degene) < 2) {
		logger('Cannot generate heatmap as < 2 DEGs detected.')
	} else {
		hmap   = file.path (outdir, "heatmap.png")
		ngene  = nrow(degene)
		if (hmrows <= 1) hmrows = as.integer(hmrows * ngene)

		ngene = min(hmrows, nrow(degene))
		mat = ematrix[rownames(degene)[1:ngene], ]
		if (!is.null(annodegs)) {
			rownames(mat) = make.unique(as.character(as.vector(degene[1:ngene, 1])))
		}
		plot.heatmap(mat, hmap, ggs = ggs$heatmap, devpars = devpars)
	}
}

# maplots
if (plot$maplot) {
	maplot = file.path(outdir, "maplot.png")
	A = rowSums(ematrix) / ncol(ematrix)
	M = alllogFC
	threshold = ifelse(cutoffway == 'p', allPval < cutoffval, allQval < cutoffval)
	plot.maplot(
		data.frame(A, M),
		maplot,
		threshold,
		ggs = ggs$maplot,
		devpars = devpars
	)
}

# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.


# G S E A -- Gene Set Enrichment Analysis

# Auxiliary functions and definitions

GSEA.GeneRanking <- function(A, class.labels, gene.labels, nperm, permutation.type = 0, sigma.correction = "GeneCluster", fraction=1.0, replace=F, reverse.sign= F) {

# This function ranks the genes according to the signal to noise ratio for the actual phenotype and also random permutations and bootstrap
# subsamples of both the observed and random phenotypes. It uses matrix operations to implement the signal to noise calculation
# in stages and achieves fast execution speed. It supports two types of permutations: random (unbalanced) and balanced.
# It also supports subsampling and bootstrap by using masking and multiple-count variables.  When "fraction" is set to 1 (default)
# the there is no subsampling or boostrapping and the matrix of observed signal to noise ratios will have the same value for
# all permutations. This is wasteful but allows to support all the multiple options with the same code. Notice that the second
# matrix for the null distribution will still have the values for the random permutations
# (null distribution). This mode (fraction = 1.0) is the defaults, the recommended one and the one used in the examples.
# It is also the one that has be tested more thoroughly. The resampling and boostrapping options are intersting to obtain
# smooth estimates of the observed distribution but its is left for the expert user who may want to perform some sanity
# checks before trusting the code.
#
# Inputs:
#   A: Matrix of gene expression values (rows are genes, columns are samples)
#   class.labels: Phenotype of class disticntion of interest. A vector of binary labels having first the 1's and then the 0's
#   gene.labels: gene labels. Vector of probe ids or accession numbers for the rows of the expression matrix
#   nperm: Number of random permutations/bootstraps to perform
#   permutation.type: Permutation type: 0 = unbalanced, 1 = balanced. For experts only (default: 0)
#   sigma.correction: Correction to the signal to noise ratio (Default = GeneCluster, a choice to support the way it was handled in a previous package)
#   fraction: Subsampling fraction. Set to 1.0 (no resampling). For experts only (default: 1.0)
#   replace: Resampling mode (replacement or not replacement). For experts only (default: F)
#   reverse.sign: Reverse direction of gene list (default = F)
#
# Outputs:
#   s2n.matrix: Matrix with random permuted or bootstraps signal to noise ratios (rows are genes, columns are permutations or bootstrap subsamplings
#   obs.s2n.matrix: Matrix with observed signal to noise ratios (rows are genes, columns are boostraps subsamplings. If fraction is set to 1.0 then all the columns have the same values
#   order.matrix: Matrix with the orderings that will sort the columns of the obs.s2n.matrix in decreasing s2n order
#   obs.order.matrix: Matrix with the orderings that will sort the columns of the s2n.matrix in decreasing s2n order
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

     A <- A + 0.00000001

     N <- length(A[,1])
     Ns <- length(A[1,])

     subset.mask <- matrix(0, nrow=Ns, ncol=nperm)
     reshuffled.class.labels1 <- matrix(0, nrow=Ns, ncol=nperm)
     reshuffled.class.labels2 <- matrix(0, nrow=Ns, ncol=nperm)
     class.labels1 <- matrix(0, nrow=Ns, ncol=nperm)
     class.labels2 <- matrix(0, nrow=Ns, ncol=nperm)

     order.matrix <- matrix(0, nrow = N, ncol = nperm)
     obs.order.matrix <- matrix(0, nrow = N, ncol = nperm)
     s2n.matrix <- matrix(0, nrow = N, ncol = nperm)
     obs.s2n.matrix <- matrix(0, nrow = N, ncol = nperm)

     obs.gene.labels <- vector(length = N, mode="character")
     obs.gene.descs <- vector(length = N, mode="character")
     obs.gene.symbols <- vector(length = N, mode="character")

     M1 <- matrix(0, nrow = N, ncol = nperm)
     M2 <- matrix(0, nrow = N, ncol = nperm)
     S1 <- matrix(0, nrow = N, ncol = nperm)
     S2 <- matrix(0, nrow = N, ncol = nperm)

     gc()

     C <- split(class.labels, class.labels)
     class1.size <- length(C[[1]])
     class2.size <- length(C[[2]])
     class1.index <- seq(1, class1.size, 1)
     class2.index <- seq(class1.size + 1, class1.size + class2.size, 1)

     for (r in 1:nperm) {
        class1.subset <- sample(class1.index, size = ceiling(class1.size*fraction), replace = replace)
        class2.subset <- sample(class2.index, size = ceiling(class2.size*fraction), replace = replace)
        class1.subset.size <- length(class1.subset)
        class2.subset.size <- length(class2.subset)
        subset.class1 <- rep(0, class1.size)
        for (i in 1:class1.size) {
            if (is.element(class1.index[i], class1.subset)) {
                subset.class1[i] <- 1
            }
        }
        subset.class2 <- rep(0, class2.size)
        for (i in 1:class2.size) {
            if (is.element(class2.index[i], class2.subset)) {
                subset.class2[i] <- 1
            }
        }
        subset.mask[, r] <- as.numeric(c(subset.class1, subset.class2))
        fraction.class1 <- class1.size/Ns
        fraction.class2 <- class2.size/Ns

        if (permutation.type == 0) { # random (unbalanced) permutation
           full.subset <- c(class1.subset, class2.subset)
           label1.subset <- sample(full.subset, size = Ns * fraction.class1)
           reshuffled.class.labels1[, r] <- rep(0, Ns)
           reshuffled.class.labels2[, r] <- rep(0, Ns)
           class.labels1[, r] <- rep(0, Ns)
           class.labels2[, r] <- rep(0, Ns)
           for (i in 1:Ns) {
               m1 <- sum(!is.na(match(label1.subset, i)))
               m2 <- sum(!is.na(match(full.subset, i)))
               reshuffled.class.labels1[i, r] <- m1
               reshuffled.class.labels2[i, r] <- m2 - m1
               if (i <= class1.size) {
                 class.labels1[i, r] <- m2
                 class.labels2[i, r] <- 0
               } else {
                  class.labels1[i, r] <- 0
                  class.labels2[i, r] <- m2
               }
           }

        } else if (permutation.type == 1) { # proportional (balanced) permutation

           class1.label1.subset <- sample(class1.subset, size = ceiling(class1.subset.size*fraction.class1))
           class2.label1.subset <- sample(class2.subset, size = floor(class2.subset.size*fraction.class1))
           reshuffled.class.labels1[, r] <- rep(0, Ns)
           reshuffled.class.labels2[, r] <- rep(0, Ns)
           class.labels1[, r] <- rep(0, Ns)
           class.labels2[, r] <- rep(0, Ns)
           for (i in 1:Ns) {
               if (i <= class1.size) {
                  m1 <- sum(!is.na(match(class1.label1.subset, i)))
                  m2 <- sum(!is.na(match(class1.subset, i)))
                  reshuffled.class.labels1[i, r] <- m1
                  reshuffled.class.labels2[i, r] <- m2 - m1
                  class.labels1[i, r] <- m2
                  class.labels2[i, r] <- 0
               } else {
                  m1 <- sum(!is.na(match(class2.label1.subset, i)))
                  m2 <- sum(!is.na(match(class2.subset, i)))
                  reshuffled.class.labels1[i, r] <- m1
                  reshuffled.class.labels2[i, r] <- m2 - m1
                  class.labels1[i, r] <- 0
                  class.labels2[i, r] <- m2
               }
           }
        }
    }

# compute S2N for the random permutation matrix

     P <- reshuffled.class.labels1 * subset.mask
     n1 <- sum(P[,1])
     M1 <- A %*% P
     M1 <- M1/n1
     gc()
     A2 <- A*A
     S1 <- A2 %*% P
     S1 <- S1/n1 - M1*M1
     S1 <- sqrt(abs((n1/(n1-1)) * S1))
     gc()
     P <- reshuffled.class.labels2 * subset.mask
     n2 <- sum(P[,1])
     M2 <- A %*% P
     M2 <- M2/n2
     gc()
     A2 <- A*A
     S2 <- A2 %*% P
     S2 <- S2/n2 - M2*M2
     S2 <- sqrt(abs((n2/(n2-1)) * S2))
     rm(P)
     rm(A2)
     gc()

     if (sigma.correction == "GeneCluster") {  # small sigma "fix" as used in GeneCluster
         S2 <- ifelse(0.2*abs(M2) < S2, S2, 0.2*abs(M2))
         S2 <- ifelse(S2 == 0, 0.2, S2)
         S1 <- ifelse(0.2*abs(M1) < S1, S1, 0.2*abs(M1))
         S1 <- ifelse(S1 == 0, 0.2, S1)
         gc()
     }

     M1 <- M1 - M2
     rm(M2)
     gc()
     S1 <- S1 + S2
     rm(S2)
     gc()

     s2n.matrix <- M1/S1

     if (reverse.sign == T) {
        s2n.matrix <- - s2n.matrix
     }
     gc()

     for (r in 1:nperm) {
        order.matrix[, r] <- order(s2n.matrix[, r], decreasing=T)
     }

# compute S2N for the "observed" permutation matrix

     P <- class.labels1 * subset.mask
     n1 <- sum(P[,1])
     M1 <- A %*% P
     M1 <- M1/n1
     gc()
     A2 <- A*A
     S1 <- A2 %*% P
     S1 <- S1/n1 - M1*M1
     S1 <- sqrt(abs((n1/(n1-1)) * S1))
     gc()
     P <- class.labels2 * subset.mask
     n2 <- sum(P[,1])
     M2 <- A %*% P
     M2 <- M2/n2
     gc()
     A2 <- A*A
     S2 <- A2 %*% P
     S2 <- S2/n2 - M2*M2
     S2 <- sqrt(abs((n2/(n2-1)) * S2))
     rm(P)
     rm(A2)
     gc()

     if (sigma.correction == "GeneCluster") {  # small sigma "fix" as used in GeneCluster
         S2 <- ifelse(0.2*abs(M2) < S2, S2, 0.2*abs(M2))
         S2 <- ifelse(S2 == 0, 0.2, S2)
         S1 <- ifelse(0.2*abs(M1) < S1, S1, 0.2*abs(M1))
         S1 <- ifelse(S1 == 0, 0.2, S1)
         gc()
     }

     M1 <- M1 - M2
     rm(M2)
     gc()
     S1 <- S1 + S2
     rm(S2)
     gc()

     obs.s2n.matrix <- M1/S1
     gc()

     if (reverse.sign == T) {
        obs.s2n.matrix <- - obs.s2n.matrix
     }

     for (r in 1:nperm) {
        obs.order.matrix[,r] <- order(obs.s2n.matrix[,r], decreasing=T)
     }

     return(list(s2n.matrix = s2n.matrix,
                 obs.s2n.matrix = obs.s2n.matrix,
                 order.matrix = order.matrix,
                 obs.order.matrix = obs.order.matrix))
}

GSEA.EnrichmentScore <- function(gene.list, gene.set, weighted.score.type = 1, correl.vector = NULL) {
#
# Computes the weighted GSEA score of gene.set in gene.list.
# The weighted score type is the exponent of the correlation
# weight: 0 (unweighted = Kolmogorov-Smirnov), 1 (weighted), and 2 (over-weighted). When the score type is 1 or 2 it is
# necessary to input the correlation vector with the values in the same order as in the gene list.
#
# Inputs:
#   gene.list: The ordered gene list (e.g. integers indicating the original position in the input dataset)
#   gene.set: A gene set (e.g. integers indicating the location of those genes in the input dataset)
#   weighted.score.type: Type of score: weight: 0 (unweighted = Kolmogorov-Smirnov), 1 (weighted), and 2 (over-weighted)
#  correl.vector: A vector with the coorelations (e.g. signal to noise scores) corresponding to the genes in the gene list
#
# Outputs:
#   ES: Enrichment score (real number between -1 and +1)
#   arg.ES: Location in gene.list where the peak running enrichment occurs (peak of the "mountain")
#   RES: Numerical vector containing the running enrichment score for all locations in the gene list
#   tag.indicator: Binary vector indicating the location of the gene sets (1's) in the gene list
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

   tag.indicator <- sign(match(gene.list, gene.set, nomatch=0))    # notice that the sign is 0 (no tag) or 1 (tag)
   no.tag.indicator <- 1 - tag.indicator
   N <- length(gene.list)
   Nh <- length(gene.set)
   Nm <-  N - Nh
   if (weighted.score.type == 0) {
      correl.vector <- rep(1, N)
   }
   alpha <- weighted.score.type
   correl.vector <- abs(correl.vector**alpha)
   sum.correl.tag    <- sum(correl.vector[tag.indicator == 1])
   norm.tag    <- 1.0/sum.correl.tag
   norm.no.tag <- 1.0/Nm
   RES <- cumsum(tag.indicator * correl.vector * norm.tag - no.tag.indicator * norm.no.tag)
   max.ES <- max(RES)
   min.ES <- min(RES)
   if (max.ES > -min.ES) {
#      ES <- max.ES
      ES <- signif(max.ES, digits = 5)
      arg.ES <- which.max(RES)
   } else {
#      ES <- min.ES
      ES <- signif(min.ES, digits=5)
      arg.ES <- which.min(RES)
   }
   return(list(ES = ES, arg.ES = arg.ES, RES = RES, indicator = tag.indicator))
}


OLD.GSEA.EnrichmentScore <- function(gene.list, gene.set) {
#
# Computes the original GSEA score from Mootha et al 2003 of gene.set in gene.list
#
# Inputs:
#   gene.list: The ordered gene list (e.g. integers indicating the original position in the input dataset)
#   gene.set: A gene set (e.g. integers indicating the location of those genes in the input dataset)
#
# Outputs:
#   ES: Enrichment score (real number between -1 and +1)
#   arg.ES: Location in gene.list where the peak running enrichment occurs (peak of the "mountain")
#   RES: Numerical vector containing the running enrichment score for all locations in the gene list
#   tag.indicator: Binary vector indicating the location of the gene sets (1's) in the gene list
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

   tag.indicator <- sign(match(gene.list, gene.set, nomatch=0))    # notice that the sign is 0 (no tag) or 1 (tag)
   no.tag.indicator <- 1 - tag.indicator
   N <- length(gene.list)
   Nh <- length(gene.set)
   Nm <-  N - Nh

   norm.tag    <- sqrt((N - Nh)/Nh)
   norm.no.tag <- sqrt(Nh/(N - Nh))

   RES <- cumsum(tag.indicator * norm.tag - no.tag.indicator * norm.no.tag)
   max.ES <- max(RES)
   min.ES <- min(RES)
   if (max.ES > - min.ES) {
      ES <- signif(max.ES, digits=5)
      arg.ES <- which.max(RES)
   } else {
      ES <- signif(min.ES, digits=5)
      arg.ES <- which.min(RES)
   }
   return(list(ES = ES, arg.ES = arg.ES, RES = RES, indicator = tag.indicator))
}

GSEA.EnrichmentScore2 <- function(gene.list, gene.set, weighted.score.type = 1, correl.vector = NULL) {
#
# Computes the weighted GSEA score of gene.set in gene.list. It is the same calculation as in
# GSEA.EnrichmentScore but faster (x8) without producing the RES, arg.RES and tag.indicator outputs.
# This call is intended to be used to asses the enrichment of random permutations rather than the
# observed one.
# The weighted score type is the exponent of the correlation
# weight: 0 (unweighted = Kolmogorov-Smirnov), 1 (weighted), and 2 (over-weighted). When the score type is 1 or 2 it is
# necessary to input the correlation vector with the values in the same order as in the gene list.
#
# Inputs:
#   gene.list: The ordered gene list (e.g. integers indicating the original position in the input dataset)
#   gene.set: A gene set (e.g. integers indicating the location of those genes in the input dataset)
#   weighted.score.type: Type of score: weight: 0 (unweighted = Kolmogorov-Smirnov), 1 (weighted), and 2 (over-weighted)
#  correl.vector: A vector with the coorelations (e.g. signal to noise scores) corresponding to the genes in the gene list
#
# Outputs:
#   ES: Enrichment score (real number between -1 and +1)
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

   N <- length(gene.list)
   Nh <- length(gene.set)
   Nm <-  N - Nh

   loc.vector <- vector(length=N, mode="numeric")
   peak.res.vector <- vector(length=Nh, mode="numeric")
   valley.res.vector <- vector(length=Nh, mode="numeric")
   tag.correl.vector <- vector(length=Nh, mode="numeric")
   tag.diff.vector <- vector(length=Nh, mode="numeric")
   tag.loc.vector <- vector(length=Nh, mode="numeric")

   loc.vector[gene.list] <- seq(1, N)
   tag.loc.vector <- loc.vector[gene.set]

   tag.loc.vector <- sort(tag.loc.vector, decreasing = F)

   if (weighted.score.type == 0) {
      tag.correl.vector <- rep(1, Nh)
   } else if (weighted.score.type == 1) {
      tag.correl.vector <- correl.vector[tag.loc.vector]
      tag.correl.vector <- abs(tag.correl.vector)
   } else if (weighted.score.type == 2) {
      tag.correl.vector <- correl.vector[tag.loc.vector]*correl.vector[tag.loc.vector]
      tag.correl.vector <- abs(tag.correl.vector)
   } else {
      tag.correl.vector <- correl.vector[tag.loc.vector]**weighted.score.type
      tag.correl.vector <- abs(tag.correl.vector)
   }

   norm.tag <- 1.0/sum(tag.correl.vector)
   tag.correl.vector <- tag.correl.vector * norm.tag
   norm.no.tag <- 1.0/Nm
   tag.diff.vector[1] <- (tag.loc.vector[1] - 1)
   tag.diff.vector[2:Nh] <- tag.loc.vector[2:Nh] - tag.loc.vector[1:(Nh - 1)] - 1
   tag.diff.vector <- tag.diff.vector * norm.no.tag
   peak.res.vector <- cumsum(tag.correl.vector - tag.diff.vector)
   valley.res.vector <- peak.res.vector - tag.correl.vector
   max.ES <- max(peak.res.vector)
   min.ES <- min(valley.res.vector)
   ES <- signif(ifelse(max.ES > - min.ES, max.ES, min.ES), digits=5)

   return(list(ES = ES))

}

GSEA.HeatMapPlot <- function(V, row.names = F, col.labels, col.classes, col.names = F, main = " ", xlab=" ", ylab=" ") {
#
# Plots a heatmap "pinkogram" of a gene expression matrix including phenotype vector and gene, sample and phenotype labels
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

       n.rows <- length(V[,1])
       n.cols <- length(V[1,])
       row.mean <- apply(V, MARGIN=1, FUN=mean)
       row.sd <- apply(V, MARGIN=1, FUN=sd)
       row.n <- length(V[,1])
       for (i in 1:n.rows) {
	   if (row.sd[i] == 0) {
    	       V[i,] <- 0
           } else {
	       V[i,] <- (V[i,] - row.mean[i])/(0.5 * row.sd[i])
           }
           V[i,] <- ifelse(V[i,] < -6, -6, V[i,])
           V[i,] <- ifelse(V[i,] > 6, 6, V[i,])
        }

        mycol <- c("#0000FF", "#0000FF", "#4040FF", "#7070FF", "#8888FF", "#A9A9FF", "#D5D5FF", "#EEE5EE", "#FFAADA", "#FF9DB0", "#FF7080", "#FF5A5A", "#FF4040", "#FF0D1D", "#FF0000") # blue-pinkogram colors. The first and last are the colors to indicate the class vector (phenotype). This is the 1998-vintage, pre-gene cluster, original pinkogram color map

        mid.range.V <- mean(range(V)) - 0.1
        heatm <- matrix(0, nrow = n.rows + 1, ncol = n.cols)
        heatm[1:n.rows,] <- V[seq(n.rows, 1, -1),]
        heatm[n.rows + 1,] <- ifelse(col.labels == 0, 7, -7)
        image(1:n.cols, 1:(n.rows + 1), t(heatm), col=mycol, axes=FALSE, main=main, xlab= xlab, ylab=ylab)

        if (length(row.names) > 1) {
            numC <- nchar(row.names)
            size.row.char <- 35/(n.rows + 5)
            size.col.char <- 25/(n.cols + 5)
            maxl <- floor(n.rows/1.6)
            for (i in 1:n.rows) {
               row.names[i] <- substr(row.names[i], 1, maxl)
            }
            row.names <- c(row.names[seq(n.rows, 1, -1)], "Class")
            axis(2, at=1:(n.rows + 1), labels=row.names, adj= 0.5, tick=FALSE, las = 1, cex.axis=size.row.char, font.axis=2, line=-1)
        }

        if (length(col.names) > 1) {
           axis(1, at=1:n.cols, labels=col.names, tick=FALSE, las = 3, cex.axis=size.col.char, font.axis=2, line=-1)
        }

        C <- split(col.labels, col.labels)
        class1.size <- length(C[[1]])
        class2.size <- length(C[[2]])
        axis(3, at=c(floor(class1.size/2),class1.size + floor(class2.size/2)), labels=col.classes, tick=FALSE, las = 1, cex.axis=1.25, font.axis=2, line=-1)

	return()
}

GSEA.Res2Frame <- function(filename = "NULL") {
#
# Reads a gene expression dataset in RES format and converts it into an R data frame
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

   header.cont <- readLines(filename, n = 1)
   temp <- unlist(strsplit(header.cont, "\t"))
   colst <- length(temp)
   header.labels <- temp[seq(3, colst, 2)]
   ds <- read.delim(filename, header=F, row.names = 2, sep="\t", skip=3, blank.lines.skip=T, comment.char="", as.is=T)
   colst <- length(ds[1,])
   cols <- (colst - 1)/2
   rows <- length(ds[,1])
   A <- matrix(nrow=rows - 1, ncol=cols)
   A <- ds[1:rows, seq(2, colst, 2)]
   table1 <- data.frame(A)
   names(table1) <- header.labels
   return(table1)
}

GSEA.Gct2Frame <- function(filename = "NULL") {
#
# Reads a gene expression dataset in GCT format and converts it into an R data frame
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.
   ds <- read.delim(filename, header=T, sep="\t", skip=2, row.names=1, blank.lines.skip=T, comment.char="", as.is=T)
   ds <- ds[-1]
   return(ds)
}

GSEA.Gct2Frame2 <- function(filename = "NULL") {
#
# Reads a gene expression dataset in GCT format and converts it into an R data frame
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.
      content <- readLines(filename)
      content <- content[-1]
      content <- content[-1]
      col.names <- noquote(unlist(strsplit(content[1], "\t")))
      col.names <- col.names[c(-1, -2)]
      num.cols <- length(col.names)
      content <- content[-1]
      num.lines <- length(content)


      row.nam <- vector(length=num.lines, mode="character")
      row.des <- vector(length=num.lines, mode="character")
      m <- matrix(0, nrow=num.lines, ncol=num.cols)

      for (i in 1:num.lines) {
         line.list <- noquote(unlist(strsplit(content[i], "\t")))
         row.nam[i] <- noquote(line.list[1])
         row.des[i] <- noquote(line.list[2])
         line.list <- line.list[c(-1, -2)]
         for (j in 1:length(line.list)) {
            m[i, j] <- as.numeric(line.list[j])
         }
      }
      ds <- data.frame(m)
      names(ds) <- col.names
      row.names(ds) <- row.nam
      return(ds)
}

GSEA.ReadClsFile <- function(file = "NULL") {
#
# Reads a class vector CLS file and defines phenotype and class labels vectors for the samples in a gene expression file (RES or GCT format)
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

      cls.cont <- readLines(file)
      num.lines <- length(cls.cont)
      class.list <- unlist(strsplit(cls.cont[[3]], " "))
      s <- length(class.list)
      t <- table(class.list)
      l <- length(t)
      phen <- vector(length=l, mode="character")
      phen.label <- vector(length=l, mode="numeric")
      class.v <- vector(length=s, mode="numeric")
      for (i in 1:l) {
         phen[i] <- noquote(names(t)[i])
         phen.label[i] <- i - 1
      }
      for (i in 1:s) {
         for (j in 1:l) {
             if (class.list[i] == phen[j]) {
                class.v[i] <- phen.label[j]
             }
         }
      }
      return(list(phen = phen, class.v = class.v))
}

GSEA.Threshold <- function(V, thres, ceil) {
#
# Threshold and ceiling pre-processing for gene expression matrix
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

        V[V < thres] <- thres
        V[V > ceil] <- ceil
        return(V)
}

GSEA.VarFilter <- function(V, fold, delta, gene.names = "NULL") {
#
# Variation filter pre-processing for gene expression matrix
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

        cols <- length(V[1,])
        rows <- length(V[,1])
        row.max <- apply(V, MARGIN=1, FUN=max)
               row.min <- apply(V, MARGIN=1, FUN=min)
        flag <- array(dim=rows)
        flag <- (row.max /row.min > fold) & (row.max - row.min > delta)
        size <- sum(flag)
        B <- matrix(0, nrow = size, ncol = cols)
        j <- 1
        if (gene.names == "NULL") {
           for (i in 1:rows) {
              if (flag[i]) {
                 B[j,] <- V[i,]
                 j <- j + 1
               }
           }
        return(B)
        } else {
            new.list <- vector(mode = "character", length = size)
            for (i in 1:rows) {
              if (flag[i]) {
                 B[j,] <- V[i,]
                 new.list[j] <- gene.names[i]
                 j <- j + 1
              }
            }
        return(list(V = B, new.list = new.list))
        }
}

GSEA.NormalizeRows <- function(V) {
#
# Stardardize rows of a gene expression matrix
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

        row.mean <- apply(V, MARGIN=1, FUN=mean)
               row.sd <- apply(V, MARGIN=1, FUN=sd)
        row.n <- length(V[,1])
        for (i in 1:row.n) {
             if (row.sd[i] == 0) {
                  V[i,] <- 0
           } else {
              V[i,] <- (V[i,] - row.mean[i])/row.sd[i]
           }
        }
        return(V)
}

GSEA.NormalizeCols <- function(V) {
#
# Stardardize columns of a gene expression matrix
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

        col.mean <- apply(V, MARGIN=2, FUN=mean)
               col.sd <- apply(V, MARGIN=2, FUN=sd)
        col.n <- length(V[1,])
        for (i in 1:col.n) {
             if (col.sd[i] == 0) {
                  V[i,] <- 0
           } else {
              V[,i] <- (V[,i] - col.mean[i])/col.sd[i]
           }
        }
        return(V)
}

# end of auxiliary functions

# ----------------------------------------------------------------------------------------
# Main GSEA Analysis Function that implements the entire methodology

GSEA <- function(
input.ds,
input.cls,
gene.ann = "",
gs.db,
gs.ann = "",
output.directory = "",
doc.string = "GSEA.analysis",
non.interactive.run = F,
reshuffling.type = "sample.labels",
nperm = 1000,
weighted.score.type = 1,
nom.p.val.threshold = -1,
fwer.p.val.threshold = -1,
fdr.q.val.threshold = 0.25,
topgs = 10,
adjust.FDR.q.val = F,
gs.size.threshold.min = 25,
gs.size.threshold.max = 500,
reverse.sign = F,
preproc.type = 0,
random.seed = 123456,
perm.type = 0,
fraction = 1.0,
replace = F,
save.intermediate.results = F,
OLD.GSEA = F,
use.fast.enrichment.routine = T) {

# This is a methodology for the analysis of global molecular profiles called Gene Set Enrichment Analysis (GSEA). It determines
# whether an a priori defined set of genes shows statistically significant, concordant differences between two biological
# states (e.g. phenotypes). GSEA operates on all genes from an experiment, rank ordered by the signal to noise ratio and
# determines whether members of an a priori defined gene set are nonrandomly distributed towards the top or bottom of the
# list and thus may correspond to an important biological process. To assess significance the program uses an empirical
# permutation procedure to test deviation from random that preserves correlations between genes.
#
# For details see Subramanian et al 2005
#
# Inputs:
#   input.ds: Input gene expression Affymetrix dataset file in RES or GCT format
#   input.cls:  Input class vector (phenotype) file in CLS format
#   gene.ann.file: Gene microarray annotation file (Affymetrix Netaffyx *.csv format) (default: none)
#   gs.file: Gene set database in GMT format
#   output.directory: Directory where to store output and results (default: .)
#   doc.string:  Documentation string used as a prefix to name result files (default: "GSEA.analysis")
#   non.interactive.run: Run in interactive (i.e. R GUI) or batch (R command line) mode (default: F)
#   reshuffling.type: Type of permutation reshuffling: "sample.labels" or "gene.labels" (default: "sample.labels")
#   nperm: Number of random permutations (default: 1000)
#   weighted.score.type: Enrichment correlation-based weighting: 0=no weight (KS), 1=standard weigth, 2 = over-weigth (default: 1)
#   nom.p.val.threshold: Significance threshold for nominal p-vals for gene sets (default: -1, no thres)
#   fwer.p.val.threshold: Significance threshold for FWER p-vals for gene sets (default: -1, no thres)
#   fdr.q.val.threshold: Significance threshold for FDR q-vals for gene sets (default: 0.25)
#   topgs: Besides those passing test, number of top scoring gene sets used for detailed reports (default: 10)
#   adjust.FDR.q.val: Adjust the FDR q-vals (default: F)
#   gs.size.threshold.min: Minimum size (in genes) for database gene sets to be considered (default: 25)
#   gs.size.threshold.max: Maximum size (in genes) for database gene sets to be considered (default: 500)
#   reverse.sign: Reverse direction of gene list (pos. enrichment becomes negative, etc.) (default: F)
#   preproc.type: Preprocessing normalization: 0=none, 1=col(z-score)., 2=col(rank) and row(z-score)., 3=col(rank). (default: 0)
#   random.seed: Random number generator seed. (default: 123456)
#   perm.type: Permutation type: 0 = unbalanced, 1 = balanced. For experts only (default: 0)
#   fraction: Subsampling fraction. Set to 1.0 (no resampling). For experts only (default: 1.0)
#   replace: Resampling mode (replacement or not replacement). For experts only (default: F)
#   OLD.GSEA: if TRUE compute the OLD GSEA of Mootha et al 2003
#   use.fast.enrichment.routine: if true it uses a faster version to compute random perm. enrichment "GSEA.EnrichmentScore2"
#
#   Output:
#    The results of the method are stored in the "output.directory" specified by the user as part of the input parameters.
#      The results files are:
#    - Two tab-separated global result text files (one for each phenotype). These files are labeled according to the doc
#      string prefix and the phenotype name from the CLS file: <doc.string>.SUMMARY.RESULTS.REPORT.<phenotype>.txt
#    - One set of global plots. They include a.- gene list correlation profile, b.- global observed and null densities, c.- heat map
#      for the entire sorted dataset, and d.- p-values vs. NES plot. These plots are in a single JPEG file named
#      <doc.string>.global.plots.<phenotype>.jpg. When the program is run interactively these plots appear on a window in the R GUI.
#    - A variable number of tab-separated gene result text files according to how many sets pass any of the significance thresholds
#      ("nom.p.val.threshold," "fwer.p.val.threshold," and "fdr.q.val.threshold") and how many are specified in the "topgs"
#      parameter. These files are named: <doc.string>.<gene set name>.report.txt.
#   - A variable number of gene set plots (one for each gene set report file). These plots include a.- Gene set running enrichment
#      "mountain" plot, b.- gene set null distribution and c.- heat map for genes in the gene set. These plots are stored in a
#      single JPEG file named <doc.string>.<gene set name>.jpg.
#  The format (columns) for the global result files is as follows.
#  GS : Gene set name.
# SIZE : Size of the set in genes.
# SOURCE : Set definition or source.
# ES : Enrichment score.
# NES : Normalized (multiplicative rescaling) normalized enrichment score.
# NOM p-val : Nominal p-value (from the null distribution of the gene set).
# FDR q-val: False discovery rate q-values
# FWER p-val: Family wise error rate p-values.
# Tag %: Percent of gene set before running enrichment peak.
# Gene %: Percent of gene list before running enrichment peak.
# Signal : enrichment signal strength.
# FDR (median): FDR q-values from the median of the null distributions.
# glob.p.val: P-value using a global statistic (number of sets above the set's NES).
#
# The rows are sorted by the NES values (from maximum positive or negative NES to minimum)
#
# The format (columns) for the gene set result files is as follows.
#
# #: Gene number in the (sorted) gene set
# GENE : gene name. For example the probe accession number, gene symbol or the gene identifier gin the dataset.
# SYMBOL : gene symbol from the gene annotation file.
# DESC : gene description (title) from the gene annotation file.
# LIST LOC : location of the gene in the sorted gene list.
# S2N : signal to noise ratio (correlation) of the gene in the gene list.
# RES : value of the running enrichment score at the gene location.
# CORE_ENRICHMENT: is this gene is the "core enrichment" section of the list? Yes or No variable specifying in the gene location is before (positive ES) or after (negative ES) the running enrichment peak.
#
# The rows are sorted by the gene location in the gene list.
# The function call to GSEA returns a  two element list containing the two global result reports as data frames ($report1, $report2).
#
# results1: Global output report for first phenotype
# result2:  Global putput report for second phenotype
#
# The Broad Institute
# SOFTWARE COPYRIGHT NOTICE AGREEMENT
# This software and its documentation are copyright 2003 by the
# Broad Institute/Massachusetts Institute of Technology.
# All rights are reserved.
#
# This software is supplied without any warranty or guaranteed support
# whatsoever. Neither the Broad Institute nor MIT can be responsible for
# its use, misuse, or functionality.

  print(" *** Running GSEA Analysis...")

if (OLD.GSEA == T) {
   print("Running OLD GSEA from Mootha et al 2003")
}

# Copy input parameters to log file

if (output.directory != "")  {

filename <- paste(output.directory, doc.string, "_params.txt", sep="", collapse="")

time.string <- as.character(as.POSIXlt(Sys.time(),"GMT"))
write(paste("Run of GSEA on ", time.string), file=filename)

if (is.data.frame(input.ds)) {
#      write(paste("input.ds=", quote(input.ds), sep=" "), file=filename, append=T)
} else {
      write(paste("input.ds=", input.ds, sep=" "), file=filename, append=T)
}
if (is.list(input.cls)) {
#      write(paste("input.cls=", input.cls, sep=" "), file=filename, append=T)
} else {
      write(paste("input.cls=", input.cls, sep=" "), file=filename, append=T)
}
if (is.data.frame(gene.ann)) {
#    write(paste("gene.ann =", gene.ann, sep=" "), file=filename, append=T)
} else {
    write(paste("gene.ann =", gene.ann, sep=" "), file=filename, append=T)
}
 if (regexpr(pattern=".gmt", gs.db[1]) == -1) {
#   write(paste("gs.db=", gs.db, sep=" "), file=filename, append=T)
} else {
   write(paste("gs.db=", gs.db, sep=" "), file=filename, append=T)
}
if (is.data.frame(gs.ann)) {
#    write(paste("gene.ann =", gene.ann, sep=" "), file=filename, append=T)
} else {
    write(paste("gs.ann =", gs.ann, sep=" "), file=filename, append=T)
}
write(paste("output.directory =", output.directory, sep=" "), file=filename, append=T)
write(paste("doc.string = ", doc.string, sep=" "), file=filename, append=T)
write(paste("non.interactive.run =", non.interactive.run, sep=" "), file=filename, append=T)
write(paste("reshuffling.type =", reshuffling.type, sep=" "), file=filename, append=T)
write(paste("nperm =", nperm, sep=" "), file=filename, append=T)
write(paste("weighted.score.type =", weighted.score.type, sep=" "), file=filename, append=T)
write(paste("nom.p.val.threshold =", nom.p.val.threshold, sep=" "), file=filename, append=T)
write(paste("fwer.p.val.threshold =", fwer.p.val.threshold, sep=" "), file=filename, append=T)
write(paste("fdr.q.val.threshold =", fdr.q.val.threshold, sep=" "), file=filename, append=T)
write(paste("topgs =", topgs, sep=" "), file=filename, append=T)
write(paste("adjust.FDR.q.val =", adjust.FDR.q.val, sep=" "), file=filename, append=T)
write(paste("gs.size.threshold.min =", gs.size.threshold.min, sep=" "), file=filename, append=T)
write(paste("gs.size.threshold.max =", gs.size.threshold.max, sep=" "), file=filename, append=T)
write(paste("reverse.sign =", reverse.sign, sep=" "), file=filename, append=T)
write(paste("preproc.type =", preproc.type, sep=" "), file=filename, append=T)
write(paste("random.seed =", random.seed, sep=" "), file=filename, append=T)
write(paste("perm.type =", perm.type, sep=" "), file=filename, append=T)
write(paste("fraction =", fraction, sep=" "), file=filename, append=T)
write(paste("replace =", replace, sep=" "), file=filename, append=T)
}

# Start of GSEA methodology

  if (.Platform$OS.type == "windows") {
      memory.limit(6000000000)
      memory.limit()
#      print(c("Start memory size=",  memory.size()))
  }

  # Read input data matrix

  set.seed(seed=random.seed, kind = NULL)
  adjust.param <- 0.5

  gc()

  time1 <- proc.time()

  if (is.data.frame(input.ds)) {
     dataset <- input.ds
  } else {
     if (regexpr(pattern=".gct", input.ds) == -1) {
         dataset <- GSEA.Res2Frame(filename = input.ds)
     } else {
#         dataset <- GSEA.Gct2Frame(filename = input.ds)
         dataset <- GSEA.Gct2Frame2(filename = input.ds)
     }
  }
  gene.labels <- row.names(dataset)
  sample.names <- names(dataset)
  A <- data.matrix(dataset)
  dim(A)
  cols <- length(A[1,])
  rows <- length(A[,1])

# preproc.type control the type of pre-processing: threshold, variation filter, normalization

 if (preproc.type == 1) {  # Column normalize (Z-score)
    A <- GSEA.NormalizeCols(A)
 } else if (preproc.type == 2) { # Column (rank) and row (Z-score) normalize
    for (j in 1:cols) {  # column rank normalization
        A[,j] <- rank(A[,j])
    }
    A <- GSEA.NormalizeRows(A)
 } else if (preproc.type == 3) { # Column (rank) norm.
    for (j in 1:cols) {  # column rank normalization
        A[,j] <- rank(A[,j])
    }
 }

  # Read input class vector

  if(is.list(input.cls)) {
     CLS <- input.cls
  } else {
     CLS <- GSEA.ReadClsFile(file=input.cls)
  }
  class.labels <- CLS$class.v
  class.phen <- CLS$phen

  if (reverse.sign == T) {
     phen1 <- class.phen[2]
     phen2 <- class.phen[1]
  } else {
     phen1 <- class.phen[1]
     phen2 <- class.phen[2]
  }

  # sort samples according to phenotype

 col.index <- order(class.labels, decreasing=F)
 class.labels <- class.labels[col.index]
 sample.names <- sample.names[col.index]
 for (j in 1:rows) {
    A[j, ] <- A[j, col.index]
 }
 names(A) <- sample.names

  # Read input gene set database

 if (regexpr(pattern=".gmt", gs.db[1]) == -1) {
      temp <- gs.db
 } else {
      temp <- readLines(gs.db)
 }

      max.Ng <- length(temp)
      temp.size.G <- vector(length = max.Ng, mode = "numeric")
      for (i in 1:max.Ng) {
          temp.size.G[i] <- length(unlist(strsplit(temp[[i]], "\t"))) - 2
      }

      max.size.G <- max(temp.size.G)
      gs <- matrix(rep("null", max.Ng*max.size.G), nrow=max.Ng, ncol= max.size.G)
      temp.names <- vector(length = max.Ng, mode = "character")
      temp.desc <- vector(length = max.Ng, mode = "character")
      gs.count <- 1
      for (i in 1:max.Ng) {
          gene.set.size <- length(unlist(strsplit(temp[[i]], "\t"))) - 2
          gs.line <- noquote(unlist(strsplit(temp[[i]], "\t")))
          gene.set.name <- gs.line[1]
          gene.set.desc <- gs.line[2]
          gene.set.tags <- vector(length = gene.set.size, mode = "character")
          for (j in 1:gene.set.size) {
              gene.set.tags[j] <- gs.line[j + 2]
          }
          existing.set <- is.element(gene.set.tags, gene.labels)
          set.size <- length(existing.set[existing.set == T])
          if ((set.size < gs.size.threshold.min) || (set.size > gs.size.threshold.max)) next
          temp.size.G[gs.count] <- set.size
          gs[gs.count,] <- c(gene.set.tags[existing.set], rep("null", max.size.G - temp.size.G[gs.count]))
          temp.names[gs.count] <- gene.set.name
          temp.desc[gs.count] <- gene.set.desc
          gs.count <- gs.count + 1
      }
      Ng <- gs.count - 1
      gs.names <- vector(length = Ng, mode = "character")
      gs.desc <- vector(length = Ng, mode = "character")
      size.G <- vector(length = Ng, mode = "numeric")
      gs.names <- temp.names[1:Ng]
      gs.desc <- temp.desc[1:Ng]
      size.G <- temp.size.G[1:Ng]

  N <- length(A[,1])
  Ns <- length(A[1,])

  print(c("Number of genes:", N))
  print(c("Number of Gene Sets:", Ng))
  print(c("Number of samples:", Ns))
  print(c("Original number of Gene Sets:", max.Ng))
  print(c("Maximum gene set size:", max.size.G))

# Read gene and gene set annotations if gene annotation file was provided

  all.gene.descs <- vector(length = N, mode ="character")
  all.gene.symbols <- vector(length = N, mode ="character")
  all.gs.descs <- vector(length = Ng, mode ="character")

  if (is.data.frame(gene.ann)) {
     temp <- gene.ann
     a.size <- length(temp[,1])
     print(c("Number of gene annotation file entries:", a.size))
     accs <- as.character(temp[,1])
     locs <- match(gene.labels, accs)
     all.gene.descs <- as.character(temp[locs, "Gene.Title"])
     all.gene.symbols <- as.character(temp[locs, "Gene.Symbol"])
     rm(temp)
  } else  if (gene.ann == "") {
     for (i in 1:N) {
        all.gene.descs[i] <- gene.labels[i]
        all.gene.symbols[i] <- gene.labels[i]
     }
  } else {
     temp <- read.delim(gene.ann, header=T, sep=",", comment.char="", as.is=T)
     a.size <- length(temp[,1])
     print(c("Number of gene annotation file entries:", a.size))
     accs <- as.character(temp[,1])
     locs <- match(gene.labels, accs)
     all.gene.descs <- as.character(temp[locs, "Gene.Title"])
     all.gene.symbols <- as.character(temp[locs, "Gene.Symbol"])
     rm(temp)
  }

  if (is.data.frame(gs.ann)) {
     temp <- gs.ann
     a.size <- length(temp[,1])
     print(c("Number of gene set annotation file entries:", a.size))
     accs <- as.character(temp[,1])
     locs <- match(gs.names, accs)
     all.gs.descs <- as.character(temp[locs, "SOURCE"])
     rm(temp)
  } else if (gs.ann == "") {
     for (i in 1:Ng) {
        all.gs.descs[i] <- gs.desc[i]
     }
  } else {
     temp <- read.delim(gs.ann, header=T, sep="\t", comment.char="", as.is=T)
     a.size <- length(temp[,1])
     print(c("Number of gene set annotation file entries:", a.size))
     accs <- as.character(temp[,1])
     locs <- match(gs.names, accs)
     all.gs.descs <- as.character(temp[locs, "SOURCE"])
     rm(temp)
  }


  Obs.indicator <- matrix(nrow= Ng, ncol=N)
  Obs.RES <- matrix(nrow= Ng, ncol=N)

  Obs.ES <- vector(length = Ng, mode = "numeric")
  Obs.arg.ES <- vector(length = Ng, mode = "numeric")
  Obs.ES.norm <- vector(length = Ng, mode = "numeric")

  time2 <- proc.time()

  # GSEA methodology

  # Compute observed and random permutation gene rankings

  obs.s2n <- vector(length=N, mode="numeric")
  signal.strength <- vector(length=Ng, mode="numeric")
  tag.frac <- vector(length=Ng, mode="numeric")
  gene.frac <- vector(length=Ng, mode="numeric")
  coherence.ratio <- vector(length=Ng, mode="numeric")
  obs.phi.norm <- matrix(nrow = Ng, ncol = nperm)
  correl.matrix <- matrix(nrow = N, ncol = nperm)
  obs.correl.matrix <- matrix(nrow = N, ncol = nperm)
  order.matrix <- matrix(nrow = N, ncol = nperm)
  obs.order.matrix <- matrix(nrow = N, ncol = nperm)

   nperm.per.call <- 100
   n.groups <- nperm %/% nperm.per.call
   n.rem <- nperm %% nperm.per.call
   n.perms <- c(rep(nperm.per.call, n.groups), n.rem)
   n.ends <- cumsum(n.perms)
   n.starts <- n.ends - n.perms + 1

   if (n.rem == 0) {
     n.tot <- n.groups
   } else {
     n.tot <- n.groups + 1
   }

 for (nk in 1:n.tot) {
   call.nperm <- n.perms[nk]

   print(paste("Computing ranked list for actual and permuted phenotypes.......permutations: ", n.starts[nk], "--", n.ends[nk], sep=" "))

   O <- GSEA.GeneRanking(A, class.labels, gene.labels, call.nperm, permutation.type = perm.type, sigma.correction = "GeneCluster", fraction=fraction, replace=replace, reverse.sign = reverse.sign)
   gc()

   order.matrix[,n.starts[nk]:n.ends[nk]] <- O$order.matrix
   obs.order.matrix[,n.starts[nk]:n.ends[nk]] <- O$obs.order.matrix
   correl.matrix[,n.starts[nk]:n.ends[nk]] <- O$s2n.matrix
   obs.correl.matrix[,n.starts[nk]:n.ends[nk]] <- O$obs.s2n.matrix
    rm(O)
 }

  obs.s2n <- apply(obs.correl.matrix, 1, median)  # using median to assign enrichment scores
  obs.index <- order(obs.s2n, decreasing=T)
  obs.s2n   <- sort(obs.s2n, decreasing=T)

  obs.gene.labels <- gene.labels[obs.index]
  obs.gene.descs <- all.gene.descs[obs.index]
  obs.gene.symbols <- all.gene.symbols[obs.index]

  for (r in 1:nperm) {
      correl.matrix[, r] <- correl.matrix[order.matrix[,r], r]
  }
  for (r in 1:nperm) {
      obs.correl.matrix[, r] <- obs.correl.matrix[obs.order.matrix[,r], r]
  }

  gene.list2 <- obs.index
  for (i in 1:Ng) {
       print(paste("Computing observed enrichment for gene set:", i, gs.names[i], sep=" "))
       gene.set <- gs[i,gs[i,] != "null"]
       gene.set2 <- vector(length=length(gene.set), mode = "numeric")
       gene.set2 <- match(gene.set, gene.labels)
       if (OLD.GSEA == F) {
          GSEA.results <- GSEA.EnrichmentScore(gene.list=gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector = obs.s2n)
       } else {
          GSEA.results <- OLD.GSEA.EnrichmentScore(gene.list=gene.list2, gene.set=gene.set2)
       }
       Obs.ES[i] <- GSEA.results$ES
       Obs.arg.ES[i] <- GSEA.results$arg.ES
       Obs.RES[i,] <- GSEA.results$RES
       Obs.indicator[i,] <- GSEA.results$indicator
       if (Obs.ES[i] >= 0) {  # compute signal strength
           tag.frac[i] <- sum(Obs.indicator[i,1:Obs.arg.ES[i]])/size.G[i]
           gene.frac[i] <- Obs.arg.ES[i]/N
       } else {
           tag.frac[i] <- sum(Obs.indicator[i, Obs.arg.ES[i]:N])/size.G[i]
           gene.frac[i] <- (N - Obs.arg.ES[i] + 1)/N
       }
       signal.strength[i] <- tag.frac[i] * (1 - gene.frac[i]) * (N / (N - size.G[i]))
   }

# Compute enrichment for random permutations

   phi <- matrix(nrow = Ng, ncol = nperm)
   phi.norm <- matrix(nrow = Ng, ncol = nperm)
   obs.phi <- matrix(nrow = Ng, ncol = nperm)

   if (reshuffling.type == "sample.labels") { # reshuffling phenotype labels
      for (i in 1:Ng) {
        print(paste("Computing random permutations' enrichment for gene set:", i, gs.names[i], sep=" "))
        gene.set <- gs[i,gs[i,] != "null"]
        gene.set2 <- vector(length=length(gene.set), mode = "numeric")
        gene.set2 <- match(gene.set, gene.labels)
        for (r in 1:nperm) {
            gene.list2 <- order.matrix[,r]
            if (use.fast.enrichment.routine == F) {
               GSEA.results <- GSEA.EnrichmentScore(gene.list=gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=correl.matrix[, r])
            } else {
               GSEA.results <- GSEA.EnrichmentScore2(gene.list=gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=correl.matrix[, r])
            }
            phi[i, r] <- GSEA.results$ES
        }
        if (fraction < 1.0) { # if resampling then compute ES for all observed rankings
            for (r in 1:nperm) {
                obs.gene.list2 <- obs.order.matrix[,r]
                if (use.fast.enrichment.routine == F) {
                   GSEA.results <- GSEA.EnrichmentScore(gene.list=obs.gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.correl.matrix[, r])
                } else {
                   GSEA.results <- GSEA.EnrichmentScore2(gene.list=obs.gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.correl.matrix[, r])
                }
                obs.phi[i, r] <- GSEA.results$ES
            }
        } else { # if no resampling then compute only one column (and fill the others with the same value)
             obs.gene.list2 <- obs.order.matrix[,1]
            if (use.fast.enrichment.routine == F) {
               GSEA.results <- GSEA.EnrichmentScore(gene.list=obs.gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.correl.matrix[, r])
            } else {
               GSEA.results <- GSEA.EnrichmentScore2(gene.list=obs.gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.correl.matrix[, r])
            }
            obs.phi[i, 1] <- GSEA.results$ES
            for (r in 2:nperm) {
               obs.phi[i, r] <- obs.phi[i, 1]
            }
        }
        gc()
     }

   } else if (reshuffling.type == "gene.labels") { # reshuffling gene labels
      for (i in 1:Ng) {
        gene.set <- gs[i,gs[i,] != "null"]
        gene.set2 <- vector(length=length(gene.set), mode = "numeric")
        gene.set2 <- match(gene.set, gene.labels)
        for (r in 1:nperm) {
            reshuffled.gene.labels <- sample(1:rows)
            if (use.fast.enrichment.routine == F) {
               GSEA.results <- GSEA.EnrichmentScore(gene.list=reshuffled.gene.labels, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.s2n)
            } else {
               GSEA.results <- GSEA.EnrichmentScore2(gene.list=reshuffled.gene.labels, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.s2n)
            }
            phi[i, r] <- GSEA.results$ES
        }
        if (fraction < 1.0) { # if resampling then compute ES for all observed rankings
           for (r in 1:nperm) {
              obs.gene.list2 <- obs.order.matrix[,r]
              if (use.fast.enrichment.routine == F) {
                 GSEA.results <- GSEA.EnrichmentScore(gene.list=obs.gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.correl.matrix[, r])
              } else {
                 GSEA.results <- GSEA.EnrichmentScore2(gene.list=obs.gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.correl.matrix[, r])
              }
              obs.phi[i, r] <- GSEA.results$ES
           }
        } else { # if no resampling then compute only one column (and fill the others with the same value)
           obs.gene.list2 <- obs.order.matrix[,1]
           if (use.fast.enrichment.routine == F) {
              GSEA.results <- GSEA.EnrichmentScore(gene.list=obs.gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.correl.matrix[, r])
           } else {
              GSEA.results <- GSEA.EnrichmentScore2(gene.list=obs.gene.list2, gene.set=gene.set2, weighted.score.type=weighted.score.type, correl.vector=obs.correl.matrix[, r])
           }
           obs.phi[i, 1] <- GSEA.results$ES
           for (r in 2:nperm) {
              obs.phi[i, r] <- obs.phi[i, 1]
           }
        }
        gc()
     }
   }

# Compute 3 types of p-values

# Find nominal p-values

print("Computing nominal p-values...")

p.vals <- matrix(0, nrow = Ng, ncol = 2)

if (OLD.GSEA == F) {
   for (i in 1:Ng) {
      pos.phi <- NULL
      neg.phi <- NULL
      for (j in 1:nperm) {
         if (phi[i, j] >= 0) {
            pos.phi <- c(pos.phi, phi[i, j])
         } else {
            neg.phi <- c(neg.phi, phi[i, j])
         }
      }
      ES.value <- Obs.ES[i]
      if (ES.value >= 0) {
         p.vals[i, 1] <- signif(sum(pos.phi >= ES.value)/length(pos.phi), digits=5)
      } else {
         p.vals[i, 1] <- signif(sum(neg.phi <= ES.value)/length(neg.phi), digits=5)
      }
   }
} else {  # For OLD GSEA compute the p-val using positive and negative values in the same histogram
   for (i in 1:Ng) {
      if (Obs.ES[i] >= 0) {
         p.vals[i, 1] <-  sum(phi[i,] >= Obs.ES[i])/length(phi[i,])
         p.vals[i, 1] <-  signif(p.vals[i, 1], digits=5)
      } else {
         p.vals[i, 1] <-  sum(phi[i,] <= Obs.ES[i])/length(phi[i,])
         p.vals[i, 1] <-  signif(p.vals[i, 1], digits=5)
      }
   }
}

# Find effective size

 erf <- function (x)
 {
    2 * pnorm(sqrt(2) * x)
 }

 KS.mean <- function(N) { # KS mean as a function of set size N
       S <- 0
       for (k in -100:100) {
          if (k == 0) next
          S <- S + 4 * (-1)**(k + 1) * (0.25 * exp(-2 * k * k * N) - sqrt(2 * pi) *  erf(sqrt(2 * N) * k)/(16 * k * sqrt(N)))
       }
      return(abs(S))
 }

# KS.mean.table <- vector(length=5000, mode="numeric")

# for (i in 1:5000) {
#    KS.mean.table[i] <- KS.mean(i)
# }

# KS.size <-  vector(length=Ng, mode="numeric")

# Rescaling normalization for each gene set null

print("Computing rescaling normalization for each gene set null...")

if (OLD.GSEA == F) {
   for (i in 1:Ng) {
         pos.phi <- NULL
         neg.phi <- NULL
         for (j in 1:nperm) {
            if (phi[i, j] >= 0) {
               pos.phi <- c(pos.phi, phi[i, j])
            } else {
               neg.phi <- c(neg.phi, phi[i, j])
            }
         }
         pos.m <- mean(pos.phi)
         neg.m <- mean(abs(neg.phi))

#         if (Obs.ES[i] >= 0) {
#            KS.size[i] <- which.min(abs(KS.mean.table - pos.m))
#         } else {
#            KS.size[i] <- which.min(abs(KS.mean.table - neg.m))
#         }

         pos.phi <- pos.phi/pos.m
         neg.phi <- neg.phi/neg.m
         for (j in 1:nperm) {
            if (phi[i, j] >= 0) {
                phi.norm[i, j] <- phi[i, j]/pos.m
            } else {
                phi.norm[i, j] <- phi[i, j]/neg.m
            }
          }
          for (j in 1:nperm) {
             if (obs.phi[i, j] >= 0) {
                obs.phi.norm[i, j] <- obs.phi[i, j]/pos.m
             } else {
                obs.phi.norm[i, j] <- obs.phi[i, j]/neg.m
             }
          }
          if (Obs.ES[i] >= 0) {
             Obs.ES.norm[i] <- Obs.ES[i]/pos.m
          } else {
             Obs.ES.norm[i] <- Obs.ES[i]/neg.m
          }
   }
} else {  # For OLD GSEA does not normalize using empirical scaling
   for (i in 1:Ng) {
      for (j in 1:nperm) {
          phi.norm[i, j] <- phi[i, j]/400
      }
      for (j in 1:nperm) {
          obs.phi.norm[i, j] <- obs.phi[i, j]/400
      }
      Obs.ES.norm[i] <- Obs.ES[i]/400
   }
}

# Save intermedite results

       if (save.intermediate.results == T) {

          filename <- paste(output.directory, doc.string, ".phi.txt", sep="", collapse="")
          write.table(phi, file = filename, quote=F, col.names= F, row.names=F, sep = "\t")

          filename <- paste(output.directory, doc.string, ".obs.phi.txt", sep="", collapse="")
          write.table(obs.phi, file = filename, quote=F, col.names= F, row.names=F, sep = "\t")

          filename <- paste(output.directory, doc.string, ".phi.norm.txt", sep="", collapse="")
          write.table(phi.norm, file = filename, quote=F, col.names= F, row.names=F, sep = "\t")

          filename <- paste(output.directory, doc.string, ".obs.phi.norm.txt", sep="", collapse="")
          write.table(obs.phi.norm, file = filename, quote=F, col.names= F, row.names=F, sep = "\t")

          filename <- paste(output.directory, doc.string, ".Obs.ES.txt", sep="", collapse="")
          write.table(Obs.ES, file = filename, quote=F, col.names= F, row.names=F, sep = "\t")

          filename <- paste(output.directory, doc.string, ".Obs.ES.norm.txt", sep="", collapse="")
          write.table(Obs.ES.norm, file = filename, quote=F, col.names= F, row.names=F, sep = "\t")
      }

# Compute FWER p-vals

      print("Computing FWER p-values...")

if (OLD.GSEA == F) {
    max.ES.vals.p <- NULL
    max.ES.vals.n <- NULL
    for (j in 1:nperm) {
       pos.phi <- NULL
       neg.phi <- NULL
       for (i in 1:Ng) {
          if (phi.norm[i, j] >= 0) {
             pos.phi <- c(pos.phi, phi.norm[i, j])
          } else {
             neg.phi <- c(neg.phi, phi.norm[i, j])
          }
       }
       if (length(pos.phi) > 0) {
          max.ES.vals.p <- c(max.ES.vals.p, max(pos.phi))
       }
       if (length(neg.phi) > 0) {
          max.ES.vals.n <- c(max.ES.vals.n, min(neg.phi))
       }
     }
   for (i in 1:Ng) {
       ES.value <- Obs.ES.norm[i]
       if (Obs.ES.norm[i] >= 0) {
          p.vals[i, 2] <- signif(sum(max.ES.vals.p >= ES.value)/length(max.ES.vals.p), digits=5)
       } else {
          p.vals[i, 2] <- signif(sum(max.ES.vals.n <= ES.value)/length(max.ES.vals.n), digits=5)
       }
     }
} else {  # For OLD GSEA compute the FWER using positive and negative values in the same histogram
    max.ES.vals <- NULL
    for (j in 1:nperm) {
       max.NES <- max(phi.norm[,j])
       min.NES <- min(phi.norm[,j])
       if (max.NES > - min.NES) {
          max.val <- max.NES
       } else {
          max.val <- min.NES
       }
       max.ES.vals <- c(max.ES.vals, max.val)
    }
    for (i in 1:Ng) {
       if (Obs.ES.norm[i] >= 0) {
          p.vals[i, 2] <- sum(max.ES.vals >= Obs.ES.norm[i])/length(max.ES.vals)
       } else {
          p.vals[i, 2] <- sum(max.ES.vals <= Obs.ES.norm[i])/length(max.ES.vals)
       }
       p.vals[i, 2] <-  signif(p.vals[i, 2], digits=4)
     }
}

# Compute FDRs

      print("Computing FDR q-values...")

      NES <- vector(length=Ng, mode="numeric")
      phi.norm.mean  <- vector(length=Ng, mode="numeric")
      obs.phi.norm.mean  <- vector(length=Ng, mode="numeric")
      phi.norm.median  <- vector(length=Ng, mode="numeric")
      obs.phi.norm.median  <- vector(length=Ng, mode="numeric")
      phi.norm.mean  <- vector(length=Ng, mode="numeric")
      obs.phi.mean  <- vector(length=Ng, mode="numeric")
      FDR.mean <- vector(length=Ng, mode="numeric")
      FDR.median <- vector(length=Ng, mode="numeric")
      phi.norm.median.d <- vector(length=Ng, mode="numeric")
      obs.phi.norm.median.d <- vector(length=Ng, mode="numeric")

      Obs.ES.index <- order(Obs.ES.norm, decreasing=T)
      Orig.index <- seq(1, Ng)
      Orig.index <- Orig.index[Obs.ES.index]
      Orig.index <- order(Orig.index, decreasing=F)
      Obs.ES.norm.sorted <- Obs.ES.norm[Obs.ES.index]
      gs.names.sorted <- gs.names[Obs.ES.index]

      for (k in 1:Ng) {
         NES[k] <- Obs.ES.norm.sorted[k]
         ES.value <- NES[k]
         count.col <- vector(length=nperm, mode="numeric")
         obs.count.col <- vector(length=nperm, mode="numeric")
         for (i in 1:nperm) {
            phi.vec <- phi.norm[,i]
            obs.phi.vec <- obs.phi.norm[,i]
            if (ES.value >= 0) {
               count.col.norm <- sum(phi.vec >= 0)
               obs.count.col.norm <- sum(obs.phi.vec >= 0)
               count.col[i] <- ifelse(count.col.norm > 0, sum(phi.vec >= ES.value)/count.col.norm, 0)
               obs.count.col[i] <- ifelse(obs.count.col.norm > 0, sum(obs.phi.vec >= ES.value)/obs.count.col.norm, 0)
            } else {
               count.col.norm <- sum(phi.vec < 0)
               obs.count.col.norm <- sum(obs.phi.vec < 0)
               count.col[i] <- ifelse(count.col.norm > 0, sum(phi.vec <= ES.value)/count.col.norm, 0)
               obs.count.col[i] <- ifelse(obs.count.col.norm > 0, sum(obs.phi.vec <= ES.value)/obs.count.col.norm, 0)
            }
         }
        phi.norm.mean[k] <- mean(count.col)
        obs.phi.norm.mean[k] <- mean(obs.count.col)
        phi.norm.median[k] <- median(count.col)
        obs.phi.norm.median[k] <- median(obs.count.col)
        FDR.mean[k] <- ifelse(phi.norm.mean[k]/obs.phi.norm.mean[k] < 1, phi.norm.mean[k]/obs.phi.norm.mean[k], 1)
        FDR.median[k] <- ifelse(phi.norm.median[k]/obs.phi.norm.median[k] < 1, phi.norm.median[k]/obs.phi.norm.median[k], 1)
      }

# adjust q-values

      if (adjust.FDR.q.val == T) {
         pos.nes <- length(NES[NES >= 0])
         min.FDR.mean <- FDR.mean[pos.nes]
         min.FDR.median <- FDR.median[pos.nes]
         for (k in seq(pos.nes - 1, 1, -1)) {
              if (FDR.mean[k] < min.FDR.mean) {
                  min.FDR.mean <- FDR.mean[k]
              }
              if (min.FDR.mean < FDR.mean[k]) {
                  FDR.mean[k] <- min.FDR.mean
              }
         }

         neg.nes <- pos.nes + 1
         min.FDR.mean <- FDR.mean[neg.nes]
         min.FDR.median <- FDR.median[neg.nes]
         for (k in seq(neg.nes + 1, Ng)) {
             if (FDR.mean[k] < min.FDR.mean) {
                 min.FDR.mean <- FDR.mean[k]
             }
             if (min.FDR.mean < FDR.mean[k]) {
                 FDR.mean[k] <- min.FDR.mean
             }
         }
     }

     obs.phi.norm.mean.sorted <- obs.phi.norm.mean[Orig.index]
     phi.norm.mean.sorted <- phi.norm.mean[Orig.index]
     FDR.mean.sorted <- FDR.mean[Orig.index]
     FDR.median.sorted <- FDR.median[Orig.index]

#   Compute global statistic

    glob.p.vals <- vector(length=Ng, mode="numeric")
    NULL.pass <- vector(length=nperm, mode="numeric")
    OBS.pass <- vector(length=nperm, mode="numeric")

    for (k in 1:Ng) {
      NES[k] <- Obs.ES.norm.sorted[k]
      if (NES[k] >= 0) {
         for (i in 1:nperm) {
             NULL.pos <- sum(phi.norm[,i] >= 0)
             NULL.pass[i] <- ifelse(NULL.pos > 0, sum(phi.norm[,i] >= NES[k])/NULL.pos, 0)
             OBS.pos <- sum(obs.phi.norm[,i] >= 0)
             OBS.pass[i] <- ifelse(OBS.pos > 0, sum(obs.phi.norm[,i] >= NES[k])/OBS.pos, 0)
         }
      } else {
         for (i in 1:nperm) {
             NULL.neg <- sum(phi.norm[,i] < 0)
             NULL.pass[i] <- ifelse(NULL.neg > 0, sum(phi.norm[,i] <= NES[k])/NULL.neg, 0)
             OBS.neg <- sum(obs.phi.norm[,i] < 0)
             OBS.pass[i] <- ifelse(OBS.neg > 0, sum(obs.phi.norm[,i] <= NES[k])/OBS.neg, 0)
         }
      }
      glob.p.vals[k] <- sum(NULL.pass >= mean(OBS.pass))/nperm
    }
    glob.p.vals.sorted <- glob.p.vals[Orig.index]

# Produce results report

      print("Producing result tables and plots...")

       Obs.ES <- signif(Obs.ES, digits=5)
       Obs.ES.norm <- signif(Obs.ES.norm, digits=5)
       p.vals <- signif(p.vals, digits=4)
       signal.strength <- signif(signal.strength, digits=3)
       tag.frac <- signif(tag.frac, digits=3)
       gene.frac <- signif(gene.frac, digits=3)
       FDR.mean.sorted <- signif(FDR.mean.sorted, digits=5)
       FDR.median.sorted <-  signif(FDR.median.sorted, digits=5)
       glob.p.vals.sorted <- signif(glob.p.vals.sorted, digits=5)

       report <- data.frame(cbind(gs.names, size.G, all.gs.descs, Obs.ES, Obs.ES.norm, p.vals[,1], FDR.mean.sorted, p.vals[,2], tag.frac, gene.frac, signal.strength, FDR.median.sorted, glob.p.vals.sorted))
       names(report) <- c("GS", "SIZE", "SOURCE", "ES", "NES", "NOM p-val", "FDR q-val", "FWER p-val", "Tag %", "Gene %", "Signal", "FDR (median)", "glob.p.val")
#       print(report)
       report2 <- report
       report.index2 <- order(Obs.ES.norm, decreasing=T)
       for (i in 1:Ng) {
           report2[i,] <- report[report.index2[i],]
       }
       report3 <- report
       report.index3 <- order(Obs.ES.norm, decreasing=F)
       for (i in 1:Ng) {
           report3[i,] <- report[report.index3[i],]
       }
       phen1.rows <- length(Obs.ES.norm[Obs.ES.norm >= 0])
       phen2.rows <- length(Obs.ES.norm[Obs.ES.norm < 0])
       report.phen1 <- report2[1:phen1.rows,]
       report.phen2 <- report3[1:phen2.rows,]

if (output.directory != "")  {
       if (phen1.rows > 0) {
          filename <- paste(output.directory, doc.string, ".SUMMARY.RESULTS.REPORT.", phen1,".txt", sep="", collapse="")
          write.table(report.phen1, file = filename, quote=F, row.names=F, sep = "\t")
       }
       if (phen2.rows > 0) {
          filename <- paste(output.directory, doc.string, ".SUMMARY.RESULTS.REPORT.", phen2,".txt", sep="", collapse="")
          write.table(report.phen2, file = filename, quote=F, row.names=F, sep = "\t")
       }
}

# Global plots

if (output.directory != "")  {
      if (non.interactive.run == F) {
           if (.Platform$OS.type == "windows") {
              glob.filename <- paste(output.directory, doc.string, ".global.plots", sep="", collapse="")
              windows(width = 10, height = 10)
           } else if (.Platform$OS.type == "unix") {
               glob.filename <- paste(output.directory, doc.string, ".global.plots.pdf", sep="", collapse="")
               pdf(file=glob.filename, height = 10, width = 10)
           }
      } else {
           if (.Platform$OS.type == "unix") {
              glob.filename <- paste(output.directory, doc.string, ".global.plots.pdf", sep="", collapse="")
              pdf(file=glob.filename, height = 10, width = 10)
           } else if (.Platform$OS.type == "windows") {
              glob.filename <- paste(output.directory, doc.string, ".global.plots.pdf", sep="", collapse="")
              pdf(file=glob.filename, height = 10, width = 10)
           }
      }
}

      nf <- layout(matrix(c(1,2,3,4), 2, 2, byrow=T), c(1,1), c(1,1), TRUE)

# plot S2N correlation profile

     location <- 1:N
     max.corr <- max(obs.s2n)
     min.corr <- min(obs.s2n)

     x <- plot(location, obs.s2n, ylab = "Signal to Noise Ratio (S2N)", xlab = "Gene List Location", main = "Gene List Correlation (S2N) Profile", type = "l", lwd = 2, cex = 0.9, col = 1)
     for (i in seq(1, N, 20)) {
       lines(c(i, i), c(0, obs.s2n[i]), lwd = 3, cex = 0.9, col = colors()[12]) # shading of correlation plot
     }
     x <- points(location, obs.s2n, type = "l", lwd = 2, cex = 0.9, col = 1)
     lines(c(1, N), c(0, 0), lwd = 2, lty = 1, cex = 0.9, col = 1) # zero correlation horizontal line
     temp <- order(abs(obs.s2n), decreasing=T)
     arg.correl <- temp[N]
     lines(c(arg.correl, arg.correl), c(min.corr, 0.7*max.corr), lwd = 2, lty = 3, cex = 0.9, col = 1) # zero correlation vertical line

     area.bias <- signif(100*(sum(obs.s2n[1:arg.correl]) + sum(obs.s2n[arg.correl:N]))/sum(abs(obs.s2n[1:N])), digits=3)
     area.phen <- ifelse(area.bias >= 0, phen1, phen2)
     delta.string <- paste("Corr. Area Bias to \"", area.phen, "\" =", abs(area.bias), "%", sep="", collapse="")
     zero.crossing.string <- paste("Zero Crossing at location ", arg.correl, " (",  signif(100*arg.correl/N, digits=3), " %)")
     leg.txt <- c(delta.string, zero.crossing.string)
     legend(x=N/10, y=max.corr, bty="n", bg = "white", legend=leg.txt, cex = 0.9)

     leg.txt <- paste("\"", phen1, "\" ", sep="", collapse="")
     text(x=1, y=-0.05*max.corr, adj = c(0, 1), labels=leg.txt, cex = 0.9)

     leg.txt <- paste("\"", phen2, "\" ", sep="", collapse="")
     text(x=N, y=0.05*max.corr, adj = c(1, 0), labels=leg.txt, cex = 0.9)

  if (Ng > 1) { # make these plots only if there are multiple gene sets.

    # compute plots of actual (weighted) null and observed

      phi.densities.pos <- matrix(0, nrow=512, ncol=nperm)
      phi.densities.neg <- matrix(0, nrow=512, ncol=nperm)
      obs.phi.densities.pos <- matrix(0, nrow=512, ncol=nperm)
      obs.phi.densities.neg <- matrix(0, nrow=512, ncol=nperm)
      phi.density.mean.pos <- vector(length=512, mode = "numeric")
      phi.density.mean.neg <- vector(length=512, mode = "numeric")
      obs.phi.density.mean.pos <- vector(length=512, mode = "numeric")
      obs.phi.density.mean.neg <- vector(length=512, mode = "numeric")
      phi.density.median.pos <- vector(length=512, mode = "numeric")
      phi.density.median.neg <- vector(length=512, mode = "numeric")
      obs.phi.density.median.pos <- vector(length=512, mode = "numeric")
      obs.phi.density.median.neg <- vector(length=512, mode = "numeric")
      x.coor.pos <-  vector(length=512, mode = "numeric")
      x.coor.neg <-  vector(length=512, mode = "numeric")

      for (i in 1:nperm) {
         pos.phi <- phi.norm[phi.norm[, i] >= 0, i]
         if (length(pos.phi) > 2) {
            temp <- density(pos.phi, adjust=adjust.param, n = 512, from=0, to=3.5)
         } else {
            temp <- list(x = 3.5*(seq(1, 512) - 1)/512, y = rep(0.001, 512))
         }
         phi.densities.pos[, i] <- temp$y
         norm.factor <- sum(phi.densities.pos[, i])
         phi.densities.pos[, i] <- phi.densities.pos[, i]/norm.factor
         if (i == 1) {
            x.coor.pos <- temp$x
         }

         neg.phi <- phi.norm[phi.norm[, i] < 0, i]
         if (length(neg.phi) > 2) {
            temp <- density(neg.phi, adjust=adjust.param, n = 512, from=-3.5, to=0)
         } else {
            temp <- list(x = 3.5*(seq(1, 512) - 1)/512, y = rep(0.001, 512))
         }
         phi.densities.neg[, i] <- temp$y
         norm.factor <- sum(phi.densities.neg[, i])
         phi.densities.neg[, i] <- phi.densities.neg[, i]/norm.factor
         if (i == 1) {
            x.coor.neg <- temp$x
         }
         pos.phi <- obs.phi.norm[obs.phi.norm[, i] >= 0, i]
         if (length(pos.phi) > 2) {
            temp <- density(pos.phi, adjust=adjust.param, n = 512, from=0, to=3.5)
         } else {
            temp <- list(x = 3.5*(seq(1, 512) - 1)/512, y = rep(0.001, 512))
         }
         obs.phi.densities.pos[, i] <- temp$y
         norm.factor <- sum(obs.phi.densities.pos[, i])
         obs.phi.densities.pos[, i] <- obs.phi.densities.pos[, i]/norm.factor

         neg.phi <- obs.phi.norm[obs.phi.norm[, i] < 0, i]
         if (length(neg.phi)> 2) {
            temp <- density(neg.phi, adjust=adjust.param, n = 512, from=-3.5, to=0)
         } else {
            temp <- list(x = 3.5*(seq(1, 512) - 1)/512, y = rep(0.001, 512))
         }
         obs.phi.densities.neg[, i] <- temp$y
         norm.factor <- sum(obs.phi.densities.neg[, i])
         obs.phi.densities.neg[, i] <- obs.phi.densities.neg[, i]/norm.factor

      }
      phi.density.mean.pos <- apply(phi.densities.pos, 1, mean)
      phi.density.mean.neg <- apply(phi.densities.neg, 1, mean)

      obs.phi.density.mean.pos <- apply(obs.phi.densities.pos, 1, mean)
      obs.phi.density.mean.neg <- apply(obs.phi.densities.neg, 1, mean)

      phi.density.median.pos <- apply(phi.densities.pos, 1, median)
      phi.density.median.neg <- apply(phi.densities.neg, 1, median)

      obs.phi.density.median.pos <- apply(obs.phi.densities.pos, 1, median)
      obs.phi.density.median.neg <- apply(obs.phi.densities.neg, 1, median)

      x <- c(x.coor.neg, x.coor.pos)
      x.plot.range <- range(x)
      y1 <- c(phi.density.mean.neg, phi.density.mean.pos)
      y2 <- c(obs.phi.density.mean.neg, obs.phi.density.mean.pos)
      y.plot.range <- c(-0.3*max(c(y1, y2)),  max(c(y1, y2)))

      print(c(y.plot.range, max(c(y1, y2)), max(y1), max(y2)))

      plot(x, y1, xlim = x.plot.range, ylim = 1.5*y.plot.range, type = "l", lwd = 2, col = 2, xlab = "NES", ylab = "P(NES)", main = "Global Observed and Null Densities (Area Normalized)")

     y1.point <- y1[seq(1, length(x), 2)]
     y2.point <- y2[seq(2, length(x), 2)]
     x1.point <- x[seq(1, length(x), 2)]
     x2.point <- x[seq(2, length(x), 2)]

#     for (i in 1:length(x1.point)) {
#       lines(c(x1.point[i], x1.point[i]), c(0, y1.point[i]), lwd = 3, cex = 0.9, col = colors()[555]) # shading
#     }
#
#     for (i in 1:length(x2.point)) {
#       lines(c(x2.point[i], x2.point[i]), c(0, y2.point[i]), lwd = 3, cex = 0.9, col = colors()[29]) # shading
#     }

      points(x, y1, type = "l", lwd = 2, col = colors()[555])
      points(x, y2, type = "l", lwd = 2, col = colors()[29])

      for (i in 1:Ng) {
         col <- ifelse(Obs.ES.norm[i] > 0, 2, 3)
         lines(c(Obs.ES.norm[i], Obs.ES.norm[i]), c(-0.2*max(c(y1, y2)), 0), lwd = 1, lty = 1, col = 1)
      }
      leg.txt <- paste("Neg. ES: \"", phen2, " \" ", sep="", collapse="")
      text(x=x.plot.range[1], y=-0.25*max(c(y1, y2)), adj = c(0, 1), labels=leg.txt, cex = 0.9)
      leg.txt <- paste(" Pos. ES: \"", phen1, "\" ", sep="", collapse="")
      text(x=x.plot.range[2], y=-0.25*max(c(y1, y2)), adj = c(1, 1), labels=leg.txt, cex = 0.9)

      leg.txt <- c("Null Density", "Observed Density", "Observed NES values")
      c.vec <- c(colors()[555], colors()[29], 1)
      lty.vec <- c(1, 1, 1)
      lwd.vec <- c(2, 2, 2)
      legend(x=0, y=1.5*y.plot.range[2], bty="n", bg = "white", legend=leg.txt, lty = lty.vec, lwd = lwd.vec, col = c.vec, cex = 0.9)

      B <- A[obs.index,]
      if (N > 300) {
         C <- rbind(B[1:100,], rep(0, Ns), rep(0, Ns), B[(floor(N/2) - 50 + 1):(floor(N/2) + 50),], rep(0, Ns), rep(0, Ns), B[(N - 100 + 1):N,])
      } else {
      # modified by pwwang@pwwang.com, in case # genes <= 300
         C <- B
      }
      rm(B)
      GSEA.HeatMapPlot(V = C, col.labels = class.labels, col.classes = class.phen, main = "Heat Map for Genes in Dataset")

# p-vals plot
      nom.p.vals <- p.vals[Obs.ES.index,1]
      FWER.p.vals <- p.vals[Obs.ES.index,2]
      plot.range <- 1.25*range(NES)
      plot(NES, FDR.mean, ylim = c(0, 1), xlim = plot.range, col = 1, bg = 1, type="p", pch = 22, cex = 0.75, xlab = "NES", main = "p-values vs. NES", ylab ="p-val/q-val")
      points(NES, nom.p.vals, type = "p", col = 2, bg = 2, pch = 22, cex = 0.75)
      points(NES, FWER.p.vals, type = "p", col = colors()[577], bg = colors()[577], pch = 22, cex = 0.75)
      leg.txt <- c("Nominal p-value", "FWER p-value", "FDR q-value")
      c.vec <- c(2, colors()[577], 1)
      pch.vec <- c(22, 22, 22)
      legend(x=-0.5, y=0.5, bty="n", bg = "white", legend=leg.txt, pch = pch.vec, col = c.vec, pt.bg = c.vec, cex = 0.9)
      lines(c(min(NES), max(NES)), c(nom.p.val.threshold, nom.p.val.threshold), lwd = 1, lty = 2, col = 2)
      lines(c(min(NES), max(NES)), c(fwer.p.val.threshold, fwer.p.val.threshold), lwd = 1, lty = 2, col = colors()[577])
      lines(c(min(NES), max(NES)), c(fdr.q.val.threshold, fdr.q.val.threshold), lwd = 1, lty = 2, col = 1)

      if (non.interactive.run == F) {
           if (.Platform$OS.type == "windows") {
               savePlot(filename = glob.filename, type ="jpeg", device = dev.cur())
           } else if (.Platform$OS.type == "unix") {
               dev.off()
           }
      } else {
           dev.off()
      }

  } # if Ng > 1

#----------------------------------------------------------------------------
# Produce report for each gene set passing the nominal, FWER or FDR test or the top topgs in each side

      if (topgs > floor(Ng/2)) {
         topgs <- floor(Ng/2)
      }

      for (i in 1:Ng) {
          if ((p.vals[i, 1] <= nom.p.val.threshold) ||
              (p.vals[i, 2] <= fwer.p.val.threshold) ||
              (FDR.mean.sorted[i] <= fdr.q.val.threshold) ||
              (is.element(i, c(Obs.ES.index[1:topgs], Obs.ES.index[(Ng - topgs + 1): Ng])))) {

#  produce report per gene set

            kk <- 1
            gene.number <- vector(length = size.G[i], mode = "character")
            gene.names <- vector(length = size.G[i], mode = "character")
            gene.symbols <- vector(length = size.G[i], mode = "character")
            gene.descs <- vector(length = size.G[i], mode = "character")
            gene.list.loc <- vector(length = size.G[i], mode = "numeric")
            core.enrichment <- vector(length = size.G[i], mode = "character")
            gene.s2n <- vector(length = size.G[i], mode = "numeric")
            gene.RES <- vector(length = size.G[i], mode = "numeric")
            rank.list <- seq(1, N)

            if (Obs.ES[i] >= 0) {
              set.k <- seq(1, N, 1)
              phen.tag <- phen1
              loc <- match(i, Obs.ES.index)
            } else {
              set.k <- seq(N, 1, -1)
              phen.tag <- phen2
              loc <- Ng - match(i, Obs.ES.index) + 1
            }

            for (k in set.k) {
               if (Obs.indicator[i, k] == 1) {
                  gene.number[kk] <- kk
                  gene.names[kk] <- obs.gene.labels[k]
                  gene.symbols[kk] <- substr(obs.gene.symbols[k], 1, 15)
                  gene.descs[kk] <- substr(obs.gene.descs[k], 1, 40)
                  gene.list.loc[kk] <- k
                  gene.s2n[kk] <- signif(obs.s2n[k], digits=3)
                  gene.RES[kk] <- signif(Obs.RES[i, k], digits = 3)
                  if (Obs.ES[i] >= 0) {
                     core.enrichment[kk] <- ifelse(gene.list.loc[kk] <= Obs.arg.ES[i], "YES", "NO")
                  } else {
                     core.enrichment[kk] <- ifelse(gene.list.loc[kk] > Obs.arg.ES[i], "YES", "NO")
                  }
                  kk <- kk + 1
               }
            }

       gene.report <- data.frame(cbind(gene.number, gene.names, gene.symbols, gene.descs, gene.list.loc, gene.s2n, gene.RES, core.enrichment))
       names(gene.report) <- c("#", "GENE", "SYMBOL", "DESC", "LIST LOC", "S2N", "RES", "CORE_ENRICHMENT")

#       print(gene.report)

if (output.directory != "")  {

       filename <- paste(output.directory, doc.string, ".", gs.names[i], ".report.", phen.tag, ".", loc, ".txt", sep="", collapse="")
       write.table(gene.report, file = filename, quote=F, row.names=F, sep = "\t")

       if (non.interactive.run == F) {
           if (.Platform$OS.type == "windows") {
               gs.filename <- paste(output.directory, doc.string, ".", gs.names[i], ".plot.", phen.tag, ".", loc, sep="", collapse="")
               windows(width = 14, height = 6)
           } else if (.Platform$OS.type == "unix") {
               gs.filename <- paste(output.directory, doc.string, ".", gs.names[i], ".plot.", phen.tag, ".", loc, ".pdf", sep="", collapse="")
               pdf(file=gs.filename, height = 6, width = 14)
           }
       } else {
           if (.Platform$OS.type == "unix") {
              gs.filename <- paste(output.directory, doc.string, ".", gs.names[i], ".plot.", phen.tag, ".", loc, ".pdf", sep="", collapse="")
              pdf(file=gs.filename, height = 6, width = 14)
           } else if (.Platform$OS.type == "windows") {
              gs.filename <- paste(output.directory, doc.string, ".", gs.names[i], ".plot.", phen.tag, ".", loc, ".pdf", sep="", collapse="")
              pdf(file=gs.filename, height = 6, width = 14)
           }
       }

}

            nf <- layout(matrix(c(1,2,3), 1, 3, byrow=T), 1, c(1, 1, 1), TRUE)
            ind <- 1:N
            min.RES <- min(Obs.RES[i,])
            max.RES <- max(Obs.RES[i,])
            if (max.RES < 0.3) max.RES <- 0.3
            if (min.RES > -0.3) min.RES <- -0.3
            delta <- (max.RES - min.RES)*0.50
            min.plot <- min.RES - 2*delta
            max.plot <- max.RES
            max.corr <- max(obs.s2n)
            min.corr <- min(obs.s2n)
            Obs.correl.vector.norm <- (obs.s2n - min.corr)/(max.corr - min.corr)*1.25*delta + min.plot
            zero.corr.line <- (- min.corr/(max.corr - min.corr))*1.25*delta + min.plot
            col <- ifelse(Obs.ES[i] > 0, 2, 4)

            # Running enrichment plot

            sub.string <- paste("Number of genes: ", N, " (in list), ", size.G[i], " (in gene set)", sep = "", collapse="")

            main.string <- paste("Gene Set ", i, ":", gs.names[i])
            plot(ind, Obs.RES[i,], main = main.string, sub = sub.string, xlab = "Gene List Index", ylab = "Running Enrichment Score (RES)", xlim=c(1, N), ylim=c(min.plot, max.plot), type = "l", lwd = 2, cex = 1, col = col)
            for (j in seq(1, N, 20)) {
                lines(c(j, j), c(zero.corr.line, Obs.correl.vector.norm[j]), lwd = 1, cex = 1, col = colors()[12]) # shading of correlation plot
            }
            lines(c(1, N), c(0, 0), lwd = 1, lty = 2, cex = 1, col = 1) # zero RES line
            lines(c(Obs.arg.ES[i], Obs.arg.ES[i]), c(min.plot, max.plot), lwd = 1, lty = 3, cex = 1, col = col) # max enrichment vertical line
            for (j in 1:N) {
               if (Obs.indicator[i, j] == 1) {
                  lines(c(j, j), c(min.plot + 1.25*delta, min.plot + 1.75*delta), lwd = 1, lty = 1, cex = 1, col = 1)  # enrichment tags
               }
            }
            lines(ind, Obs.correl.vector.norm, type = "l", lwd = 1, cex = 1, col = 1)
            lines(c(1, N), c(zero.corr.line, zero.corr.line), lwd = 1, lty = 1, cex = 1, col = 1) # zero correlation horizontal line
            temp <- order(abs(obs.s2n), decreasing=T)
            arg.correl <- temp[N]
            lines(c(arg.correl, arg.correl), c(min.plot, max.plot), lwd = 1, lty = 3, cex = 1, col = 3) # zero crossing correlation vertical line

            leg.txt <- paste("\"", phen1, "\" ", sep="", collapse="")
            text(x=1, y=min.plot, adj = c(0, 0), labels=leg.txt, cex = 1.0)

            leg.txt <- paste("\"", phen2, "\" ", sep="", collapse="")
            text(x=N, y=min.plot, adj = c(1, 0), labels=leg.txt, cex = 1.0)

            adjx <- ifelse(Obs.ES[i] > 0, 0, 1)

            leg.txt <- paste("Peak at ", Obs.arg.ES[i], sep="", collapse="")
            text(x=Obs.arg.ES[i], y=min.plot + 1.8*delta, adj = c(adjx, 0), labels=leg.txt, cex = 1.0)

            leg.txt <- paste("Zero crossing at ", arg.correl, sep="", collapse="")
            text(x=arg.correl, y=min.plot + 1.95*delta, adj = c(adjx, 0), labels=leg.txt, cex = 1.0)

            # nominal p-val histogram

            sub.string <- paste("ES =", signif(Obs.ES[i], digits = 3), " NES =", signif(Obs.ES.norm[i], digits=3), "Nom. p-val=", signif(p.vals[i, 1], digits = 3),"FWER=", signif(p.vals[i, 2], digits = 3), "FDR=", signif(FDR.mean.sorted[i], digits = 3))
            temp <- density(phi[i,], adjust=adjust.param)
            x.plot.range <- range(temp$x)
            y.plot.range <- c(-0.125*max(temp$y), 1.5*max(temp$y))
            plot(temp$x, temp$y, type = "l", sub = sub.string, xlim = x.plot.range, ylim = y.plot.range, lwd = 2, col = 2, main = "Gene Set Null Distribution", xlab = "ES", ylab="P(ES)")
            x.loc <- which.min(abs(temp$x - Obs.ES[i]))
            lines(c(Obs.ES[i], Obs.ES[i]), c(0, temp$y[x.loc]), lwd = 2, lty = 1, cex = 1, col = 1)
            lines(x.plot.range, c(0, 0), lwd = 1, lty = 1, cex = 1, col = 1)

            leg.txt <- c("Gene Set Null Density", "Observed Gene Set ES value")
            c.vec <- c(2, 1)
            lty.vec <- c(1, 1)
            lwd.vec <- c(2, 2)
            legend(x=-0.2, y=y.plot.range[2], bty="n", bg = "white", legend=leg.txt, lty = lty.vec, lwd = lwd.vec, col = c.vec, cex = 1.0)

            leg.txt <- paste("Neg. ES \"", phen2, "\" ", sep="", collapse="")
            text(x=x.plot.range[1], y=-0.1*max(temp$y), adj = c(0, 0), labels=leg.txt, cex = 1.0)
            leg.txt <- paste(" Pos. ES: \"", phen1, "\" ", sep="", collapse="")
            text(x=x.plot.range[2], y=-0.1*max(temp$y), adj = c(1, 0), labels=leg.txt, cex = 1.0)

            # create pinkogram for each gene set

            kk <- 1

            pinko <- matrix(0, nrow = size.G[i], ncol = cols)
            pinko.gene.names <- vector(length = size.G[i], mode = "character")
            for (k in 1:rows) {
               if (Obs.indicator[i, k] == 1) {
                  pinko[kk,] <- A[obs.index[k],]
                  pinko.gene.names[kk] <- obs.gene.symbols[k]
                  kk <- kk + 1
               }
            }
            GSEA.HeatMapPlot(V = pinko, row.names = pinko.gene.names, col.labels = class.labels, col.classes = class.phen, col.names = sample.names, main =" Heat Map for Genes in Gene Set", xlab=" ", ylab=" ")

      if (non.interactive.run == F) {
           if (.Platform$OS.type == "windows") {
               savePlot(filename = gs.filename, type ="jpeg", device = dev.cur())
           } else if (.Platform$OS.type == "unix") {
               dev.off()
           }
      } else {
           dev.off()
      }

        } # if p.vals thres

      } # loop over gene sets


  return(list(report1 = report.phen1, report2 = report.phen2))

}  # end of definition of GSEA.analysis


GSEA.write.gct <- function (gct, filename)
{
    f <- file(filename, "w")
    cat("#1.2", "\n", file = f, append = TRUE, sep = "")
    cat(dim(gct)[1], "\t", dim(gct)[2], "\n", file = f, append = TRUE, sep = "")
    cat("Name", "\t", file = f, append = TRUE, sep = "")
    cat("Description", file = f, append = TRUE, sep = "")
    names <- names(gct)
    cat("\t", names[1], file = f, append = TRUE, sep = "")
    for (j in 2:length(names)) {
        cat("\t", names[j], file = f, append = TRUE, sep = "")
    }
    cat("\n", file = f, append = TRUE, sep = "\t")
    oldWarn <- options(warn = -1)
    m <- matrix(nrow = dim(gct)[1], ncol = dim(gct)[2] +  2)
    m[, 1] <- row.names(gct)
    m[, 2] <- row.names(gct)
    index <- 3
    for (i in 1:dim(gct)[2]) {
        m[, index] <- gct[, i]
        index <- index + 1
    }
    write.table(m, file = f, append = TRUE, quote = FALSE, sep = "\t", eol = "\n", col.names = FALSE, row.names = FALSE)
    close(f)
    options(warn = 0)
    return(gct)
}


GSEA.ConsPlot <- function(V, col.names, main = " ", sub = " ", xlab=" ", ylab=" ") {

# Plots a heatmap plot of a consensus matrix

     cols <- length(V[1,])
     B <- matrix(0, nrow=cols, ncol=cols)
     max.val <- max(V)
     min.val <- min(V)
     for (i in 1:cols) {
         for (j in 1:cols) {
             k <- cols - i + 1
	     B[k, j] <-  max.val - V[i, j] + min.val
          }
     }



#     col.map <- c(rainbow(100, s = 1.0, v = 0.75, start = 0.0, end = 0.75, gamma = 1.5), "#BBBBBB", "#333333", "#FFFFFF")
     col.map <- rev(c("#0000FF", "#4040FF", "#7070FF", "#8888FF", "#A9A9FF", "#D5D5FF", "#EEE5EE", "#FFAADA", "#FF9DB0", "#FF7080", "#FF5A5A", "#FF4040", "#FF0D1D"))

#     max.size <- max(nchar(col.names))
     par(mar = c(5, 15, 15, 5))
     image(1:cols, 1:cols, t(B), col = col.map, axes=FALSE, main=main, sub=sub, xlab= xlab, ylab=ylab)

     for (i in 1:cols) {
         col.names[i]  <- substr(col.names[i], 1, 25)
     }
     col.names2 <- rev(col.names)

     size.col.char <- ifelse(cols < 15, 1, sqrt(15/cols))

     axis(2, at=1:cols, labels=col.names2, adj= 0.5, tick=FALSE, las = 1, cex.axis=size.col.char, font.axis=1, line=-1)
     axis(3, at=1:cols, labels=col.names, adj= 1, tick=FALSE, las = 3, cex.axis=size.col.char, font.axis=1, line=-1)

     return()
}

GSEA.HeatMapPlot2 <- function(V, row.names = "NA", col.names = "NA", main = " ", sub = " ", xlab=" ", ylab=" ", color.map = "default") {
#
# Plots a heatmap of a matrix

       n.rows <- length(V[,1])
       n.cols <- length(V[1,])

       if (color.map == "default") {
         color.map <- rev(rainbow(100, s = 1.0, v = 0.75, start = 0.0, end = 0.75, gamma = 1.5))
       }

        heatm <- matrix(0, nrow = n.rows, ncol = n.cols)
        heatm[1:n.rows,] <- V[seq(n.rows, 1, -1),]

        par(mar = c(7, 15, 5, 5))
        image(1:n.cols, 1:n.rows, t(heatm), col=color.map, axes=FALSE, main=main, sub = sub, xlab= xlab, ylab=ylab)

        if (length(row.names) > 1) {
            size.row.char <- ifelse(n.rows < 15, 1, sqrt(15/n.rows))
            size.col.char <- ifelse(n.cols < 15, 1, sqrt(10/n.cols))
#            size.col.char <- ifelse(n.cols < 2.5, 1, sqrt(2.5/n.cols))
            for (i in 1:n.rows) {
               row.names[i] <- substr(row.names[i], 1, 40)
            }
            row.names <- row.names[seq(n.rows, 1, -1)]
            axis(2, at=1:n.rows, labels=row.names, adj= 0.5, tick=FALSE, las = 1, cex.axis=size.row.char, font.axis=1, line=-1)
        }

        if (length(col.names) > 1) {
           axis(1, at=1:n.cols, labels=col.names, tick=FALSE, las = 3, cex.axis=size.col.char, font.axis=2, line=-1)
        }

	return()
}


GSEA.Analyze.Sets <- function(
   directory,
   topgs = "",
   non.interactive.run = F,
   height = 12,
   width = 17) {

   file.list <- list.files(directory)
   files <- file.list[regexpr(pattern = "\\.report\\.", file.list) > 1]
   max.sets <- length(files)

   set.table <- matrix(nrow = max.sets, ncol = 5)

   for (i in 1:max.sets) {
      temp1 <-  strsplit(files[i], split="\\.report\\.")
      temp2 <-  strsplit(temp1[[1]][1], split="\\.")
      s <- length(temp2[[1]])
      prefix.name <- paste(temp2[[1]][1:(s-1)], sep="", collapse="")
      set.name <- temp2[[1]][s]
      temp3 <-  strsplit(temp1[[1]][2], split="\\.")
      phenotype <- temp3[[1]][1]
      seq.number <- temp3[[1]][2]
      dataset <- paste(temp2[[1]][1:(s-1)], sep="", collapse=".")

      set.table[i, 1] <- files[i]

      set.table[i, 3] <- phenotype
      set.table[i, 4] <- as.numeric(seq.number)
      set.table[i, 5] <- dataset

#      set.table[i, 2] <- paste(set.name, dataset, sep ="", collapse="")
      set.table[i, 2] <- substr(set.name, 1, 20)
   }

   print(c("set name=", prefix.name))
   doc.string <- prefix.name

   set.table <- noquote(set.table)
   phen.order <- order(set.table[, 3], decreasing = T)
   set.table <- set.table[phen.order,]
   phen1 <- names(table(set.table[,3]))[1]
   phen2 <- names(table(set.table[,3]))[2]
   set.table.phen1 <- set.table[set.table[,3] == phen1,]
   set.table.phen2 <- set.table[set.table[,3] == phen2,]

   seq.order <- order(as.numeric(set.table.phen1[, 4]), decreasing = F)
   set.table.phen1 <- set.table.phen1[seq.order,]
   seq.order <- order(as.numeric(set.table.phen2[, 4]), decreasing = F)
   set.table.phen2 <- set.table.phen2[seq.order,]

#   max.sets.phen1 <- length(set.table.phen1[,1])
#   max.sets.phen2 <- length(set.table.phen2[,1])

   if (topgs == "") {
      max.sets.phen1 <- length(set.table.phen1[,1])
      max.sets.phen2 <- length(set.table.phen2[,1])
   } else {
      max.sets.phen1 <- ifelse(topgs > length(set.table.phen1[,1]), length(set.table.phen1[,1]), topgs)
      max.sets.phen2 <- ifelse(topgs > length(set.table.phen2[,1]), length(set.table.phen2[,1]), topgs)
   }

   # Analysis for phen1

   leading.lists <- NULL
   for (i in 1:max.sets.phen1) {
      inputfile <- paste(directory, set.table.phen1[i, 1], sep="", collapse="")
      gene.set <- read.table(file=inputfile, sep="\t", header=T, comment.char="", as.is=T)
      leading.set <- as.vector(gene.set[gene.set[,"CORE_ENRICHMENT"] == "YES", "SYMBOL"])
      leading.lists <- c(leading.lists, list(leading.set))
      if (i == 1) {
         all.leading.genes <- leading.set
      } else{
         all.leading.genes <- union(all.leading.genes, leading.set)
      }
   }
   max.genes <- length(all.leading.genes)
   M <- matrix(0, nrow=max.sets.phen1, ncol=max.genes)
   for (i in 1:max.sets.phen1) {
      M[i,] <- sign(match(all.leading.genes, as.vector(leading.lists[[i]]), nomatch=0))   # notice that the sign is 0 (no tag) or 1 (tag)
   }

   Inter <- matrix(0, nrow=max.sets.phen1, ncol=max.sets.phen1)
   for (i in 1:max.sets.phen1) {
      for (j in 1:max.sets.phen1) {
         Inter[i, j] <- length(intersect(leading.lists[[i]], leading.lists[[j]]))/length(union(leading.lists[[i]], leading.lists[[j]]))
      }
   }

   Itable <- data.frame(Inter)
   names(Itable) <- set.table.phen1[1:max.sets.phen1, 2]
   row.names(Itable) <- set.table.phen1[1:max.sets.phen1, 2]

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.overlap.", phen1, sep="", collapse="")
           windows(height = width, width = width)
        } else if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.overlap.", phen1, ".pdf", sep="", collapse="")
           pdf(file=filename, height = width, width = width)
        }
   } else {
        if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.overlap.", phen1, ".pdf", sep="", collapse="")
           pdf(file=filename, height = width, width = width)
        } else if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.overlap.", phen1, ".pdf", sep="", collapse="")
           pdf(file=filename, height = width, width = width)
        }
   }

   GSEA.ConsPlot(Itable, col.names = set.table.phen1[1:max.sets.phen1, 2], main = " ", sub=paste("Leading Subsets Overlap ", doc.string, " - ", phen1, sep=""), xlab=" ", ylab=" ")

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
            savePlot(filename = filename, type ="jpeg", device = dev.cur())
        } else if (.Platform$OS.type == "unix") {
            dev.off()
        }
   } else {
        dev.off()
   }

   # Save leading subsets in a GCT file

   D.phen1 <- data.frame(M)
   names(D.phen1) <- all.leading.genes
   row.names(D.phen1) <- set.table.phen1[1:max.sets.phen1, 2]
   output <- paste(directory, doc.string, ".leading.genes.", phen1, ".gct", sep="")
   GSEA.write.gct(D.phen1, filename=output)

   # Save leading subsets as a single gene set in a .gmt file

   row.header <- paste(doc.string, ".all.leading.genes.", phen1, sep="")
   output.line <- paste(all.leading.genes, sep="\t", collapse="\t")
   output.line <- paste(row.header, row.header, output.line, sep="\t", collapse="")
   output <- paste(directory, doc.string, ".all.leading.genes.", phen1, ".gmt", sep="")
   write(noquote(output.line), file = output, ncolumns = length(output.line))

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.assignment.", phen1, sep="", collapse="")
           windows(height = height, width = width)
        } else if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.assignment.", phen1, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        }
   } else {
        if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.assignment.", phen1, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        } else if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.assignment.", phen1, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        }
   }

   cmap <-  c("#AAAAFF", "#111166")
   GSEA.HeatMapPlot2(V = data.matrix(D.phen1), row.names = row.names(D.phen1), col.names = names(D.phen1), main = "Leading Subsets Assignment", sub = paste(doc.string, " - ", phen1, sep=""), xlab=" ", ylab=" ", color.map = cmap)

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
            savePlot(filename = filename, type ="jpeg", device = dev.cur())
        } else if (.Platform$OS.type == "unix") {
            dev.off()
        }
   } else {
        dev.off()
   }

   DT1.phen1 <- data.matrix(t(D.phen1))
   DT2.phen1 <- data.frame(DT1.phen1)
   names(DT2.phen1) <- set.table.phen1[1:max.sets.phen1, 2]
   row.names(DT2.phen1) <- all.leading.genes
#   GSEA.write.gct(DT2.phen1, filename=outputfile2.phen1)

   # Analysis for phen2

   leading.lists <- NULL
   for (i in 1:max.sets.phen2) {
      inputfile <- paste(directory, set.table.phen2[i, 1], sep="", collapse="")
      gene.set <- read.table(file=inputfile, sep="\t", header=T, comment.char="", as.is=T)
      leading.set <- as.vector(gene.set[gene.set[,"CORE_ENRICHMENT"] == "YES", "SYMBOL"])
      leading.lists <- c(leading.lists, list(leading.set))
      if (i == 1) {
         all.leading.genes <- leading.set
      } else{
         all.leading.genes <- union(all.leading.genes, leading.set)
      }
   }
   max.genes <- length(all.leading.genes)
   M <- matrix(0, nrow=max.sets.phen2, ncol=max.genes)
   for (i in 1:max.sets.phen2) {
      M[i,] <- sign(match(all.leading.genes, as.vector(leading.lists[[i]]), nomatch=0))   # notice that the sign is 0 (no tag) or 1 (tag)
   }

   Inter <- matrix(0, nrow=max.sets.phen2, ncol=max.sets.phen2)
   for (i in 1:max.sets.phen2) {
     for (j in 1:max.sets.phen2) {
        Inter[i, j] <- length(intersect(leading.lists[[i]], leading.lists[[j]]))/length(union(leading.lists[[i]], leading.lists[[j]]))
     }
   }

   Itable <- data.frame(Inter)
   names(Itable) <- set.table.phen2[1:max.sets.phen2, 2]
   row.names(Itable) <- set.table.phen2[1:max.sets.phen2, 2]

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.overlap.", phen2, sep="", collapse="")
           windows(height = width, width = width)
        } else if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.overlap.", phen2, ".pdf", sep="", collapse="")
           pdf(file=filename, height = width, width = width)
        }
   } else {
        if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.overlap.", phen2, ".pdf", sep="", collapse="")
           pdf(file=filename, height = width, width = width)
        } else if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.overlap.", phen2, ".pdf", sep="", collapse="")
           pdf(file=filename, height = width, width = width)
        }
   }

   GSEA.ConsPlot(Itable, col.names = set.table.phen2[1:max.sets.phen2, 2], main = " ", sub=paste("Leading Subsets Overlap ", doc.string, " - ", phen2, sep=""), xlab=" ", ylab=" ")

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
            savePlot(filename = filename, type ="jpeg", device = dev.cur())
        } else if (.Platform$OS.type == "unix") {
            dev.off()
        }
   } else {
        dev.off()
   }

   # Save leading subsets in a GCT file

   D.phen2 <- data.frame(M)
   names(D.phen2) <- all.leading.genes
   row.names(D.phen2) <- set.table.phen2[1:max.sets.phen2, 2]
   output <- paste(directory, doc.string, ".leading.genes.", phen2, ".gct", sep="")
   GSEA.write.gct(D.phen2, filename=output)

   # Save primary subsets as a single gene set in a .gmt file

   row.header <- paste(doc.string, ".all.leading.genes.", phen2, sep="")
   output.line <- paste(all.leading.genes, sep="\t", collapse="\t")
   output.line <- paste(row.header, row.header, output.line, sep="\t", collapse="")
   output <- paste(directory, doc.string, ".all.leading.genes.", phen2, ".gmt", sep="")
   write(noquote(output.line), file = output, ncolumns = length(output.line))

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.assignment.", phen2, sep="", collapse="")
           windows(height = height, width = width)
        } else if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.assignment.", phen2, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        }
   } else {
        if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.assignment.", phen2, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        } else if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.assignment.", phen2, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        }
   }

   cmap <-  c("#AAAAFF", "#111166")
   GSEA.HeatMapPlot2(V = data.matrix(D.phen2), row.names = row.names(D.phen2), col.names = names(D.phen2), main = "Leading Subsets Assignment", sub = paste(doc.string, " - ", phen2, sep=""), xlab=" ", ylab=" ", color.map = cmap)

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
            savePlot(filename = filename, type ="jpeg", device = dev.cur())
        } else if (.Platform$OS.type == "unix") {
            dev.off()
        }
   } else {
        dev.off()
   }

   DT1.phen2 <- data.matrix(t(D.phen2))
   DT2.phen2 <- data.frame(DT1.phen2)
   names(DT2.phen2) <- set.table.phen2[1:max.sets.phen2, 2]
   row.names(DT2.phen2) <- all.leading.genes
#   GSEA.write.gct(DT2.phen2, filename=outputfile2.phen2)

   # Resort columns and rows for phen1

   A <- data.matrix(D.phen1)
   A.row.names <- row.names(D.phen1)
   A.names <- names(D.phen1)

   # Max.genes

#   init <- 1
#   for (k in 1:max.sets.phen1) {
#      end <- which.max(cumsum(A[k,]))
#      if (end - init > 1) {
#         B <- A[,init:end]
#         B.names <- A.names[init:end]
#        dist.matrix <- dist(t(B))
#         HC <- hclust(dist.matrix, method="average")
##         B <- B[,HC$order] + 0.2*(k %% 2)
#        B <- B[,HC$order]
#         A[,init:end] <- B
#         A.names[init:end] <- B.names[HC$order]
#         init <- end + 1
#     }
#   }

#   windows(width=14, height=10)
#   GSEA.HeatMapPlot2(V = A, row.names = A.row.names, col.names = A.names, sub = "  ", main = paste("Primary Sets Assignment - ", doc.string, " - ", phen1, sep=""), xlab=" ", ylab=" ")

   dist.matrix <- dist(t(A))
   HC <- hclust(dist.matrix, method="average")
   A <- A[, HC$order]
   A.names <- A.names[HC$order]

   dist.matrix <- dist(A)
   HC <- hclust(dist.matrix, method="average")
   A <- A[HC$order,]
   A.row.names <- A.row.names[HC$order]

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen1, sep="", collapse="")
           windows(height = height, width = width)
        } else if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen1, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        }
   } else {
        if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen1, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        } else if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen1, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        }
   }

   cmap <-  c("#AAAAFF", "#111166")
#   GSEA.HeatMapPlot2(V = A, row.names = A.row.names, col.names = A.names, main = "Leading Subsets Assignment (clustered)", sub = paste(doc.string, " - ", phen1, sep=""), xlab=" ", ylab=" ", color.map = cmap)

   GSEA.HeatMapPlot2(V = t(A), row.names = A.names, col.names = A.row.names, main = "Leading Subsets Assignment (clustered)", sub = paste(doc.string, " - ", phen1, sep=""), xlab=" ", ylab=" ", color.map = cmap)

    text.filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen1, ".txt", sep="", collapse="")
    line.list <- c("Gene", A.row.names)
    line.header <- paste(line.list, collapse="\t")
    line.length <- length(A.row.names) + 1
    write(line.header, file = text.filename, ncolumns = line.length)
    write.table(t(A), file=text.filename, append = T, quote=F, col.names= F, row.names=T, sep = "\t")

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
            savePlot(filename = filename, type ="jpeg", device = dev.cur())
        } else if (.Platform$OS.type == "unix") {
            dev.off()
        }
   } else {
        dev.off()
   }


# resort columns and rows for phen2

   A <- data.matrix(D.phen2)
   A.row.names <- row.names(D.phen2)
   A.names <- names(D.phen2)

   # Max.genes

#   init <- 1
#   for (k in 1:max.sets.phen2) {
#      end <- which.max(cumsum(A[k,]))
#      if (end - init > 1) {
#         B <- A[,init:end]
#         B.names <- A.names[init:end]
#         dist.matrix <- dist(t(B))
#         HC <- hclust(dist.matrix, method="average")
##         B <- B[,HC$order] + 0.2*(k %% 2)
#        B <- B[,HC$order]
#         A[,init:end] <- B
#         A.names[init:end] <- B.names[HC$order]
#         init <- end + 1
#     }
#   }

#  windows(width=14, height=10)
#  GESA.HeatMapPlot2(V = A, row.names = A.row.names, col.names = A.names, sub = "  ", main = paste("Primary Sets Assignment - ", doc.string, " - ", phen2, sep=""), xlab=" ", ylab=" ")

   dist.matrix <- dist(t(A))
   HC <- hclust(dist.matrix, method="average")
   A <- A[, HC$order]
   A.names <- A.names[HC$order]

   dist.matrix <- dist(A)
   HC <- hclust(dist.matrix, method="average")
   A <- A[HC$order,]
   A.row.names <- A.row.names[HC$order]

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen2, sep="", collapse="")
           windows(height = height, width = width)
        } else if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen2, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        }
   } else {
        if (.Platform$OS.type == "unix") {
           filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen2, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        } else if (.Platform$OS.type == "windows") {
           filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen2, ".pdf", sep="", collapse="")
           pdf(file=filename, height = height, width = width)
        }
   }

   cmap <-  c("#AAAAFF", "#111166")

#   GSEA.HeatMapPlot2(V = A, row.names = A.row.names, col.names = A.names, main = "Leading Subsets Assignment (clustered)", sub = paste(doc.string, " - ", phen2, sep=""), xlab=" ", ylab=" ", color.map = cmap)
   GSEA.HeatMapPlot2(V = t(A), row.names =A.names , col.names = A.row.names, main = "Leading Subsets Assignment (clustered)", sub = paste(doc.string, " - ", phen2, sep=""), xlab=" ", ylab=" ", color.map = cmap)

    text.filename <- paste(directory, doc.string, ".leading.assignment.clustered.", phen2, ".txt", sep="", collapse="")
    line.list <- c("Gene", A.row.names)
    line.header <- paste(line.list, collapse="\t")
    line.length <- length(A.row.names) + 1
    write(line.header, file = text.filename, ncolumns = line.length)
    write.table(t(A), file=text.filename, append = T, quote=F, col.names= F, row.names=T, sep = "\t")

   if (non.interactive.run == F) {
        if (.Platform$OS.type == "windows") {
            savePlot(filename = filename, type ="jpeg", device = dev.cur())
        } else if (.Platform$OS.type == "unix") {
            dev.off()
        }
   } else {
        dev.off()
   }

}

#################### GSEA funcitons loaded ######################

# GSEA 1.0 -- Gene Set Enrichment Analysis / Broad Institute
#
# R script to run GSEA Analysis of the Gender vs C1 example (cut and paste into R console)

# Paralleling
options(error = dump.frames)
nthread  = {{args.nthread}}
seed     = {{args.seed}}
if (seed > -1) set.seed(seed)

if (nthread > 1) {
    library(doParallel)
    # split gmt file
    gmtlines = readLines("{{i.gmtfile}}")
    gmtsize  = ceiling(length(gmtlines) / nthread)
    outdirs  = c()
    gmtfiles = c()
    for (i in 1:nthread) {
        outdir   = paste(file.path("{{o.outdir}}", paste("Thread-", i, sep="")), '/', sep="")
        dir.create(outdir, showWarnings=F)
        gmtfile  = file.path(outdir, paste('Thread-', i, '.gmt', sep=""))
        outdirs  = c(outdirs, outdir)
        gmtfiles = c(gmtfiles, gmtfile)
        gmtconn  = file(gmtfile)
        writeLines(gmtlines[ ((i-1)*gmtsize + 1):min(i*gmtsize, length(gmtlines)) ], gmtconn)
        close(gmtconn)
    }

    cl <- makeCluster(nthread)
    registerDoParallel(cl)
    foreach(i=1:nthread, .verbose=T) %dopar% capture.output({
        options(error = dump.frames)
        GSEA(                                     # Input/Output Files :-------------------------------------------
            input.ds =  "{{i.gctfile}}",            # Input gene expression Affy dataset file in RES or GCT format
            input.cls = "{{i.clsfile}}",            # Input class vector (phenotype) file in CLS format
            gs.db =     gmtfiles[i],            # Gene set database in GMT format
            output.directory      = outdirs[i],            # Directory where to store output and results (default: "")
            #  Program parameters :----------------------------------------------------------------------------------------------------------------------------
            doc.string            = "GSEA",     # Documentation string used as a prefix to name result files (default: "GSEA.analysis")
            non.interactive.run   = F,               # Run in interactive (i.e. R GUI) or batch (R command line) mode (default: F)
            reshuffling.type      = "sample.labels", # Type of permutation reshuffling: "sample.labels" or "gene.labels" (default: "sample.labels"
            nperm                 = {{args.nperm}},  # Number of random permutations (default: 1000)
            weighted.score.type   = {{args.weightexp}}, # Enrichment correlation-based weighting: 0=no weight (KS), 1= weigthed, 2 = over-weigthed (default: 1)
            nom.p.val.threshold   = -1,              # Significance threshold for nominal p-vals for gene sets (default: -1, no thres)
            fwer.p.val.threshold  = -1,              # Significance threshold for FWER p-vals for gene sets (default: -1, no thres)
            fdr.q.val.threshold   = 0.25,            # Significance threshold for FDR q-vals for gene sets (default: 0.25)
            topgs                 = 20,              # Besides those passing test, number of top scoring gene sets used for detailed reports (default: 10)
            adjust.FDR.q.val      = F,               # Adjust the FDR q-vals (default: F)
            gs.size.threshold.min = 15,              # Minimum size (in genes) for database gene sets to be considered (default: 25)
            gs.size.threshold.max = 500,             # Maximum size (in genes) for database gene sets to be considered (default: 500)
            reverse.sign          = F,               # Reverse direction of gene list (pos. enrichment becomes negative, etc.) (default: F)
            preproc.type          = 0,               # Preproc.normalization: 0=none, 1=col(z-score)., 2=col(rank) and row(z-score)., 3=col(rank). (def: 0)
            random.seed           = 111,             # Random number generator seed. (default: 123456)
            perm.type             = 0,               # For experts only. Permutation type: 0 = unbalanced, 1 = balanced (default: 0)
            fraction              = 1.0,             # For experts only. Subsampling fraction. Set to 1.0 (no resampling) (default: 1.0)
            replace               = F,               # For experts only, Resampling mode (replacement or not replacement) (default: F)
            save.intermediate.results = F,           # For experts only, save intermediate results (e.g. matrix of random perm. scores) (default: F)
            OLD.GSEA              = F,               # Use original (old) version of GSEA (default: F)
            use.fast.enrichment.routine = T          # Use faster routine to compute enrichment for random permutations (default: T)
        )
        #--------------------------------------------------------------------------------------------------------------------------------------------------
        # Overlap and leading gene subset assignment analysis of the GSEA results

        GSEA.Analyze.Sets(
            directory           = outdirs[i],        # Directory where to store output and results (default: "")
            topgs = 20,                                    # number of top scoring gene sets used for analysis
            height = 16,
            width = 16
        )
    }, file = file.path(outdirs[i], "log.txt"))
    stopCluster(cl)
} else {
    GSEA(                                     # Input/Output Files :-------------------------------------------
        input.ds =  "{{i.gctfile}}",            # Input gene expression Affy dataset file in RES or GCT format
        input.cls = "{{i.clsfile}}",            # Input class vector (phenotype) file in CLS format
        gs.db =     "{{i.gmtfile}}",            # Gene set database in GMT format
        output.directory      = "{{o.outdir}}/",            # Directory where to store output and results (default: "")
        #  Program parameters :----------------------------------------------------------------------------------------------------------------------------
        doc.string            = "GSEA",     # Documentation string used as a prefix to name result files (default: "GSEA.analysis")
        non.interactive.run   = F,               # Run in interactive (i.e. R GUI) or batch (R command line) mode (default: F)
        reshuffling.type      = "sample.labels", # Type of permutation reshuffling: "sample.labels" or "gene.labels" (default: "sample.labels"
        nperm                 = {{args.nperm}},  # Number of random permutations (default: 1000)
        weighted.score.type   = {{args.weightexp}}, # Enrichment correlation-based weighting: 0=no weight (KS), 1= weigthed, 2 = over-weigthed (default: 1)
        nom.p.val.threshold   = -1,              # Significance threshold for nominal p-vals for gene sets (default: -1, no thres)
        fwer.p.val.threshold  = -1,              # Significance threshold for FWER p-vals for gene sets (default: -1, no thres)
        fdr.q.val.threshold   = 0.25,            # Significance threshold for FDR q-vals for gene sets (default: 0.25)
        topgs                 = 20,              # Besides those passing test, number of top scoring gene sets used for detailed reports (default: 10)
        adjust.FDR.q.val      = F,               # Adjust the FDR q-vals (default: F)
        gs.size.threshold.min = 15,              # Minimum size (in genes) for database gene sets to be considered (default: 25)
        gs.size.threshold.max = 500,             # Maximum size (in genes) for database gene sets to be considered (default: 500)
        reverse.sign          = F,               # Reverse direction of gene list (pos. enrichment becomes negative, etc.) (default: F)
        preproc.type          = 0,               # Preproc.normalization: 0=none, 1=col(z-score)., 2=col(rank) and row(z-score)., 3=col(rank). (def: 0)
        random.seed           = 111,             # Random number generator seed. (default: 123456)
        perm.type             = 0,               # For experts only. Permutation type: 0 = unbalanced, 1 = balanced (default: 0)
        fraction              = 1.0,             # For experts only. Subsampling fraction. Set to 1.0 (no resampling) (default: 1.0)
        replace               = F,               # For experts only, Resampling mode (replacement or not replacement) (default: F)
        save.intermediate.results = F,           # For experts only, save intermediate results (e.g. matrix of random perm. scores) (default: F)
        OLD.GSEA              = F,               # Use original (old) version of GSEA (default: F)
        use.fast.enrichment.routine = T          # Use faster routine to compute enrichment for random permutations (default: T)
    )
    #--------------------------------------------------------------------------------------------------------------------------------------------------
    # Overlap and leading gene subset assignment analysis of the GSEA results

    GSEA.Analyze.Sets(
        directory           = "{{o.outdir}}/",        # Directory where to store output and results (default: "")
        topgs = 20,                                    # number of top scoring gene sets used for analysis
        height = 16,
        width = 16
    )
}

infile  = {{i.infile | quote}}
outfile = {{o.outfile | quote}}
mutypes = {{args.mutypes | R}}
binary  = {{args.binary | R}}
na      = {{args.na | R}}
samfn   = {{args.samfn}}

# read the maf file
maf  = read.table(
	if(endsWith(infile, '.gz')) gzfile(infile) else infile,
	header      = T,
	row.names   = NULL,
	check.names = F,
	sep         = "\t",
	quote       = ''
)

# select mutations with the give mutation types
if (!is.null(mutypes)) {
	maf = maf[which(maf$Variant_Classification %in% mutypes), , drop = F]
}

# get all samples
samples = unique(maf[, "Tumor_Sample_Barcode", drop = T])
# get all genes
genes   = unique(maf[, "Hugo_Symbol", drop = T])

# result matrix
ret = matrix(na, ncol = length(samples), nrow = length(genes))
rownames(ret) = genes
colnames(ret) = unique(samfn(samples))

for (gene in genes) {
	gsamples = maf[which(maf$Hugo_Symbol == gene), "Tumor_Sample_Barcode", drop = T]
	gsamples = samfn(gsamples)
	if (binary) {
		value2fill = matrix(1, nrow = length(gsamples))
		rownames(value2fill) = gsamples
	} else {
		value2fill = as.matrix(table(gsamples))
	}
	ret[gene, rownames(value2fill)] = value2fill
}
write.table(ret, outfile, row.names = T, col.names = T, sep = "\t", quote = F)

{{rimport}}('__init__.r')
options(stringsAsFactors = TRUE)

infile = {{i.infile | quote}}
inopts = {{args.inopts | R}}
outdir = {{o.outdir | R}}

data = read.table.inopts(infile, inopts)
if ("{{args.informat}}" == "value") {
	for (i in 1:ncol(data)) {
		data[, i] = length(data[, i]) + 1 - rank (data[, i])
	}
}
out   = data

devpars = {{args.devpars | R}}
rp      = data^(1/ncol(data))
rp      = apply (rp, 1, prod)
out     = cbind (out, RP = format(round(rp, 2), scientific=F, nsmall=2))

r     = rank(rp)
out   = cbind (out, RP_Rank = r)

if ({{args.pval | R}}) {
	# rankprodbounds
	#
	# Description
	#
	# This function computes bounds on the p-value for rank products.
	#
	# Usage
	#
	# rankprodbounds(rho,n,k,Delta = c('lower','upper','geometric'))
	#
	# Arguments
	#
	# rho     a vector of integers corresponding to the rank products for which one wishes to
	#         compute the p-value.
	# n       the number of molecules.
	# k       the number of replicates.
	# Delta   a character string indicating whether an upper bound ('upper'), lower bound
	#         ('lower'), or geometric approximation ('geometric') should be computed.
	#
	# Value
	#
	# A vector of p-values, one for each rank product.
	#
	# Details
	#
	# The exact p-value is guaranteed to be in between the lower and the upper bound. The
	# geometric mean of the two bounds can be used as an approximation. Each bound is a piecewise
	# continuous function of the rank product. The different pieces each have an analytic form,
	# the parameters of which can be computed recursively.
	#
	# Note
	#
	# This implementation closely follows the description in Heskes, Eisinga, Breitling:
	# "A fast algorithm for determining bounds and accurate approximate p-values of the
	# rank product statistic for replicate experiments", further referred to as HEB.
	# More specifically, this R function corresponds to the recursive variant, sketched
	# as pseudocode in the additional material of HEB.
	#
	# updated version August 2015: fixed a bug with the help of Vicenzo Lagani
	
	rankprodbounds <- function(rho,n,k,Delta){
	  
	  # INPUT HANDLING
	  
	  if(any(rho > n^k) || any(rho < 1)) stop('rho out of bounds')
	  
	  if(is.numeric(Delta) == FALSE) {
		if(Delta == 'geometric') {
		  temp1 <- rankprodbounds(rho,n,k,'upper')
		  temp2 <- rankprodbounds(rho,n,k,'lower')
		  pvalue <- sqrt(temp1*temp2)   # geometric mean of upper and lower bound
		  return(pvalue)
		}
		else {
		  Delta <- switch(Delta,
			upper = 1,        # for computing upper bound
			lower = 0)        # for computing lower bound
		}
	  }
	
	  
	  # COMPUTE INTERVALS THAT CONTAIN THE RANK PRODUCTS
	
	  logn <- log(n)
	  allj <- ceiling(-(log(rho)/logn)+k)   # index specifying the interval that contains rho 
	  minj <- min(allj)                     # lowest interval index
	  maxj <- max(allj)                     # highest interval index
	
	  
	  # INITIALIZE PARAMETERS
	
	  param <- matrix(list(), nrow=k+1, ncol=maxj+1)
	  for(i in 1:(k+1)){
		  for(j in 1:(maxj+1)){
			  param[[i,j]] <- list(a=c(),b=c(),c=c(),d=c(),e=c())
		  }
	  }
	  
	  # param is a matrix of lists; each element of param is a list with values for the parameters
	  # a through e, which correspond to the parameters alpha through epsilon in HEB;
	  # specifially, param[[i+1,j+1]]$a corresponds to alpha_{i,j} in HEB, etc, where the offset
	  # of 1 is introduced to be able to represent, for example, alpha_{0,0};
	  # a, b, and c can be vectors (with possibly different lengths for different i and j),
	  # d and e are scalars
	  
	  
	  # COMPUTE PARAMETERS
	
	  for(j in minj:maxj){
		param <- updateparam(param,n,k,j,Delta)
	  }
	  
	  # call to the function updateparam which recursively computes all parameters that are needed
	  # to calculate the p-value for a rank product rho that lies in the interval with index j
	
	  
	  # COMPUTE RANK PRODUCTS GIVEN PARAMETERS
	  
	  k1 <- 1+k
	  G <- rep(0,length(rho))   # G is a vector of the same length as rho,
								# for each rho bounding the number of rank products 
	  for(j in unique(allj)) {  # updated: thanks to Vicenzo Lagani for pointing this out
		j1 <- 1+j
		iii <- which(allj == j)         # indices of all rank products that fall in interval j:
										# bounds for these rank products can be computed with
										# the same set of parameters                                    
		thisrho <- rho[iii]
		thisparam <- param[[k1,j1]]
		thisG <- thisparam$e
		if(j != 0) {
		  nrho <- length(thisrho)
		  nterms <- length(thisparam$a)
		  thisG <- thisG + thisparam$d*thisrho
		  d1 <- matrix(thisparam$c) %*% thisrho
		  d2 <- matrix(rep(log(thisrho),nterms),nrow=nterms,byrow=TRUE) -
			t(matrix(rep(logn*(k-j+thisparam$b),nrho),nrow=nrho,byrow=TRUE))
		  d3 <- t(matrix(rep(thisparam$a,nrho),nrow=nrho,byrow=TRUE)) 
		  thisG <- thisG + colSums(d1*(d2^d3))
		}
		# the 10 lines above implement equation (8) in HEB
		G[iii] <- thisG
	  }
	
	  pvalue <- G/n^k
	  return(pvalue)
	}
	
	###############################
	#
	# updateparam
	#
	# Description
	#
	# This subroutine updates the current set of parameters to make sure that the parameters
	# corresponding to k replicates and the j'th interval are included.
	#
	# Arguments
	#
	# param   a matrix of lists, where each element of param is a list with values for the
	#         parameters a through e; these parameters specify the functional form of the bound;
	#         a, b, and c are all vectors of unknown length, d and e are scalars.
	# n       the number of molecules.
	# k       the number of replicates for which we need to compute the corresponding parameters.
	# j       the index of the interval for which we need to compute the corresponding parameters.
	# Delta   0 for the lower bound and 1 for the upper bound.
	#
	# Value
	#
	# A possibly updated set of parameters, at least including those corresponding to (k,j).
	#
	# Details
	# 
	# This subroutine make sure that the parameters corresponding to k replicates and a rank product
	# within the j'th interval are already. If they already are (because calculated before), it
	# does not compute anything. Otherwise, it recursively computes all parameters
	# that are needed to arrive at the parameters for (k,j).
	#
	# Note
	#
	# This implementation closely follows HEB, in particular equations (9) through (11).
	
	updateparam <- function(param,n,k,j,Delta) {
	
	  k1 <- 1+k
	  j1 <- 1+j
	  
	  if(length(param[[k1,j1]]$e) == 0) {  # apparently empty, so needs to be calculated
		
		if(j == 0) {   # initializing G_{k0}
		  
		  param[[k1,j1]]$e <- n^k
		  param[[k1,j1]]$d <- 0
		  # the 2 lines above implement equation (11) in HEB
	
		}
		else {
		  k0 <- k1-1
		  j0 <- j1-1
		  param <- updateparam(param,n,k-1,j-1,Delta)
				# checking that the parameters for (k-1,j-1) that are needed to compute the
				# parameters for (k,j) are indeed available; if not, they are themselves computed
		  param00 = param[[k0,j0]]
		  newa0 = param00$a+1
		  newb0 = param00$b
		  newc0 = param00$c/newa0
		  param11 = param00
		  # the 5 lines above predefine some parameters common to equations (9) and (10) in HEB
		
		  if(k == j){ # updates for G_{kk}
		
			param11$e <- (1-Delta)*(1-param00$e)
			param11$d <- Delta*param00$d+param00$e
			param11$a <- c(1,param00$a,newa0)
			param11$b <- c(0,param00$b,newb0)
			param11$c <- c(param00$d,Delta*param00$c,newc0)
			# the 5 lines above implement equation (10) in HEB
		  }
		  else {  # updates for G_{kj}, j < k
			param <- updateparam(param,n,k-1,j,Delta)
			  # checking that the parameters for (k-1,j) that are needed to compute the
			  # parameters for (k,j) are indeed available; if not, they are themselves computed
			param01 <- param[[k0,j1]]
		  
			logn <- log(n)
			lognnkj <- (k-j)*logn
			newa1 <- param01$a+1
			newa <- c(newa0,newa1)
			newb <- c(newb0,param01$b)
			newc <- c(newc0,-param01$c/newa1)
			param11$e <- n*param01$e + (Delta-1)*(param00$e-param01$e)
			lognminb <- c(-1*param00$b * logn,(1-param01$b)*logn)
			param11$d <- Delta*param00$d + (1-Delta)*param01$d/n + 
			  (param00$e-param01$e)/exp(lognnkj) - 
				sum(newc*(lognminb^newa))
			param11$a <- c(1,1,param00$a,param01$a,newa)
			param11$b <- c(0,1,param00$b,param01$b,newb)
			param11$c <- c(param00$d,-param01$d,
							Delta*param00$c,(1-Delta)*param01$c/n,newc)
			# the 15 lines above implement equation (9) in HEB
		  }
		param[[k1,j1]] <- makeunique(param11)
		# although not strictly necessary, the a, b and c vectors can possibly be shortened by
		# restricting oneselves to unique combinations of a and b values
		}
	  }
	  return(param)
	}
	
	###############################
	#
	# makeunique
	#
	# Description
	#
	# This subroutine updates the parameters for a specific number of replicates and interval
	# such that it contains only unique combinations of the parameters a and b.
	#
	# Arguments
	#
	# param   a single list with values for the parameters a through e; these parameters
	#         specify the functional form of the bound; a, b, and c are all vectors of
	#         unknown length, d and e are scalars.
	# 
	# Value
	#
	# A possibly updated and then more concise set of parameters containing only unique
	# combinations of the parameters a and b.
	#
	# Details
	#
	# While updating the vectors a and b, one may end up with the exact same combinations of
	# a and b. Given the functional form of the bound, the representation can then be made more
	# concise by simply adding the corresponding elements of c.
	  
	makeunique <- function(param) {
	  
	  ab <- t(rbind(param$a,param$b))
	  uniqueab <- unique(ab)
	  nunique <- dim(uniqueab)[1]
	  param$a <- t(uniqueab[,1])
	  param$b <- t(uniqueab[,2])
	  newc <- rep(0,nunique)
	  for(i in 1:nunique) {
		iii <- intersect(which(ab[,1]==uniqueab[i,1]),which(ab[,2]==uniqueab[i,2]))
		newc[i] <- sum(param$c[iii])  
	  }
	  param$c <- newc
	  
	  return(param)
	  
	}
	pvals = rankprodbounds (rp, nrow(data), ncol(data), "geometric")
	out   = cbind (out, RP_Pval = format(pvals, scientific=T, digits=3))
}
out = out [order(out[ncol(data) + 2]), ]
write.table (out, file.path("{{o.outdir}}", "{{i.infile | fn}}.rp.txt"), row.names=T, col.names=T, quote=F, sep="\t")

nrplot = {{args.plot}}
if (nrplot > 0) {
	plotRanks = function (data, cellwidth = 40, cellheight = 20, cnheight = {{args.cnheight}}, rnwidth = {{args.rnwidth}}, minwidth = 100, minheight=600) {
	  numcol = ncol(data)
	  numrow = nrow(data)
	  width  = numcol * (cellwidth + 1) + rnwidth
	  height = numrow * (cellheight+ 1) + cnheight
	  colgap = 1
	  rowgap = 1
	
	  if (width < minwidth)   {
		cellwidth  = (minwidth - rnwidth)   / numcol - colgap
		width      = minwidth
	  }
	  if (height < minheight) {
		cellheight = (minheight - cnheight) / numrow - rowgap
		height     = minheight
	  }
	
	  cols = col(data)
	  rows = row(data)
	  # plot canvas
	  plot (c(0, width), c(0, height), axes=F, xlab="", ylab="", type="n")
	  
	  # colnames
	  cnames = colnames(data)
	  cnx    = rnwidth + cellwidth/2 + (cols[1, ]-1) * (cellwidth + colgap)
	  cnx    = as.vector(cnx)
	  cny    = rep(height - cnheight + 4*rowgap, numcol)
	  text (cnx, cny, cnames, srt=45, cex={{args.cex}}, adj = c(0, 0))
	  
	  # rownames
	  rnames = rownames(data)
	  rnx    = rep(rnwidth - 4*colgap, numrow)
	  rny    = height - cnheight - cellheight / 2 - (rows[, 1] - 1) * (cellheight + rowgap)
	  text (rnx, rny, rnames, cex={{args.cex}}, adj = c(1, 0.5))
	  
	  # colors
	  vd     = matrix (as.vector(as.matrix(data)), ncol=1)
	  km     = kmeans(vd, 2)
	  cnter1 = as.numeric(km$centers[1, 1])
	  cnter2 = as.numeric(km$centers[2, 1])
	  firstc = ifelse(cnter1 <  cnter2, 1, 2)
	  scondc = ifelse(cnter1 >= cnter2, 1, 2)
	  
	  cfunc1 = colorRampPalette(c("darkred", "#ffeeee"))
	  cfunc2 = colorRampPalette(c("#eeeeff", "lightblue"))
	  u1     = unique(vd[km$cluster == firstc])
	  u2     = unique(vd[km$cluster == scondc])
	  cs1    = cfunc1 ( length(u1) )
	  cs2    = cfunc2 ( length(u2) )
	
	  clusts = matrix(km$cluster, ncol=numcol)
	  colors = matrix(ncol = numcol, nrow=numrow)
	  colors[clusts == firstc] = cs1 [rank(u1)[match(data[clusts == firstc], u1)]]
	  colors[clusts == scondc] = cs2 [rank(u2)[match(data[clusts == scondc], u2)]]
		
	  rx1    = rnwidth + (cols - 1) * (cellwidth + colgap)
	  rx1    = as.vector(rx1)
	  ry1    = height - cnheight - (rows - 1) * (cellheight + rowgap)
	  ry1    = as.vector(ry1)
		
	  rx2    = rx1 + cellwidth  + colgap
	  ry2    = ry1 - cellheight - rowgap
	  rect (rx1, ry1, rx2, ry2, col=colors, border="white")
	
	}

	data2plot = out[1:nrplot, c(1:ncol(data), ncol(data)+2)]
	#size=300*480/72
	plotfile = file.path(outdir, paste0(basename(infile), '.png'))
	params = c(list(file = plotfile), devpars)
	do.call(png, params)
	plotRanks (data2plot)
	dev.off()
}

dat = read.table('{{i.infile}}', header = T, row.names = 1, sep="\t", check.names = F)
sim = cor(t(dat), method = '{{args.method}}')
p   = sim
n   = ncol(dat)

{% if args.pval %}
{% if args.method == 'pearson' or args.method == 'spearman' %}
t = sim / sqrt((1-sim*sim)/(n-2))
p = 2*pt(-abs(t), n-2)

{% elif args.method == 'kendall' %}
z = 3*sim * sqrt( n*(n-1)/2/(2*n+5) )
p = 2*pnorm(-abs(z))

{% endif %}
{% endif %}

write.table(format(sim, digits=4, scientific=F), '{{o.outfile}}', sep="\t", row.names=T, col.names=T, quote=F)
write.table(format(p, digits=3, scientific=T)  , '{{o.outpval}}', sep="\t", row.names=T, col.names=T, quote=F)

library(rpart)
{{rimport}}('__init__.r', 'plot.r')

infile       = {{i.infile | quote}}
outmodel     = {{o.outmodel | quote}}
outdir       = {{o.outdir | quote}}
args.plot    = {{args.plot | R}}
args.formula = {{args.formula | R}}
inopts       = {{args.inopts | R}}
devpars      = {{args.devpars | R}}
na           = {{args.na | R}}
prefix       = {{i.infile | stem | quote}}

indata = read.table.inopts(infile, inopts)
indata[is.na(indata)] = na

cnames = colnames(indata)
if (is.null(cnames)) {
	colnames(indata) = c(paste('X', 1:(ncol(indata)-1)), 'Y')
	cnames = colnames(indata)
}

if (is.null(args.formula)) {
	backtick = function(x) sprintf('`%s`', x)
	ycol = cnames[ncol(indata)]
	args.formula = as.formula(paste(cnames[ncol(indata)], '~', paste(backtick(cnames[1:(ncol(indata)-1)]), collapse = '+')))
} else {
	ycol = unlist(strsplit(args.formula, '\\s*~\\s*'))[1]
	args.formula = as.formula(args.formula)
}

model.dt = rpart(args.formula, data = indata)
saveRDS(model.dt, outmodel)

# save importance
write.table(
	round(model.dt$variable.importance, 3), 
	file.path(outdir, paste0(prefix, '.importance.txt')), 
	col.names = F, row.names = T, quote = F, sep = "\t")

# plot importance
{% if args.plot %}
vi    = as.matrix(model.dt$variable.importance)
nfeat = min(30, nrow(vi))
vi    = vi[1:nfeat, , drop = F]
feats = rownames(vi)
plot.col(
	data.frame(Feature = feats, Importance = vi[, 1]), 
	file.path(outdir, paste0(prefix, '.importance.png')), 
	params  = list(aes(x = factor(feats, levels = rev(feats)))),
	ggs = list(coord_flip = list()),
	devpars = devpars)
{% endif %}

library("methods")
library("metap")
{{rimport}}('__init__.r')
options(stringsAsFactors = FALSE)

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
intype  = {{args.intype | R}}
inopts  = {{args.inopts | R}}
method  = {{args.method | R}}
na      = {{args.na | R}}
if (method == 'fisher') {
	method = 'sumlog'
}

indata = read.table.inopts(infile, inopts)
if (intype == 'matrix') {
	entries = rownames(indata)
	if (is.null(entries)) {
		entries = 1:nrow(indata)
	}
} else {
	entries = levels(factor(indata[,1]))
}

ret = data.frame(Entry = character(), N = numeric(), MetaPval = numeric())
for (entry in entries) {
	if (intype == 'matrix') {
		pvals = indata[entry,]
	} else {
		pvals = indata[which(indata[,1] == entry), 2]
	}
	pvals = na.omit(pvals)
	lenps = length(pvals)
	if (lenps < 1) {
		ret = rbind(ret, list(Entry = entry, N = 0, MetaPval = NA))
	} else if (lenps == 1) {
		ret = rbind(ret, list(Entry = entry, N = 1, MetaPval = pvals))
	} else {
		ret = rbind(ret, list(Entry = entry, N = length(pvals), MetaPval = do.call(method, list(pvals))$p))
	}
}

write.table(pretty.numbers(ret, list(MetaPval = '%.2E')), outfile, row.names = F, col.names = T, sep = "\t", quote = F)

{{rimport}}('__init__.r')
library(methods)
library(boot)
options(stringsAsFactors = FALSE)

{% python from os import path %}
infile  = {{i.infile | quote}}
outfile = {{o.outfile | quote}}
outdir  = {{o.outdir | quote}}
prefix  = {{o.outdir | path.join: fn2(i.infile) | quote}}
inopts  = {{args.inopts | R}}
params  = {{args.params | R}}
nthread = {{args.nthread | R}}
# all: plot all statstics
# c(1,2): plot first 2
# FALSE or NULL: don't plot any
plots   = {{args.plot | R}}
devpars = {{args.devpars | R}}
n       = {{args.n | R}}
stats   = {{args.stats}}

# boot(data, statistic, R, sim = "ordinary", stype = c("i", "f", "w"), 
#      strata = rep(1,n), L = NULL, m = 0, weights = NULL, 
#      ran.gen = function(d, p) d, mle = NULL, simple = FALSE, ...,
#      parallel = c("no", "multicore", "snow"),
#      ncpus = getOption("boot.ncpus", 1L), cl = NULL)

# options
if (nthread > 1) {
	options(boot.parallel = 'multicore')
	options(boot.ncpus, nthread)
}

indata = read.table.inopts(infile, inopts)
statfunc = function(data, index) {
	d = data[index, ]
	r = stats(d)
	if (is.list(r)) r = unlist(r)
	as.vector(r)
}

params$data      = indata
params$statistic = statfunc
params$R         = n
b = do.call(boot, params)
rownames(b$t) = paste0('t', 1:nrow(b$t))
write.table(b$t, outfile, row.names = TRUE, col.names = FALSE, sep = "\t", quote = FALSE)

if (!is.null(plots) && plots != FALSE) {
	if (plots == 'all') {
		plots = 1:ncol(b$t)
	}
	for (p in plots) {
		plotfile = paste0(prefix, '.stat', p, '.png')
		do.call(png, c(list(plotfile), devpars))
		plot(b, index = p)
		dev.off()
	}
}

library(methods)
{{rimport}}('__init__.r')
options(stringsAsFactors = F)

infile   = {{i.infile | R}}
gfile    = {{i.groupfile | R}}
cfile    = {{i.casefile | R}}
outfile  = {{o.outfile | R}}
outdir   = {{o.outdir | R}}
pcut     = {{args.pval | R}}
dofdr    = {{args.fdr | R}}
plotchow = {{args.plot | R}}
devpars  = {{args.devpars | R}}
ggs      = {{args.ggs | R}}
inopts   = {{args.inopts | R}}
covfile  = {{args.cov | R}}

if (plotchow) {
	{{rimport}}('plot.r')
}

if (dofdr == T) dofdr = 'BH'

chow.test = function(formula, group, data, covdata = NULL, ...) {
	fmvars  = all.vars(as.formula(formula))
	vars    = colnames(data)
	if (length(fmvars) == 2 && fmvars[2] == '.') {
		fmvars = c(fmvars[1], vars[vars!=fmvars[1] & vars!=group])
	}
	formula = sprintf(
		'%s ~ %s',
		bQuote(fmvars[1]),
		paste(sapply(fmvars[2:length(fmvars)], bQuote), collapse = '+')
	)
	covs = NULL
	if (is.null(covdata)) {
		pooledfm = as.formula(formula)
	} else {
		covdata = covdata[rownames(data),,drop = FALSE]
		covs    = colnames(covdata)
		data    = cbind(data, covdata)
		rm(covdata)
		pooledfm = as.formula(paste(formula, '+', paste(sapply(covs, bQuote), collapse = '+')))
		fmvars   = c(fmvars, covs)
	}
	
	if (sum(complete.cases(data[,fmvars])) < 2) {
		pooled_lm = NULL
	} else {
		pooled_lm = lm(pooledfm, data = data, ...)
	}
	#coeff     = as.list(pooled_lm$coefficients)
	groups    = levels(as.factor(data[, group]))
	group_lms = sapply(groups, function(g) {
		if (is.null(covdata)) {
			subfm  = as.formula(formula)
		} else {
			subfm = as.formula(paste(
				formula, '+', 
				#paste(sapply(covs, function(x) paste0('offset(', coeff[[x]], '*', bQuote(x), ')')), collapse = '+')
				paste(sapply(covs, bQuote), collapse = '+')
			))
		}
		sublmdata = data[data[,group] == g, , drop = FALSE]
		if (sum(complete.cases(sublmdata[,fmvars])) < 2) {
			NULL
		} else {
			list(lm(subfm, data = sublmdata, ...))
		}
	})

	pooled.ssr = ifelse(is.null(pooled_lm), NA, sum(pooled_lm$residuals ^ 2))
	subssr     = ifelse(is.false(group_lms, 'any'), NA, sum(sapply(group_lms, function(x) sum(x$residuals ^ 2))))
	ngroups    = length(groups)
	K          = length(fmvars) + length(covs)
	J          = (ngroups - 1) * K
	DF         = nrow(data) - ngroups * K
	FS         = (pooled.ssr - subssr) * DF / subssr / J
	list(
		pooled.lm  = pooled_lm,
		group.lms  = group_lms,
		Fstat      = FS,
		group      = group,
		pooled.ssr = pooled.ssr,
		group.ssr  = subssr,
		Pval       = pf(FS, J, DF, lower.tail = FALSE)
	)
}

plot.chow = function(chow, plotfile, ggs, devpars) {
	cols     = all.vars(chow$pooled.lm$terms)[1:2]
	plotdata = do.call(rbind, lapply(names(chow$group.lms), function(m) data.frame(chow$group.lms[[m]]$model[, cols, drop = FALSE], group = m)))
	colnames(plotdata)[3] = chow$group
	if (!is.null(ggs$scale_color_discrete)) {
		ggs$scale_color_discrete$name = ifelse(
			is.function(ggs$scale_color_discrete$name), 
			ggs$scale_color_discrete$name(chow$group),
			chow$group
		)
		ggs$scale_color_discrete$labels = sapply(names(chow$group.lms), function(x) {
			coeff = as.list(chow$group.lms[[x]]$coefficients)
			bquote(.(x): beta[.(cols[2])]==.(round(coeff[[cols[2]]], 3)) ~ "," ~ epsilon == .(round(coeff[['(Intercept)']], 3)))
		})
	}

	if (!is.null(ggs$scale_shape_discrete)) {
		ggs$scale_shape_discrete$name = ifelse(
			is.function(ggs$scale_shape_discrete$name), 
			ggs$scale_shape_discrete$name(chow$group),
			chow$group
		)
		ggs$scale_shape_discrete$labels = sapply(names(chow$group.lms), function(x) {
			coeff = as.list(chow$group.lms[[x]]$coefficients)
			bquote(.(x): beta[.(cols[2])]==.(round(coeff[[cols[2]]], 3)) ~ "," ~ epsilon == .(round(coeff[['(Intercept)']], 3)))
		})
	}

	if (is.null(ggs$scale_color_discrete) && is.null(ggs$scale_shape_discrete)) {
		ggs$scale_color_discrete = list(
			name = chow$group,
			labels = sapply(names(chow$group.lms), function(x) {
				coeff = as.list(chow$group.lms[[x]]$coefficients)
				bquote(.(x): beta[.(cols[2])]==.(round(coeff[[cols[2]]], 3)) ~ "," ~ epsilon == .(round(coeff[['(Intercept)']], 3)))
			})
		)
	}

	if (is.null(ggs$scale_color_discrete)) ggs$scale_color_discrete = ggs$scale_shape_discrete
	if (is.null(ggs$scale_shape_discrete)) ggs$scale_shape_discrete = ggs$scale_color_discrete
	
	plot.points(
		plotdata, 
		plotfile, 
		x = 2, y = 1, 
		params = list(aes_string(color = chow$group, shape = chow$group)), 
		ggs = c(ggs, list(
			geom_smooth = list(aes_string(color = chow$group), method = "lm", se = FALSE)
		))
	)
}

formatlm = function(m) {
	if (class(m) == 'lm') {
		coeff = as.list(m$coefficients)
		vars = all.vars(m$terms)
		terms = unlist(sapply(c(vars[2:length(vars)], '(Intercept)', 'N'), function(x) {
			ce = list.get(coeff, x, list.get(coeff, bQuote(x)))
			if (x == 'N') {
				paste0('N=', nrow(m$model))
			} else if (is.null(ce)) {
				NULL
			} else {
				l = ifelse(x == '(Intercept)', '_', x)
				paste0(l, '=', round(ce, 3))
			}
		}))
		paste(terms[!is.null(terms)], collapse = ', ')
	} else {
		paste(sapply(names(m), function(x) {
			paste0(x, ': ', formatlm(m[[x]]))
		}), collapse = ' // ')
	}
}

results = data.frame(
	Case   = character(),
	Pooled = character(),
	Groups = character(),
	SSR    = double(),
	SumSSR = double(),
	Fstat  = double(),
	Pval   = double()
)

indata = read.table.inopts(infile, inopts, try = TRUE)
if (is.null(indata)) {
	write.table(results, outfile, col.names = T, row.names = F, sep = "\t", quote = F)
	quit(save = "no")
}

#     X1  X2  X3  X4 ... Y
# G1  1   2   1   4  ... 9
# G2  2   3   1   1  ... 3
# ... ...
# Gm  3   9   1   7  ... 8
#K      = ncol(indata)
covdata = NULL
covs    = NULL
if (covfile != "") {
	covdata = read.table(covfile, header = T, row.names = 1, check.names = F)
	#indata  = cbind(covdata[rownames(indata),,drop = F], indata)
	covs = colnames(covs)
}
gdata  = read.table.inopts(gfile, list(cnames = TRUE, rnames = TRUE))
# 	Case1	Case2
# G1	Group1	Group1
# G2	Group1	NA
# G3	Group2	Group1
# ... ...
# Gm	Group2	Group2
cases  = colnames(gdata)
fmulas = data.frame(x = rep(paste(bQuote(colnames(indata)[ncol(indata)]), '~ .'), length(cases)))
rownames(fmulas) = cases
if (!is.null(cfile) && cfile != "") {
	fmulas = read.table.inopts(cfile, list(cnames = FALSE, rnames = TRUE))
	cases  = rownames(fmulas)
}

for (case in cases) {
	logger('Handling case: ', case, '...')
	fmula  = fmulas[case,,drop = TRUE]
	groups = gdata[!is.na(gdata[,case]),case,drop = FALSE]
	data   = cbind(indata[rownames(groups),, drop = FALSE], group = groups)
	colnames(data)[ncol(data)] = case
	ct = chow.test(fmula, case, data, covdata = covdata)
	if (dofdr == FALSE && (is.na(ct$Pval) || ct$Pval >= pcut)) {
		next
	}
	results = rbind(results, list(
		Case   = case,
		Pooled = formatlm(ct$pooled.lm),
		Groups = formatlm(ct$group.lms),
		SSR    = ct$pooled.ssr,
		SumSSR = ct$group.ssr,
		Fstat  = ct$Fstat,
		Pval   = ct$Pval
	))
	# doplot
	if (plotchow && ct$Pval < pcut) {
		plot.chow(ct, file.path(outdir, paste0(case, '.png')), ggs, devpars)
	}
}

if (dofdr != F) {
	results = cbind(results, Qval = p.adjust(results$Pval, method = dofdr))
} 
write.table(pretty.numbers(results, list(
	SSR..SumSSR..Fstat = '%.3f',
	Pval..Qval = '%.3E'
)), outfile, col.names = T, row.names = F, sep = "\t", quote = F)

{{rimport}}('__init__.r', 'plot.r')

library(ggplot2) # make aes available

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
inopts  = {{args.inopts | R }}
devpars = {{args.devpars | R}}
x       = {{args.x | repr}}

data = read.table.inopts(infile, inopts)
if (!is.na(as.numeric(x))) x = as.integer(x)

eval(parse(text = {{args.helper | repr}}))
params  = {{args.params | R}}
ggs     = {{args.ggs | R}}

plot.histo(data, outfile, x, params, ggs, devpars = devpars)

{{rimport}}('__init__.r')

{% python from bioprocs.utils import alwaysList %}
infile  = {{i.infile | quote}}
outfile = {{o.outfile | quote}}
covs    = {{args.covs | alwaysList | R}}
asnum   = {{args.asnum | R}}
suffix  = {{args.suffix | alwaysList | R}}

if (length(suffix) == 0) suffix = ''

cldata = read.table.inopts(infile, list(
	sep = "\t",
	skip = 1,
	cnames = TRUE,
	rnames = FALSE
))

# remove CDE_ID: row
covdata = cldata[-1, covs, drop = FALSE]
covdata[covdata == '']                = '[Not Applicable]'
covdata[covdata == '[Not Available]'] = '[Not Applicable]'
covdata[covdata == '[Not Evaluated]'] = '[Not Applicable]'
covdata[covdata == '[Unknown]']       = '[Not Applicable]'
if (asnum) {
	for (cov in covs) {
		covdata[, cov] = as.numeric(covdata[, cov])
	}
}

ret = NULL
for (suf in suffix) {
	rownames(covdata) = paste0(cldata[-1, 'bcr_patient_barcode'], suf)
	if (is.null(ret)) {
		ret = covdata
	} else {
		ret = rbind(ret, covdata)
	}
}

write.table(ret, outfile, sep = "\t", quote = FALSE)

{{rimport}}('__init__.r')

infile  = {{ i.infile | quote}}
outfile = {{ o.outfile | quote}}
outdir  = {{ o.outdir | quote}}
inopts  = {{ args.inopts | R}}
k       = {{ args.k | R}}
doplot  = {{args.plot | R}}
devpars = {{args.devpars | R}}
ggs     = {{args.ggs | R}}

if (!is.numeric(k)) {
	stop('Number of clusters `k` must be an integer.')
}

if (doplot) {
	{{rimport}}('plot.r')
}

indata  = read.table.inopts(infile, inopts)
samples = rownames(indata)
if (is.null(samples)) {
	samples = 1:nrow(indata)
}

cluster = kmeans(indata, k)
# Sample,Cluster,Center,Withinss,Mean_Feature1,Mean_Feature2,...
ret = NULL
for (i in 1:k) {
	indexes = which(cluster$cluster == i)
	cSample = samples[indexes]
	tmp = data.frame(
		Cluster  = as.factor(rep(i, length(cSample))),
		Withinss = cluster$withinss[i]
	)
    cmeans = t(colMeans(indata[cSample, ]))
    colnames(cmeans) = sapply(colnames(cmeans), function(s) paste0("Mean_", s))
	tmp = cbind(tmp, cmeans)
    rownames(tmp) = cSample
	if (is.null(ret)) {
		ret = tmp
	} else {
		ret = rbind(ret, tmp)
	}
}
ret = ret[samples,]
write.table(ret, outfile, row.names = TRUE, col.names = TRUE, sep = "\t", quote = FALSE)

if (doplot) {
	plotdata = cbind(indata, ret)
	plotfile = file.path(
		outdir,
		paste0(
			tools::file_path_sans_ext(tools::file_path_sans_ext(basename(outfile))),
			'.png'
		)
	)
	ggs = c(list(
		geom_point = list(
			mapping = aes(x = ret[,3], y = ret[,4], color = 'Center', shape = 'Center'),
			size = 4
		)
	), ggs)
	if (ncol(indata) == 2) {
		plot.scatter(
			plotdata,
			plotfile,
			x       = 1,
			y       = 2,
			params  = list(mapping = aes_string(color = 'Cluster', shape = 'Cluster')),
			ggs     = ggs,
			devpars = devpars
		)
	} else {
		stop('Not implemented yet.')
	}
}

#library (Gviz)
region = unlist(strsplit({{i.chrom | quote}}, ':', fixed = T))
chrom  = region[1]

infile = {{i.infile | quote}}
ext    = {{i.infile | ext | [1:] | quote}}
if (ext == 'bedx') {
	bname   = basename(infile)
	bedfile = file.path({{job.outdir | quote}}, substr(bname, 1, nchar(bname) - 1))
	file.symlink(infile, bedfile)
	infile = bedfile
}

params = list(
	range      = infile,
	genome     = {{args.genome | quote}},
	chromosome = chrom,
	name       = {{i.name | quote}}
)
params          = c(params, {{args.params | Rlist}})
ret             = list()
ret$trackType   = 'AnnotationTrack'
ret$trackParams = params

saveRDS (ret, {{o.outfile | quote}})

{{rimport}}('plot.r', '__init__.r')

set.seed(8525)

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
outdir  = {{o.outdir | R}}
intype  = {{args.intype | R}}
rnames  = {{args.rnames | lambda x: 1 if x else 'NULL' | R}}
ngroup  = as.integer({{args.ngroup | R}})
alphas  = {{args.alphas | lambda x: x if isinstance(x, list) else [float(a.strip()) for a in x.split(',')] if isinstance(x, str) else [x] | R}}
betas   = {{args.betas | lambda x: x if isinstance(x, list) else [float(a.strip()) for a in x.split(',')] if isinstance(x, str) else [x] | R}}
ngroup1 = {{i.ngroup1 | : int(a) if a else 0}}
ngroup2 = {{i.ngroup2 | : int(a) if a else 0}}
ngroup3 = {{i.ngroup3 | : int(a) if a else 0}}
ngroup4 = {{i.ngroup4 | : int(a) if a else 0}}

ncut = function(dat, n, prefix = 'q') {
	diffdata = max(dat) - min(dat)
	if (diffdata == 0) diffdata = 1e-2
	diffdata = diffdata * 1e-8
	fakedata = dat + runif(length(dat), diffdata/10, diffdata)
	q = quantile(fakedata, probs = seq(0, 1, 1/n), include.lowest = T)
	return(cut(fakedata, q, labels = paste0(prefix, 1:n), include.lowest = T))
}

assignGroup = function(dat, ngroups, prefix = 'q') {
	r = rank(dat, ties.method = 'first')
	b = 0
	for (i in 1:length(ngroups)) {
		dat[r > b & r <= b + ngroups[i]] = paste0(prefix, i)
		b = b + ngroups[i]
	}
	return(dat)
}

data = list()
if (intype == 'detail' || intype == 'detailed') {
	detailed  = read.table(infile, header = T, row.names = rnames, sep = '\t', check.names = F)
	censoring = as.integer(levels(factor(detailed[, 2, drop = T])))
	alive = min(censoring)
	cnames = colnames(detailed)
	for (x in 3:length(cnames)) {
		var    = cnames[x]
		groups = levels(factor(detailed[, var, drop = T]))
		lengroup = length(groups)
		if (lengroup < 2) {
			logger('Variable', var, 'skipped, as only one ground found.', level = 'WARN')
			next
		} else if (lengroup > ngroup) {
			if (ngroup1 == 0) {
				detailed[, var] = ncut(detailed[, var], ngroup)
				lengroup = ngroup
				groups   = levels(factor(detailed[, var, drop = T]))
			} else {
				ngroups = c()
				if (ngroup1 > 0) ngroups = c(ngroups, ngroup1)
				if (ngroup2 > 0) ngroups = c(ngroups, ngroup2)
				if (ngroup3 > 0) ngroups = c(ngroups, ngroup3)
				if (ngroup4 > 0) ngroups = c(ngroups, ngroup4)
				detailed[, var] = assignGroup(detailed[, var], ngroups)
				lengroup = length(ngroups)
				groups   = levels(factor(detailed[, var, drop = T]))
			}
		}

		for (i in 1:(lengroup-1)) {
			for (j in (i+1):lengroup) {
				group1 = groups[i]
				group2 = groups[j]
				variable = paste0(var, '(', group1, '-', group2, ')')
				data1  = detailed[which(detailed[[var]] == group1), , drop = F]
				data2  = detailed[which(detailed[[var]] == group2), , drop = F]
				nrow1  = nrow(data1)
				nrow2  = nrow(data2)
				data[[variable]] = list(
					survrate1 = nrow(data1[which(data1[, 2] == alive), var, drop = F]) / nrow1,
					survrate2 = nrow(data2[which(data2[, 2] == alive), var, drop = F]) / nrow2,
					ssratio   = nrow1 / nrow2
				)
			}
		}
	}
} else {
	rdata = read.table(infile, header = T, row.names = rnames, sep = '\t', check.names = F)
	if (!rnames) {
		rownames(rdata) = paste0('Var', 1:nrow(rdata))
	}
	for (rname in rownames(rdata)) {
		data[[rname]] = list(
			survrate1 = rdata[rname, 1],
			survrate2 = rdata[rname, 2],
			ssratio   = rdata[rname, 3]
		)
	}
}

samsize = function(survrate1, survrate2, ssratio, a, b) {
	za     = abs(qnorm(1-a/2))
	zb     = abs(qnorm(1-b))
	sqrtA  = za + zb
	A      = sqrtA * sqrtA
	hr     = (1-survrate1)/(1-survrate2 + 1e-3)
	loghr  = log(hr) # ln
	# B    = pi1*pi2*(logHR)^2
	# B    = (ssratio/(ssratio + 1))*(1/(ssratio + 1)) * loghr * loghr
	B      = ssratio * loghr * loghr / (ssratio + 1) / (ssratio + 1)
	events = A/B

	return(list(
		ssize1 = as.integer(ssratio * events / (ssratio + 1)),
		ssize2 = as.integer(events / (ssratio + 1)),
		total  = as.integer(events),
		# hazard ratio
		hr     = hr
	))
}

outs = matrix(ncol = 10, nrow = 0)
colnames(outs) = c('Variable', 'Alpha', 'Beta', 'Survrate1', 'Survrate2', 'SSRatio', 'HRatio', 'SSize1', 'SSize2', 'Total')

alpha_plots = alphas
beta_plots  = betas
{% if args.plot %}
alpha_plots = c(exp(seq(-7, -2, by = .5)), alphas)
{% endif %}

for (var in names(data)) {
	plot_hr   = NA
	plot_data = matrix(ncol = 3, nrow = 0)
	colnames(plot_data) = c('mlogp', 'ssize', 'power')
	for (a in alpha_plots) {
		for (b in beta_plots) {
			ret = samsize(data[[var]]$survrate1, data[[var]]$survrate2, data[[var]]$ssratio, a, b)
			plot_hr   = ret$hr
			plot_data = rbind(plot_data, c(
				mlogp = -log2(a),
				ssize = ret$total,
				power = 1-b
			))
			if (a %in% alphas && b %in% betas) {
				outs = rbind(outs, c(
					Variable  = var,
					Alpha     = a,
					Beta      = b,
					Survrate1 = round(data[[var]]$survrate1, 3),
					Survrate2 = round(data[[var]]$survrate2, 3),
					SSRatio   = round(data[[var]]$ssratio, 3),
					HRatio    = round(ret$hr, 3),
					SSize1    = ret$ssize1,
					SSize2    = ret$ssize2,
					Total     = ret$total
				))
			}

		}
	}
	{% if args.plot %}
	plotfile = file.path(outdir, paste0(gsub("[[:punct:]]", "_", var), '.png'))
	vldata   = data.frame(x = -log2(alphas), y=-Inf, pval = alphas, label = paste('p = ', alphas))
	ggs = list(
		xlab = list("-log2(p-value)"),
		ylab = list("Sample size"),
		labs = list(color = 'Power'),
		geom_smooth = list(aes(color = factor(power)), method = lm, se = F),
		geom_vline  = list(
			aes(xintercept = x),
			color = '#555555',
			vldata,
			linetype = 'dotdash',
			inherit.aes = FALSE
		),
		geom_text = list(
			aes(x = x, y = y, label = label),
			vldata,
			color = '#555555',
			angle = 90,
			vjust = 1.5,
			hjust = -.2,
			inherit.aes = FALSE
		),
		annotate = list(
			"text",
			label = paste('Hazrd ratio =', round(plot_hr, 2)),
			x = Inf,
			y = -Inf,
			color = '#555555',
			vjust = -.8,
			hjust = 1.1
		)
	)
	plot.points(
		as.data.frame(plot_data),
		plotfile,
		params = list(mapping = aes(color = factor(power))),
		ggs = ggs
	)
	{% endif %}
}

write.table(outs, outfile, sep = '\t', row.names = F, col.names = T, quote = F)

{{rimport}}('__init__.r')
library (Gviz)

tracks = NULL
region = unlist(strsplit({{i.region | quote}}, ':', fixed = T))
chrom  = region[1]
region = unlist(strsplit(region[2], '-', fixed = T))
start  = as.numeric(region[1])
end    = as.numeric(region[2])

trackFiles = {{i.trkfiles | R}}
highlights = {{i.highlight | R}}
genome     = {{args.genome | R}}
ideoTrack  = {{args.ideoTrack | R}}
axisTrack  = {{args.axisTrack | R}}
geneTrack  = {{args.geneTrack | R}}
params     = {{args.params | R}}
scheme     = {{args.scheme | R}}
devpars    = {{args.devpars | R}}
outfile    = {{o.outfile | R}}

scheme.default = getScheme()
scheme         = update.list(scheme.default, scheme, recursive = T)

addScheme(scheme, "bioprocs")
options(Gviz.scheme = "bioprocs")

ntracks = 0
tracks  = list()

# ideoTrack
if (is.logical(ideoTrack) && ideoTrack) {
	ideofile = textConnection(readLines(gzcon(url('http://hgdownload.soe.ucsc.edu/goldenPath/hg19/database/cytoBand.txt.gz'))))
} else if (!is.logical(ideoTrack)) {
	ideofile = ifelse(endsWith(ideoTrack, '.gz'), gzfile(ideoTrack), ideoTrack)
}
if (!is.logical(ideoTrack) || ideoTrack) {
	ideoParams = list(
		chromosome = chrom,
		genome     = genome,
		bands      = read.table(ideofile)
	)
	colnames(ideoParams$bands) = c('chrom', 'chromStart', 'chromEnd', 'name', 'gieStain')
	tracks = c(tracks, do.call(IdeogramTrack, ideoParams))
}

# axisTrack
if (axisTrack) {
	tracks = c(tracks, GenomeAxisTrack())
}

# highlightable
hiableTracks = NULL
# geneTrack
if (!is.logical(geneTrack) || geneTrack) {
	ntracks = ntracks + 1
	data(geneModels)
	geneParams = list(
		range      = geneTrack,
		name       = 'Gene',
		chromosome = chrom
	)
	hiableTracks = c(hiableTracks, do.call(GeneRegionTrack, geneParams))
}

# other tracks
for (trackfile in trackFiles) {
	ntracks   = ntracks + 1
	trackData = readRDS(trackfile)

	# interaction track
	if (trackData$trackType == 'InteractionTrack') {
		library(GenomicInteractions)
		trackData$trackParams$x = do.call(makeGenomicInteractionsFromFile, trackData$interactionParams)
		irtrackParams = list()
		for (name in c('x', 'chromosome', 'name', 'start', 'end')) {
			irtrackParams[[name]] = trackData$trackParams[[name]]
			trackData$trackParams[[name]] = NULL
		}
		
		track = do.call(InteractionTrack, irtrackParams)
		displayPars(track)  = trackData$trackParams
	} else {
		track = do.call(trackData$trackType, trackData$trackParams)
	}
	hiableTracks = c(hiableTracks, track)
}

# highlight tracks
if (nchar(highlights) > 0) {
	hregs   = unlist(strsplit(highlights, ';', fixed = T))
	hstarts = NULL
	hends   = NULL
	for (hreg in hregs) {
		reg = unlist(strsplit(hreg, '-', fixed = T))
		hstarts = c(hstarts, as.numeric(reg[1]))
		hends   = c(hends  , as.numeric(reg[2]))
	}
	hstarts = sapply(hstarts, function(x) max(x, start))
	hends   = sapply(hends, function(x) min(x, end))
	hltrack = HighlightTrack(trackList = hiableTracks, start = hstarts, end = hends, chromosome = chrom)
	tracks  = c(tracks, hltrack)
} else {
	tracks  = c(tracks, hiableTracks)
}

devpars$height = (1 + ntracks) * devpars$height
do.call(png, c(list(filename = outfile), devpars))
params.default = list(
	trackList = tracks,
	from      = start,
	to        = end
)
params = c(params.default, params)
do.call(plotTracks, params)
dev.off()

{{rimport}}('sampleinfo.r')
library(superFreq)
options(stringsAsFactors = FALSE)

indir    = {{i.indir | quote}}
gfile    = {{i.gfile | quote}}
outdir   = {{o.outdir | quote}}
params   = {{args.params | R}}
nthread  = {{args.nthread | R}}
baits    = {{args.baits | quote}}
resdir   = {{args.resdir | quote}}
ref      = {{args.ref | quote}}
genome   = {{args.genome | quote}}
cachedir = {{job.cachedir | quote}}
if (!file.exists(cachedir)) {
	dir.create(cachedir, showWarnings = FALSE, recursive = FALSE, mode = "0777")
}

# construct meta file
metafile = file.path(outdir, 'superFreq.meta.txt')
saminfo  = SampleInfo2$new(gfile, checkPaired = TRUE)
metadata = saminfo$as.superfreq.meta(datadir = indir)
write.table(metadata, metafile, row.names = FALSE, sep = "\t", quote = FALSE)

# try to find index of all bam files
for (bam in unique(unlist(metadata$BAM))) {
	reticulate::import('bioprocs')$utils$reference$bamIndex(bam, samtools = NULL, nthread = nthread)
}

# convert baits to bed
if (baits == "") {
	# try to find it in resource directory
	if (file.exists(file.path(resdir, genome))) {
		allbeds   = Sys.glob(file.path(resdir, genome, '*.bed'))
		namedbeds = Sys.glob(file.path(resdir, genome, '*.named*.bed'))
		baits     = setdiff(allbeds, namedbeds)
	}
} else if (endsWith(baits, ".gff") || endsWith(baits, ".gtf")) {
	baitfile = file.path(outdir, 'bait.bed')
	reticulate::import('gff')$Gff$toBedfile(baits, baitfile, name = '{attributes[gene_id]}')
	baits = baitfile
} 

# normal directory
normaldir_cache = file.path(cachedir, 'normalDirectory')
if (!file.exists(normaldir_cache)) {
	dir.create(normaldir_cache, showWarnings = FALSE, recursive = FALSE, mode = "0777")
}
normaldir = file.path(outdir, 'normalDirectory')
file.symlink(normaldir_cache, normaldir)
nbamdir   = file.path(normaldir, 'bam')
if (!file.exists(nbamdir)) {
	dir.create(nbamdir, showWarnings = FALSE, recursive = FALSE, mode = "0777")
}
for (normal in metadata[which(metadata$NORMAL == "YES"), "BAM", drop = TRUE]) {
	file.symlink(normal, file.path(nbamdir, basename(normal)))
	file.symlink(paste0(normal, '.bai'), file.path(nbamdir, basename(paste0(normal, '.bai'))))
}

Rdir_cache = file.path(cachedir, 'R')
Rdir = file.path(outdir, 'R')
if (!file.exists(Rdir_cache)) {
	dir.create(Rdir_cache, showWarnings = FALSE, recursive = FALSE, mode = "0777")
}
file.symlink(Rdir_cache, Rdir)

plotsdir_cache = file.path(cachedir, 'plots')
plotsdir = file.path(outdir, 'plots')
if (!file.exists(plotsdir_cache)) {
	dir.create(plotsdir_cache, showWarnings = FALSE, recursive = FALSE, mode = "0777")
}
file.symlink(plotsdir_cache, plotsdir)

# resource dir
resourcedir = file.path(outdir, 'resource')
file.symlink(resdir, resourcedir)

params$metaDataFile      = metafile
params$captureRegions    = baits
params$normalDirectory   = normaldir
params$Rdirectory        = Rdir
params$plotDirectory     = plotsdir
params$reference         = ref
params$genome            = genome
params$cpus              = nthread
params$resourceDirectory = resourcedir
tryCatch({
	data = do.call(superFreq, params)
}, error = function(e) {
	cat("Error encountered:\n", file = stderr())
	cat(paste0(e, "\n"), file = stderr())
})
printHTML(metaDataFile = metafile, outputFile = file.path(outdir, 'plots', 'superFreq.html'))

{{rimport}}('__init__.r')

infile   = {{i.infile | quote}}
casefile = {{i.casefile | quote}}
outfile  = {{o.outfile | quote}}
model    = {{args.model | quote}}
fmula    = {{args.fmula | R}}
inopts   = {{args.inopts | R}}
cov      = {{args.cov | quote}}

indata  = read.table.inopts(infile, inopts)
covs    = NULL
if (cov != '') {
	covdata = read.table.inopts(cov, list(cnames = TRUE, rnames = TRUE))
	covs    = colnames(covdata)
	indata  = cbind(indata, covdata[rownames(indata),,drop = FALSE])
} else if (is.null(fmula)) {
	stop('Either `i.casefile` or `args.fmula` should be specified.')
}

add.covs = function(fmula) {
	if (is.null(covs) || is.null(fmula)) {
		return(fmula)
	} else {
		asfmula = as.formula(fmula)
		allvars = all.vars(asfmula)
		if (length(allvars) == 2 && allvars[2] == '.') {
			return (fmula)
		} else {
			return (paste(fmula, paste(sapply(covs, bQuote), collapse = '+'), sep = '+'))
		}
	}
}

do.case = function(case, m, fmula1, fmula2 = NULL) {
	fmula1 = as.formula(add.covs(fmula1))
	fmula2 = ifelse(is.null(fmula2), NULL, as.formula(add.covs(fmula2)))
	model1 = do.call(m, list(fmula1, data = indata))
	if (!is.null(fmula2)) {
		model2 = do.call(m, list(fmula2, data = indata))
		ret = anova(model2, mode1)
		colnames(ret) = c('Res_DF', 'RSS', 'DF', 'SumSq', 'Fstat', 'Pval')
		ret = cbind(list(Case = case), ret[2,,drop = FALSE])
	} else {
		ret = anova(model1)
		colnames(ret) = c('DF', 'SumSq', 'MeanSq', 'Fstat', 'Pval')
		ret = ret[complete.cases(ret),,drop = FALSE]
		ret = cbind(list(Case = case), list(Var = rownames(ret)), ret)
		rownames(ret) = NULL
	}
	ret
}

if (casefile == '') {
	casedata = data.frame(Case = 'Case1', Formula = fmula[1], Formula2 = fmula[2], Model = model)
} else {
	casedata = read.table.inopts(casefile, list(rnames = FALSE, cnames = TRUE))
	cdncol = ncol(casedata)
	if (cdncol < 2) {
		stop('Case file requires >=2 columns (Case and Formula)')
	} else if (cdncol == 2) {
		colnames(casedata) = c('Case', 'Formula')
	} else if (cdncol == 3) {
		colnames(casedata) = c('Case', 'Formula', 'Formula2')
	} else {
		colnames(casedata) = c('Case', 'Formula', 'Formula2', 'Model')
	}
	if (!'Formula2' %in% colnames(casedata)) {
		casedata$Formula2 = NA
	}
	if (!'Model' %in% colnames(casedata)) {
		casedata$Model = 'lm'
	}
}

r = do.call(rbind, apply(casedata, 1, function(row) {
	do.case(row[1], row[4], row[2], ifelse(is.na(row[3]), NULL, row[3]))
}))

write.table(r, outfile, quote = FALSE, sep = "\t")

#library(Gviz)
#library(GenomicInteractions)

region = unlist(strsplit({{i.region | quote}}, ':', fixed = T))
chrom  = region[1]
region = unlist(strsplit(region[2], '-', fixed = T))
start  = as.numeric(region[1])
end    = as.numeric(region[2])

infile = {{i.infile | quote}}
intype = {% if args.intype == 'auto' %}{{i.infile | ext | [1:] | quote}}{% else %}{{args.intype | quote}}{% endif %}

if (intype == 'bedpe') {
	# check bedpe format
	# normally it should be: (see http://bedtools.readthedocs.io/en/latest/content/general-usage.html#bedpe-format)
	# chrom1	start1	end1	chrom2	start2	end2	name	score	strand1	strand2[	other fields]
	# chr1	3427000	2343059	chr1	2351020	2351159	42401_42410	3.783	+	-	143	79	3
	# chr16	3043880	3044279	chr16	3056380	3056559	12898_12909	2.344	-	*	492	89	2
	# !!! No header
	# !!! Strand must be +, - or *

	# Try to remove header and convert strand . to * (this format is usually from Encode)
	lines = readLines(infile)
	# has header
	if (startsWith(lines[1], "chrom")) {
		lines = lines[-1]
	}
	lines2 = NULL
	for (line in lines) {
		parts = unlist(strsplit(line, '\t', fixed = T))
		# filter out interaction for other chromosomes, cuz you can't plot it!
		# TODO: Also do for other input file types! Dramatically save time!
		if (parts[1] != chrom) { next } 
		if (parts[9] == '.')  parts[9]  = '*'
		if (parts[10] == '.') parts[10] = '*'
		#lines[i] = paste(parts, collapse = '\t')
		lines2 = c(lines2, paste0(paste(parts, collapse = '\t'), '\n'))
	}
	rm(lines)
	#infile = textConnection(lines2)
	infile = "{{job.outdir}}/{{i.infile | fn}}.bedpe"
	writeLines(lines2, infile)
	rm(lines2)
} else if (intype == 'bedx') {
	lines = readLines(infile)
	lines2 = NULL
	chr2index    = NA
	start2index  = NA
	end2index    = NA
	name2index   = NA
	strand2index = NA
	for (line in lines) {
		parts = unlist(strsplit(line, '\t', fixed = T))
		if (startsWith(parts[1], "##")) { next }
		if (startsWith(parts[1], "#CHR") || startsWith(parts[1], "CHR")) { # header
			chr2index    = match("CHR2", parts)
			start2index  = match("START2", parts)
			end2index    = match("END2", parts)
			name2index   = match("NAME2", parts)
			strand2index = match("STRAND2", parts)
			next
		} 
		if (is.na(chr2index) || is.na(start2index) || is.na(end2index)) {
			stop('Cannot find CHR2, START2, END2 columns in bedx file')
		}
		name    = if (is.na(name2index)) parts[4] else paste(parts[4], parts[name2index], sep = '-')
		strand2 = if (is.na(strand2index)) '+' else parts[strand2index]
		lines2  = c(lines2, paste0(paste(c(parts[1:3], parts[chr2index], parts[start2index], parts[end2index], name, max(as.character(parts[5]), 1), parts[6], strand2), collapse = '\t'), '\n'))
	}
	rm(lines)
	infile = "{{job.outdir}}/{{i.infile | fn}}.bedpe"
	writeLines(lines2, infile)
	rm(lines2)
	intype = 'bedpe'
}

ret = list()
ret$trackType = 'InteractionTrack'
ret$interactionParams = list(
	fn   = infile,
	type = intype,
	experiment_name = {{i.infile | fn | quote}},
	description = "Interaction data for {{i.infile | fn}}"
)
ret$trackParams = list(
	x          = '',
	chromosome = chrom,
	name       = {{i.name | quote}}
)
ret$trackParams = c(ret$trackParams, {{args.params | Rlist}})

saveRDS (ret, {{o.outfile | quote}})

library(methods)
{{rimport}}('__init__.r', 'plot.r')

indir  = {{i.indir | R}}
outdir = {{o.outdir | R}}

plink   = {{args.plink | R}}
cutoff  = {{args.cutoff | R}}
devpars = {{args.devpars | R}}

bedfile = Sys.glob(file.path(indir, '*.bed'))
input   = tools::file_path_sans_ext(bedfile)
output  = file.path(outdir, basename(input))

params = list(
	bfile = input,
	het   = T,
	out   = output
)
cmd = sprintf("%s %s 1>&2", plink, cmdargs(params, equal = ' '))
runcmd(cmd)

phet = read.table(paste0(output, '.het'), header = T, row.names = NULL, check.names = F)
het = data.frame(Het = 1 - phet[, "O(HOM)"]/phet[, "N(NM)"])
rownames(het) = paste(phet$FID, phet$IID, sep = "\t")
het.mean = mean(het$Het, na.rm = T)
het.sd   = sd(het$Het, na.rm = T)
het.fail = rownames(het[!is.na(het$Het) & (het$Het < het.mean-cutoff*het.sd | het$Het > het.mean+cutoff*het.sd),, drop = F])
writeLines(het.fail, con = file(paste0(output, '.het.fail')))

{% if args.plot %}
het$Status = "Pass"
het[het.fail, "Status"] = "Fail"

plot.histo(
	data     = het,
	plotfile = paste0(output, '.het.png'),
	params   = list(aes(fill=Status), bins = 50),
	ggs      = list(
		xlab       = list("Sample Heterozygosity"),
		ylab       = list("Count"),
		geom_vline = list(xintercept = c(het.mean-cutoff*het.sd, het.mean+cutoff*het.sd), color = "red", linetype="dashed"),
		geom_vline = list(xintercept = het.mean, color = "blue", linetype="dashed"),
		theme      = list(legend.position = "none"),
		geom_text  = list(
			aes(x = het.mean-cutoff*het.sd, y = Inf, label = sprintf('mean - %ssd (%.3f)', cutoff, het.mean - cutoff*het.sd)),
			colour="red", angle=90, vjust = 1.2, hjust = 1.2
		),
		geom_text  = list(
			aes(x = het.mean+cutoff*het.sd, y = Inf, label = sprintf('mean + %ssd (%.3f)', cutoff, het.mean + cutoff*het.sd)),
			colour="red", angle=90, vjust = 1.2, hjust = 1.2
		),
		geom_text  = list(
			aes(x = het.mean, y = Inf, label = sprintf('mean (%.3f)', het.mean)),
			colour="blue", vjust = 1.5, hjust = -.1
		)
	),
	devpars = devpars
)
{% endif %}

library ('factoextra')
library ('mclust')
data = read.table ({{i.infile | quote}}, sep="\t", header={{args.cnames | R}}, row.names={{args.rnames | lambda x: 'NULL' if not x else int(x)}}, check.names=F)
if ({{args.transpose | R}}) {
	data = t(data)
}

data = data[, apply(data, 2, sd)!=0, drop=F]
mc        = Mclust (data, G={{args.minc}}:{{args.maxc}})
clustfile = file.path ({{o.outdir | quote}}, "clusters.txt")
write.table (mc$classification, clustfile, quote=F, col.names = F, sep="\t")
clustfig  = file.path ({{o.outdir | quote}}, "clusters.png")
do.call(png, c(list(file = clustfig), {{args.devpars | Rlist}}))
labels    = colnames(data)
print (fviz_cluster (mc, main = ""))
dev.off()

library(RUVcorr)

seed     = {{i.seed | R}}
outfile  = {{o.outfile | quote}}
nsamples = {{args.nsamples | R}}
ngenes   = {{args.ngenes | R}}
slabel   = {{args.slabel | quote}}
glabel   = {{args.glabel | quote}}
params   = {{args.params | R}}

set.seed(seed)
update.list = function (list1, list2, recursive = F) {
	names2 = names(list2)
	for (name in names2) {
		if (is.list(list1[[name]]) && is.list(list2[[name]]) && recursive) {
			list1[[name]] = update.list(list1[[name]], list2[[name]], recursive = recursive)
		} else {
			list1[[name]] = list2[[name]]
		}
	}
	return (list1)
}
params   = update.list(params, list(
	k             = 10,
	size.alpha    = 2,
	corr.strength = 3,
	g             = NULL,
	Sigma.eps     = 1,
	# An integer setting the number of negative controls.
	nc            = ngenes/2,
	# An integer setting the number of strongly expressed genes.
	ne            = ngenes/2,
	intercept     = TRUE,
	check         = TRUE
))
params$n = ngenes
params$m = nsamples
exprs    = do.call(simulateGEdata, params)$Y
colnames(exprs) = paste0(glabel, 1:ngenes)
rownames(exprs) = paste0(slabel, 1:nsamples)

write.table(t(exprs), outfile, sep = "\t", quote = FALSE, row.names = TRUE, col.names = TRUE)

{{rimport}}('__init__.r')
library('openxlsx')
options("openxlsx.maxWidth" = 25)
options("openxlsx.minWidth" = 5)

infile   = {{i.infile | quote}}
survfile = {{i.survfile | quote}}
outfile  = {{o.outfile | quote}}
covfile  = {{args.covfile | R}}
rnames   = {{args.inopts.get('rnames', True) | R}}
chi2n    = {{args.chi2n | R}}

survret = read.table(infile, header = T, row.names = NULL, sep = "\t", check.names = F)
survret = unique(survret[, c('var', 'groups')])

survdata = read.table(survfile, header = T, row.names = if (rnames) 1 else NULL, sep = "\t", check.names = F)

covs = c()
if (!is.null(covfile)) {
	covdata = read.table(covfile,  header = T, row.names = 1, sep = "\t", check.names = F)
	covs    = colnames(covdata)
}

lighten = function(color, factor = 1.5){
	col = col2rgb(color)
	col = col*factor
	col[col>255] = 255
	col = rgb(t(col), maxColorValue=255)
	col
}
# 	A	B
# R1: 1 (6.67%, 1.82%)	6 (15.00%, 10.91%)
# R2: 2 (13.33%, 3.64%)	7 (17.50%, 12.73%)
# R3: 3 (20.00%, 5.45%)	8 (20.00%, 14.55%)
# R4: 4 (26.67%, 7.27%)	9 (22.50%, 16.36%)
# R5: 5 (33.33%, 9.09%)	10 (25.00%, 18.18%)
ctable.summary = function(ctable) {
	lines  = paste(colnames(ctable), collapse = "; ")
	rnames = rownames(ctable)
	for (i in 1:nrow(ctable)) {
        vals = sapply(1:length(ctable[i,]), function(x)  sprintf("%d (%.2f%%, %.2f%%)", ctable[i,x], 100*ctable[i,x]/sum(ctable[,x]), 100*ctable[i,x]/sum(ctable)))
        #vals = sapply(ctable[i,], function(x) sprintf("%d (%.2f%%, %.2f%%)", x, 100*x/sum(ctable[,1]), 100*x/sum(ctable)))
		lines = c(lines, paste0(paste0(rnames[i], ": "), paste(vals, collapse="; ")))
	}
	paste(lines, collapse = "\n")
}

wb = createWorkbook()
for (i in 1:nrow(survret)) {

	var     = as.character(survret[i, 'var'])
	vars    = c(var, covs)
	logger('Handling variable', var)
	groups  = as.integer(unlist(strsplit(as.character(survret[i, 'groups']), ",", fixed = T)))
	ngroups = length(groups)
	# nothing to do if less 2 groups
	if (ngroups < 2) next
	ncomb   = ngroups * (ngroups -1) / 2

	vardata = survdata[, var, drop = F]
	# alive
	alvdata = survdata[which(survdata$status == min(survdata$status)), var, drop = F]
	# dead
	deadata = survdata[setdiff(rownames(survdata), rownames(alvdata)), var, drop = F]
	if (!is.null(covfile)) {
		vardata = cbind.fill(vardata, covdata)
		alvdata = cbind.fill(alvdata, covdata)
		deadata = cbind.fill(deadata, covdata)
	}

	vardata = vardata[complete.cases(vardata),, drop = F]
	vardata = vardata[order(vardata[, var]),, drop = F]

	alvdata = alvdata[complete.cases(alvdata),, drop = F]
	alvdata = alvdata[order(alvdata[, var]),, drop = F]

	deadata = deadata[complete.cases(deadata),, drop = F]
	deadata = deadata[order(deadata[, var]),, drop = F]

	out = matrix(, ncol = 3 + ngroups + 3 + ncomb * 3 + 1 + ncomb + 8, nrow = 5 + length(covs) * 5)
	cnamesout = c('All', 'Alive', 'Deceased', paste0('Group_', 1:ngroups))
	# t-test
	for (tn in c('T_P_', 'T_ConfInt_', 'T_Means_')) {
		cnamesout = c(cnamesout, paste0(tn, 'AvsD'))
	}
	for (tn in c('T_P_', 'T_ConfInt_', 'T_Means_')) {
		for (j in 1:ngroups) {
			for (k in 1:ngroups) {
				if (k >= j) next
				cnamesout = c(cnamesout, paste0(tn, j, 'vs', k))
			}
		}
	}
	# wilcox-test
	cnamesout = c(cnamesout, paste0('Wilcox_P_AvsD'))
	for (j in 1:ngroups) {
		for (k in 1:ngroups) {
			if (k >= j) next
			cnamesout = c(cnamesout, paste0('Wilcox_P_', j, 'vs', k))
		}
	}
	# chi2-test
	cnamesout = c(cnamesout, 'Chi2_P_AvsD', 'Chi2_Chi2_AvsD', 'Chi2_Obs_AvsD', 'Chi2_Exp_AvsD', 'Chi2_P_Groups', 'Chi2_Chi2_Groups', 'Chi2_Obs_Groups', 'Chi2_Exp_Groups')
	colnames(out) = cnamesout
	rnamesout = c()
	for (v in c(var, covs)) {
		rnamesout = c(rnamesout, paste0(v, c('_Min', '_Max', '_Mean', '_Median', '_Stdev')))
	}
	rownames(out) = rnamesout

	for (v in vars) {
		out[paste0(v, '_Min'), 'All']    = round(min(vardata[, v]), 2)
		out[paste0(v, '_Max'), 'All']    = round(max(vardata[, v]), 2)
		out[paste0(v, '_Mean'), 'All']   = round(mean(vardata[, v]), 2)
		out[paste0(v, '_Median'), 'All'] = round(median(vardata[, v]), 2)
		out[paste0(v, '_Stdev'), 'All']  = round(sd(vardata[, v]), 2)

		out[paste0(v, '_Min'), 'Alive']    = round(min(alvdata[, v]), 2)
		out[paste0(v, '_Max'), 'Alive']    = round(max(alvdata[, v]), 2)
		out[paste0(v, '_Mean'), 'Alive']   = round(mean(alvdata[, v]), 2)
		out[paste0(v, '_Median'), 'Alive'] = round(median(alvdata[, v]), 2)
		out[paste0(v, '_Stdev'), 'Alive']  = round(sd(alvdata[, v]), 2)

		out[paste0(v, '_Min'), 'Deceased']    = round(min(deadata[, v]), 2)
		out[paste0(v, '_Max'), 'Deceased']    = round(max(deadata[, v]), 2)
		out[paste0(v, '_Mean'), 'Deceased']   = round(mean(deadata[, v]), 2)
		out[paste0(v, '_Median'), 'Deceased'] = round(median(deadata[, v]), 2)
		out[paste0(v, '_Stdev'), 'Deceased']  = round(sd(deadata[, v]), 2)
	}

	prevgroup = 0
	groupdata = list()
	for (j in 1:ngroups) {
		groupdata[[j]] = vardata[(prevgroup + 1):(prevgroup + groups[j]),,drop = F]
		prevgroup = prevgroup + groups[j]
		for (v in vars) {
			out[paste0(v, '_Min'), paste0('Group_', j)]    = round(min(groupdata[[j]][, v]), 2)
			out[paste0(v, '_Max'), paste0('Group_', j)]    = round(max(groupdata[[j]][, v]), 2)
			out[paste0(v, '_Mean'), paste0('Group_', j)]   = round(mean(groupdata[[j]][, v]), 2)
			out[paste0(v, '_Median'), paste0('Group_', j)] = round(median(groupdata[[j]][, v]), 2)
			out[paste0(v, '_Stdev'), paste0('Group_', j)]  = round(sd(groupdata[[j]][, v]), 2)
		}
	}
	# t-test, wilcox-test
	for (v in vars) {
		ttest = t.test(alvdata[, v], deadata[, v])
		out[paste0(v, '_Min'), 'T_P_AvsD'] = formatC(ttest$p.value, format = "E", digits = 2)
		out[paste0(v, '_Min'), 'T_ConfInt_AvsD'] = paste(round(ttest$conf.int, 2), collapse = ',')
		out[paste0(v, '_Min'), 'T_Means_AvsD'] = paste(round(ttest$estimate, 2), collapse = ',')
		wtest = wilcox.test(alvdata[, v], deadata[, v])
		out[paste0(v, '_Min'), 'Wilcox_P_AvsD'] = formatC(wtest$p.value, format = "E", digits = 2)
	}
	for (j in 1:ngroups) {
		for (k in 1:ngroups) {
			if (k >= j) next
			for (v in vars) {
				tryCatch({
					ttest = t.test(groupdata[[j]][, v], groupdata[[k]][, v])
					out[paste0(v, '_Min'), paste0('T_P_', j, 'vs', k)] = formatC(ttest$p.value, format = "E", digits = 2)
					out[paste0(v, '_Min'), paste0('T_ConfInt_', j, 'vs', k)] = paste(round(ttest$conf.int, 2), collapse = ',')
					out[paste0(v, '_Min'), paste0('T_Means_', j, 'vs', k)] = paste(round(ttest$estimate, 2), collapse = ',')
				}, error = function(e) {
					out[paste0(v, '_Min'), paste0('T_P_', j, 'vs', k)] = 'NA'
				})
				tryCatch({
				wtest = wilcox.test(groupdata[[j]][, v], groupdata[[k]][, v])
					out[paste0(v, '_Min'), paste0('Wilcox_P_', j, 'vs', k)] = formatC(wtest$p.value, format = "E", digits = 2)
				}, error = function(e){
					out[paste0(v, '_Min'), paste0('Wilcox_P_', j, 'vs', k)] = 'NA'
				})
			}
		}
	}
	# chi2-test
	for (v in vars) {

		if (length(levels(as.factor(vardata[, v]))) > chi2n) {
			out[paste0(v, '_Min'), 'Chi2_P_AvsD'] = 'NA'
			out[paste0(v, '_Min'), 'Chi2_P_Groups'] = 'NA'
			next
		}

		ctable = NULL
		tdata  = as.data.frame(table(alvdata[, v]))
		rownames(tdata) = as.character(tdata$Var1)
		tdata  = tdata[, -1, drop = F]
		colnames(tdata) = 'Alive'
		ctable = cbind.fill(ctable, tdata)
		tdata  = as.data.frame(table(deadata[, v]))
		rownames(tdata) = as.character(tdata$Var1)
		tdata  = tdata[, -1, drop = F]
		colnames(tdata) = 'Deceased'
		ctable = cbind.fill(ctable, tdata)
		ctable[is.na(ctable)] = 0
		ctable = ctable[order(rownames(ctable)), , drop = F]
		tryCatch({
			ctest  = chisq.test(ctable)
			out[paste0(v, '_Min'), 'Chi2_P_AvsD']    = formatC(ctest$p.value, format = "E", digits = 2)
			out[paste0(v, '_Min'), 'Chi2_Chi2_AvsD'] = as.character(round(ctest$statistic, 2))
			out[paste0(v, '_Min'), 'Chi2_Obs_AvsD']  = ctable.summary(ctest$observed)
			out[paste0(v, '_Min'), 'Chi2_Exp_AvsD']  = paste(apply(round(ctest$expected, 2), 1, function(r) paste(r, collapse = ',')), collapse = '; ')
		}, error = function(e) {
			out[paste0(v, '_Min'), 'Chi2_P_AvsD']    = 'NA'
		})
		
		ctable   = NULL
		for (j in 1:ngroups) {
			tdata   = as.data.frame(table(groupdata[[j]][, v]))
			rownames(tdata) = as.character(tdata$Var1)
			tdata = tdata[, -1, drop = F]
			colnames(tdata) = paste0("Group", j)
			ctable  = cbind.fill(ctable, tdata)
		}
		ctable[is.na(ctable)] = 0
		ctable = ctable[order(rownames(ctable)), , drop = F]
		tryCatch({
		ctest  = chisq.test(ctable)
			out[paste0(v, '_Min'), 'Chi2_P_Groups']    = formatC(ctest$p.value, format = "E", digits = 2)
			out[paste0(v, '_Min'), 'Chi2_Chi2_Groups'] = as.character(round(ctest$statistic, 2))
			out[paste0(v, '_Min'), 'Chi2_Obs_Groups']  = ctable.summary(ctest$observed)
			out[paste0(v, '_Min'), 'Chi2_Exp_Groups']  = paste(apply(round(ctest$expected, 2), 1, function(r) paste(r, collapse = ',')), collapse = '; ')
		}, error = function(e){
			out[paste0(v, '_Min'), 'Chi2_P_Groups']    = 'NA'
		})
	}
	sheet = paste0(var)
	addWorksheet(wb, sheet)
	writeData(wb, sheet, out, startCol = 2, startRow = 2, rowNames = T)
	colors = lighten(rainbow(length(vars) + ncomb + 14))
	for (j in 1:length(vars)) {
		mergeCells(wb, sheet, cols = 1, rows = (3 + 5 * (j - 1)):(3 + 5 * j - 1)) 
		writeData(wb, sheet, vars[j], startCol = 1, startRow = 3 + 5 * (j - 1))
		style = createStyle(fgFill = substring(colors[j], 1, 7), valign = "center", textDecoration = "bold", border="Bottom", borderColour = "#000000")
		#addStyle(wb, sheet, style, cols = 1, rows = 3 + 5 * (j - 1))
		addStyle(wb, sheet, style, cols = 1:2, rows = (3 + 5 * (j - 1)):(3 + 5 * j - 1), gridExpand = TRUE)

		style = createStyle(fgFill = substring(colors[j], 1, 7), valign = "center", border="LeftBottom", borderColour = "#000000")
		# total columns: 3 + ngroups + 3 + ncomb * 3 + 1 + ncomb + 8
		addStyle(wb, sheet, style, cols = 3:(17+ngroups+ncomb*4), rows = (3 + 5 * (j - 1)):(3 + 5 * j - 1), gridExpand = TRUE)

		for (k in (6+ngroups):(17+ngroups+ncomb*4)) {
			mergeCells(wb, sheet, cols = k, rows = (3 + 5 * (j - 1)):(3 + 5 * j - 1)) 
		}
	}
	mergeCells(wb, sheet, cols = 3:5, rows = 1)
	writeData(wb, sheet, 'Samples', startCol = 3, startRow = 1)
	style = createStyle(fgFill = substring(colors[length(vars)+1], 1, 7), halign = "center", textDecoration = "bold")
	addStyle(wb, sheet, style, cols = 3:5, rows = 1:2, gridExpand = TRUE)

	mergeCells(wb, sheet, cols = 6:(5+ngroups), rows = 1)
	writeData(wb, sheet, 'Groups', startCol = 6, startRow = 1)
	style = createStyle(fgFill = substring(colors[length(vars)+2], 1, 7), halign = "center", textDecoration = "bold")
	addStyle(wb, sheet, style, cols = 6:(5+ngroups), rows = 1:2, gridExpand = TRUE)

	mergeCells(wb, sheet, cols = (6+ngroups):(8+ngroups), rows = 1)
	writeData(wb, sheet, 'T-Test (Alive vs Deceased)', startCol = 6+ngroups, startRow = 1)
	style = createStyle(fgFill = substring(colors[length(vars)+3], 1, 7), halign = "center", textDecoration = "bold")
	addStyle(wb, sheet, style, cols = (6+ngroups):(8+ngroups), rows = 1:2, gridExpand = TRUE)

	mergeCells(wb, sheet, cols = (9+ngroups):(8+ngroups+ncomb*3), rows = 1)
	writeData(wb, sheet, 'T-Test', startCol = 9+ngroups, startRow = 1)
	style = createStyle(fgFill = substring(colors[length(vars)+4], 1, 7), halign = "center", textDecoration = "bold")
	addStyle(wb, sheet, style, cols = (9+ngroups):(8+ngroups+ncomb*3), rows = 1:2, gridExpand = TRUE)
	
	mergeCells(wb, sheet, cols = (9+ngroups+ncomb*3):(9+ngroups+ncomb*4), rows = 1)
	writeData(wb, sheet, 'Wilcox-Test', startCol = 9+ngroups+ncomb*3, startRow = 1)
	style = createStyle(fgFill = substring(colors[length(vars)+5], 1, 7), halign = "center", textDecoration = "bold")
	addStyle(wb, sheet, style, cols = (9+ngroups+ncomb*3):(9+ngroups+ncomb*4), rows = 1:2, gridExpand = TRUE)

	mergeCells(wb, sheet, cols = (10+ngroups+ncomb*4):(13+ngroups+ncomb*4), rows = 1)
	writeData(wb, sheet, 'Chi2-Test (Alive vs Deceased)', startCol = 10+ngroups+ncomb*4, startRow = 1)
	style = createStyle(fgFill = substring(colors[length(vars)+6], 1, 7), halign = "center", textDecoration = "bold")
	addStyle(wb, sheet, style, cols = (10+ngroups+ncomb*4):(13+ngroups+ncomb*4), rows = 1:2, gridExpand = TRUE)

	mergeCells(wb, sheet, cols = (14+ngroups+ncomb*4):(17+ngroups+ncomb*4), rows = 1)
	writeData(wb, sheet, 'Chi2-Test', startCol = 14+ngroups+ncomb*4, startRow = 1)
	style = createStyle(fgFill = substring(colors[length(vars)+7], 1, 7), halign = "center", textDecoration = "bold")
	addStyle(wb, sheet, style, cols = (14+ngroups+ncomb*4):(17+ngroups+ncomb*4), rows = 1:2, gridExpand = TRUE)
	
	setColWidths(wb, sheet, 1:(17+ngroups+ncomb*4), widths = 'auto')

}

saveWorkbook(wb, outfile, overwrite = TRUE)

{{rimport}}('__init__.r', 'plot.r')

{% python from os import path %}
library(methods)
library(survival)
library(survminer)

inunit   = {{args.inunit | R}}
outunit  = {{args.outunit | R}}
exprfile = {{i.exprfile | R}}
survfile = {{i.survfile | R}}
gene     = {{i.gene | quote}}
gep70    = {{args.gep70 | R}}
devpars  = {{args.devpars | R}}
params   = {{args.params | R}}
name     = {{args.name | R}}
prefix   = {{fn2(i.survfile), i.gene, o.outdir, args.name | lambda v1, v2, v3, v4, path = path: path.join(v3, '{}.{}-{}.'.format(v1, v4, v2) if v2 else '{}.{}.'.format(v1, v4)) | quote }}

mainggs       = {{args.ggs | R}}
tableggs      = mainggs$table
mainggs$table = NULL

# read raw survival data
fct = 1
{% case (args.inunit, args.outunit) %}
	{% when ('days', 'weeks') %}
	fct = 1 / 7
	{% when ('days', 'months') %}
	fct = 1 / 30
	{% when ('days', 'years') %}
	fct = 1 / 365 # 365.25?
	{% when ('weeks', 'days') %}
	fct = 7
	{% when ('weeks', 'months') %}
	fct = 7*12/365
	{% when ('weeks', 'years') %}
	fct = 7/365
	{% when ('years', 'days') %}
	fct = 365
	{% when ('years', 'weeks') %}
	fct = 365/7
	{% when ('years', 'months') %}
	fct = 12
{% endcase %}
# rows: samples
# cols: patients, time, status
survdata = read.table(survfile, header = T, row.names = 1, sep = "\t", check.names = F)
if (fct != 1) {
	survdata[, 1] = survdata[, 1] * fct
}

# read all expression data
# rows: genes
# cols: samples
exprdata = read.table.nodup(exprfile, header = T, row.names = 1, sep = "\t", check.names = F)
allgenes = rownames(exprdata)

# read the 70 genes
gene70 = read.table(gep70, row.names = 1, header = T, sep = "\t", check.names = F)

gene51   = intersect(allgenes, rownames(gene70[which(gene70[,1] == 'up'),,drop=F]))
gene19   = intersect(allgenes, rownames(gene70[which(gene70[,1] == 'down'),,drop=F]))	
exp51    = as.matrix(colMeans(exprdata[gene51, , drop = F]))
exp19    = as.matrix(colMeans(exprdata[gene19, , drop = F]))
gep70val = exp51 - exp19
colnames(gep70val) = name

samples  = intersect(rownames(gep70val), rownames(survdata))
gep70val = gep70val[samples, , drop=F]
if (gene != "") {
	gexpr = exprdata[gene, samples, drop = F]
	survdata = cbind(survdata[samples, ], gep70val, t(gexpr))
} else {
	survdata = cbind(survdata[samples, ], gep70val)
}

write.table(
	survdata, 
	paste0(prefix, 'rawdata.txt'),
	row.names = T,
	col.names = T,
	sep = "\t",
	quote = F
)

autogroup = function(survdata, var) {
	quantsteps = seq(0.15, 0.85, by = 0.005)
	survscores = sapply(quantsteps, function(x){
		newdata = survdata
		newdata[, var] = as.numeric(survdata[, var] >= quantile(survdata[, var], x))
		fmula = as.formula(paste('Surv(time, status) ~', var))
		tryCatch({
			coxph(fmula, data = newdata)$score
		}, error = function(x) 1)
	})
	plot.scatter(
		data.frame(step = quantsteps, survscores = survscores), 
		paste0(prefix, var, '.quant.png'), 
		ggs = list(geom_line = list()), 
		devpars = devpars
	)
	quantsteps[which.max(survscores)][1]
}

survdata[, name] = c('low', 'high')[as.numeric(survdata[, name] > quantile(
	survdata[, name], 
	autogroup(survdata, name)
)) + 1]

if (gene != "") {
	survdata[, gene] = c('low', 'high')[as.numeric(survdata[, gene] > quantile(
		survdata[, gene], 
		autogroup(survdata, gene)
	)) + 1]
	Group = apply(survdata, 1, function(row) paste(row[3], row[4], sep = ':'))
	Group = matrix(Group, ncol = 1)
	colnames(Group) = paste(name, gene, sep = ':')
	survdata = cbind(survdata, Group)
}

write.table(
	survdata, 
	paste0(prefix, 'groupdata.txt'),
	row.names = T,
	col.names = T,
	sep = "\t",
	quote = F
)

plot.survival = function(data, v) {
	var            = make.names(v)
	cnames         = colnames(data)
	cnames[which(cnames == v)] = var
	colnames(data) = cnames
	varlvls        = levels(factor(data[, var]))
	params.default = list(
		legend.title = paste0('Strata(', v, ')'),
		legend.labs  = varlvls,
		xlab         = paste0("Time (", outunit ,")"),
		ylim.min     = 0.0,
		pval.coord   = c(0, 0.1)
	)
	params = update.list(params.default, params)
	fmula  = as.formula(paste('Surv(time, status) ~', var))
	modkm  = surv_fit(fmula, data = data)
	survp  = surv_pvalue(modkm)

	params$legend.title = gsub('{var}', v, params$legend.title, fixed = T)
	if (!is.null(params$pval) && params$pval != F) {
		params$pval = gsub('{pval}', sprintf('%.2E', survp$pval), params$pval, fixed = T)
	}
	ylim.min        = params$ylim.min
	params$ylim.min = NULL
	if (!is.numeric(ylim.min)) { # auto
		ylim.min = min(modkm$lower[!is.na(modkm$lower)]) - .2
		ylim.min = max(ylim.min, 0)
		params$ylim          = c(ylim.min, 1)
		params$pval.coord[2] = params$pval.coord[2] + ylim.min
	} else if (ylim.min > 0) {
		params$ylim          = c(ylim.min, 1)
		params$pval.coord[2] = params$pval.coord[2] + ylim.min
	}
	params$fit     = modkm
	params$data    = data

	if (length(varlvls) < length(params$legend.labs))
		params$legend.labs = varlvls

	ret.plot      = do.call(ggsurvplot, params)
	ret.plot$plot = apply.ggs(ret.plot$plot, mainggs)

	# hack the table
	if (params$risk.table) {
		tableggs.one = list(
			ylab             = list(params$legend.title),
			xlab             = list(paste0("Time (", outunit ,")")),
			scale_y_discrete = list(labels = rev(params$legend.labs))
		)
		tableggs.one   = update.list(tableggs.one, tableggs)
		ret.plot$table = apply.ggs(ret.plot$table, tableggs.one)
	}
	do.call(png, c(paste0(prefix, var, '.survival.png'), devpars))
	print(ret.plot)
	dev.off()

	ret.summary = matrix(ncol = 6, nrow = 0)
	colnames(ret.summary) = c('var', 'method', 'test', 'groups', 'df', 'pvalue')
	ret.summary = rbind(ret.summary, c(v, 'logrank', 'NA', paste(table(data[, var]), collapse = ','), 1, survp$pval))
	write.table(ret.summary, paste0(prefix, var, '.survival.txt'), row.names = F, col.names = T, sep = "\t", quote = F)
}

plot.survival(survdata, name)
if (gene != "") {
	plot.survival(survdata, paste(name, gene, sep = ':'))
}

#library (Gviz)
region = unlist(strsplit({{i.region | quote}}, ':', fixed = T))
chrom  = region[1]
region = unlist(strsplit(region[2], '-', fixed = T))
start  = as.numeric(region[1])
end    = as.numeric(region[2])
geneParams = list(
	genome     = {{args.genome | quote}},
	chromosome = chrom,
	from       = start,
	to         = end,
	name       = {{i.name | quote}},
	trackType  = 'GeneRegionTrack',
	table      = 'knownGene',
	track      = 'UCSC Genes',
	rstarts    = 'exonStarts',
	rends      = 'exonEnds',
	gene       = "name",
	symbol     = "name2",
	transcript = "name",
	strand     = "strand"
)
geneParams = c(geneParams, {{args.params | Rlist}})

ret             = list()
ret$trackType   = 'UcscTrack'
ret$trackParams = geneParams

saveRDS (ret, {{o.outfile | quote}})

library(methods)
library(fastLiquidAssociation)
{{rimport}}('__init__.r', 'plot.r')
options(stringsAsFactors = FALSE)
set.seed(8525)

infile   = {{i.infile | R}}
outfile  = {{o.outfile | R}}
outdir   = {{o.outdir | R}}
casefile = {{i.casefile | R}}
inopts   = {{args.inopts | R}}
plotla   = {{args.plot | R}}
pval     = {{args.pval | R}}
dofdr    = {{args.fdr | R}}
fdrfor   = {{args.fdrfor | R}}
devpars  = {{args.devpars | R}}
nthread  = {{args.nthread | R}}
zcat     = {{args.zcat | R}}
ggs      = {{args.ggs | R}}

if (dofdr == T) dofdr = 'BH'

onecase = function(idata, zs, xs = NULL, nthread, zcat, case) {
	ncut   = max(ceiling(nrow(idata)/22), 4)
	inames = colnames(idata)
	z      = na.omit(match(zs, inames))
	x      = ifelse(is.null(xs), NULL, na.omit(match(xs, inames)))
	if (length(z) == 0)
		stop('Find no rows in "Z" group from input file.')
	ret    = fastMLA(
		as.matrix(idata), 
		nvec    = list(z = z, x = x),
		rvalue  = 0.3,
		cut     = ncut,
		zcat    = zcat,
		threads = nthread
	)
	if (nrow(ret) == 0) {
		return(cbind(ret, Pval = double()))
	} else {
		dupFlag = F
		if (nrow(ret) == 1) {
			dupFlag = T
			ret = rbind(ret, ret)
		}
		ret = mass.CNM(data=idata,GLA.mat=ret,nback=max(2, nrow(ret)))$`top p-values`
		ret = ret[, c(1:5, 9), drop = F]
		colnames(ret) = c('X', 'Y', 'Z', 'rhoDiff', 'LA', 'Pval')
		if (dupFlag)
			ret = ret[1,,drop=F]
		ret = cbind(Case = case, ret)
		return(ret)
	}
}

indata = t(read.table.inopts(infile, inopts))
ret = data.frame(
	Case    = character(),
	X       = character(),
	Y       = character(),
	Z       = character(),
	rhoDiff = double(),
	LA      = double(),
	Pval    = double()
)
if (dofdr != FALSE) {
	ret = cbind(ret, Qval = double())
}

casedata = read.table(casefile, header = F, row.names = NULL, check.names = F, sep = "\t")
if (ncol(casedata) == 2)
	casedata$Case = 'Case1'

cases = levels(factor(casedata[,3]))
for (case in cases) {
	cdata = casedata[which(casedata[,3] == case),,drop=F]
	zs    = cdata[which(cdata[,2] == 'Z'), 1]
	xs    = cdata[which(cdata[,2] == 'X'), 1]
	if (length(xs) == 0 || is.na(xs)) xs = NULL
	
	out = onecase(indata, zs, xs, nthread, zcat, case)
	

	if (dofdr != FALSE && fdrfor == 'case') {
		out = cbind(out, Qval = p.adjust(out$Pval, method = dofdr))
	}
	ret = rbind(ret, out)
}
if (dofdr != FALSE && fdrfor == 'all') {
	ret = cbind(ret, Qval = p.adjust(ret$Pval, method = dofdr))
}
ret = ret[ret$Pval < pval,,drop = FALSE]
write.table(pretty.numbers(ret, list(rhoDiff..LA = '%.3f', Pval..Qval = '%.2E')), outfile, col.names = T, row.names = F, sep = "\t", quote = F)

# plot
if (plotla && nrow(ret)>0) {
	ncut = max(ceiling(nrow(indata)/22), 4)
	for (i in 1:nrow(ret)) {
		row = ret[i,]
		plotfile = file.path(outdir, sprintf('%s.%s.', case, paste(row[2:4], collapse = '_')))
		if (!zcat) {
			LiquidAssociation::plotGLA(indata[, unlist(row[2:4]), drop = F], cut = ncut, dim = 3, pch = 4, filen = plotfile, save = T)
		} else {
			plotdata = data.frame(
				X = indata[, row$X], 
				Y = indata[, row$Y],
				Z = as.character(indata[, row$Z]))
			rcase = make.names(row$Z)
			colnames(plotdata) = c(row$X, row$Y, rcase)
			
			subgroups = levels(factor(plotdata[,3]))
			labels = sapply(subgroups, function(m) {
				r = cor(plotdata[plotdata[,3]==m, 1], plotdata[plotdata[,3]==m, 2], use = "pairwise.complete.obs")
				paste0(row$Z, '=', m, ' (r=', round(r, 3), ')')
			})
			ggs1 = c(ggs, list(
				geom_smooth = list(
					aes_string(color = rcase),
					method  = 'lm',
					se      = F
				),
				theme = list(
					legend.position = "bottom"
				),
				guides = list(
					color=guide_legend(ncol=1),
					shape=F
				),
				scale_color_manual = list(
					values = scales::hue_pal()(length(subgroups)), 
					name   = "",
					limit  = subgroups,
					labels = labels
				)
			))
			plot.scatter(
				plotdata, 
				paste0(plotfile, '.png'), 
				x      = 1,
				y      = 2,
				ggs    = ggs1,
				params = list(aes_string(shape = rcase, color = rcase))
			)
		}
	}
}

library(methods)
{{rimport}}('__init__.r', 'plot.r')

indir   = {{i.indir | R}}
outdir  = {{o.outdir | R}}
params  = {{args.params | R}}
cutoff  = {{args.cutoff | R}}
plots   = {{args.plot | R}}
devpars = {{args.devpars | R}}
plink   = {{args.plink | quote}}
nthread = {{args.nthread | R}}
bedfile = Sys.glob(file.path(indir, '*.bed'))
input   = tools::file_path_sans_ext(bedfile)
output  = file.path(outdir, basename(input))

shell$load_config(plink = plink)

params$bfile   = input
params$out     = output
params$threads = nthread

shell$plink(params, .raise = TRUE, .report = TRUE, .fg = TRUE)$reset()

sexcheck_result = paste0(output, '.sexcheck')
if (file.exists(sexcheck_result)) {
	sexcheck = read.table(sexcheck_result, header = T, row.names = NULL, check.names = F)
	sex.sample.fail = sexcheck[which(sexcheck$STATUS == 'PROBLEM'), c('FID', 'IID'), drop=F]
	write.table(sex.sample.fail, paste0(output, '.sex.fail'), col.names = F, row.names = F, sep = "\t", quote = F)
}

hwe_result = paste0(output, '.hwe')
if (file.exists(hwe_result)) {
	hardy = read.table(paste0(output, '.hwe'), header = T, row.names = NULL, check.names = F)
	if (!is.null(cutoff$hardy.hwe)) {
		hardy.fail = hardy[which(hardy$P < cutoff$hardy.hwe), 'SNP', drop = F]
		write.table(hardy.fail, paste0(output, '.hardy.fail'), col.names = F, row.names = F, sep = "\t", quote = F)
	}
	if (is.true(plots$hardy.hwe)) {
		hardy$Pval   = -log10(hardy$P)
		hardy$Status = "Pass"
		ggs          = list()
		if (!is.null(cutoff$hardy.hwe)) {
			hardy[which(hardy$SNP %in% hardy.fail$SNP), "Status"] = "Fail"
			ggs$geom_vline = list(xintercept = -log10(cutoff$hardy.hwe), color = "red", linetype="dashed")
			ggs$geom_text  = list(
				aes(x = -log10(cutoff$hardy.hwe), y = Inf, label = cutoff$hardy.hwe),
				colour="red", angle=90, vjust = 1.2, hjust = 1.2
			)
		}
		ggs$xlab  = list("-log10(HWE p-value)")
		ggs$ylab  = list("Count")
		ggs$theme = list(legend.position = "none")
		plot.histo(
			data     = hardy,
			x        = 'Pval',
			plotfile = paste0(output, '.hardy.png'),
			params   = list(aes(fill=Status), bins = 50),
			ggs      = ggs,
			devpars  = devpars
		)
	}
	if (!is.null(cutoff$hardy.mingt) || is.true(plots$hardy.mingt)) {
		mingt = data.frame(SNP = hardy$SNP)
		gts   = t(as.data.frame(lapply(hardy$GENO, function(x) as.numeric(unlist(strsplit(as.character(x), "/", fixed = TRUE))))))
		mingt$MINGT_NO = apply(gts, 1, function(x) min(x))
		mingt$MINGT    = apply(gts, 1, function(x) min(x)/sum(x))

		if (!is.null(cutoff$hardy.mingt)) {
			if (cutoff$hardy.mingt < 1) {
				mingt.fail = mingt[which(mingt$MINGT < cutoff$hardy.mingt), 'SNP', drop = F]
				write.table(mingt.fail, paste0(output, '.mingt.fail'), col.names = F, row.names = F, sep = "\t", quote = F)
			} else {
				mingt.fail = mingt[which(mingt$MINGT_NO < cutoff$hardy.mingt), 'SNP', drop = F]
				write.table(mingt.fail, paste0(output, '.mingt.fail'), col.names = F, row.names = F, sep = "\t", quote = F)
			}
		}

		if (is.true(plots$hardy.mingt)) {
			mingt$Status = "Pass"
			ggs = list()
			if (!is.null(cutoff$hardy.mingt)) {
				mingt[which(mingt$SNP %in% mingt.fail$SNP), "Status"] = "Fail"
				ggs$geom_vline = list(xintercept = cutoff$hardy.mingt, color = "red", linetype="dashed")
				ggs$geom_text  = list(
					aes(x = cutoff$hardy.mingt, y = Inf, label = cutoff$hardy.mingt),
					colour="red", angle=90, vjust = 1.2, hjust = 1.2
				)
			}
			ggs$xlab  = list("Min_GT")
			ggs$ylab  = list("Count")
			ggs$theme = list(legend.position = "none")
			plot.histo(
				data     = mingt,
				x        = 'MINGT',
				plotfile = paste0(output, '.mingt_rate.png'),
				params   = list(aes(fill=Status), bins = 50),
				ggs      = ggs,
				devpars  = devpars
			)
			plot.histo(
				data     = mingt,
				x        = 'MINGT_NO',
				plotfile = paste0(output, '.mingt_no.png'),
				params   = list(aes(fill=Status), bins = 50),
				ggs      = ggs,
				devpars  = devpars
			)
		}
	}
}

het_result = paste0(output, '.het')
if (file.exists(het_result)) {
	phet = read.table(het_result, header = T, row.names = NULL, check.names = F)
	het = data.frame(Het = 1 - phet[, "O(HOM)"]/phet[, "N(NM)"])
	rownames(het) = paste(phet$FID, phet$IID, sep = "\t")
	if (!is.null(cutoff$het)) {
		het.mean = mean(het$Het, na.rm = T)
		het.sd   = sd(het$Het, na.rm = T)
		het.fail = rownames(het[!is.na(het$Het) & (het$Het < het.mean-cutoff$het*het.sd | het$Het > het.mean+cutoff$het*het.sd),, drop = F])
		writeLines(het.fail, con = file(paste0(output, '.het.fail')))
	}
	if (is.true(plots$het)) {
		het$Status = "Pass"
		ggs        = list()
		if (!is.null(cutoff$het)) {
			het[het.fail, "Status"] = "Fail"
			ggs$geom_vline = list(xintercept = c(het.mean-cutoff$het*het.sd, het.mean+cutoff$het*het.sd), color = "red", linetype="dashed")
			ggs$geom_text  = list(
				aes(x = het.mean-cutoff$het*het.sd, y = Inf, label = sprintf('mean - %ssd (%.3f)', cutoff$het, het.mean - cutoff$het*het.sd)),
				colour="red", angle=90, vjust = 1.2, hjust = 1.2
			)
			ggs$geom_text  = list(
				aes(x = het.mean+cutoff$het*het.sd, y = Inf, label = sprintf('mean + %ssd (%.3f)', cutoff$het, het.mean + cutoff$het*het.sd)),
				colour="red", angle=90, vjust = 1.2, hjust = 1.2
			)
		}
		ggs$xlab       = list("Sample Heterozygosity")
		ggs$ylab       = list("Count")
		ggs$geom_vline = list(xintercept = het.mean, color = "blue", linetype="dashed")
		ggs$theme      = list(legend.position = "none")
		ggs$geom_text  = list(
			aes(x = het.mean, y = Inf, label = sprintf('mean (%.3f)', het.mean)),
			colour="blue", vjust = 1.5, hjust = -.1
		)
		plot.histo(
			data     = het,
			plotfile = paste0(output, '.het.png'),
			params   = list(aes(fill=Status), bins = 50),
			ggs      = ggs,
			devpars  = devpars
		)
	}
}

freq_result = paste0(output, '.frq')
if (file.exists(freq_result)) {
	freq = read.table(freq_result, header = T, row.names = NULL, check.names = F)
	if (!is.null(cutoff$freq)) {
		freq.fail = freq[which(freq$MAF < cutoff$freq), 'SNP', drop = F]
		write.table(freq.fail, paste0(output, '.freq.fail'), col.names = F, row.names = F, sep = "\t", quote = F)
	}
	if (is.true(plots$freq)) {
		freq$Status = "Pass"
		ggs         = list()
		if (!is.null(cutoff$freq)) {
			freq[which(freq$SNP %in% freq.fail$SNP), "Status"] = "Fail"
			ggs$geom_vline = list(xintercept = cutoff$freq, color = "red", linetype="dashed")
			ggs$geom_text  = list(
				aes(x = cutoff$freq, y = Inf, label = cutoff$freq),
				colour="red", angle=90, vjust = 1.2, hjust = 1.2
			)
		}
		ggs$xlab       = list("MAF")
		ggs$ylab       = list("Count")
		ggs$theme      = list(legend.position = "none")
		plot.histo(
			data     = freq,
			x        = 'MAF',
			plotfile = paste0(output, '.freq.png'),
			params   = list(aes(fill=Status), bins = 50),
			ggs      = ggs,
			devpars  = devpars
		)
	}
}

imiss_result = paste0(output, '.imiss')
if (file.exists(imiss_result)) {
	imiss = read.table(imiss_result, header = T, row.names = NULL, check.names = F)
	callrate.sample = data.frame(Callrate = 1-imiss$F_MISS)
	rownames(callrate.sample) = paste(imiss$FID, imiss$IID, sep = "\t")
	if (!is.null(cutoff$missing.sample)) {
		callrate.sample.fail = rownames(callrate.sample[callrate.sample$Callrate < cutoff$missing.sample, , drop = F])
		writeLines(callrate.sample.fail, con = file(paste0(output, '.samplecr.fail')))
	}
	if (is.true(plots$missing.sample)) {
		callrate.sample$Status = "Pass"
		ggs = list()
		if (!is.null(cutoff$missing.sample)) {
			callrate.sample[callrate.sample.fail, "Status"] = "Fail"
			ggs$geom_vline = list(xintercept = cutoff$missing.sample, color = "red", linetype="dashed")
			ggs$geom_text  = list(
				aes(x = cutoff$missing.sample, y = Inf, label = cutoff$missing.sample),
				colour="red", angle=90, vjust = 1.2, hjust = 1.2
			)
		}
		ggs$xlab  = list("Sample Call Rate")
		ggs$ylab  = list("Count")
		ggs$theme = list(legend.position = "none")
		plot.histo(
			data     = callrate.sample,
			plotfile = paste0(output, '.samplecr.png'),
			params   = list(aes(fill=Status), bins = 50),
			ggs      = ggs
		)
	}
}

lmiss_result = paste0(output, '.lmiss')
if (file.exists(lmiss_result)) {
	lmiss = read.table(lmiss_result, header = T, row.names = NULL, check.names = F)
	lmiss$Callrate = 1-lmiss$F_MISS
	if (!is.null(cutoff$missing.snp)) {
		callrate.snp.fail = lmiss[which(lmiss$Callrate < cutoff$missing.snp), 'SNP', drop = F]
		write.table(callrate.snp.fail, paste0(output, '.snpcr.fail'), row.names = F, col.names = F, sep = "\t", quote = F)
	}
	if (is.true(plots$missing.snp)) {
		lmiss$Status = "Pass"
		ggs = list()
		if (!is.null(cutoff$missing.snp)) {
			lmiss[which(lmiss$Callrate < cutoff$missing.snp), "Status"] = "Fail"
			ggs$geom_vline = list(xintercept = cutoff$missing.snp, color = "red", linetype="dashed")
			ggs$geom_text  = list(
				aes(x = cutoff$missing.snp, y = Inf, label = cutoff$missing.snp),
				colour="red", angle=90, vjust = 1.2, hjust = 1.2
			)
		}
		ggs$xlab  = list("SNP Call Rate")
		ggs$ylab  = list("Count")
		ggs$theme = list(legend.position = "none")
		plot.histo(
			data     = lmiss,
			plotfile = paste0(output, '.snpcr.png'),
			x        = 'Callrate',
			params   = list(aes(fill=Status), bins = 50),
			ggs      = ggs,
			devpars  = devpars
		)
	}
}

{% python from os import path %}
library("MatrixEQTL");

{# check if dist is wrongly assign at `args.dist` instead of `args.cisopts.dist`  #}
args = {{args | R}}
if (!is.null(args$dist) && args$cisopts$dist == 0) {
	stop('Set "args.cisopts.dist" instead of "args.dist" to perform cis-eQTL analysis.')
}
snpfile = {{i.snpfile | R}}
expfile = {{i.expfile | R}}
outfile = {{o.outfile | R}}
cisfile = {{o.cisfile | R}}

#snpmatrix = read.table({{i.snpfile | quote}}, sep = "\t", header = T, row.names = 1, check.names = F)
#expmatrix = read.table({{i.expfile | quote}}, sep = "\t", header = T, row.names = 1, check.names = F)
#cnames    = intersect(colnames(snpmatrix), colnames(expmatrix))
#cnames = colnames(expmatrix)
#snpmatrix = snpmatrix[, cnames, drop = F]
#expmatrix = expmatrix[, cnames, drop = F]

snps = SlicedData$new();
snps$fileDelimiter = "\t";       # the TAB character
snps$fileOmitCharacters = "NA";  # denote missing values;
snps$fileSkipRows = 1;           # one row of column labels
snps$fileSkipColumns = 1;        # one column of row labels
snps$fileSliceSize = 10000;      # read file in pieces of 2,000 rows
#snps$CreateFromMatrix( as.matrix(snpmatrix) );
snps$LoadFile( snpfile );

gene = SlicedData$new();
gene$fileDelimiter = "\t";       # the TAB character
gene$fileOmitCharacters = "NA";  # denote missing values;
gene$fileSkipRows = 1;           # one row of column labels
gene$fileSkipColumns = 1;        # one column of row labels
gene$fileSliceSize = 10000;      # read file in pieces of 2,000 rows
#gene$CreateFromMatrix( as.matrix(expmatrix) );
gene$LoadFile( expfile );

cvrt = SlicedData$new();
{% if path.isfile(i.covfile) %}
covmatrix = t(read.table({{i.covfile | quote}}, header = T, row.names = 1, check.names = F))
#covmatrix = covmatrix[, cnames, drop = F]
#cvrt$fileDelimiter = "\t";       # the TAB character
#cvrt$fileOmitCharacters = "NA";  # denote missing values;
#cvrt$fileSkipRows = 1;           # one row of column labels
#cvrt$fileSkipColumns = 1;        # one column of row labels
#cvrt$fileSliceSize = 10000;      # read file in pieces of 2,000 rows
cvrt$CreateFromMatrix( as.matrix(covmatrix) );
{% endif %}

{% if args.cisopts.dist %}
spfile = {{args.cisopts.snppos  | quote}}
gpfile = {{args.cisopts.genepos | quote}}
if (endsWith(spfile, ".bed")) {
	snpspos = read.table(spfile, header = F, sep = '\t', stringsAsFactors = FALSE);
	snpspos = snpspos[, c(4, 1, 2)]
	colnames(snpspos) = c("snp", "chr", "pos")
} else if (endsWith(spfile, ".gff") || endsWith(spfile, ".gtf")) {
	snpspos = read.table(spfile, header = F, sep = '\t', stringsAsFactors = FALSE);
	snpspos = snpspos[, c(9, 1, 4)]
	colnames(snpspos) = c("snp", "chr", "pos")
	snpspos$snp = lapply(snpspos$snp, function(x) for (s in unlist(strsplit(x, '; ', fixed=T))) if (startsWith(s, "gene_id ")) return(substring(s, 9)))
} else {
	snpspos = read.table(spfile, header = TRUE, stringsAsFactors = FALSE);
}
if (endsWith(gpfile, ".bed")) {
	genepos = read.table(gpfile, header = F, sep = '\t', stringsAsFactors = FALSE);
	genepos = genepos[, c(4, 1, 2, 3)]
	colnames(genepos) = c("geneid", "chr", "s1", "s2")
} else if (endsWith(gpfile, ".gff") || endsWith(gpfile, ".gtf")) {
	genepos = read.table(gpfile, header = F, sep = '\t', stringsAsFactors = FALSE);
	genepos = genepos[, c(9, 1, 4, 5)]
	colnames(genepos) = c("geneid", "chr", "s1", "s2")
	genepos$geneid = lapply(genepos$geneid, function(x) for (s in unlist(strsplit(x, '; ', fixed=T))) if (startsWith(s, "gene_id ")) return(substring(s, 9)))
} else {
	genepos = read.table(gpfile, header = TRUE, stringsAsFactors = FALSE);
}

Matrix_eQTL_main(
	snps = snps, 
	gene = gene, 
	cvrt = cvrt, 
	output_file_name = outfile, 
	pvOutputThreshold = {{args.pval}},
	useModel = {{args.model | lambda x: 'r:' + x | R}}, 
	errorCovariance = numeric(), 
	verbose=T, 
	output_file_name.cis  = cisfile,
	pvOutputThreshold.cis = {{args.cisopts.cispv}},
	snpspos = snpspos, 
	genepos = genepos,
	cisDist = {{args.cisopts.dist}},
	noFDRsaveMemory = !{{args.fdr | R}}
)
# if trans-eqtl analysis is not done (args.pval = 0)
if (!file.exists(outfile))
	file.create(outfile)
{% else %}
Matrix_eQTL_engine(
	snps = snps, 
	gene = gene, 
	cvrt = cvrt, 
	output_file_name = outfile, 
	pvOutputThreshold = {{args.pval}}, 
	useModel = {{args.model | lambda x: 'r:' + x | R}}, 
	errorCovariance = numeric(), 
	verbose = T,
	noFDRsaveMemory = !{{args.fdr | R}}
)
file.create(cisfile)
{% endif %}

if (!exists('utils')) {
	# don't load them twice
	# python modkit package makes second load of utils$shell2 raise exceptions
	utils  = reticulate::import('bioprocs', delay_load = TRUE)$utils
	shell  = utils$shell2
	runcmd = shell$runcmd
	mem2   = utils$mem2
}
options(stringsAsFactors = FALSE)

cbindfill = function (...) {
	dfs = list(...)
	ret = Reduce(function(...) {
		ret = merge(..., by='row.names', all=T, sort = F)
		rownames(ret) = ret[, "Row.names"]
		ret = ret[, -1, drop=F]
		ret
	}, dfs)
	cnames = unlist(lapply(dfs, colnames))
	if (length(cnames) > 0) {
		colnames(ret) = make.unique(cnames)
	}
	return (ret)
}

rbindfill = function (...) {
	library(data.table)
	dfs = lapply(list(...), as.data.frame)
	ret = as.data.frame(rbindlist(dfs, fill = T, use.names = T))
	rnames = unlist(lapply(dfs, rownames))
	if (length(rnames) > 0) {
		rownames(ret) = make.unique(rnames)
	}
	return (ret)
}

logger = function(..., level = 'INFO') {
	cat(paste0(level, ': ', paste(...), '\n'), file = stderr())
}

log2pyppl = function(..., level = 'LOG') {
	msg = paste(...)
	if (!endsWith(msg, "\n")) msg = paste0(msg, "\n")
	cat(paste0('pyppl.log.', level, ': ', msg), file = stderr())
}

# avoid typos
cbind.fill = cbindfill
rbind.fill = rbindfill

read.table.nodup = function(...) {
	args = list(...)
	if (!'row.names' %in% names(args) || is.null(args$row.names)) {
		return(read.table(...))
	} else {
		# 'row.names' removed
		args$row.names = NULL
		# get it back
		args = c(args, list(row.names = NULL))
		mat = do.call(read.table, args)
		rnames = make.unique(as.character(as.vector(mat[,1,drop = T])))
		mat = mat[,-1,drop=F]
		row.names(mat)  = rnames
		return(mat)
	}
}

update.list = function (list1, list2, recursive = F) {
	names2 = names(list2)
	for (name in names2) {
		if (is.list(list1[[name]]) && is.list(list2[[name]]) && recursive) {
			list1[[name]] = update.list(list1[[name]], list2[[name]], recursive = recursive)
		} else {
			list1[[name]] = list2[[name]]
		}
	}
	return (list1)
}

# allow ifelse to return NULL
ifelse = function(condition, true, false) {
	if(condition) return(true)
	return(false)
}

read.table.inopts = function(infile, inopts) {
	inopts.default = function(key, default) list.get(inopts, key, default, check.names = TRUE)
	optrnames = inopts.default('rnames', TRUE)
	dup = inopts$dup
	try = list.get(inopts, 'try', FALSE)
	inopts$dup = NULL
	params = list(
		infile,
		#header      = ifelse('cnames' %in% opts, inopts$cnames, T),
		header      = inopts.default('cnames', TRUE),
		row.names   = ifelse(!is.null(dup), NULL, ifelse(optrnames, 1, NULL)),
		sep         = inopts.default('delimit', "\t"),
		check.names = F,
		quote       = inopts.default('quote', ""),
		skip        = inopts.default('skip', 0)
	)
	inopts$cnames  = NULL
	inopts$rnames  = NULL
	inopts$delimit = NULL
	inopts$quote   = NULL
	inopts$skip    = NULL
	params = c(params, inopts)
	if (!try) {
		d = do.call(read.table, params)
	} else {
		d = tryCatch({do.call(read.table, params)}, error = function(e) {
			logger('Error encountered while read file:', infile, level = 'WARNING')
			logger(e, level = 'WARNING')
			return (NULL)
		})
	}
	if (is.null(dup) || !optrnames || is.null(d)) {
		#return (d)
	} else {
		rnames = as.character(as.vector(d[,1,drop = T]))
		if (dup == 'drop') {
			rindex = !duplicated(rnames)
			d = d[rindex, -1, drop = FALSE]
			rownames(d) = rnames[rindex]
		} else if (dup == 'mean') {
			d = aggregate(d[,-1,drop=FALSE], by = list(rnames), FUN = mean)
			rownames(d) = as.character(d[,1,drop=TRUE])
			d = d[,-1,drop=FALSE]
		} else  { # keep
			rownames(d) = make.unique(rnames)
			d = d[,-1,drop = FALSE]
		}
	}
	d
}

write.xls = function(x, file, ...) {
	rnames         = rownames(x)
	args           = list(...)
	args$quote     = list.get(args, 'quote', FALSE)
	args$sep       = list.get(args, 'sep', "\t")
	args$row.names = list.get(args, 'row.names', TRUE)
	if (!is.null(rnames) && args$row.names == TRUE) {
		cnames = colnames(x)
		x = cbind(`.` = rnames, x)
		colnames(x) = c('.', cnames)
		args$row.names = FALSE
	}
	do.call(write.table, c(list(x, file), args))
}

# format data.frame to output
pretty.numbers = function(df, formats) {
	# remember set stringsAsFactors as FALSE for the dataframe!!
	if (nrow(df) == 0) {
		return(df)
	}
	allCols      = colnames(df)
	formatedCols = c()
	for (fcols in names(formats)) {
		if (fcols == '.') { # must be last element of formats
			cols = which(!allCols %in% formatedCols)
		} else {
			cols = unlist(strsplit(fcols, '..', fixed = T))
			formatedCols = c(formatedCols, cols)
		}
		cols = intersect(cols, allCols)
		df[, cols] = sprintf(formats[[fcols]], as.numeric(unlist(df[, cols])))
	}
	df
}

# format data.frame to output
pretty.numbers2 = function(df, ...) {
	formats = list(...)
	df = as.data.frame(df)
	if (nrow(df) == 0)
		return(df)

	allCols      = colnames(df)
	if (is.null(allCols))
		allCols = 1:ncol(df)
	formatedCols = c()
	for (fcols in names(formats)) {
		if (fcols == '.') { # must be last element of formats
			if (length(formatedCols) == 0) {
				cols = allCols
			} else {
				cols = which(!allCols %in% formatedCols)
			}
		} else {
			cols = unlist(strsplit(fcols, '..', fixed = T))
			formatedCols = c(formatedCols, cols)
		}
		cols = intersect(cols, allCols)
		df[, cols] = sprintf(formats[[fcols]], as.numeric(unlist(df[, cols])))
	}
	df
}

is.installed = function(pkg) {
	is.element(pkg, installed.packages()[,1])
}

.bQuote = function(s) {
	if (startsWith(s, '`') && endsWith(s, '`')) {
		return (s)
	} else {
		paste0('`', s, '`')
	}
}
bQuote = Vectorize(.bQuote)

.nobQuote = function(s) {
	if (!startsWith(s, '`') || !endsWith(s, '`'))
		return(s)
	return (substring(s, 2, nchar(s) - 1))
}
nobQuote = Vectorize(.nobQuote)

is.true = function(x, collapse = 'all') {
	if (is.null(x)) return (FALSE)
	if (length(x) == 0) return (FALSE)
	if (length(x) == 1) {
		if (is.na(x)) return (FALSE)
		if (is.list(x)) return (TRUE)
		if (is.character(x)) return (nchar(x) > 0)
		tryCatch({
			x = as.logical(x)
		}, error = function(e){
			x <<- TRUE
		})
		if (is.na(x)) return (TRUE)
		return (x)
	} else if (collapse == 'all') {
		for (i in x) {
			if (!is.true(i, 'any')) return (FALSE)
		}
		return (TRUE)
	} else {
		for (i in x) {
			if (is.true(i, 'any')) return (TRUE)
		}
		return (FALSE)
	}
}

is.false = function(x, collapse = 'all') {
	!is.true(x, ifelse(collapse == 'all', 'any', 'all'))
}

list.get = function(l, key, default = NULL, check.names = FALSE) {
	# get the value of a key in list with default
	# @params:
	#	`l`: The list
	#	`key`: The key
	#	`default`: The default value. Default: `NULL`
	#	`check.names`: Check whether the name exists, even with value `NULL`. Default: `FALSE`
	#		- `list.get(list(a = NULL), 'a', default = 1, check.names = TRUE) == NULL`
	#		- `list.get(list(a = NULL), 'a', default = 1, check.names = FALSE) == 1`
	if (!check.names) {
		ifelse(is.null(l[[key]]), default, l[[key]])
	} else {
		ns = names(l)
		if (key %in% ns)
			return (l[[key]])
		return (default)
	}
}

{{rimport}}('__init__.r', 'plot.r')
pdf(NULL) # preventing Rplot.pdf in cwd
library(ggpubr)
# usage: https://cran.r-project.org/web/packages/egg/vignettes/Ecosystem.html

options(stringsAsFactors=FALSE)
infile  = {{i.infile | R}}
outdir  = {{o.outdir | R}}
inopts  = {{args.inopts | R}}
types   = {{args.types | R}}
groups  = {{args.groups | R}}
ignore  = {{args.ignore | R}}
devpars = {{args.devpars | R}}
devpars2 = devpars
devpars2$width = 2*devpars$width

indata = read.table.inopts(infile, inopts)
ninst  = nrow(indata)


do_continuous = function (feat, groups, outdir) {
	#histp = plot.histo(data, 'return')
	statfile = file.path(outdir, paste0('feature-stat.', feat, '.txt'))
	testfile = file.path(outdir, paste0('feature-test.', feat, '.txt'))
	densfile = file.path(outdir, paste0('feature-plot.', feat, '.png'))
	statdata = data.frame()
	fdata = as.numeric(indata[, feat])
	statdata = rbind(statdata, list(
		Group  = '__ALL__',
		N      = ninst,
		Max    = max(fdata, na.rm = TRUE),
		Min    = min(fdata, na.rm = TRUE),
		Mean   = mean(fdata, na.rm = TRUE),
		Median = median(fdata, na.rm = TRUE),
		Sd     = sd(fdata, na.rm = TRUE)
	))
	testdata = data.frame()
	densdata = data.frame(values = fdata, Group = '__ALL__')
	colnames(densdata)[1] = feat
	for (grup in groups) {
		if (grup == feat) {next}
		lvls = levels(factor(indata[, grup]))
		for (lvl in lvls) {
			lvldata = as.numeric(indata[indata[, grup] == lvl, feat])
			densdf  = data.frame(values = lvldata, Group = paste0(grup, '[', lvl ,']'))
			colnames(densdf)[1] = feat
			densdata = rbind(densdata, densdf)
			statdata = rbind(statdata, data.frame(
				Group  = paste0(grup, ' [', lvl, ']'),
				N      = length(lvldata),
				Max    = max(lvldata, na.rm = TRUE),
				Min    = min(lvldata, na.rm = TRUE),
				Mean   = mean(lvldata, na.rm = TRUE),
				Median = median(lvldata, na.rm = TRUE),
				Sd     = sd(lvldata, na.rm = TRUE),
				check.names = FALSE))
		}
		# t, wilcox, anova, Kruskal-Wallis
		t = NULL
		tryCatch({
			t = t.test(fdata ~ indata[, grup])
		}, error = function(e) {
			t = list(p.value = '-')
		})
		w = NULL
		tryCatch({
			w = wilcox.test(fdata ~ indata[, grup])
		}, error = function(e) {
			w = list(p.value = '-')
		})
		a = summary(aov(fdata ~ indata[, grup]))[[1]]
		k = kruskal.test(fdata ~ indata[, grup])

		testdata = rbind(testdata, data.frame(
			Group = paste0(grup, ' [', paste(lvls, collapse = ', ') ,']'),
			t.test = paste0('p=', ifelse(is.numeric(t$p.value), round(t$p.value, 3), t$p.value)),
			wilcox.test = paste0('p=', ifelse(is.numeric(w$p.value), round(w$p.value, 3), w$p.value)),
			ANOVA = paste0('p=', round(a[1,5], 3)),
			Kruskal.Wallis.test = paste0('p=', round(k$p.value, 3)),
		check.names = FALSE))
	}
	# align the violin and boxplot
	dodge = ggplot2::position_dodge(width = 0.4)
	densplot = plot.density(densdata, 'return', devpars = devpars)
	vioplot = plot.violin(densdata, 'return', devpars = devpars, ggs = list(geom_boxplot = list(
		position = dodge,
		width = .1
	)), params = list(position = dodge))

	p = ggarrange(densplot, vioplot, ncol = 2)
	save.plot(p, densfile, devpars2)
	write.table(statdata, statfile, row.names = FALSE, col.names = TRUE, quote = FALSE, sep = "\t")
	if (nrow(testdata)) {
		write.table(testdata, testfile, row.names = FALSE, col.names = TRUE, quote = FALSE, sep = "\t")
	}
}

.count.levels = function(fdata, flevels) {
	counts = as.list(table(fdata))
	cnames = names(counts)
	ret = list()
	for (lvl in flevels) {
		ret[[lvl]] = ifelse(lvl %in% cnames, counts[[lvl]], 0)
	}
	ret
}

do_categorical = function(feat, groups, outdir) {
	# contingency tables
	statfile = file.path(outdir, paste0('feature-stat.', feat, '.txt'))
	testfile = file.path(outdir, paste0('feature-test.', feat, '.txt'))
	densfile = file.path(outdir, paste0('feature-plot.', feat, '.png'))
	fdata    = indata[, feat]
	flevels  = levels(fdata)
	statdata = data.frame(Group = '__ALL__')
	statdata = cbind(statdata, as.data.frame(.count.levels(fdata, flevels)))

	testdata = data.frame()
	for (grup in groups) {
		if (grup == feat) {next}
		lvls = levels(factor(indata[, grup]))
		for (lvl in lvls) {
			lvldata = indata[indata[, grup] == lvl, feat]

			counts = c(list(Group = paste0(grup, '[', lvl ,']')), .count.levels(lvldata, flevels))
			statdata = rbind(statdata, as.data.frame(counts))
		}
		# chi-squre, fisher exact
		csq = chisq.test(table(fdata, indata[, grup]))
		fex = fisher.test(table(fdata, indata[, grup]))

		testdata = rbind(testdata, data.frame(
			Group = paste0(grup, ' [', paste(lvls, collapse = ', ') ,']'),
			chi.squared.test = paste0('p=', round(csq$p.value, 3)),
			fisher.exact.test = paste0('p=', round(fex$p.value, 3)),
		check.names = FALSE))
	}

	plot.col(indata[, c(feat, grup), drop = FALSE], densfile, x = 2,
		params = list(ggplot2::aes_string(fill = feat)))
	write.table(statdata, statfile, row.names = FALSE, col.names = TRUE, quote = FALSE, sep = "\t")
	if (nrow(testdata)) {
		write.table(testdata, testfile, row.names = FALSE, col.names = TRUE, quote = FALSE, sep = "\t")
	}
}

features = make.names(colnames(indata))
colnames(indata) = features
features = setdiff(features, make.names(ignore))


# top 10 records of the data
write.table(
	indata[1:10, features, drop=FALSE],
	file.path(outdir, {{i.infile | stem | @append: ".top10.txt" | quote}}),
	row.names = inopts$rnames,
	col.names = inopts$cnames,
	sep = inopts$delimit,
	quote = FALSE)

for (grup in groups) {
	indata[, grup] = as.factor(as.character(indata[, grup]))
}
for (feat in features) {
	ftype = list.get(types, feat, 'auto')
	if (feat %in% groups) {
		ftype = 'categorical'
	} else if (ftype == 'auto') {
		lvls  = levels(factor(indata[, feat]))
		if (length(lvls) < 10 && length(lvls) < ninst * .8) {
			ftype = 'categorical'
		} else {
			lvls = as.numeric(indata[, feat])
			if (sum(is.na(lvls)) >= ninst * .9) {
				ftype = 'categorical'
			} else {
				ftype = 'continuous'
			}
		}
	}
	ftype = ifelse(startsWith(ftype, 'cont'), 'continuous', 'categorical')
	if (ftype == 'categorical') {
		indata[, feat] = as.factor(as.character(indata[, feat]))
	}
	do.call(paste0('do_', ftype), list(feat = feat, groups = make.names(groups), outdir = outdir))
}

{{rimport}}('__init__.r', 'plot.r')

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
outdir  = {{o.outdir | R}}
inopts  = {{args.inopts | R}}
params  = {{args.params | R}}
devpars = {{args.devpars | R}}
ggs     = {{args.ggs | R}}

indata = read.table.inopts(infile, inopts)

plotfile = file.path(outdir, '{{i.infile | stem}}.roc.png')
aucfile = file.path(outdir, '{{i.infile | stem}}.roc.txt')
params$returnTable = TRUE
ret = plot.roc(indata, plotfile, stacked = FALSE, params = params, ggs = ggs, devpars = devpars)
write.table(
	ret$table,
	aucfile,
	sep       = "\t",
	quote     = FALSE,
	col.names = TRUE,
	row.names = FALSE)

library(methods)
library(data.table)
{{rimport}}('__init__.r', 'plot.r')

indir  = {{i.indir | R}}
outdir = {{o.outdir | R}}

plink    = {{args.plink | R}}
indep    = {{args.indep | R}}
highld   = {{args.highld | R}}
devpars  = {{args.devpars | R}}
pihat    = {{args.pihat | R}}
samid    = {{R(args.samid) if not args.samid.startswith("function") else args.samid}}
annofile = {{args.anno | R}}
doplot   = {{args.plot | R}}
seed     = {{args.seed | R}}

shell$load_config(plink = plink)
bedfile = Sys.glob(file.path(indir, '*.bed'))
input   = tools::file_path_sans_ext(bedfile)
output  = file.path(outdir, basename(input))

params = list(
	bfile            = input,
	exclude          = highld,
	range            = T,
	`indep-pairwise` = indep,
	out              = output
)
shell$plink(params, .raise = TRUE, .report = TRUE, .fg = TRUE)$reset()

prunein = paste0(output, '.prune.in')
params = list(
	bfile   = input,
	extract = prunein,
	genome  = T,
	out     = output
)
shell$plink(params, .raise = TRUE, .report = TRUE, .fg = TRUE)$reset()

genome = read.table(paste0(output, '.genome'), row.names = NULL, header = T, check.names = F)
# "unmelt" it
# FID1 IID1 FID2 IID2 RT EZ Z0     Z1     Z2     PI_HAT PHE DST      PPC    RATIO
# s1   s1   s2   s2   UN NA 1.0000 0.0000 0.0000 0.0000 -1  0.866584 0.0000 0.9194
# s1   s1   s2   s2   UN NA 0.4846 0.3724 0.1431 0.3293 -1  0.913945 0.7236 2.0375
# s1   s1   s3   s3   UN NA 1.0000 0.0000 0.0000 0.0000 -1  0.867186 0.0000 1.0791
genome$SAMPLE1 = paste(genome$FID1, genome$IID1, sep = "\t")
genome$SAMPLE2 = paste(genome$FID2, genome$IID2, sep = "\t")


# get all samples
samples    = unique(c(genome$SAMPLE1, genome$SAMPLE2))
# make paired into a distance-like matrix
similarity = dcast(genome, SAMPLE1 ~ SAMPLE2, value.var = "PI_HAT")
rm(genome)
# get the rownames back
samids = unlist(similarity[, 1, drop = TRUE])
rownames(similarity) = samids
similarity = similarity[, -1, drop = F]
# get samples that didn't involved
missedrow  = setdiff(samples, rownames(similarity))
missedcol  = setdiff(samples, colnames(similarity))
similarity[missedrow, ] = NA
similarity[, missedcol] = NA
# order the matrix
similarity = similarity[samples, samples, drop = F]
# transpose the matrix to get the symmetric values
sim2 = t(similarity)
isna = is.na(similarity)
# fill the na's with their symmetric values
similarity[isna] = sim2[isna]
rm(sim2)
# still missing: keep them
similarity[is.na(similarity)] = 0
# get the marks (samples that fail the pihat cutoff)
nsams = length(samples)
fails = which(similarity > pihat)
marks = data.frame(x = (fails - 1)%%nsams + 1, y = ceiling(fails/nsams))
diag(similarity) = 1

failflags = rep(F, nrow(marks))
freqs     = as.data.frame(table(factor(as.matrix(marks))))
freqs     = freqs[order(freqs$Freq, decreasing = T), 'Var1', drop = T]
ibd.fail  = c()
while (sum(failflags) < nrow(marks)) {
	samidx   = freqs[1]
	ibd.fail = c(ibd.fail, samples[samidx])
	freqs    = freqs[-1]
	sapply(1:nrow(marks), function(i) {
		if (samidx %in% marks[i,])
			failflags[i] <<- T
	})
}
if (!is.null(ibd.fail))
	writeLines(ibd.fail, con = file(paste0(output, '.ibd.fail')))

if (doplot) {
	set.seed(seed)
	library(ComplexHeatmap)
	fontsize8 = gpar(fontsize = 8)
	fontsize9 = gpar(fontsize = 9)
	ht_opt$heatmap_row_names_gp    = fontsize8
	ht_opt$heatmap_column_names_gp = fontsize8
	ht_opt$legend_title_gp         = fontsize9
	ht_opt$legend_labels_gp        = fontsize8
	ht_opt$simple_anno_size        = unit(3, "mm")

	samids = sapply(samples, function(sid) {
		fidiid = unlist(strsplit(sid, "\t", fixed = TRUE))
		if (is.function(samid)) {
			do.call(samid, as.list(fidiid))
		} else {
			gsub("fid", fidiid[1], gsub("iid", fidiid[2], samid))
		}
	})
	rownames(similarity) = samids
	colnames(similarity) = samids

	annos = list()
	if (is.true(annofile)) {
		options(stringsAsFactors = TRUE)
		andata = read.table.inopts(annofile, list(cnames = TRUE, rnames = TRUE))
		andata = andata[samids,,drop = FALSE]
		for (anname in colnames(andata)) {
			annos[[anname]] = as.matrix(andata[, anname])
		}
		annos$annotation_name_gp = fontsize8
		annos = do.call(HeatmapAnnotation, annos)
	}

	params = list(
		name = "PI_HAT",
		cell_fun = function(j, i, x, y, width, height, fill) {
			if (similarity[i, j] > pihat && i != j)
				grid.points(x, y, pch = 4, size = unit(.5, "char"))
		},
		#heatmap_legend_param = list(
		#	title_gp  = fontsize9,
		#	labels_gp = fontsize8
		#),
		clustering_distance_rows = function(m) as.dist(1-m),
		clustering_distance_columns = function(m) as.dist(1-m),
		top_annotation = if (length(annos) == 0) NULL else annos
	)

	plot.heatmap2(
		similarity,
		paste0(output, '.ibd.png'),
		params = params,
		draw = list(
			annotation_legend_list = list(
				Legend(
					labels = paste(">", pihat),
					title = "",
					type = "points",
					pch = 4,
					title_gp = fontsize9,
					labels_gp = fontsize8)),
			merge_legend = TRUE),
		devpars = devpars)
}

{{rimport}}('plot.r', '__init__.r')

library(ggplot2) # make aes available

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
cnames  = {{args.cnames | R }}  # required to be TRUE
rnames  = {{args.rnames | R }}
devpars = {{args.devpars | R}}
x       = {{args.x | repr}}
y       = {{args.y | repr}}

data = read.table(infile, header = cnames, row.names = if (rnames) 1 else NULL, sep = '\t', check.names = F)
if (!is.na(as.numeric(x))) x = as.integer(x)
if (!is.na(as.numeric(y))) y = as.integer(y)
cnames = colnames(data)
m1 = if (is.numeric(x)) cnames[x] else x
m2 = if (is.numeric(y)) cnames[y] else y

data$.group = apply(data[,c(x, y)], 1, function(row) if(row[1]>row[2]) m1 else if (row[1]<row[2]) m2 else 'None')

eval(parse(text = {{args.helper | repr}}))
params  = {{args.params | R}}
ggs     = {{args.ggs | R}}

if ("mapping" %in% names(params)) {
	params$mapping = update.list(aes(color = .group), params$mapping)
} else if ('' %in% names(params)) {
	params[[1]] = update.list(aes(color = .group), params[[1]])
} else {
	params$mapping = aes(color = .group)
}

# plot diagonal line and legend
ggs = c(
	list(
		geom_abline = list(intercept = 0, slop = 1),
		scale_color_discrete = list(name = 'Winner')
	),
	ggs
)

plot.scatter(data, outfile, x, y, params, ggs, devpars = devpars)

{{rimport}}('__init__.r')

infile  = {{i.infile | R}}
outdir  = {{o.outdir | R}}
params  = {{args.params | R}}
inopts  = {{args.inopts | R}}
size    = as.numeric({{args.size | R}})

inparams = list(
	file      = infile,
	header    = as.logical(inopts$cnames),
	row.names = if (as.logical(inopts$rnames)) 1 else NULL,
	skip      = if (is.null(inopts$skip)) 0 else as.numeric(inopts$skip),
	sep       = inopts$delimit
)

mat   = do.call(read.table.nodup, c(inparams, params))
heads = if (as.logical(inopts$cnames)) colnames(mat) else paste0("COL", 1:ncol(mat))

for ( chunk in split(1:length(heads), ceiling(seq_along(1:length(heads))/size)) ) {
	cnames    = heads[chunk]
	m         = mat[, cnames, drop = F]
	fn        = paste(gsub("[[:punct:]]", "_", cnames), collapse='-')
	fn        = paste0({{i.infile | fn2 | quote}}, '.', fn, {{i.infile | ext | quote}})
	outfile   = file.path(outdir, fn)
	outparams = list(
		x         = m,
		file      = outfile,
		sep       = inopts$delimit,
		quote     = F,
		col.names = as.logical(inopts$cnames),
		row.names = as.logical(inopts$rnames)
	)
	do.call(write.table, outparams)
}

infile   = {{i.infile    | quote}}
outfile  = {{o.outfile  | quote}}
obsvfile = {{o.obsvfile | quote}}
exptfile = {{o.exptfile | quote}}

{% if args.intype == 'cont' %}

#
#         | Disease | Healthy |
# --------+---------+---------+
#   mut   |   40    |   12    |
# non-mut |   23    |   98    |
# --------+---------+---------+
#
cont.table = read.table(infile, sep = "\t", header = T, row.names = 1, check.names = F)

{% else %}

#
# Contingency table rows: Mut, Non
# Contingency table cols: Disease, Healthy
# 
#         | S1 | S2 | ... | Sn |
# --------+----+----+-----+----+
# Disease | 1  | 0  | ... | 1  |
# Healthy | 0  | 1  | ... | 0  |
# --------+----+----+-----+----+
# Mut     | 1  | 0  | ... | 1  |
# Non     | 0  | 1  | ... | 0  |
#
ct.cnames = c()
ct.rnames = c()
{% if isinstance(args.ctcols, list) %}
ct.cnames = {{args.ctcols}}
{% elif args.ctcols %}
ct.cnames = {{args.ctcols | lambda x: [y.strip() for y in x.split(',') if y.strip()]}}
{% else %}
trim  = Vectorize(function (x) gsub("^\\s+|\\s+$", "", x))
lines = readLines(infile, n = 2)
for (line in lines) {
	if (!startsWith(line, '# Contingency table ')) next
	if (startsWith(line, '# Contingency table cols:')) {
		ct.cnames = trim(unlist(strsplit(substring(line, 26), ',', fixed = T)))
	} 
	else if (startsWith(line, '# Contingency table rows:')) {
		ct.rnames = trim(unlist(strsplit(substring(line, 26), ',', fixed = T)))
	}
}
{% endif %}

raw.data   = read.table(infile, sep = "\t", header = T, row.names = 1, check.names = F)
# generate contingency table
if (length(ct.rnames) == 0 && length(ct.cnames) == 0) {
	stop('No row names and col names specified for contingency table.')
}
if (length(ct.rnames) == 0) {
	ct.rnames = setdiff(rownames(raw.data), ct.cnames)
}
if (length(ct.cnames) == 0) {
	ct.cnames = setdiff(rownames(raw.data), ct.rnames)
}

# transposed cont.table
cont.table = matrix(NA, ncol = length(ct.cnames), nrow = length(ct.rnames))
colnames(cont.table) = ct.cnames
rownames(cont.table) = ct.rnames
# get the number of each contingency cell
for (rname in ct.rnames) {
	for (cname in ct.cnames) {
		tmp1 = raw.data[rname, ] == 1
		tmp2 = raw.data[cname, ] == 1
		tmp  = tmp1 & tmp2
		cont.table[rname, cname] = length(tmp[tmp])
	}
}
{% endif %}

# further parameters may be introduced, but for now just use defaults
ret = chisq.test(cont.table)
out = data.frame(Xsquare = ret$statistic, df = ret$parameter, pval = ret$p.value, method = ret$method)

#
# Xsquare 1.706667
# df  1
# pval    0.1914184
# method  Pearson's Chi-squared test with Yates' continuity correction
#
write.table(t(out), outfile, col.names = F, sep = "\t", quote = F)
write.table(ret$observed, obsvfile, sep = "\t", quote = F)
write.table(ret$expected, exptfile, sep = "\t", quote = F)

# Adopted from GSEA R package (GSEA.Gct2Frame2), read the GCT file
readGCT <- function(filename = "NULL") {
      content <- readLines(filename)
      content <- content[-1]
      content <- content[-1]
      col.names <- noquote(unlist(strsplit(content[1], "\t")))
      col.names <- col.names[c(-1, -2)]
      num.cols <- length(col.names)
      content <- content[-1]
      num.lines <- length(content)


      row.nam <- vector(length=num.lines, mode="character")
      #row.des <- vector(length=num.lines, mode="character")
      m <- matrix(0, nrow=num.lines, ncol=num.cols)

      for (i in 1:num.lines) {
         line.list <- noquote(unlist(strsplit(content[i], "\t")))
         row.nam[i] <- noquote(line.list[1])
         #row.des[i] <- noquote(line.list[2])
         line.list <- line.list[c(-1, -2)]
         for (j in 1:length(line.list)) {
            m[i, j] <- as.numeric(line.list[j])
         }
      }
      ds <- data.frame(m)
      names(ds) <- col.names
      row.names(ds) <- row.nam
      return(ds)
}

readGMT <- function (filename = "NULL") {
	temp = readLines (filename)
	max.Ng <- length(temp)
	gs = list()
	for (i in 1:max.Ng) {
		line = unlist(strsplit(temp[[i]], "\t"))
		name = make.names(line[1])
		line = line [-1]
		line = line [-1] # desc
		gs[[name]] = line

	}

	return (gs)
}

# Calculate ES score, adopted from GSEA R package (GSEA.EnrichmentScore)
EnrichmentScore <- function(gene.list, gene.set, weighted.score.type = {{args.weightexp}}, correl.vector = NULL) {
	tag.indicator <- sign(match(gene.list, gene.set, nomatch=0))    # notice that the sign is 0 (no tag) or 1 (tag)
	no.tag.indicator <- 1 - tag.indicator
	N <- length(gene.list)
	Nh <- length(gene.set)
	Nm <-  N - Nh
	if (weighted.score.type == 0) {
		correl.vector <- rep(1, N)
	}
	alpha <- weighted.score.type
	correl.vector <- abs(correl.vector**alpha)
	sum.correl.tag    <- sum(correl.vector[tag.indicator == 1])
	norm.tag    <- 1.0/sum.correl.tag
	norm.no.tag <- 1.0/Nm
	RES <- cumsum(tag.indicator * correl.vector * norm.tag - no.tag.indicator * norm.no.tag)
	max.ES <- max(RES)
	min.ES <- min(RES)
	if (is.na(max.ES) || is.na(min.ES)) {
		return(list(ES = 0, arg.ES = 1, RES = RES, indicator = tag.indicator))
	}
	if (max.ES > - min.ES) {
	#      ES <- max.ES
		ES <- signif(max.ES, digits = 5)
		arg.ES <- which.max(RES)
	} else {
	#      ES <- min.ES
		ES <- signif(min.ES, digits=5)
		arg.ES <- which.min(RES)
	}
	return(list(ES = ES, arg.ES = arg.ES, RES = RES, indicator = tag.indicator))
}

ESPlot = function (es, gs, outprefix) {
	for (gset in names(es)) {
		png (filename = paste (outprefix, make.names(gset), ".png", sep="", collapse = ""), type="cairo")
		esret = es [[gset]][[1]]
		N = length(esret$indicator)
		sub.string <- paste("Number of genes: ", N, " (in list), ", length(gs[[gset]]), " (in gene set)", sep = "", collapse="")

		main.string <- paste("Gene Set: ", gset)
		minRES = min (esret$RES)
		maxRES = max (esret$RES)
		if (is.na(maxRES) || maxRES < 0.3) maxRES <- 0.3
		if (is.na(minRES) || minRES > -0.3) minRES <- -0.3
		delta <- (maxRES - minRES)*.5
		minplot <- minRES - delta
		maxplot <- maxRES
		col <- ifelse(esret$ES > 0, 2, 4)
		plot(1:N, esret$RES, main = main.string, sub = sub.string, xlab = "Gene List Index", ylab = "Running Enrichment Score (RES)", xlim=c(1, N), ylim=c(minplot, maxplot), type = "l", lwd = 2, cex = 1, col = col)

		rect (0, minplot, N, minplot + 0.5*delta, col=rgb(255, 250, 230, maxColorValue=255), border=NA, lwd=0)
		lines(c(1, N), c(0, 0), lwd = 1, lty = 2, cex = 1, col = 1) # zero RES line
		lines(c(esret$arg.ES, esret$arg.ES), c(minplot, maxplot), lwd = 1, lty = 3, cex = 1, col = col) # max enrichment vertical line
		for (j in 1:N) {
			if (esret$indicator[j] == 1) {
				lines(c(j, j), c(minplot, minplot + 0.5*delta), lwd = 1, lty = 1, cex = 1, col = 1)  # enrichment tags
			}
		}


		adjx <- ifelse(esret$ES > 0, 0, 1)

		leg.txt <- paste("Peak at ", esret$arg.ES, sep="", collapse="")
		text(x=esret$arg.ES, y=minplot + 1.8*delta, adj = c(adjx, 0), labels=leg.txt, cex = 1.0)
		dev.off()
	}
}

NPvalPlot = function (es, outprefix) {
	Ns = length(es[[1]])
	NESret = vector (length = 0, mode = "numeric")
	for (gset in names(es)) {
		png (filename = paste (outprefix, make.names(gset), ".png", sep="", collapse = ""), type="cairo")
		esrets = es [[gset]]
		nes = esrets[[1]]$ES / mean (esrets[[1]]$RES[esrets[[1]]$RES > 0])
		NESret = c (NESret, nes)
		if (esrets[[1]]$ES < 0) {
			nes = - esrets[[1]]$ES / mean (esrets[[1]]$RES[esrets[[1]]$RES < 0])
		}
		#sub.string <- paste("ES =", signif(esrets[[1]]$ES, digits = 3), ", NES =", signif(nes, digits=3), ", Nom. p-val=", signif(esrets[[1]]$p, digits = 3), ", FDR=", signif(esrets[[1]]$q, digits = 3), sep="", collapse="")
		sub.string <- paste("ES =", signif(esrets[[1]]$ES, digits = 3), ", NES =", signif(nes, digits=3), ", Nom. p-val=", signif(esrets[[1]]$p, digits = 3), sep="", collapse="")

		phi = vector (length = Ns, mode = "numeric")
		for (i in 1:Ns) {
			phi[i] = esrets[[i]]$ES
		}

		temp <- density(phi, adjust=.5)
		x.plot.range <- range(temp$x)
		y.plot.range <- c(-0.125*max(temp$y), 1.5*max(temp$y))
		plot(temp$x, temp$y, type = "l", sub = sub.string, xlim = x.plot.range, ylim = y.plot.range, lwd = 2, col = 2, main = "Gene Set Null Distribution", xlab = "ES", ylab="P(ES)")
		x.loc <- which.min(abs(temp$x - esrets[[1]]$ES))
		lines(c(esrets[[1]]$ES, esrets[[1]]$ES), c(0, temp$y[x.loc]), lwd = 2, lty = 1, cex = 1, col = 1)
		lines(x.plot.range, c(0, 0), lwd = 1, lty = 1, cex = 1, col = 1)

		leg.txt <- c("Gene Set Null Density", "Observed Gene Set ES value")
		c.vec <- c(2, 1)
		lty.vec <- c(1, 1)
		lwd.vec <- c(2, 2)
		legend(x=-0.2, y=y.plot.range[2], bty="n", bg = "white", legend=leg.txt, lty = lty.vec, lwd = lwd.vec, col = c.vec, cex = 1.0)
		dev.off()
	}
	return (NESret)
}

ESWithPerm = function (exp, gs, nperm = {{args.nperm}}) {
  exp      = exp[order(-exp[,1]),,drop=F]
  corrVec  = c (exp[,1])

  geneList = rownames(exp)
  ret = list()
  for (gset in names(gs)) {
    ess = vector (length = nperm, mode = "numeric")
    ret[[ gset ]] = vector (length = nperm, mode = "list")
    ret[[ gset ]][[1]] = EnrichmentScore (geneList, gs[[gset]], correl.vector = corrVec)
    ret[[ gset ]][[1]]$hits = geneList[as.logical(ret[[ gset ]][[1]]$indicator)]
    ess[1] = ret[[ gset ]][[1]]$ES
    for (i in 1:(nperm-1)) {
      geneList1 = sample(geneList)
      ret[[ gset ]][[i+1]] = EnrichmentScore (geneList1, gs[[gset]], correl.vector = corrVec)
      #ret[[ gset ]][[i+1]]$hits = geneList1[as.logical(ret[[ gset ]][[i+1]]$tag.indicator)]
      ess[i+1] = ret[[ gset ]][[i+1]]$ES
    }
    #ess.sorted = sort (ess, index.return = T)
    for (i in 1:nperm) {
      if (ess[i] > 0) {
        ret[[ gset ]][[i]]$p = sum (ess >= ess[i]) / nperm
      } else {
        ret[[ gset ]][[i]]$p = sum (ess <= ess[i]) / nperm
      }
    }
  }

  return (ret)
}

AdjustP = function (esp) {
	ret = esp
	for (gset in names(ret)) {
		pvec = vector (length = length(ret[[ gset ]]), mode="numeric")
		for (j in 1:length(ret[[ gset ]])) {
			pvec[j] = ret[[ gset ]][[ j ]]$p
		}
		qs = p.adjust (pvec)
		for (j in 1:length(ret[[ gset ]])) {
			ret[[ gset ]][[ j ]]$q = qs[j]
		}
	}
	return (ret)
}

ExportResult = function (es, nes, outfile) {
	ES   = vector(length = 0, mode = "numeric")
	pval = vector(length = 0, mode = "numeric")
	fdr  = vector(length = 0, mode = "numeric")
	maxI = integer(length = 0)

	for (gset in names(es)) {
		esret = es[[gset]][[1]]
		ES    = c (ES, esret$ES)
		pval  = c (pval, esret$p)
		fdr   = c (fdr, esret$q)
		maxI  = c (maxI, esret$arg.ES)
		Hits  = paste(esret$hits, collapse=",")
	}
	outmat = data.frame (cbind(ES = ES, NES = nes, Pval = pval, Qval = fdr, PeatAt = maxI, Hits=Hits))
	rownames (outmat) = names(es)
	write.table (outmat, outfile, sep= "\t", quote=F, col.names=T, row.names=T)
	#write.table (es, outfile, append=T, sep= "\t", quote=F, col.names=T, row.names=T)
}
seed = {{args.seed}}
if (seed > -1) set.seed(seed)
dir.create("{{o.outdir}}", showWarnings = F, recursive = T)
exp = readGCT("{{i.gctfile}}")
gs  = readGMT("{{i.gmtfile}}")
ess = ESWithPerm(exp = exp, gs = gs)
esq = AdjustP(ess)
ESPlot(es = esq, gs = gs, outprefix = "{{o.outdir}}/RES.")
nes = NPvalPlot(es = esq, outprefix = "{{o.outdir}}/normP.")
ExportResult (es = esq, nes=nes, outfile = "{{o.outdir}}/report.txt")

{{rimport}}('__init__.r', 'plot.r', 'sampleinfo.r')
library(methods)
options(stringsAsFactors = FALSE)

infile  = {{i.infile | quote}}
gfile   = {{i.gfile | quote}}
prefix  = {{i.infile | fn2 | quote}}
outdir  = {{o.outdir | quote}}
inopts  = {{args.inopts | R}}
tsform  = {{args.tsform or 'NULL'}}
filter  = {{args.filter or 'NULL'}}
plots   = {{args.plot | R}}
ggs     = {{args.ggs | R}}
params  = {{args.params | R}}
devpars = {{args.devpars | R}}

expr = read.table.inopts(infile, inopts)
if (is.function(filter)) {
	expr = filter(expr)
	outfile = file.path(outdir, basename(infile))
	write.table(expr, outfile, row.names = TRUE, col.names = TRUE, sep = "\t", quote = FALSE)
}
if (is.function(tsform)) {
	expr = tsform(expr)
}
saminfo = NULL
if (gfile != "") {
	saminfo = SampleInfo2$new(gfile)
	groups  = saminfo$all.groups()
}

if (plots$boxplot) {
	bpfile = file.path(outdir, paste0(prefix, '.boxplot.png'))
	plot.boxplot(expr, bpfile, stacked = F, devpars = devpars, params = params$boxplot, ggs = ggs$boxplot)
	if (!is.null(saminfo)) {
		for (group in groups) {
			bpfile = file.path(outdir, paste0(prefix, '.', group, '.boxplot.png'))
			plot.boxplot(
				expr[, saminfo$get.samples('Group', group), drop = FALSE], 
				bpfile, stacked = F, devpars = devpars, params = params$boxplot, ggs = ggs$boxplot)
		}
	}
}

if (plots$histogram) {
	histfile = file.path(outdir, paste0(prefix, ".histo.png"))
	plot.histo(stack(as.data.frame(expr)), histfile, devpars = devpars, params = params$histogram, ggs = ggs$histogram)
	if (!is.null(saminfo)) {
		for (group in groups) {
			histfile = file.path(outdir, paste0(prefix, '.', group, '.histo.png'))
			plot.histo(
				stack(expr[, saminfo$get.samples('Group', group), drop = FALSE]), 
				histfile, devpars = devpars, params = params$histogram, ggs = ggs$histogram)
		}
	}
}

if (plots$qqplot) {
	qqfile = file.path(outdir, paste0(prefix, ".qq.png"))
	plot.qq(expr, qqfile, stacked = FALSE, devpars = devpars, params = params$qqplot, ggs = ggs$qqplot)
	if (!is.null(saminfo)) {
		for (group in groups) {
			qqfile = file.path(outdir, paste0(prefix, '.', group, '.qq.png'))
			plot.qq(
				stack(expr[, saminfo$get.samples('Group', group), drop = FALSE]), 
				qqfile, stacked = FALSE, devpars = devpars, params = params$qqplot, ggs = ggs$qqplot)
		}
	}
}

infile   = {{i.infile    | quote}}
outfile  = {{o.outfile  | quote}}

{% if args.intype == 'cont' %}

#
#         | Disease | Healthy |
# --------+---------+---------+
#   mut   |   40    |   12    |
# non-mut |   23    |   98    |
# --------+---------+---------+
#
cont.table = read.table(infile, sep = "\t", header = T, row.names = 1, check.names = F)

{% else %}

#
# Contingency table rows: Disease, Healthy
# Contingency table cols: Mut, Non
# 
#    | Disease Healthy | Mut  Non  |
# ---+--------+--------+-----+-----+
# S1 |    1   |    0   |  0  |  1  |
# S2 |    0   |    1   |  1  |  0  |
# .. |   ...  |   ...  | ... | ... |
# Sn |    0   |    1   |  0  |  1  |

# NOTE: now it should the transpose of it


ct.cnames = c()
ct.rnames = c()
{% if isinstance(args.ctcols, list) %}
ct.cnames = {{args.ctcols}}
{% elif args.ctcols %}
ct.cnames = {{args.ctcols | lambda x: [y.strip() for y in x.split(',') if y.strip()]}}
{% else %}
trim  = Vectorize(function (x) gsub("^\\s+|\\s+$", "", x))
lines = readLines(infile, n = 2)
for (line in lines) {
	if (!startsWith(line, '# Contingency table ')) next
	if (startsWith(line, '# Contingency table cols:')) {
		ct.cnames = trim(unlist(strsplit(substring(line, 26), ',', fixed = T)))
	} 
	else if (startsWith(line, '# Contingency table rows:')) {
		ct.rnames = trim(unlist(strsplit(substring(line, 26), ',', fixed = T)))
	}
}
{% endif %}

raw.data   = read.table(infile, sep = "\t", header = T, row.names = 1, check.names = F)
# generate contingency table
if (length(ct.rnames) == 0 && length(ct.cnames) == 0) {
	stop('No row names and col names specified for contingency table.')
}
if (length(ct.rnames) == 0) {
	ct.rnames = setdiff(colnames(raw.data), ct.cnames)
}
if (length(ct.cnames) == 0) {
	ct.cnames = setdiff(colnames(raw.data), ct.rnames)
}

# transposed cont.table
cont.table = matrix(NA, ncol = length(ct.cnames), nrow = length(ct.rnames))
colnames(cont.table) = ct.cnames
rownames(cont.table) = ct.rnames
# get the number of each contingency cell
for (rname in ct.rnames) {
	for (cname in ct.cnames) {
		tmp1 = raw.data[, rname] == 1
		tmp2 = raw.data[, cname] == 1
		tmp  = tmp1 & tmp2
		cont.table[rname, cname] = length(tmp[tmp])
	}
}
{% endif %}

# further parameters may be introduced, but for now just use defaults
ret = fisher.test(cont.table)
out = data.frame(
	confInt1    = ret$conf.int[1],
	confInt2    = ret$conf.int[2],
	oddsRatio   = ret$estimate,
	pval        = ret$p.value,
	alternative = ret$alternative,
	method      = ret$method
)

#
# Xsquare 1.706667
# df  1
# pval    0.1914184
# method  Pearson's Chi-squared test with Yates' continuity correction
#
write.table(t(out), outfile, col.names = F, row.names = T, sep = "\t", quote = F)

library(survival)
library(survminer)
{{rimport}}('__init__.r', 'plot.r')

set.seed(8525)

# load parameters
infile      = {{i.infile | R}}
incovfile   = {{i.covfile | R}}
outfile     = {{o.outfile | R}}
outdir      = {{o.outdir | R}}
inunit      = {{args.inunit | R}}
outunit     = {{args.outunit | R}}
inopts      = {{args.inopts | R}}
argscovfile = {{args.covfile | R}}
combine     = {{args.combine | R}}
method      = {{args.method | R}}
devpars     = {{args.devpars | R}}
params      = {{args.params | R}}
ggs         = {{args.ggs | R}}
covfile = ifelse(is.true(incovfile), incovfile, argscovfile)

data  = read.table.inopts(infile, inopts)

fct = 1
{% case (args.inunit, args.outunit) %}
	{% when ('days', 'weeks') %}
	fct = 1 / 7
	{% when ('days' ,'months') %}
	fct = 1 / 30
	{% when ('days' ,'years') %}
	fct = 1 / 365.25
	{% when ('weeks', 'days') %}
	fct = 7
	{% when ('weeks', 'months') %}
	fct = 7*12/365.25
	{% when ('weeks', 'years') %}
	fct = 7/365.25
	{% when ('years', 'days') %}
	fct = 365.25
	{% when ('years', 'weeks') %}
	fct = 365.25/7
	{% when ('years', 'months') %}
	fct = 12
{% endcase %}

if (fct != 1) {
	data[,1] = data[,1]*fct
}

cnames = make.names(colnames(data))
vars   = cnames[3:length(cnames)]
cnames[1] = 'Time'
cnames[2] = 'Status'

colnames(data) = cnames
covdata = NULL
if (is.true(covfile)) {
	if (method == 'km') {
		stop('Kaplan Merier is not able to do multi-variate analysis.')
	}
	covdata = read.table.inopts(covfile, list(rnames = TRUE, cnames = TRUE))
	rnames  = intersect(rownames(data), rownames(covdata))
	data    = data[rnames,,drop = FALSE]
	covdata = covdata[rnames,,drop = FALSE]
}

results = lapply(vars, function(v) {
	plotfile = file.path(outdir, sprintf('%s.surv.png', v))
	if (method == 'km') {
		r = plot.survival.km(data[, c(cnames[1:2], v), drop = FALSE],
			plotfile = plotfile, params = params, ggs = ggs, devpars = devpars)
	} else {
		if (!is.null(covdata)) {
			coxdata = cbind(data[, c(cnames[1:2], v), drop = FALSE], covdata)
		} else {
			coxdata = data[, c(cnames[1:2], v), drop = FALSE]
		}
		coxdata = coxdata[complete.cases(coxdata),,drop = FALSE]
		r = plot.survival.cox(coxdata,
			plotfile = plotfile, params = params, ggs = ggs, devpars = devpars)
	}
	as.list(r)
})

retable = NULL
# combine the tables
for (i in 1:length(results)) {
	if (method == 'cox') {
		results[[i]]$table = cbind(mainvar = vars[i], results[[i]]$table)
	}
	retable = ifelse(is.null(retable), results[[i]]$table, rbind(retable, results[[i]]$table))
}
write.table(pretty.numbers2(retable, HR..CI95_1..CI95_2..z = '%.3f', pvalue..modpval = '%.3E'), outfile, sep = "\t", row.names = FALSE, quote = FALSE)

if (is.true(combine) && length(results) > 1) {
	if(is.true(combine$nrow)) {
		devpars$height = devpars$height*combine$nrow
	}
	if(is.true(combine$ncol)) {
		devpars$width = devpars$width*combine$ncol
	}
	library(ggpubr)
	if (is.true(params$risk.table)) {

	}
	p = do.call(arrange_ggsurvplots,
		c(list(x=lapply(1:length(results), function(i) results[[i]]$plot), print=TRUE), combine))
	save.plot(p, file.path(outdir, 'survival.combined.png'), devpars)
}

{{rimport}}('__init__.r', 'sampleinfo.r')
library(clonevol)

# use to save converted pyclone results
indir     = {{job.indir | quote}}
mutfile   = {{i.mutfile | quote}}
indrivers = {{i.drivers | quote}}
samfile   = {{i.samfile | quote}}
outdir    = {{o.outdir | quote}}
inopts    = {{args.inopts | R}}
devpars   = {{args.devpars | R}}
drivers   = {{args.drivers | R}}
refgene   = {{args.refgene | R}}
bedtools  = {{args.bedtools | R}}

if (is.true(indrivers)) {
	if (file.exists(indrivers)) {
		drvfile = indrivers
		drvtype = 'plain'
		if (dir.exists(indrivers)) {
			drvfile = Sys.glob(file.path(indrivers, "*.sig_genes.txt"))[1]
			drvtype = 'mutsig'
		} else if (endsWith(indrivers, '.sig_genes.txt')) {
			drvtype = 'mutsig'
		}

		if (drvtype == 'plain') {
			drivers = read.table.inopts(drvfile, list(cnames = FALSE, rnames = FALSE))
			drivers = unlist(drivers[, 1])
		} else {
			drivers = read.table.inopts(drvfile, list(cnames = TRUE, rnames = FALSE))
			drivers = drivers[1:10, , drop = FALSE]
			drivers = unlist(drivers[drivers$p < 0.05, 1, drop = TRUE])
		}
	} else {
		drivers = unlist(strsplit(indrivers, ",", fixed = TRUE))
	}
}

params.plot.variant.clusters =
	{{args.params['plot.variant.clusters'] | R}}
params.plot.cluster.flow =
	{{args.params['plot.cluster.flow'] | R}}
params.infer.clonal.models =
	{{args.params['infer.clonal.models'] | R}}
params.transfer.events.to.consensus.trees =
	{{args.params['transfer.events.to.consensus.trees'] | R}}
params.convert.consensus.tree.clone.to.branch =
	{{args.params['convert.consensus.tree.clone.to.branch'] | R}}
params.plot.clonal.models =
	{{args.params['plot.clonal.models'] | R}}

saminfo = SampleInfo2$new(samfile)

samples = saminfo$get.samples()
sample.groups = c()
for (sam in samples) {
	sample.groups[[sam]] = saminfo$sample.info(sam, info = 'Group')[1]
}

# expect mutfile:
# cluster gene is.driver P.vaf R.vaf P.ccf R.ccf P.ref.count P.var.count P.depth R.ref.count R.var.count R.depth P R
# 1 SMC3 TRUE 50.28 49.13 100.56 98.26 3027 2611 5639 2035 1990 4024 50.28 49.13
# 1 PTPRT TRUE 45.24 45.31 90.48 90.62 2159 1799 3958 1715 1579 3294 45.24 45.31
# 1 - FALSE 43.83 41.37 87.66 82.74 2931 2364 5296 2224 1501 3725 43.83 41.37

# in case mutfile is pylone output
if (dir.exists(mutfile) && endsWith(mutfile, '.pyclone')) {
	# tables/loci.tsv
	#mutation_id	sample_id	cluster_id	cellular_prevalence	cellular_prevalence_std	variant_allele_frequency	gene
	#chr10:17875816	NA12878	2	0.828865827591	0.0355432431918	0.904883227176	Gene1
	#chr10:17875816	NA12156	2	0.741264908504	0.11050033704	0.560311284047	Gene2

	# <sample>.mut.beds
	##CHR   START   END     NAME            GT  REF VAR CASE    VAF
	#chr2	3482633	3482633	chr2:3482633	AB	103	2	sample1	0.019
	#chr2	9661972	9661972	chr2:9661972	AB	60	6	sample1	0.091
	logger('Extracting information from pyclone results ...')
	mutations = read.table.inopts(file.path(mutfile, "tables/loci.tsv"), list(rnames = FALSE))
	mutations = mutations[, c(
		"mutation_id", "sample_id", "cluster_id", "variant_allele_frequency", "cellular_prevalence"),
		drop = FALSE]
	rownames(mutations) = make.unique(do.call(paste, c(mutations[c("sample_id", "mutation_id")], sep = "-")))

	samples = levels(as.factor(mutations$sample_id))
	mutbeds = NULL
	for (sample in samples) {
		mutbed = file.path(mutfile, paste0(sample, '.muts.bed'))
		mutbed_withgene = file.path(outdir, paste0(sample, '.muts.bed'))
		runcmd(sprintf("%s intersect -a '%s' -b '%s' -loj > '%s'", bedtools, mutbed, refgene, mutbed_withgene))

		mbtmp = read.table.inopts(mutbed_withgene, list(cnames = FALSE, rnames = FALSE))
		mbtmp = mbtmp[, c(1:9, 18), drop = FALSE]
		colnames(mbtmp) = c("CHR", "START", "END", "NAME", "GENOTYPE",
							"REFCOUNTS", "VARCOUNTS", "CASE", "VARFREQ", "GENE")
		mbtmp$GENE = sapply(mbtmp$GENE, function(g) {
			if (g == '.') {
				'-'
			} else {
				#gene_id "DCDC2C"
				geneid = unlist(strsplit(g, "; ", fixed = TRUE))[1]
				substring(geneid, 10, nchar(geneid)-1)
			}
		})
		mbtmp$SAMPLE = sample
		mbtmp$DEPTH  = mbtmp$VARCOUNTS / mbtmp$VARFREQ
		if (is.null(mutbeds)) {
			mutbeds = mbtmp
		} else {
			mutbeds = rbind(mutbeds, mbtmp)
		}
	}
	rownames(mutbeds) = make.unique(do.call(paste, c(mutbeds[c("SAMPLE", "NAME")], sep = "-")))
	mutbeds = mutbeds[rownames(mutations),,drop = FALSE]

	mutations = cbind(mutations, mutbeds)
	mutations = mutations[, c(
		"cluster_id", "variant_allele_frequency", "cellular_prevalence",
		"REFCOUNTS", "VARCOUNTS", "DEPTH", "SAMPLE", "mutation_id", "GENE"
	), drop = FALSE]

	sample0 = samples[1]
	mutinfo = data.frame(
		#Cluster identities must be contiguous integer starting at 1
		cluster   = mutations[mutations$SAMPLE == sample0, "cluster_id"] + 1,
		gene      = mutations[mutations$SAMPLE == sample0, "GENE"],
		is.driver = mutations[mutations$SAMPLE == sample0, "GENE"] %in% drivers)
	rownames(mutinfo) = make.unique(mutations[mutations$SAMPLE == sample0, "mutation_id"])
	for (sample in samples) {
		samdata = mutations[mutations$SAMPLE == sample,,drop = FALSE]
		rownames(samdata) = make.unique(samdata$mutation_id)
		samdata = samdata[rownames(mutinfo),,drop = FALSE]
		mutinfo[[sample]] = samdata$variant_allele_frequency * 100
		mutinfo[[paste(sample, 'vaf', sep = '.')]] = samdata$variant_allele_frequency * 100
		mutinfo[[paste(sample, 'ccf', sep = '.')]] = samdata$cellular_prevalence * 100
		mutinfo[[paste(sample, 'ref.count', sep = '.')]] = samdata$REFCOUNTS
		mutinfo[[paste(sample, 'var.count', sep = '.')]] = samdata$VARCOUNTS
		mutinfo[[paste(sample, 'depth', sep = '.')]] = samdata$DEPTH
	}
	write.table(mutinfo, file.path(indir, paste0(basename(mutfile), '.txt')), row.names = FALSE, col.names = TRUE, sep = "\t", quote = FALSE)
} else {
	mutinfo = read.table.inopts(mutfile, inopts)
}

# plot.variant.clusters
logger('Running plot.variant.clusters ...')
variant.cluster.outfile = file.path(outdir, 'variant_cluster.png')
do.call(png, c(list(filename = variant.cluster.outfile), devpars))
do.call(plot.variant.clusters,
		c(list(df = mutinfo, vaf.col.names = samples), params.plot.variant.clusters))
dev.off()

# plot.cluster.flow
logger('Running plot.cluster.flow ...')
cluster.flow.outfile = file.path(outdir, 'cluster_flow.png')
do.call(png, c(list(filename = cluster.flow.outfile), devpars))
do.call(plot.cluster.flow,
		c(list(variants = mutinfo, vaf.col.names = samples), params.plot.cluster.flow))
dev.off()

# infer.clonal.models
logger('Running infer.clonal.models ...')
# determin founding cluster if it is NULL as default
# if (is.null(params.infer.clonal.models$founding.cluster)) {
# 	allVafs = aggregate(as.formula(paste(paste(samples, collapse = '+'), 'cluster', sep = '~')), mutinfo, sum)
# 	params.infer.clonal.models$founding.cluster = allVafs[which.max(allVafs[,2]), 'cluster'][1]
# }

passed = FALSE
# try to remove invalid samples, instead of stop the program
while (!passed) {
	tryCatch({
		capture = capture.output(y <<- do.call(infer.clonal.models,
			c(list(variants = mutinfo,
				   vaf.col.names = samples,
				   sample.groups = sample.groups),
			params.infer.clonal.models)), type = 'message')
		if (!grepl("ERROR: No clonal models for sample:", capture[1], fixed = TRUE)) {
			passed <<- TRUE
		} else {
			exclude.sample = sub(" $", "", substring(capture[1], 37))
			logger(paste('Sample', exclude.sample, 'not valid for modeling', level = 'warning'))
			samples = setdiff(samples, exclude.sample)
			if (len(samples) < 2) {
				stop('Not enough valid samples.')
			}
		}
	}, error = function(e) { passsed <<- FALSE })
}

if (any(mutinfo$is.driver)) {
	# transfer.events.to.consensus.trees
	logger('Running transfer.events.to.consensus.trees ...')
	y = do.call(transfer.events.to.consensus.trees,
				c(list(x = y,
					events = mutinfo[mutinfo$is.driver,]),
				params.transfer.events.to.consensus.trees))
}

# convert.consensus.tree.clone.to.branch
logger('Running convert.consensus.tree.clone.to.branch ...')
y = do.call(convert.consensus.tree.clone.to.branch,
			c(list(x=y), params.convert.consensus.tree.clone.to.branch))

logger('Running plot.clonal.models ...')
do.call(plot.clonal.models,
		c(list(y,
			   out.dir = outdir,
			   out.format = 'png',
			   resolution = devpars$res,
			   # let it choose
			   #width = devpars$width / 96 * 1.5,
			   #height = devpars$height / 96,
			   overwrite.output = TRUE), params.plot.clonal.models))

{{rimport}}('__init__.r')
library(methods)
library(glmnet)
options(stringsAsFactors = FALSE)

inD     = {{i.D | quote}}
inPt    = {{i.Pt | quote}}
inY     = {{i.Y | quote}}
outW    = {{o.W | quote}}
outdir  = {{o.outdir | quote}}
seed    = {{args.seed | R}}
inopts  = {{args.inopts | R}}
svdP    = {{args.svdP | R}}
predY   = {{args.predY | R}}
WPt     = {{args.WPt | R}}
WtDtY   = {{args.WtDtY | R}}
nfold   = {{args.nfold | R}}
tfrac   = {{args.tfrac | R}}
nthread = {{args.nthread | R}}
method  = {{args.method | quote}}

set.seed(seed)

logger('Reading input files ...')
D  = as.matrix(read.table.inopts(inD, inopts))
Pt = as.matrix(read.table.inopts(inPt, inopts))
Y  = as.matrix(read.table.inopts(inY, inopts))

logger('Deciding training and testing sets ...')
samples = colnames(Y)
nsams   = length(samples)
tnsams  = sample(samples, as.integer(nsams * tfrac))
ttsams  = setdiff(samples, tnsams)

trainY  = Y [, tnsams]
trainPt = Pt[, tnsams]
testY   = Y [, ttsams]
testPt  = Pt[, ttsams]

# Normlization funcs
L2 = function(mat) {
	t(t(mat)/sqrt(colSums(mat^2)))
}

logger('Normalizing data ...')
D            = L2(D)
trainYrmean  = rowMeans(trainY)
trainY       = t(scale(t(trainY), scale = FALSE))
trainY       = L2(trainY)
trainPtrmean = rowMeans(trainPt)
trainP       = scale(t(trainPt), scale = FALSE)

testY = testY - trainYrmean
testY = L2(testY)
testP = t(testPt) - trainPtrmean

if (svdP > 0) {
	logger('Using SVD to approximate X ...')
	idx   = 1:svdP
	if (is.installed('corpcor')) {
		library(corpcor)
		P.svd = fast.svd(t(trainP))
	} else {
		P.svd = svd(t(trainP))
	}
	diagP = diag(P.svd$d)[idx, idx]
	U     = as.matrix(P.svd$u[, idx])
	V     = as.matrix(P.svd$v[, idx])
	XR    = t(diagP %*% t(V))
	XL    = t(trainY) %*% D
	X     = kronecker(XR, XL)
} else {
	logger('Calculating X ...')
	X = kronecker(trainP, t(trainY) %*% D)
}
vecYtY = as.matrix(as.vector(t(trainY) %*% trainY))

# train 
alpha = 0
if (nthread > 1) {
	library(doMC)
	registerDoMC(cores = nthread)
}
logger('Doing cv.glmnet ...')
cvfit = cv.glmnet(X, vecYtY, alpha=alpha, nfolds=nfold, lower = -1, upper = 1, parallel = nthread > 1)
if (method == 'glmnet') {
	logger('Calculating fit using glmnet ...')
	fit  = glmnet(X, vecYtY, alpha=alpha, lower = -1, upper = 1)
	vecW = predict(fit, X, s=cvfit$lambda.min, type="coefficients")
} else {
	logger('Calculating fit using admm ...')
	if (nthread > 1) {
		vecW = admm_enet(x, y)$penalty(exp(-2), alpha = alpha)$parallel$fit()
	} else {
		vecW = admm_enet(x, y)$penalty(exp(-2), alpha = alpha)$fit()
	}
}

logger('Calculating W ...')
if (svdP > 0) {
	hatW = matrix(vecW[-1], ncol = svdP)
	W    = hatW %*% t(U)
} else {
	W = matrix(as.vector(vecW[-1]), nrow = ncol(D))
}

rownames(W) = colnames(D)
colnames(W) = colnames(trainP)
write.table(round(W, 4), outW, quote = F, sep = "\t")

if (predY) {
	logger('Predicting Y ...')
	predY = D %*% W %*% t(testP)
	predyfile = file.path(outdir, 'predY.txt')
	write.table(predY, predyfile, sep="\t", quote=F)

	spcors  = NULL
	for (tts in ttsams) {
		spcor  = cor.test(predY[, tts], testY[, tts], method = 'spearman')
		#spcors = rbind(spcors, sample = tts, cor = spcor$rho, p = spcor$p.value)
		spcors = rbind(spcors, c(tts, spcor$estimate, spcor$p.value))
	}
	colnames(spcors) = c('sample', 'cor', 'p')
	predycorfile = file.path(outdir, 'predYcor.txt')
	write.table(spcors, predycorfile, sep="\t", quote=F, row.names = F)

	predycmsfile = file.path(outdir, 'predYcorMeanSd.txt')
	cormeansd = matrix(c(mean(as.numeric(spcors[, 'cor'])), sd(as.numeric(spcors[, 'cor']))), ncol = 1)
	rownames(cormeansd) = c('mean', 'sd')
	write.table(cormeansd, predycmsfile, sep="\t", quote=F, col.names = F)
}

if (WPt) {
	logger('Calculating WPt ...')
	outfile = file.path(outdir, 'WPt.txt')
	write.table(W %*% as.matrix(Pt), outfile, sep="\t", quote=F)
}

if (WtDtY) {
	logger('Calculating WtDtY ...')
	outfile = file.path(outdir, 'WtDtY.txt')
	write.table(t(W) %*% t(as.matrix(D)) %*% as.matrix(Y), outfile, sep="\t", quote=F)
}

# legacy
SampleInfo  = reticulate::import('bioprocs.utils.sampleinfo')$SampleInfo

library(R6)
options(stringsAsFactors = FALSE)

SampleInfo2 = R6Class("SampleInfo2", public = list(

	mat = NULL,
	cnames = c(),

	initialize = function(sifile, checkPaired = FALSE) {
		# 'Sample', 'Patient', 'Group', 'Batch'
		private$read(sifile)
		if (checkPaired && "Patient" %in% self$cnames) {
			for (patient in self$all.patients()) {
				if (length(self$get.samples(by = 'Patient', value = patient)) != 2) {
					stop(sprintf('Expect paired comparisons, but Patient %s has # samples other than 2.', patient))
				}
			}
		}
	},

	select = function(samples) {
		self$mat = self$mat[match(samples, self$mat$Sample),, drop=F]
	},

	as.edger.design = function() {
		private$relevel.group()
		if (self$is.paired()) {
			model.matrix(~ self$mat$Patient + self$mat$Group)
		} else {
			model.matrix(~ self$mat$Group)
		}
	},

	as.deseq2.design = function() {
		private$relevel.group()
		coldata = data.frame(Group = self$mat$Group)
		design  = ~ Group
		if (self$is.paired()) {
			coldata$Patient = self$mat$Patient
			design = ~ Patient + Group
		}
		list(coldata = coldata, design = design)
	},

	as.superfreq.meta = function(datadir = NULL) {
		# BAM, VCF, NAME, INDIVIDUAL, NORMAL, TIMEPOINT
		# Sample  Patient  Group  Batch
		# A.bam   A        Indvd1 NORMAL
		# A.vcf   A        Indvd1 NORMAL
		# B.bam   B        Indvd1 TUMOR
		# B.vcf   B        Indvd1 TUMOR
		ret = data.frame(
			BAM        = character(), VCF    = character(), NAME      = character(),
			INDIVIDUAL = character(), NORMAL = character(), TIMEPOINT = character()
		)
		patients = self$all.patients()
		for (patient in patients) {
			pair = self$get.samples("Patient", patient)
			if (endsWith(pair[1], ".bam")) {
				BAM = pair[1]
				VCF = pair[2]
			} else {
				BAM = pair[2]
				VCF = pair[1]
			}
			BamInfo = self$sample.info(BAM)
			ret = rbind(ret, list(
				BAM        = if (is.null(datadir)) BAM else file.path(datadir, BAM),
				VCF        = if (is.null(datadir)) VCF else file.path(datadir, VCF),
				NAME       = patient,
				INDIVIDUAL = BamInfo$Group,
				NORMAL     = if (toupper(BamInfo$Batch) %in% c("NORMAL", "HEALTHY", "CONTROL")) "YES" else "NO",
				TIMEPOINT  = ""
			))
		}
		ret
	},

	is.paired = function() {
		allpatients = self$all.patients()
		if (is.null(allpatients))
			return (FALSE)
		for (patient in allpatients) {
			if (length(self$get.samples("Patient", patient)) != 2)
				return (FALSE)
		}
		return (TRUE)
	},

	all.patients = function() {
		if (!"Patient" %in% self$cnames)
			return (NULL)
		unique(as.vector(self$mat$Patient))
	},

	all.groups = function() {
		as.vector(levels(relevel(factor(self$mat$Group), self$mat[1, "Group"])))
	},

	get.samples = function(by = NULL, value = NULL) {
		if (!is.null(by) && !by %in% self$cnames) {
			stop(sprintf('%s is not a valid column name.', by))
		}
		if (is.null(by))
			return (as.vector(self$mat$Sample))
		as.vector(self$mat[which(self$mat[, by] == value), "Sample", drop = TRUE])
	},

	sample.info = function(sample, info = NULL) {
		#Get the information of a given sample
		ret = self$mat[which(self$mat$Sample == sample), , drop = FALSE]
		if (is.null(info))
			return (ret)
		return (ret[, info, drop = TRUE])
	}

), private = list(

	read = function(sifile) {
		standard.cnames = c("", "Sample", "Patient", "Group", "Batch")
		self$mat = read.table(sifile, header = TRUE, row.names = NULL, sep = "\t", check.names = FALSE)
		self$cnames = colnames(self$mat)
		if (is.null(self$cnames)) {
			stop('Headers for sample information file is required.')
		}
		if (length(setdiff(self$cnames, standard.cnames)) > 0) {
			stop(sprintf('Headers should be a subset of "%s"', paste(standard.cnames, collapse = ",")))
		}
		if (!"Group" %in% self$cnames) {
			stop("Column 'Group' is required in sample information file.")
		}
		self$cnames = replace(self$cnames, self$cnames == "", "Sample")
		colnames(self$mat) = self$cnames
	},

	relevel.group = function() {
		groups = self$all.groups()
		self$mat$Group = as.factor(self$mat$Group)
		self$mat$Group = relevel(self$mat$Group, groups[2])
	}

))

{{rimport}}('__init__.r')
{% assign default_inopts = {'delimit': '\t', 'rnames': False, 'cnames': True, 'check.names': False} %}
{% python default_inopts.update(args.inopts) %}
{% python default_inopts['sep'] = default_inopts['delimit'] %}
{% python default_inopts['row.names'] = default_inopts['rnames'] or None %}
{% python default_inopts['header'] = default_inopts['cnames'] %}
{% python del default_inopts['delimit'] %}
{% python del default_inopts['rnames'] %}
{% python del default_inopts['cnames'] %}
{% assign default_binopts = {'nbin': None, 'step': None, 'nan': 'skip', 'out': 'lower'} %}
{% python default_binopts.update(args.binopts) %}

infile  = {{i.infile | quote}}
outfile = {{o.outfile | quote}}
inopts  = {{default_inopts | R}}
binopts = {{default_binopts | R}}
cols    = {{args.cols | R: False}}

inopts = c(infile, inopts)
data   = do.call(read.table, inopts)
cnames = colnames(data)

newcols = list()
if (is.null(cols)) {
	for (col in cnames) {
		newcols[[col]] = binopts
	}
} else if (is.list(cols)) {
	for (col in names(cols)) {
		cname = as.integer(col)
		if (is.na(cname)) 
			cname = col
		else
			cname = cnames[cname]
		newcols[[cname]] = update.list(binopts, cols[[col]])
	}
} else {
	for (col in cols) {
		cname = as.integer(col)
		if (is.na(cname)) 
			cname = col
		else
			cname = cnames[cname]
		newcols[[cname]] = binopts
	}
}

ret = NULL
for (i in 1:ncol(data)) {
	cname = cnames[i]
	dcol  = data[, i, drop = F]
	if (cname %in% names(newcols)) {
		attach (newcols[[cname]])
		if (nan == 'as0') {
			dcol[is.na(dcol)] = 0
			dcol2 = dcol
		} else {
			dcol2 = dcol[!is.na(dcol)]
		}
		
		cmax = max(dcol2)
		cmin = min(dcol2)
		probs = NULL
		if (!is.null(nbin)) {
			breaks = quantile(dcol2, probs = seq(0, 1, 1/nbin))
		} else if (!is.null(step)) {
			breaks = seq(cmin, cmax + 1, step)
		} else {
			stop('One of `nbin` and `step` is required for binning.')
		} 
		cuts = cut(dcol2, breaks = breaks, include.lowest = T)
		ucuts = levels(factor(cuts))
		for (j in 1:length(ucuts)) {
			idx = which(cuts == ucuts[j])
			if (out == 'step') {
				dcol2[idx] = unlist(strsplit(substring(ucuts[j], 2), ',', fixed=T))[1]
			} else if (out == 'lower' || out == 'min') {
				dcol2[idx] = min(dcol2[idx])
			} else if (out == 'upper' || out == 'max') {
				dcol2[idx] = max(dcol2[idx])
			} else if (out == 'mean') {
				dcol2[idx] = mean(dcol2[idx])
			} else if (out == 'median') {
				dcol2[idx] = median(dcol2[idx])
			} else {
				dcol2[idx] = j
			}
		}
		dcol[!is.na(dcol)] = dcol2
	}
	if (is.null(ret)) {
		ret = dcol
	} else {
		ret = cbind(ret, dcol)
	}
}

write.table(ret, outfile, sep = inopts$sep, col.names = inopts$header, row.names = if (is.null(inopts$row.names)) F else T, quote = F)

{{rimport}}('plot.r')

library(ggplot2) # make aes available

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
cnames  = {{args.cnames | R }}
rnames  = {{args.rnames | R }}
devpars = {{args.devpars | R}}
aesList = {{args.aes | R}}

data = read.table(infile, header = cnames, row.names = if (rnames) 1 else NULL, sep = '\t', check.names = F)

eval(parse(text = {{args.helper | repr}}))
params  = {{args.params | R}}
ggs     = {{args.ggs | R}}

aesNames = names(aesList)
for (name in aesNames) {
	if (name == 'x' && !is.na(as.numeric(aesList$x))) {
		aesList$x = as.numeric(aesList$x)
	}
	if (name == 'y' && !is.na(as.numeric(aesList$y))) {
		aesList$y = as.numeric(aesList$y)
	}
}
if ('x' %in% aesNames && 'y' %in% aesNames) {
	plot.xy(data, outfile, x, y, params, ggs, devpars = devpars)
} else if ('x' %in% aesNames) {
	plot.x(data, outfile, x, params, ggs, devpars = devpars)
} else {
	plot.no(data, outfile, params, ggs, devpars = devpars)
}

library(methods)
{{rimport}}('__init__.r')

indir  = {{i.indir | R}}
outdir = {{o.outdir | R}}

plink    = {{args.plink | R}}

bedfile = Sys.glob(file.path(indir, '*.bed'))
input   = tools::file_path_sans_ext(bedfile)
output  = file.path(outdir, basename(input))

params = list(
	bfile       = input,
	`check-sex` = T,
	out         = output
)
cmd = sprintf("%s %s 1>&2", plink, cmdargs(params, equal = ' '))
runcmd(cmd)

sexcheck = read.table(paste0(output, '.sexcheck'), header = T, row.names = NULL, check.names = F)
sex.sample.fail = sexcheck[which(sexcheck$STATUS == 'PROBLEM'), c('FID', 'IID'), drop=F]
write.table(sex.sample.fail, paste0(output, '.sex.fail'), col.names = F, row.names = F, sep = "\t", quote = F)

library(optCluster)

d = read.table ({{i.infile | quote}}, sep="\t", header={{args.cnames | R}}, row.names={{args.rnames | lambda x: 'NULL' if not x else int(x)}}, check.names=F)
if ({{args.transpose | R}}) {
	d = t(d)
}
names = rownames(d)
{% if args.methods == 'all' %}
#methods = c("agnes", "clara", "diana", "hierarchical", "kmeans", "pam", "som", "em.nbinom", "da.nbinom", "sa.nbinom", "em.poisson", "da.poisson", "sa.poisson")
methods = c("agnes", "clara", "diana", "hierarchical", "pam", "em.nbinom", "da.nbinom", "sa.nbinom", "em.poisson", "da.poisson", "sa.poisson")
{% elif isinstance(args.methods, list) %}
methods = {{args.methods | Rvec}}
{% else %}
methods = unlist(strsplit({{args.methods | .replace(' ', '') | quote}}, ',', fixed = T))
{% endif %}

if ({{args.isCount | R}}) {
	methods = intersect(c("em.nbinom", "da.nbinom", "sa.nbinom", "em.poisson", "da.poisson", "sa.poisson"), methods)
} else {
	methods = intersect(c("agnes", "clara", "diana", "hierarchical", "kmeans", "model", "pam", "som", "sota", "fanny"), methods)
}
minc = max({{args.minc}}, 2)
maxc = min({{args.maxc}}, nrow(d) - 1)

ret = optCluster(d, minc:maxc, clMethods = methods, countData = {{args.isCount | R}}, clVerbose = T, rankVerbose = F)


ret = optAssign(ret)

outfile = "{{o.outdir}}/clusters.txt"
metfile = "{{o.outdir}}/method.txt"
outfig  = "{{o.outdir}}/clusters.png"
outdir  = "{{o.outdir}}"
clusters = matrix(ret$cluster, ncol=1)
rownames(clusters) = names
write.table (clusters, outfile, row.names=T, sep="\t", quote=F, col.names=F)
write.table (ret$method, metfile, row.names=F, sep="\t", quote=F, col.names=F)
if ({{args.plot | R}}) {
	library(factoextra)
	pdata = list()
	pdata$data = d
	pdata$cluster = ret$cluster
	do.call(png, c(list(file = outfig), {{args.devpars | Rlist}}))
	print (fviz_cluster(pdata, data=d, main = ""))
	dev.off()
}

{{rimport}}('__init__.r', 'poll.r')

params = {{args.params | Rlist}}
params$i = {{i.infile | quote}}
params$o = {{o.outfile | quote}}
{% if args.feature != 'wgs' %}
params$f = {{args.feature | quote}}
{% endif %}

cmd = paste('{{args.bamstats}}', mem2({{args.mem | quote}}, 'java'), cmdargs(params), sep = ' ')
poll = Poll({{proc.workdir | quote}}, {{proc.size}}, {{job.index}})

{% if args.plot %}
{{rimport}}('plot.r')

{% if job.index == 0 %}
runcmd(cmd)
{% endif %}
poll$non1st(cmd)

{% if job.index == 0 %}
##### start plotting

bsfiles = Sys.glob("{{proc.workdir}}/*/output/*/*.stat.txt")
means   = matrix(ncol=1, nrow=length(bsfiles))
chrs    = NULL

rnames  = make.unique(unlist(lapply(bsfiles, function(x){ x=basename(x); return (substr(x, 1, nchar(x)-9)) })), sep='_')
rownames(means) = rnames
colnames(means) = c("Average_coverage")
for (i in 1:length(bsfiles)) {
	bsfile = bsfiles[i]
	if (file.info(bsfile)$size == 0) {
		logger ('No content in file:', bsfile)
		next
	}
	logger ("Reading", bsfile, "...")
	sample = rnames[i]
	stat   = read.table (bsfile, sep="", header=T, check.names=F, row.names=1)
	#stat   = stat[chrs2, ]
	#stat[, "N"] = as.numeric(gsub(",", "", stat[, "N"]))
	m      = stat[which(stat[, "mean"] > {{args.cutoff}} & stat[, "mean"] < {{args.cap}}), "mean", drop=F]
	#N      = stat[rownames(m), "N", drop = F]
	#means[sample, 1] = sum(N * m)/sum(N)
	means[sample, 1] = mean(m[, "mean", drop=T])
	col2in = m[order(m[, "mean"], decreasing = T), "mean", drop=F][1:(2*{{args.nfeats}}), , drop=F]
	colnames(col2in) = sample
	if (is.null(chrs)) {
		chrs = col2in
	} else {
		chrs = cbindfill(chrs, col2in)
	}
}
chrs = chrs[order(rowMeans(chrs), decreasing = T),,drop=F][1:min({{args.nfeats}}, nrow(chrs)),,drop=F]

logger("Plotting average coverages ...")
write.table (means, "{{out.outdir}}/avgCoverage.txt", quote=F, sep="\t")
plot.histo (means, "{{out.outdir}}/avgCoverage.png", ggs = {{args.histplotggs | Rlist}}, devpars = {{args.devpars | Rlist}})

# plot chromosomes
logger ("Plotting feature coverages ...")
plot.boxplot(t(chrs), "{{out.outdir}}/featureCoverage.png", ggs = {{args.boxplotggs | Rlist}}, devpars = {{args.devpars | Rlist}})

{% endif %} # end if job.index

{% else %}
runcmd (cmd)
{% endif %} # end if args.plot

{{rimport}}('plot.r')

ggs     = {{args.ggs | R}}
infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
rnames  = {{args.rnames | R}}
ggs     = {{args.ggs | R}}
devpars = {{args.devpars | R}}
data    = read.table.nodup(infile, sep = "\t", header = T, row.names = rnames)

plot.pie(data, outfile, ggs, devpars)

{% case args.infmt %}
# full
{% when 'full' %}
mat = read.table({{i.infile | quote}}, row.names = 1, header = T, check.names = F, sep = "\t")

# upper
{% when 'upper' %}
mat = read.table({{i.infile | quote}}, row.names = 1, header = T, check.names = F, sep = "\t", fill = T)
mat[lower.tri(mat)] <- t(mat)[lower.tri(mat)]

# lower
{% when 'lower' %}
mat = read.table({{i.infile | quote}}, row.names = 1, header = T, check.names = F, sep = "\t", fill = T)
mat[upper.tri(mat)] <- t(mat)[upper.tri(mat)]

# pair
{% when 'pair' %}
mat0 <- read.table({{i.infile | quote}}, header=F, row.names=NULL, stringsAsFactor=F, check.names=F)
name1 = as.character (mat0[, 1])
name2 = as.character (mat0[, 2])
names = unique(union(name1, name2))
nlen  = length(names)
mat   = matrix(NA, ncol = nlen, nrow = nlen)
rownames(mat) = names
colnames(mat) = names
diag(mat)     = 0
mat[as.matrix(mat0[,1:2,drop=F])] = mat0[,3]

ut = upper.tri(mat)
lt = lower.tri(mat)

utdata = mat[ut]
ltdata = mat[lt]

uttdata = t(mat)[ut]
lttdata = t(mat)[lt]

utdata[is.na(utdata)] = uttdata[!is.na(uttdata)]
ltdata[is.na(ltdata)] = lttdata[!is.na(lttdata)]

mat[ut] = utdata
mat[lt] = ltdata

{% endcase %}

coords = cmdscale(mat, k={{args.k}})
coords = round(coords, 3)
write.table (coords, {{o.outfile | quote}}, col.names=T, row.names=T, quote=F, sep="\t", na="")

{{rimport}}('plot.r', '__init__.r', 'sampleinfo.r')

exprfile  = {{i.expr      | R}}
batchfile = {{i.batch     | R}}
tool      = {{args.tool    | R}}
outfile   = {{o.outfile  | R}}
outdir    = {{o.outdir   | R}}
plot      = {{args.plot    | R}}
ggs       = {{args.ggs     | R}}
devpars   = {{args.devpars | R}}
hmrows    = {{args.hmrows  | R}}

expr    = read.table.nodup (exprfile, sep = "\t", header = TRUE, row.names = 1, check.names = F)

samples    = colnames(expr)
sampleinfo = SampleInfo(batchfile)
batch      = sampleinfo$dataframe(sampleinfo$select(sample = samples, get = c('Sample', 'Batch')))

batch      = factor(batch[samples, 'Batch'])

if (tool == 'combat') {
	library(sva)
	newexpr   = ComBat(dat=expr, batch=batch, par.prior = TRUE, mod = NULL)
	write.table (round(newexpr, 3), outfile, col.names=T, row.names=T, sep="\t", quote=F)
} else { # leave it for further tools
	stop('Unsupported tool: {{args.tool}}.')
}

# boxplot
if (plot$boxplot) {
	bpfile = file.path(outdir, "{{i.expr | fn2}}.boxplot.png")
	plot.boxplot(newexpr, bpfile, stack = T, devpars = devpars, ggs = ggs$boxplot)
}

# heatmap
if (plot$heatmap) {
	hmfile = file.path(outdir, "{{i.expr | fn2}}.heatmap.png")
	hmexp  = if (nrow(newexpr) > hmrows) newexpr[sample(nrow(newexpr),size=hmrows),] else newexpr
	plot.heatmap(hmexp, hmfile, devpars = devpars, ggs = ggs$heatmap)
}

# histgram
if (plot$histogram) {
	histfile = file.path(outdir, "{{i.expr | fn2}}.histo.png")
	plot.histo(as.data.frame(newexpr), histfile, devpars = devpars, ggs = ggs$histogram)
}

#library (Gviz)
region = unlist(strsplit({{i.chrom | quote}}, ':', fixed = T))
chrom  = region[1]
params = list(
	range      = {{i.infile | quote}},
	genome     = {{args.genome | quote}},
	chromosome = chrom,
	name       = {{i.name | quote}}
)
params          = c(params, {{args.params | Rlist}})

ret             = list()
ret$trackType   = 'DataTrack'
ret$trackParams = params

saveRDS (ret, {{o.outfile | quote}})

{{rimport}}('__init__.r')

infile   = {{i.infile    | quote}}
outfile  = {{o.outfile  | quote}}
byrow    = {{args.byrow   | R}}
inopts   = {{args.inopts  | R}}
method   = {{args.tie     | quote}}
na       = {{args.na      | quote}}
reverse  = {{args.reverse | R}}

inparams = list(
	file        = infile,
	header      = ifelse(is.null(inopts$cnames) || inopts$cnames, T, F),
	row.names   = ifelse(is.null(inopts$rnames) || inopts$rnames, 1, NULL),
	sep         = ifelse(is.null(inopts$delimit), "\t", inopts$delimit),
	check.names = F
)

data = do.call(read.table.nodup, inparams)
if (reverse) data = -data
if (byrow)   data = t(data)

if (na == 'remove') {
	na = NA
} else if (na == 'first') {
	na = F
} else if (na == 'last') {
	na = T
} # else keep

ranks = apply(data, 2, function(row) rank(row, na.last = na, ties.method = method))
if (byrow) ranks = t(ranks)

outparams = list(
	x         = ranks,
	file      = outfile,
	quote     = F,
	sep       = inparams$sep,
	row.names = ifelse(byrow, is.null(inopts$cnames) || inopts$cnames, is.null(inopts$rnames) || inopts$rnames),
	col.names = ifelse(byrow, is.null(inopts$rnames) || inopts$rnames, is.null(inopts$cnames) || inopts$cnames)
)
do.call(write.table, outparams)

{{rimport}}('plot.r', '__init__.r')

infiles  = {{i.infiles | R}}
metafile = {{i.metafile | R}}
outfile  = {{o.outfile | R}}
inopts   = {{args.inopts | R}}

allelements = c()
categories  = c()
datalist    = list()
for (infile in infiles) {
	indata = read.table.inopts(infile, inopts)
	if (is.true(inopts$cnames)) {
		category = colnames(indata)[1]
	} else {
		category = tools::file_path_sans_ext(basename(infile))
	}
	categories  = make.unique(c(categories, category))
	catdata     = as.vector(unlist(indata[,1]))
	datalist[[category]] = catdata
	allelements = unique(c(allelements, catdata))
}
data = NULL
for (name in names(datalist)) {
	tmpdata = data.frame(tmp = as.integer(allelements %in% datalist[[name]]))
	colnames(tmpdata) = name
	if (!is.null(data)) {
		data = cbind(data, tmpdata)
	} else {
		data = tmpdata
	}
}
rownames(data) = allelements

tool    = {{args.tool | R}}
ncols   = ncol(data)
cnames  = colnames(data)
devpars = {{args.devpars | R}}
# use real venn plot
if ((ncols <= 3 && tool == 'auto') || tool == 'venn') {
	params = {{args.params | R}}
	plot.venn(data, outfile, params, devpars)
} else {
	metadata = data.frame(counts = colSums(data), ratio = colSums(data)/nrow(data))
	if (metafile != "") {
		exmeta   = read.table(metafile, sep = "\t", header = TRUE, row.names = 1, check.names = F)
		metadata = cbind.fill(metadata, exmeta)
	}
	metadata = cbind(metadata, sets = rownames(metadata))
	missingcols = rownames(metadata[metadata$counts == 0,,drop=F])
	if (length(missingcols) > 0) {
		log2pyppl('No data in columns:', missingcols)
	}
	metadata = metadata[metadata$counts>0, , drop = F]
	data = data[, rownames(metadata), drop = F]
	params = {{args.params | R}}
	plot.upset(data, outfile, params, devpars)
}

{{rimport}}('__init__.r', 'plot.r')

indir     = {{i.indir | R}}
exrows    = {{args.exrows | R}}
fn2sample = Vectorize({{args.fn2sample}})
pattern   = {{args.pattern | R}}
outfile   = {{o.outfile | R}}
outdir    = {{o.outdir | R}}
plot      = {{args.plot | R}}
prefix    = {{i.indir, args.pattern | dirpat2name | R}}
devpars   = {{args.devpars | R}}
hmrows    = {{args.hmrows | R}}
ggs       = {{args.ggs | R}}

setwd(indir)

isGoodRname = function(rname) {
	for (excl in exrows) {
		if (grepl(excl, rname)) {
			return (FALSE)
		}
	}
	return (TRUE)
}
isGoodRname = Vectorize(isGoodRname)


exp = NULL
for (efile in Sys.glob(pattern)) {

	logger("Reading", efile, "...")
	
	sample = tools::file_path_sans_ext(basename(efile))
	sample = fn2sample(sample)

	if (grepl ('.gz$', efile)) efile = gzfile (efile)

	tmp = read.table.nodup (efile, sep="\t", header = F, row.names = 1, check.names = F)
	tmp = tmp[isGoodRname(rownames(tmp)), , drop=F]

	colnames(tmp) = sample

	exp    = if(is.null(exp)) tmp else cbind (exp, tmp)
}

write.table (exp, outfile, col.names = T, row.names = T, sep = "\t", quote = F)

exp = log2(exp + 1)

if (plot$boxplot) {
	bpfile = file.path(outdir, paste0(prefix, '.boxplot.png'))
	plot.boxplot(exp, bpfile, stack = T, devpars = devpars, ggs = ggs$boxplot)
}

if (plot$heatmap) {
	hmfile = file.path(outdir, paste0(prefix, ".heatmap.png"))
	hmexp  = if (nrow(exp) > hmrows) exp[sample(nrow(exp),size=hmrows),] else exp
	plot.heatmap(hmexp, hmfile, devpars = devpars, ggs = ggs$heatmap)
}

if (plot$histogram) {
	histfile = file.path(outdir, paste0(prefix, ".histo.png"))
	plot.histo(stack(as.data.frame(exp)), histfile, devpars = devpars, ggs = ggs$histogram)
}

{{rimport}}('__init__.r', 'plot.r')

#library(ggplot2) # make aes available

infile  = {{i.infile | R}}
outfile = {{o.outfile | R}}
inopts  = {{args.inopts | R}}
devpars = {{args.devpars | R}}

data = read.table.inopts(infile, inopts)

eval(parse(text = {{args.helper | repr}}))
params  = {{args.params | R}}
ggs     = {{args.ggs | R}}

plot.heatmap(data, outfile, params, ggs, devpars = devpars)

function cmdargs() {
	dash="auto"
	equal="auto"
	if [[ $# -gt 1 ]]; then
		dash=$2
	fi
	if [[ $# -gt 2 ]]; then
		equal=$3
	fi
	$__python__ -c "from bioprocs.utils import cmdargs; import sys; sys.stdout.write(cmdargs($1, dash='$dash', equal='$equal'))"
}

function logger() {
	flag="INFO"
	if [[ $# -gt 1 ]]; then
		flag="$2"
	fi
	printf "%s: %s\n" $flag "$1" 1>&2
}

mutsig={{args.mutsig | quote}}
mcr={{args.mcr | quote}}
infile={{i.infile | quote}}
cvrg={{args.cvrg | quote}}
cvrt={{args.cvrt | quote}}
out="{{o.outdir}}/{{i.infile | fn}}"
mutdict={{args.mutdict | quote}}
chrdir={{args.chrdir | quote}}
mafile="$infile"
if echo $infile | grep '.gz$' >/dev/null; then
	mafile="{{job.outdir}}/{{i.infile | fn}}" # no .gz
	gunzip -c "$infile" > "$mafile"
	infile="$mafile"
fi
cmd="$mutsig '$mcr' '$infile' '$cvrg' '$cvrt' '$out' '$mutdict' '$chrdir'"
echo $cmd
exec $cmd

function logger() {
	flag="INFO"
	if [[ $# -gt 1 ]]; then
		flag="$2"
	fi
	printf "%s: %s\n" $flag "$1" 1>&2
}

function ref_check() {
	if [[ -e "$1" ]]; then
		echo 0
	else
		echo 1
	fi
}

# $1: The ref file
# $2: The index file
# $3: samtools
function reffai_do() {
	samtools="samtools"
	if [[ $# -gt 2 ]]; then
		samtools=$3
	fi
	if [[ ! -e "$1" ]]; then
		echo "Reference file not exists: $1"
		exit 1
	fi
	$samtools faidx "$1"
	if [[ "$1.fai" != "$2" ]]; then
		mv "$1.fai" "$2"
	fi
}

# $1: The ref file
# $2: The index file
# $3: picard
function refdict_do() {
	picard="picard"
	if [[ $# -gt 2 ]]; then
		picard=$3
	fi
	if [[ ! -e "$1" ]]; then
		echo "Reference file not exists: $1"
		exit 1
	fi
	$picard CreateSequenceDictionary R="$1" O="$2"
}

function refkallisto_check() {
	if [[ -e "$1" ]]; then
		echo 0
	else
		echo 1
	fi
}

function refkallisto_do() {
	kallisto="kallisto"
	if [[ $# -gt 2 ]]; then
		kallisto=$3
	fi
	if [[ ! -e "$1" ]]; then
		echo "Reference file not exists: $1"
		exit 1
	fi
	$kallisto index -i "$1" "$2"
}

function reference_bwa() {
	if [[ -z "$bwa" ]]; then bwa="bwa"; fi
	ref=$1
	ref2check="$1.pac"
	if [[ ! -e "$ref2check" ]]; then
		logger "BWA index not exists, creating ..." "WARNING"
		$bwa index -a bwtsw -b 10000000000 "$ref"
	fi
}

function reference_bowtie2() {
	if [[ -z "$bowtie2" ]]; then bowtie2="bowtie2"; fi
	if [[ -z "$nthread" ]]; then nthread=1; fi
	bowtie2_build="${bowtie2}-build"
	ref=$1
	if [[ ! -e "$ref.bt2" && ! -e "$ref.1.bt2" ]]; then
		logger "Bowtie2 index not exists, creating ..." "WARNING"
		$bowtie2_build --threads $nthread $ref $ref
	fi
}

function reference_ngm() {
	if [[ -z "$ngm" ]]; then ngm="ngm"; fi
	if [[ -z "$nthread" ]]; then nthread=1; fi
	ref=$1
	if [[ ! -e "$ref-enc.2.ngm" ]]; then
		logger "NGM index not exists, creating ..." "WARNING"
		$ngm -r $ref -t $nthread
	fi
}

function reference_star() {
	if [[ -z "$star" ]]; then star="star"; fi
	if [[ -z "$nthread" ]]; then nthread=1; fi
	ref=$1
	refdir="${ref%.fa*}.star"
	if [[ ! -d "$refdir" ]]; then
		logger "Star index not exists, creating ..." "WARNING"
		mkdir -p "$refdir"
		$star --runMode genomeGenerate --genomeDir "$refdir" --genomeFastaFiles $ref --sjdbGTFfile $refexon --runThreadN $nthread
	fi
}

function reference_fasta() {
	if [[ -z "$samtools" ]]; then samtools="samtools"; fi
	ref=$1
	if [[ ! -e "$ref.fai" ]]; then
		logger "Fasta index not exists, creating ..." "WARNING"
		$samtools faidx $ref "$ref.fai"
	fi
}

function reference_picard() {
	if [[ -z "$picard" ]]; then picard="picard"; fi
	ref=$1
	if [[ ! -e "${ref%.fa*}.dict" ]]; then
		logger "Picard index not exists, creating ..." "WARNING"
		$picard CreateSequenceDictionary REFERENCE=$ref OUTPUT="${ref%.fa*}.dict"
	fi
}

function reference_elprep() {
	if [[ -z "$elprep" ]]; then elprep="elprep"; fi
	ref=$1
	if [[ ! -e "$ref.elprep" ]]; then
		logger "Elprep index not exists, creating ..." "WARNING"
		$elprep fasta-to-elfasta $ref "$ref.elprep"
	fi
}

function reference_kallisto() {
	ref=$1
	if [[ ! -e "$ref" ]]; then
		logger "Kallisto index does not exist, please create it before run this process."
		logger "Check: kallisto index ..."
		logger "  Please use a reference with gene sequences only!"
		logger "  Whole genome sequence reference will take forever!"
		exit 1
	fi
}

function reference() {
	tool="reference_$1"
	shift;
	$tool $@
}

# {{title}}

The filters were applied using bcftools[1].

{% import yaml %}
{% from os import path %}
{% if args.stat %}
```table
caption: Number of varaints with filters.
csvargs:
	delimiter: ','
---
{% for i, job in enumerate(jobs) -%}
{%- assign fstable = glob1(job.outdir, '*.filterstats.txt') -%}
{%- for j, line in enumerate(readlines(fstable)) -%}
{%- if j > 0 or i == 0 %}
{{line.replace('\t', ',')}}
{%- endif -%}
{%- endfor -%}
{%- endfor %}
```
{%- assign tableannfile = open(glob1(jobs[0].outdir, '*.filterstats.txt.ann')) -%}
{%- assign tableann = yaml.safe_load(tableannfile) -%}
{%- python tableannfile.close() -%}
{%- if report.get('tableann') -%}
{%- python tableann.update(report.tableann) -%}
{%- endif -%}{# if report.get('tableann') #}
{%- for key, value in tableann.items() %}
- {{key}}: {{value}}
{%- endfor -%}
{% endif %}{# if args.stat #}

[1]: Li, Heng, et al. "The sequence alignment/map format and SAMtools." Bioinformatics 25.16 (2009): 2078-2079.

# {{title}}

LICHeE[1] is a combinatorial method designed to reconstruct multi-sample cell lineage trees and infer the subclonal composition of the given samples based on variant allele frequencies (VAFs) of deep-sequencing somatic single nucleotide variants (SSNVs). The program accepts as input a list of SNVs with specified per-sample VAFs and outputs the inferred cell lineage tree(s) and the sample subclone decomposition. It provides an optional simple GUI to allow users to interact with the trees dynamically.

It:

- Doesn't require mutations to be clustered before analysis
- Doesn't require mutations to be shared in all samples
- Provides sample decomposition
- Reports one tree preferably

{% from os import path %}
{% for job in jobs %}
:::: {.tab}

	{%- if forloop.length > 1: %}
## {{job.i.infile | stem}}
	{%- endif %}

	{%- assign hash = forloop.length | ?:_>1 | :'#' | :'' %}

	{%- if `job.errfile | read | :"Found 0 valid trees after network adjustments" not in _` %}
##{{hash}} Top tree

![Top tree]({{job.o.outdir, '*.png' | *glob1}})

##{{hash}} Cluster details

```table
file: {{job.o.outdir, '*.snvinfo.txt' | *glob1}}
caption: Variant information
```
	{%- else %}
No valid trees generated.
	{%- endif %}

::::
{% endfor %}


[1]: Popic, Victoria, et al. "Fast and scalable inference of multi-sample cancer lineages." Genome biology 16.1 (2015): 91.

# {{title}}

{% python from os import path %}
{% for job in jobs %}
::: {.tab}
{% if len(jobs) > 1 %}
## {{job.i.infile | stem}}
{% endif %}


{% assign modelfigs = glob1(job.o.outdir, '*.model.png', first = False) %}
{% if report.get('modelfig', True) and modelfigs %}
![The model]({{modelfigs[0]}})
{% endif %}

{% assign rocfigs = glob1(job.o.outdir, '*.roc.png', first = False) %}
{% if report.get('roc', True) and rocfigs %}
![ROC curve]({{rocfigs[0]}})
{% endif %}

{% if report.get('auc', True) %}
```table
caption: AUCs
file: {{glob1(job.o.outdir, '*.aucs.txt')}}
```
{% endif %}

{% assign varimpfigs = glob1(job.o.outdir, '*.varimp.png', first = False) %}
{% if report.get('varimpfig', True) and varimpfigs %}
![Feature importance]({{varimpfigs[0]}})
{% endif %}

{% if report.get('varimp', True) %}
```table
caption: Feature importance
file: {{glob1(job.o.outdir, '*.varimp.txt')}}
```
{% endif %}

:::
{% endfor %}{# for job #}

# {{title}}

SCHISM[1] is a computational tool designed to infer subclonal hierarchy and the tumor evolution from somatic mutations. The inference process involves computational assessment of two fundamental properties of tumor evolution: lineage precedence rule and lineage divergence rule.

First, SCHISM combines information about somatic mutation cellularity (aka mutation cancer cell fraction) across all tumor sample(s) available from a patient in a hypothesis testing framework to identify the statistical support for the lineage relationship between each pair of mutations or mutation clusters. The results of the hypothesis test are represented as Cluster Order Precedence Violation (CPOV) matrix which informs the subsequent step in SCHISM and ensures compliance of candidate tree topologies with lineage precedence rule.

Next, an implementation of genetic algorithm (GA) based on a fitness function that incorporates considerations for both lineage precedence (CPOV) rule and lineage divergence rule explores the space of tree topologies and returns a prioritized list of candidate subclonal phylogenetic trees, most compatible with observed cellularity data.

It:

- Requires mutations to be clustered somewhere else
- Requires mutations to be shared in all samples
- Doesn't report sample decomposition
- Reports multiple trees

{% from os import path %}
{% for job in jobs %}
:::: {.tab}

	{%- if forloop.length > 1: %}
## {{job.i.infile | stem}}
	{%- endif %}

{% assign hash = forloop.length | ?:_>1 | :'#' | :'' %}
##{{hash}} Consensus trees

![Consensus trees]({{job.o.outdir, '*.tree.png' | *glob1}})

##{{hash}} Variants in each cluster

```table
file: {{job.o.outdir | str | path.join: 'mutation_to_cluster_assignment.tsv'}}
caption: 'Variants in each cluster'
```

::::
{% endfor %}

[1]: Niknafs, Noushin, et al. "Subclonal hierarchy inference from somatic mutations: automatic reconstruction of cancer evolutionary trees from multi-region next generation sequencing." PLoS computational biology 11.10 (2015): e1004416.

# {{title}}

Enrichr[1] is an easy to use intuitive enrichment analysis web-based tool providing various types of visualization summaries of collective functions of gene lists. Here we use its API to perform the analysis of out gene sets.


{% python from pyppl.utils import alwaysList %}
{% python from os import path %}
{% for job in jobs %}

:::: {.tab .force-collapse}

{% if len(jobs) > 1 %}
## {{job.i.infile | stem}}
{% endif %}

{% for lib in alwaysList(args.libs) %}

::: {.tab .force-tab}

{% if len(jobs) > 1 %}#{% endif %}## {{lib}}

{% if path.isfile(glob1(job.o.outdir, '*.%s.png' % lib)) %}
![Gene set enrichment analysis against {{lib}}]({{glob1(job.o.outdir, '*.%s.png' % lib)}})

```table
caption: Details of GSEA against {{lib}}
file: {{glob1(job.o.outdir, '*.%s.txt' % lib)}}
dtargs:
	order: [[3, 'asc']]
```
{% else %}
Nothing enriched.

{% endif %}

:::

{% endfor %}

::::

{% endfor %}


[1]: Kuleshov, Maxim V., et al. "Enrichr: a comprehensive gene set enrichment analysis web server 2016 update." Nucleic acids research 44.W1 (2016): W90-W97.

# {{title}}

{% python from os import path %}
{% for job in jobs %}

:::: {.tab .force-collapse}
{% if len(jobs) > 1 %}
## {{job.i.mutfile | stem}}
{% endif %}

{% for modelfile in glob1(job.o.outdir, 'model-*.png', first = False) %}

::: {.tab}
{% if len(jobs) > 1 %}#{% endif %}## {{modelfile | stem}}
![{{modelfile | stem}}]({{modelfile}})
:::

{% endfor %}

::::

{% endfor %}

# {{title}}

{% python from pathlib import Path %}
{% for job in jobs %}

:::: {.tab}
## {{job.i.infile | stem}}

```table
file: {{Path(job.o.outfile).with_suffix('.neat.txt') | str}}
caption: Prioritized neoantigens by given HLA alleles
rows: 100
```

::::
{% endfor %}

# {{title}}

The OxoG artifact from SNV calls was removed by D-ToxoG[1]. The goal of D-ToxoG is to limit the output mutation calls to less than {{args.params.artifactThresholdRate}} artifact by following steps:

1. Make an estimate of the number of OxoG artifacts in a given MAF file \
2. Calculate the likelihood that a given SNV is an OxoG artifact \
3. Apply threshold ({{args.params.artifactThresholdRate}}) to false discovery rate \

{% for job in jobs %}
:::: {.tab}

{% if len(jobs) > 1 %}
## {{job.i.infile | stem}}
{% endif %}

{% if report.get('download') %}
[Download MAF file]({{job.o.outfile}} "file-download")
{% endif %}

::: {.tab}
### All cases
```table
file: {{glob1(job.outdir, 'caseTableData.tsv')}}
caption: Summary of all cases
```

![Lego plot before filtering for all cases]({{glob1(job.outdir, 'figures', '*.dtoxog.maf*_lego_before.png')}})

![Lego plot after filtering for all cases]({{glob1(job.outdir, 'figures', '*.dtoxog.maf*_lego_after.png')}})

:::

{% for legoplot in glob1(job.outdir, 'figures', '*_lego_before.png', first = False) %}
{% if '.dtoxog.maf' not in legoplot %}
::: {.tab}
### {{legoplot | bn | [:-16]}}

![Lego plot before filtering for {{legoplot | bn | [:-16]}}]({{legoplot}})


![Lego plot after filtering]({{legoplot | bn | [:-16] | @append: "_lego_after.png" | @prepend: dirname(legoplot) + '/'}})
:::
{% endif %}{# if not legoplot.endswith #}
{% endfor %}{# for legoplot #}

::::
{% endfor %}{# for job #}

[1]: Costello, Maura, et al. "Discovery and characterization of artifactual mutations in deep coverage targeted capture sequencing data due to oxidative DNA damage during sample preparation." Nucleic acids research 41.6 (2013): e67-e67.

# {{title}}

One of the aim of RNAseq data analysis is the detection of differentially expressed genes. The analysis takes the normalised read count data and performing statistical analysis to discover quantitative changes in expression levels between experimental groups.

{% case args.tool %}
	{%- when 'deseq2' %}
Here we use DESeq2[1] to perform the analysis. DESeq2 provides methods to test for differential expression by use of negative binomial generalized linear models; the estimates of dispersion and logarithmic fold changes incorporate data-driven prior distributions.
	{%- when 'edger' %}
Here we use edgeR[1] to perform the analysis. edgeR is a Bioconductor software package for examining differential expression of replicated count data. An overdispersed Poisson model is used to account for both biological and technical variability.
{% endcase %}

{% for job in jobs %}
:::: {.tab}
	{%- if forloop.length > 1 %}
## {{ job.i.efile | stem | stem | @append: "-" + stem(job.i.gfile) }}
	{%- endif %}

##{% if forloop.length > 1 %}#{%endif%} Compairson

```table
file: {{job.i.gfile}}
caption: Compairson {{job.i.gfile | stem}}
dtargs:
	order: [[1, 'asc']]
```

##{% if forloop.length > 1 %}#{%endif%} Differentially expressed genes
::: {.tab .force-tab}
###{% if forloop.length > 1 %}#{%endif%} Top DEGs

```table
file: {{job.o.outfile}}
caption: Top DEGs
rows: 100
dtargs:
	order: [[3, 'asc']]
```
:::

::: {.tab .force-tab}
###{% if forloop.length > 1 %}#{%endif%} Top up-regulated genes

```table
file: {{job.o.outfile | prefix | prefix | @append: ".up.xls" }}
caption: Top up-regulated genes
rows: 100
dtargs:
	order: [[3, 'asc']]
```
:::

::: {.tab .force-tab}
###{% if forloop.length > 1 %}#{%endif%} Top down-regulated genes

```table
file: {{job.o.outfile | prefix | prefix | @append: ".down.xls" }}
caption: Top down-regulated genes
rows: 100
dtargs:
	order: [[3, 'asc']]
```
:::

##{% if forloop.length > 1 %}#{%endif%} Plots

::: {.tab .force-tab}
###{% if forloop.length > 1 %}#{%endif%} MDS plot
![MDSplot]({{job.o.outdir | @append: "/mdsplot.png"}})
:::

::: {.tab .force-tab}
###{% if forloop.length > 1 %}#{%endif%} Volcano plot
![Volcano plot]({{job.o.outdir | @append: "/volcano.png"}})
:::

::: {.tab .force-tab}
###{% if forloop.length > 1 %}#{%endif%} MA plot
![MAplot]({{job.o.outdir | @append: "/maplot.png"}})
:::

::: {.tab .force-tab}
###{% if forloop.length > 1 %}#{%endif%} Heatmap
![Heatmap]({{job.o.outdir | @append: "/heatmap.png"}})
:::


::: {.tab .force-tab}
###{% if forloop.length > 1 %}#{%endif%} QQplot on p-values
![QQplot on p-values]({{job.o.outdir | @append: "/qqplot.png"}})
:::

::::
{% endfor %}


{% case args.tool %}
	{%- when 'deseq2' %}
[1]: Love, Michael I., Wolfgang Huber, and Simon Anders. "Moderated estimation of fold change and dispersion for RNA-seq data with DESeq2." Genome biology 15.12 (2014): 550.
	{%- when 'edger' -%}
[1]: Robinson, Mark D., Davis J. McCarthy, and Gordon K. Smyth. "edgeR: a Bioconductor package for differential expression analysis of digital gene expression data." Bioinformatics 26.1 (2010): 139-140.
{% endcase %}

# {{title}}

{% python from os import path %}
{% for job in jobs %}
::: {.tab}

{% if len(jobs) > 1 %}
## {{job.i.infile | stem}}
{% endif %}

{% if path.exists(glob1(job.o.outdir, '*.combined.png')) %}
![Survival plot]({{glob1(job.o.outdir, '*.combined.png')}})\
{% else %}

{% for survplot in glob1(job.o.outdir, '*.surv.png', first = False) %}
![{{survplot.split('.')[0]}}]({{survplot}})
{% endfor %}

{% endif %}{# if path.exists #}

```table
file: {{glob1(job.o.outdir, '*.survival.txt')}}
caption: Details
```

:::
{% endfor %}

# {{title}}

This analysis is done using PyClone[1], which is designed to infer the prevalence of point mutations in heterogeneous cancer samples.

{% python from os import path %}
{% for job in jobs %}

:::: {.tab}
{% 	if path.exists(path.join(job.o.outdir, 'tables')) %}

{# tab title #}
{% 		if len(jobs) > 1 %}
## {{job.i.muts | stem}}
{% 		endif %}

{% 	if len(jobs) > 1 %}#{% endif %}## Cluster
::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}### Density
![Cluster density]({{job.o.outdir}}/plots/cluster/density.svg)
:::

::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}### Parallel coordinates
{% 	if path.exists(path.join(job.o.outdir, 'plots/cluster/parallel_coordinates.svg')) %}
![Parallel coordinates for clusters]({{job.o.outdir}}/plots/cluster/parallel_coordinates.svg)
{% 	endif %}
:::

::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}### Scatter
{% 	if path.exists(path.join(job.o.outdir, 'plots/cluster/scatter.svg')) %}
![Scatter for clusters]({{job.o.outdir}}/plots/cluster/scatter.svg)
{% 	endif %}
:::

::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}### Table
```table
file: {{job.o.outdir}}/tables/cluster.tsv
caption: Cellular density of clusters
rows: 100
```
:::

{% 	if len(jobs) > 1 %}#{% endif %}## Loci
::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}### Density
{% 	if path.exists(path.join(job.o.outdir, 'plots/loci/density.svg')) %}
![cluster-density]({{job.o.outdir}}/plots/loci/density.svg)
{%  endif %}
:::

::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}### Parallel coordinates
{% 	if path.exists(path.join(job.o.outdir, 'plots/loci/parallel_coordinates.svg')) %}
![Cellular prevalence]({{job.o.outdir}}/plots/loci/parallel_coordinates.svg)
{% 	endif %}
{% 	if path.exists(path.join(job.o.outdir, 'plots/loci/vaf_parallel_coordinates.svg')) %}
![VAF]({{job.o.outdir}}/plots/loci/vaf_parallel_coordinates.svg)
{% 	endif %}
:::

::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}### Scatter
{% 	if path.exists(path.join(job.o.outdir, 'plots/loci/scatter.svg')) %}
![Cellular prevalence]({{job.o.outdir}}/plots/loci/scatter.svg)
{% 	endif %}
{% 	if path.exists(path.join(job.o.outdir, 'plots/loci/vaf_scatter.svg')) %}
![VAF]({{job.o.outdir}}/plots/loci/vaf_scatter.svg)
{% 	endif %}
:::

::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}### Similarity
{% 	if path.exists(path.join(job.o.outdir, 'plots/loci/similarity_matrix.svg')) %}
![Loci similarity by cellular prevalence]({{job.o.outdir}}/plots/loci/similarity_matrix.svg)
{% 	endif %}
:::

::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}### Table
```table
file: {{job.o.outdir}}/tables/loci.tsv
caption: Cellular prevalence for loci
rows: 100
```
:::

{% else %}{# if path.exists #}

{# Show the last line of error messages #}
{{job.errfile | readlines | lambda x: x[-1] if x else ''}}

{% endif %}{# if path.exists #}
::::
{% endfor %}{# for jobs #}

[1]: Roth, Andrew, et al. "PyClone: statistical inference of clonal population structure in cancer." Nature methods 11.4 (2014): 396.

# {{title}}

{% for job in jobs %}

::: {.tab}
{% if len(jobs) > 1 %}
## {{job.i.infile | stem}}
{% endif %}

```table
caption: Model features
file: {{glob1(job.o.outdir, '*.features.txt')}}
```

{% if args.plot %}
![]({{glob1(job.o.outdir, '*.glm.png')}})
{% endif %}

:::
{% endfor %}

# {{title}}
## Glimpse

{% mode loose %}
{% python from os import path %}
{% for job in jobs %}
:::: {.tab}

{% if len(jobs) > 1 %}
### {{job.i.infile | stem}}
{% endif %}

```table
caption: First 10 samples
file: {{glob1(job.o.outdir, "*.top10.txt")}}
```

::::
{% endfor %}

## Statistics

{% for job in jobs %}
:::: {.tab}

{% if len(jobs) > 1 %}
### {{job.i.infile | stem}}
{% endif %}

{% for i, statfile in enumerate(sorted(glob1(job.o.outdir, "feature-stat.*.txt", first = False))) %}
::: {.tab}
{% assign feature = statfile | stem | [13:] %}
{% if len(jobs) > 1 %}#{%endif%}### {{feature}}

```table
caption: Basic statistics
file: {{statfile}}
```

![{{feature}} distribution]({{path.join(job.o.outdir, "feature-plot." + feature + ".png")}})

{% assign testfile = path.join(job.o.outdir, "feature-test." + feature + ".txt") %}
{% if path.isfile(testfile) %}
```table
caption: Tests
file: {{testfile}}
```

{% if i == 0 %}
{# Explain tests #}
- T test: Used to determine if there is a significant difference between the means of two groups. [Ref](https://en.wikipedia.org/wiki/Student%27s_t-test)
- Wilcoxon rank-sum test (a.k.a: Mann–Whitney U test): Used to determine whether two independent samples were selected from populations having the same distribution. [Ref](https://en.wikipedia.org/wiki/Mann%E2%80%93Whitney_U_test)
- ANOVA: Provides a statistical test of whether two or more population means are equal. [Ref](https://en.wikipedia.org/wiki/Analysis_of_variance)
- Kruskal Wallis test: Tests whether the mean ranks are the same in all the groups. [Ref](https://en.wikipedia.org/wiki/Kruskal%E2%80%93Wallis_one-way_analysis_of_variance)
- Chi-square test: Used to determine whether there is a significant difference between the expected frequencies and the observed frequencies in one or more categories. [Ref](https://en.wikipedia.org/wiki/Chi-squared_test)
- Fisher's exact test: Used to determine if there are nonrandom associations between two categorical variables. [Ref](https://en.wikipedia.org/wiki/Fisher%27s_exact_test)
{% endif %}

{% endif %}
:::
{% endfor %}


::::
{% endfor %}

# {{title}}

Principal Component Analysis (PCA) extracts the fundamental structure of the data without the need to build any model to represent it. This 'summary' of the data is arrived at through a process of reduction that can transform the large number of variables into a lesser number that are uncorrelated (i.e. the 'principal components'), whilst at the same time being capable of easy interpretation on the original data.

PCAtools[1] provides functions for data exploration via PCA, and allows the user to generate publication-ready figures.

{% for job in jobs %}
:::: {.tab}

	{%- if forloop.length > 1 %}
## {{job.i.infile | stem}}
	{%- endif %}
	{%- assign hash = forloop.length | ?:_>1 | :'#' | :'' %}

	{%- assign plots = job.o.outdir, '*.png' | *glob1: first = False %}
	{%- if plots %}
##{{hash}} Plots
	{% for png in plots %}
::: {.tab .force-tab}

		{%- case png | stem | ext | [1:] %}
			{%- when 'scree' %}
###{{hash}} Scree plot
A scree plot to show the proportion of explained variance by PC

![Scree plot]({{png}})
			{%- when 'bi' %}
###{{hash}} Bi-plot
![Bi-plot]({{png}})
			{%- when 'pairs' %}
###{{hash}} Pairs plot
![Pairs plot]({{png}})
			{%- when 'loadings' %}
###{{hash}} Loadings plot
Component loadings and label genes most responsible for variation

![Loadings plot]({{png}})
			{%- when 'eigencor' %}
###{{hash}} Eigen correlation plot
![Eigen correlation plot]({{png}})
		{%- endcase %}
:::
	{% endfor  %}
	{%- endif %}

##{{hash}} Selected PCs

```table
file: {{job.o.outfile}}
caption: Selected components
```

::::
{% endfor %}

[1]: Blighe, Kevin. "Haplotype Classification Using Copy Number Variation and Principal Components Analysis." Open Bioinformatics Journal 7 (2013): 19-24.

# {{title}}

{% for job in jobs %}

::: {.tab}
{% if len(jobs) > 1 %}
## {{job.i.infile | stem}}
{% endif %}


![]({{glob1(job.o.outdir, '*.roc.png')}})

{% if report.get('detail') %}
```table
caption: Details of model performance
file: {{glob1(job.o.outdir, '*.result.txt')}}
```
{% endif %}

:::
{% endfor %}

# {{title}}
Using method: {{args.method | @capitalize}}

{% for job in jobs %}
:::: {.tab}

{% if len(jobs) > 1 %}
## {{job.i.infile | stem}}
{% endif %}

::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}## Table
```table
file: {{ job.o.outfile | prefix | @append: ".mat.txt" }}
caption: {{args.method | @capitalize}} Correlation Coefficient between variables
```

:::

{% if args.plot %}
::: {.tab}
{% 	if len(jobs) > 1 %}#{% endif %}## Plot

![Heatmap of {{args.method | @capitalize}} Correlation Coefficient]({{ job.o.outfile | prefix | @append: ".png" }})

:::
{% endif %}

::::

{% endfor %}

# {{title}}

All of the basic anlyses were performed by Maftools[1], which attempts to summarize, analyze, annotate and visualize MAF files in an efficient manner from either TCGA sources or any in-house studies as long as the data is in MAF format.

{% python from os import path %}
{% for job in jobs %}

:::: {.tab .force-collapse}

{% 	if len(jobs) > 1 %}
## {{job.i.indir | stem}}
{% 	endif %}

{% 	if len(jobs) > 1 %}#{% endif %}## Summary
![Summary of mutations]({{glob1(job.o.outdir, 'summary.png')}})

{% 	if path.isfile(glob1(job.o.outdir, 'titv.png')) %}

![Transition-transversion ratio]({{glob1(job.o.outdir, 'titv.png')}})

- Transitions are interchanges of two-ring purines (A &lt;-&gt; G) or of one-ring pyrimidines (C &lt;-&gt; T): they therefore involve bases of similar shape. \
- Transversions are interchanges of purine for pyrimidine bases, which therefore involve exchange of one-ring and two-ring structures.
{% 	endif %}

{% 	if path.isfile(glob1(job.o.outdir, 'genecloud.png')) %}
Gene clound: Size of each gene is proportional to the total number of samples in which it is mutated/altered. \

![Gene Cloud]({{glob1(job.o.outdir, 'genecloud.png')}})

{% 	endif %}

{% 	if path.isfile(glob1(job.o.outdir, 'tcgacomp.png')) %}
TCGA contains over 30 different cancer cohorts and median mutation load across them varies from as low as 7 per exome (Pheochromocytoma and Paraganglioma arising from Adrenal Gland) to as high as 315 per exome (Skin Cutaneoys Melanoma). It is informative to see how mutation load in given maf stands against TCGA cohorts. This draws distribution of variants compiled from over 10,000 WXS samples across 33 TCGA landmark cohorts. Plot generated is similar to the one described in [3]. \

![Tumor mutation burden compared with TCGA cohorts]({{glob1(job.o.outdir, 'tcgacomp.png')}})

{% 	endif %}


{% 	if path.isfile(glob1(job.o.outdir, 'rainfalls', '*.png')) %}
{% 		if len(jobs) > 1 %}#{% endif %}## Rainfall plots
Cancer genomes, especially solid tumors are characterized by genomic loci with localized hyper-mutations[4]. Such hyper mutated genomic regions can be visualized by plotting inter variant distance on a linear genomic scale. \
{% 		for rainfall in glob1(job.o.outdir, 'rainfalls', '*.png', first = False) %}

::: {.tab .force-tab}
{% 			if len(jobs) > 1 %}#{% endif %}### {{path.basename(rainfall)[:-13]}}

![Rainfall plot for sample {{path.basename(rainfall)[:-13]}}]({{rainfall}})

:::

{% 		endfor %}
{% 	endif %}

{% 	if path.isfile(glob1(job.o.outdir, 'oncoplot.png')) %}
{% 		if len(jobs) > 1 %}#{% endif %}## Oncoplot

![Oncoplot of top mutated genes]({{glob1(job.o.outdir, 'oncoplot.png')}})

NOTE: Variants annotated as Multi_Hit are those genes which are mutated more than once in the same sample.
{% 	endif %}

{% 	if path.isfile(glob1(job.o.outdir, 'lollipops', '*.png')) %}
{% 		if len(jobs) > 1 %}#{% endif %}## Mutations on protein domains
{% 		if path.isfile(glob1(job.o.outdir, 'pfam.png')) %}

::: {.tab .force-tab}
{% 			if len(jobs) > 1 %}#{% endif %}### Overall
This serves the purpose of knowing what domain in given cancer cohort, is most frequently affected. \

![Mutated domains]({{glob1(job.o.outdir, 'pfam.png')}})

```table
caption: Details of mutated domains
file: {{glob1(job.o.outdir, 'pfam.csv')}}
rows: 100
csvargs:
	delimiter: ','
```
:::

{% 		endif %}
{% 		for lollipop in glob1(job.o.outdir, 'lollipops', '*.png', first = False) %}

::: {.tab .force-tab}
{% 			if len(jobs) > 1 %}#{% endif %}### {{path.basename(lollipop)[:-13]}}
Lollipop plots are simple and most effective way showing mutation spots on protein structure. Many oncogenes have a preferential sites which are mutated more often than any other locus. These spots are considered to be mutational hot-spots and lollipop plots can be used to display them along with rest of the mutations. \

![Lollipop plot for gene {{path.basename(lollipop)[:-13]}}]({{lollipop}})

:::

{% 		endfor %}
{% 	endif %}

{% 	if path.isfile(glob1(job.o.outdir, 'oncodrive.png')) or path.isfile(glob1(job.o.outdir, 'pancan.png')) %}
{% 		if path.isfile(glob1(job.o.outdir, 'oncodrive.png')) %}
{% 		if len(jobs) > 1 %}#{% endif %}## Detecting cancer driver genes based on positional clustering

Cancer genes (driver) detection from a given MAF is a based on algorithm oncodriveCLUST[2]. Concept is based on the fact that most of the variants in cancer causing genes are enriched at few specific loci (aka hot-spots). This method takes advantage of such positions to identify cancer genes. \

![Driver genes]({{glob1(job.o.outdir, 'oncodrive.png')}})

{%  	endif %}
{% 		if path.isfile(glob1(job.o.outdir, 'pancan.png')) %}
{% 		if len(jobs) > 1 %}#{% endif %}## Comparison with pancancer mutated genes

[5] performed MutSigCV[6] analysis on 21 cancer cohorts and identified over 200 genes to be significantly mutated which consists of previously un-subscribed novel genes. Their results show only few genes are mutated in multiple cohort while many of them are tissue/cohort specific. We can compare mutSig results against this pan-can list of significantly mutated genes to see genes specifically mutated in given cohort. \

![Comparison with pancancer mutated genes]({{glob1(job.o.outdir, 'pancan.png')}})

{%  	endif %}
{%  endif %}

{% 	if path.isfile(glob1(job.o.outdir, 'signature.png')) %}
{% 		if len(jobs) > 1 %}#{% endif %}## Mutation signatures

Every cancer, as it progresses leaves a signature characterized by specific pattern of nucleotide substitutions. Studies[3] have shown such mutational signatures, derived from over 7000 cancer samples 5. Such signatures can be extracted by decomposing matrix of nucleotide substitutions, classified into 96 substitution classes based on immediate bases surrounding the mutated base. Extracted signatures can also be compared to those [validated COSMIC signatures](http://cancer.sanger.ac.uk/cosmic/signatures).

![Identified signatures]({{glob1(job.o.outdir, 'signature.png')}})

![Mutation signature similarities]({{glob1(job.o.outdir, 'signature-sim.png')}})
{%  endif %}

::::

{% endfor %}{# for job #}

[1]: Mayakonda, Anand, et al. "Maftools: efficient and comprehensive analysis of somatic variants in cancer." Genome research 28.11 (2018): 1747-1756.
[2]: Tamborero, David, Abel Gonzalez-Perez, and Nuria Lopez-Bigas. "OncodriveCLUST: exploiting the positional clustering of somatic mutations to identify cancer genes." Bioinformatics 29.18 (2013): 2238-2244.
[3]: Alexandrov, Ludmil B., et al. "Signatures of mutational processes in human cancer." Nature 500.7463 (2013): 415.
[4]: Leiserson, Mark DM, et al. "CoMEt: a statistical approach to identify combinations of mutually exclusive alterations in cancer." Genome biology 16.1 (2015): 160.
[5]: Lawrence, Michael S., et al. "Discovery and saturation analysis of cancer genes across 21 tumour types." Nature 505.7484 (2014): 495.
[6]: Lawrence, Michael S., et al. "Mutational heterogeneity in cancer and the search for new cancer-associated genes." Nature 499.7457 (2013): 214.

# {{title}}
{% python from pathlib import Path %}
{% for job in jobs %}

{%  if len(jobs) == 1 %}

{%  else %}
:::: {.tab}

## {{job.i.infile | stem}}

{% for sumfile in sorted(job.o.outdir.glob('summary-*.png')) %}
::: {.tab .force-tab}
### {{sumfile.stem}}
![{{sumfile.stem}}]({{sumfile}})
:::
{% endfor %}

::::
{%  endif %}

{% endfor %}
